(() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[Object.keys(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __reExport = (target, module, desc) => {
    if (module && typeof module === "object" || typeof module === "function") {
      for (let key of __getOwnPropNames(module))
        if (!__hasOwnProp.call(target, key) && key !== "default")
          __defProp(target, key, { get: () => module[key], enumerable: !(desc = __getOwnPropDesc(module, key)) || desc.enumerable });
    }
    return target;
  };
  var __toModule = (module) => {
    return __reExport(__markAsModule(__defProp(module != null ? __create(__getProtoOf(module)) : {}, "default", module && module.__esModule && "default" in module ? { get: () => module.default, enumerable: true } : { value: module, enumerable: true })), module);
  };

  // node_modules/nearley/lib/nearley.js
  var require_nearley = __commonJS({
    "node_modules/nearley/lib/nearley.js"(exports, module) {
      (function(root, factory) {
        if (typeof module === "object" && module.exports) {
          module.exports = factory();
        } else {
          root.nearley = factory();
        }
      })(exports, function() {
        function Rule(name, symbols, postprocess) {
          this.id = ++Rule.highestId;
          this.name = name;
          this.symbols = symbols;
          this.postprocess = postprocess;
          return this;
        }
        Rule.highestId = 0;
        Rule.prototype.toString = function(withCursorAt) {
          var symbolSequence = typeof withCursorAt === "undefined" ? this.symbols.map(getSymbolShortDisplay).join(" ") : this.symbols.slice(0, withCursorAt).map(getSymbolShortDisplay).join(" ") + " \u25CF " + this.symbols.slice(withCursorAt).map(getSymbolShortDisplay).join(" ");
          return this.name + " \u2192 " + symbolSequence;
        };
        function State(rule, dot, reference, wantedBy) {
          this.rule = rule;
          this.dot = dot;
          this.reference = reference;
          this.data = [];
          this.wantedBy = wantedBy;
          this.isComplete = this.dot === rule.symbols.length;
        }
        State.prototype.toString = function() {
          return "{" + this.rule.toString(this.dot) + "}, from: " + (this.reference || 0);
        };
        State.prototype.nextState = function(child) {
          var state = new State(this.rule, this.dot + 1, this.reference, this.wantedBy);
          state.left = this;
          state.right = child;
          if (state.isComplete) {
            state.data = state.build();
            state.right = void 0;
          }
          return state;
        };
        State.prototype.build = function() {
          var children = [];
          var node = this;
          do {
            children.push(node.right.data);
            node = node.left;
          } while (node.left);
          children.reverse();
          return children;
        };
        State.prototype.finish = function() {
          if (this.rule.postprocess) {
            this.data = this.rule.postprocess(this.data, this.reference, Parser3.fail);
          }
        };
        function Column(grammar2, index) {
          this.grammar = grammar2;
          this.index = index;
          this.states = [];
          this.wants = {};
          this.scannable = [];
          this.completed = {};
        }
        Column.prototype.process = function(nextColumn) {
          var states = this.states;
          var wants = this.wants;
          var completed = this.completed;
          for (var w = 0; w < states.length; w++) {
            var state = states[w];
            if (state.isComplete) {
              state.finish();
              if (state.data !== Parser3.fail) {
                var wantedBy = state.wantedBy;
                for (var i = wantedBy.length; i--; ) {
                  var left = wantedBy[i];
                  this.complete(left, state);
                }
                if (state.reference === this.index) {
                  var exp = state.rule.name;
                  (this.completed[exp] = this.completed[exp] || []).push(state);
                }
              }
            } else {
              var exp = state.rule.symbols[state.dot];
              if (typeof exp !== "string") {
                this.scannable.push(state);
                continue;
              }
              if (wants[exp]) {
                wants[exp].push(state);
                if (completed.hasOwnProperty(exp)) {
                  var nulls = completed[exp];
                  for (var i = 0; i < nulls.length; i++) {
                    var right = nulls[i];
                    this.complete(state, right);
                  }
                }
              } else {
                wants[exp] = [state];
                this.predict(exp);
              }
            }
          }
        };
        Column.prototype.predict = function(exp) {
          var rules = this.grammar.byName[exp] || [];
          for (var i = 0; i < rules.length; i++) {
            var r = rules[i];
            var wantedBy = this.wants[exp];
            var s = new State(r, 0, this.index, wantedBy);
            this.states.push(s);
          }
        };
        Column.prototype.complete = function(left, right) {
          var copy = left.nextState(right);
          this.states.push(copy);
        };
        function Grammar2(rules, start) {
          this.rules = rules;
          this.start = start || this.rules[0].name;
          var byName = this.byName = {};
          this.rules.forEach(function(rule) {
            if (!byName.hasOwnProperty(rule.name)) {
              byName[rule.name] = [];
            }
            byName[rule.name].push(rule);
          });
        }
        Grammar2.fromCompiled = function(rules, start) {
          var lexer = rules.Lexer;
          if (rules.ParserStart) {
            start = rules.ParserStart;
            rules = rules.ParserRules;
          }
          var rules = rules.map(function(r) {
            return new Rule(r.name, r.symbols, r.postprocess);
          });
          var g = new Grammar2(rules, start);
          g.lexer = lexer;
          return g;
        };
        function StreamLexer() {
          this.reset("");
        }
        StreamLexer.prototype.reset = function(data, state) {
          this.buffer = data;
          this.index = 0;
          this.line = state ? state.line : 1;
          this.lastLineBreak = state ? -state.col : 0;
        };
        StreamLexer.prototype.next = function() {
          if (this.index < this.buffer.length) {
            var ch = this.buffer[this.index++];
            if (ch === "\n") {
              this.line += 1;
              this.lastLineBreak = this.index;
            }
            return { value: ch };
          }
        };
        StreamLexer.prototype.save = function() {
          return {
            line: this.line,
            col: this.index - this.lastLineBreak
          };
        };
        StreamLexer.prototype.formatError = function(token, message) {
          var buffer = this.buffer;
          if (typeof buffer === "string") {
            var lines = buffer.split("\n").slice(Math.max(0, this.line - 5), this.line);
            var nextLineBreak = buffer.indexOf("\n", this.index);
            if (nextLineBreak === -1)
              nextLineBreak = buffer.length;
            var col = this.index - this.lastLineBreak;
            var lastLineDigits = String(this.line).length;
            message += " at line " + this.line + " col " + col + ":\n\n";
            message += lines.map(function(line, i) {
              return pad(this.line - lines.length + i + 1, lastLineDigits) + " " + line;
            }, this).join("\n");
            message += "\n" + pad("", lastLineDigits + col) + "^\n";
            return message;
          } else {
            return message + " at index " + (this.index - 1);
          }
          function pad(n, length) {
            var s = String(n);
            return Array(length - s.length + 1).join(" ") + s;
          }
        };
        function Parser3(rules, start, options) {
          if (rules instanceof Grammar2) {
            var grammar2 = rules;
            var options = start;
          } else {
            var grammar2 = Grammar2.fromCompiled(rules, start);
          }
          this.grammar = grammar2;
          this.options = {
            keepHistory: false,
            lexer: grammar2.lexer || new StreamLexer()
          };
          for (var key in options || {}) {
            this.options[key] = options[key];
          }
          this.lexer = this.options.lexer;
          this.lexerState = void 0;
          var column = new Column(grammar2, 0);
          var table = this.table = [column];
          column.wants[grammar2.start] = [];
          column.predict(grammar2.start);
          column.process();
          this.current = 0;
        }
        Parser3.fail = {};
        Parser3.prototype.feed = function(chunk) {
          var lexer = this.lexer;
          lexer.reset(chunk, this.lexerState);
          var token;
          while (true) {
            try {
              token = lexer.next();
              if (!token) {
                break;
              }
            } catch (e) {
              var nextColumn = new Column(this.grammar, this.current + 1);
              this.table.push(nextColumn);
              var err = new Error(this.reportLexerError(e));
              err.offset = this.current;
              err.token = e.token;
              throw err;
            }
            var column = this.table[this.current];
            if (!this.options.keepHistory) {
              delete this.table[this.current - 1];
            }
            var n = this.current + 1;
            var nextColumn = new Column(this.grammar, n);
            this.table.push(nextColumn);
            var literal = token.text !== void 0 ? token.text : token.value;
            var value = lexer.constructor === StreamLexer ? token.value : token;
            var scannable = column.scannable;
            for (var w = scannable.length; w--; ) {
              var state = scannable[w];
              var expect = state.rule.symbols[state.dot];
              if (expect.test ? expect.test(value) : expect.type ? expect.type === token.type : expect.literal === literal) {
                var next = state.nextState({ data: value, token, isToken: true, reference: n - 1 });
                nextColumn.states.push(next);
              }
            }
            nextColumn.process();
            if (nextColumn.states.length === 0) {
              var err = new Error(this.reportError(token));
              err.offset = this.current;
              err.token = token;
              throw err;
            }
            if (this.options.keepHistory) {
              column.lexerState = lexer.save();
            }
            this.current++;
          }
          if (column) {
            this.lexerState = lexer.save();
          }
          this.results = this.finish();
          return this;
        };
        Parser3.prototype.reportLexerError = function(lexerError) {
          var tokenDisplay, lexerMessage;
          var token = lexerError.token;
          if (token) {
            tokenDisplay = "input " + JSON.stringify(token.text[0]) + " (lexer error)";
            lexerMessage = this.lexer.formatError(token, "Syntax error");
          } else {
            tokenDisplay = "input (lexer error)";
            lexerMessage = lexerError.message;
          }
          return this.reportErrorCommon(lexerMessage, tokenDisplay);
        };
        Parser3.prototype.reportError = function(token) {
          var tokenDisplay = (token.type ? token.type + " token: " : "") + JSON.stringify(token.value !== void 0 ? token.value : token);
          var lexerMessage = this.lexer.formatError(token, "Syntax error");
          return this.reportErrorCommon(lexerMessage, tokenDisplay);
        };
        Parser3.prototype.reportErrorCommon = function(lexerMessage, tokenDisplay) {
          var lines = [];
          lines.push(lexerMessage);
          var lastColumnIndex = this.table.length - 2;
          var lastColumn = this.table[lastColumnIndex];
          var expectantStates = lastColumn.states.filter(function(state) {
            var nextSymbol = state.rule.symbols[state.dot];
            return nextSymbol && typeof nextSymbol !== "string";
          });
          if (expectantStates.length === 0) {
            lines.push("Unexpected " + tokenDisplay + ". I did not expect any more input. Here is the state of my parse table:\n");
            this.displayStateStack(lastColumn.states, lines);
          } else {
            lines.push("Unexpected " + tokenDisplay + ". Instead, I was expecting to see one of the following:\n");
            var stateStacks = expectantStates.map(function(state) {
              return this.buildFirstStateStack(state, []) || [state];
            }, this);
            stateStacks.forEach(function(stateStack) {
              var state = stateStack[0];
              var nextSymbol = state.rule.symbols[state.dot];
              var symbolDisplay = this.getSymbolDisplay(nextSymbol);
              lines.push("A " + symbolDisplay + " based on:");
              this.displayStateStack(stateStack, lines);
            }, this);
          }
          lines.push("");
          return lines.join("\n");
        };
        Parser3.prototype.displayStateStack = function(stateStack, lines) {
          var lastDisplay;
          var sameDisplayCount = 0;
          for (var j = 0; j < stateStack.length; j++) {
            var state = stateStack[j];
            var display = state.rule.toString(state.dot);
            if (display === lastDisplay) {
              sameDisplayCount++;
            } else {
              if (sameDisplayCount > 0) {
                lines.push("    ^ " + sameDisplayCount + " more lines identical to this");
              }
              sameDisplayCount = 0;
              lines.push("    " + display);
            }
            lastDisplay = display;
          }
        };
        Parser3.prototype.getSymbolDisplay = function(symbol) {
          return getSymbolLongDisplay(symbol);
        };
        Parser3.prototype.buildFirstStateStack = function(state, visited) {
          if (visited.indexOf(state) !== -1) {
            return null;
          }
          if (state.wantedBy.length === 0) {
            return [state];
          }
          var prevState = state.wantedBy[0];
          var childVisited = [state].concat(visited);
          var childResult = this.buildFirstStateStack(prevState, childVisited);
          if (childResult === null) {
            return null;
          }
          return [state].concat(childResult);
        };
        Parser3.prototype.save = function() {
          var column = this.table[this.current];
          column.lexerState = this.lexerState;
          return column;
        };
        Parser3.prototype.restore = function(column) {
          var index = column.index;
          this.current = index;
          this.table[index] = column;
          this.table.splice(index + 1);
          this.lexerState = column.lexerState;
          this.results = this.finish();
        };
        Parser3.prototype.rewind = function(index) {
          if (!this.options.keepHistory) {
            throw new Error("set option `keepHistory` to enable rewinding");
          }
          this.restore(this.table[index]);
        };
        Parser3.prototype.finish = function() {
          var considerations = [];
          var start = this.grammar.start;
          var column = this.table[this.table.length - 1];
          column.states.forEach(function(t) {
            if (t.rule.name === start && t.dot === t.rule.symbols.length && t.reference === 0 && t.data !== Parser3.fail) {
              considerations.push(t);
            }
          });
          return considerations.map(function(c) {
            return c.data;
          });
        };
        function getSymbolLongDisplay(symbol) {
          var type2 = typeof symbol;
          if (type2 === "string") {
            return symbol;
          } else if (type2 === "object") {
            if (symbol.literal) {
              return JSON.stringify(symbol.literal);
            } else if (symbol instanceof RegExp) {
              return "character matching " + symbol;
            } else if (symbol.type) {
              return symbol.type + " token";
            } else if (symbol.test) {
              return "token matching " + String(symbol.test);
            } else {
              throw new Error("Unknown symbol type: " + symbol);
            }
          }
        }
        function getSymbolShortDisplay(symbol) {
          var type2 = typeof symbol;
          if (type2 === "string") {
            return symbol;
          } else if (type2 === "object") {
            if (symbol.literal) {
              return JSON.stringify(symbol.literal);
            } else if (symbol instanceof RegExp) {
              return symbol.toString();
            } else if (symbol.type) {
              return "%" + symbol.type;
            } else if (symbol.test) {
              return "<" + String(symbol.test) + ">";
            } else {
              throw new Error("Unknown symbol type: " + symbol);
            }
          }
        }
        return {
          Parser: Parser3,
          Grammar: Grammar2,
          Rule
        };
      });
    }
  });

  // node_modules/rambda/dist/rambda.esm.js
  function curry(fn, args = []) {
    return (..._args) => ((rest) => rest.length >= fn.length ? fn(...rest) : curry(fn, rest))([...args, ..._args]);
  }
  function adjustFn(index, replaceFn2, list) {
    const actualIndex = index < 0 ? list.length + index : index;
    if (index >= list.length || actualIndex < 0)
      return list;
    const clone = list.slice();
    clone[actualIndex] = replaceFn2(clone[actualIndex]);
    return clone;
  }
  var adjust = curry(adjustFn);
  function always(x) {
    return () => x;
  }
  var _isArray = Array.isArray;
  function assocFn(prop, newValue, obj) {
    return Object.assign({}, obj, {
      [prop]: newValue
    });
  }
  var assoc = curry(assocFn);
  function _isInteger(n) {
    return n << 0 === n;
  }
  var _isInteger$1 = Number.isInteger || _isInteger;
  function assocPathFn(path2, newValue, input) {
    const pathArrValue = typeof path2 === "string" ? path2.split(".").map((x) => _isInteger(Number(x)) ? Number(x) : x) : path2;
    if (pathArrValue.length === 0) {
      return newValue;
    }
    const index = pathArrValue[0];
    if (pathArrValue.length > 1) {
      const condition = typeof input !== "object" || input === null || !input.hasOwnProperty(index);
      const nextinput = condition ? _isInteger(pathArrValue[1]) ? [] : {} : input[index];
      newValue = assocPathFn(Array.prototype.slice.call(pathArrValue, 1), newValue, nextinput);
    }
    if (_isInteger(index) && _isArray(input)) {
      const arr = input.slice();
      arr[index] = newValue;
      return arr;
    }
    return assoc(index, newValue, input);
  }
  var assocPath = curry(assocPathFn);
  function clampFn(min, max, input) {
    if (min > max) {
      throw new Error("min must not be greater than max in clamp(min, max, value)");
    }
    if (input >= min && input <= max)
      return input;
    if (input > max)
      return max;
    if (input < min)
      return min;
  }
  var clamp = curry(clampFn);
  var _keys = Object.keys;
  function mapArray(fn, list, isIndexed = false) {
    let index = 0;
    const willReturn = Array(list.length);
    while (index < list.length) {
      willReturn[index] = isIndexed ? fn(list[index], index) : fn(list[index]);
      index++;
    }
    return willReturn;
  }
  function mapObject(fn, obj) {
    let index = 0;
    const keys2 = _keys(obj);
    const len = keys2.length;
    const willReturn = {};
    while (index < len) {
      const key = keys2[index];
      willReturn[key] = fn(obj[key], key, obj);
      index++;
    }
    return willReturn;
  }
  function map(fn, list) {
    if (arguments.length === 1)
      return (_list) => map(fn, _list);
    if (list === void 0)
      return [];
    if (_isArray(list))
      return mapArray(fn, list);
    return mapObject(fn, list);
  }
  function reduceFn(reducer, acc, list) {
    if (!_isArray(list)) {
      throw new TypeError("reduce: list must be array or iterable");
    }
    let index = 0;
    const len = list.length;
    while (index < len) {
      acc = reducer(acc, list[index], index, list);
      index++;
    }
    return acc;
  }
  var reduce = curry(reduceFn);
  function isFalsy(input) {
    return input === void 0 || input === null || Number.isNaN(input) === true;
  }
  function defaultTo(defaultArgument, input) {
    if (arguments.length === 1) {
      return (_input) => defaultTo(defaultArgument, _input);
    }
    return isFalsy(input) ? defaultArgument : input;
  }
  function type(input) {
    const typeOf = typeof input;
    if (input === null) {
      return "Null";
    } else if (input === void 0) {
      return "Undefined";
    } else if (typeOf === "boolean") {
      return "Boolean";
    } else if (typeOf === "number") {
      return Number.isNaN(input) ? "NaN" : "Number";
    } else if (typeOf === "string") {
      return "String";
    } else if (_isArray(input)) {
      return "Array";
    } else if (typeOf === "symbol") {
      return "Symbol";
    } else if (input instanceof RegExp) {
      return "RegExp";
    }
    const asStr = input && input.toString ? input.toString() : "";
    if (["true", "false"].includes(asStr))
      return "Boolean";
    if (!Number.isNaN(Number(asStr)))
      return "Number";
    if (asStr.startsWith("async"))
      return "Async";
    if (asStr === "[object Promise]")
      return "Promise";
    if (typeOf === "function")
      return "Function";
    if (input instanceof String)
      return "String";
    return "Object";
  }
  function parseError(maybeError) {
    const typeofError = maybeError.__proto__.toString();
    if (!["Error", "TypeError"].includes(typeofError))
      return [];
    return [typeofError, maybeError.message];
  }
  function parseDate(maybeDate) {
    if (!maybeDate.toDateString)
      return [false];
    return [true, maybeDate.getTime()];
  }
  function parseRegex(maybeRegex) {
    if (maybeRegex.constructor !== RegExp)
      return [false];
    return [true, maybeRegex.toString()];
  }
  function equals(a, b) {
    if (arguments.length === 1)
      return (_b) => equals(a, _b);
    const aType = type(a);
    if (aType !== type(b))
      return false;
    if (aType === "Function") {
      return a.name === void 0 ? false : a.name === b.name;
    }
    if (["NaN", "Undefined", "Null"].includes(aType))
      return true;
    if (aType === "Number") {
      if (Object.is(-0, a) !== Object.is(-0, b))
        return false;
      return a.toString() === b.toString();
    }
    if (["String", "Boolean"].includes(aType)) {
      return a.toString() === b.toString();
    }
    if (aType === "Array") {
      const aClone = Array.from(a);
      const bClone = Array.from(b);
      if (aClone.toString() !== bClone.toString()) {
        return false;
      }
      let loopArrayFlag = true;
      aClone.forEach((aCloneInstance, aCloneIndex) => {
        if (loopArrayFlag) {
          if (aCloneInstance !== bClone[aCloneIndex] && !equals(aCloneInstance, bClone[aCloneIndex])) {
            loopArrayFlag = false;
          }
        }
      });
      return loopArrayFlag;
    }
    const aRegex = parseRegex(a);
    const bRegex = parseRegex(b);
    if (aRegex[0]) {
      return bRegex[0] ? aRegex[1] === bRegex[1] : false;
    } else if (bRegex[0])
      return false;
    const aDate = parseDate(a);
    const bDate = parseDate(b);
    if (aDate[0]) {
      return bDate[0] ? aDate[1] === bDate[1] : false;
    } else if (bDate[0])
      return false;
    const aError = parseError(a);
    const bError = parseError(b);
    if (aError[0]) {
      return bError[0] ? aError[0] === bError[0] && aError[1] === bError[1] : false;
    }
    if (aType === "Object") {
      const aKeys = Object.keys(a);
      if (aKeys.length !== Object.keys(b).length) {
        return false;
      }
      let loopObjectFlag = true;
      aKeys.forEach((aKeyInstance) => {
        if (loopObjectFlag) {
          const aValue = a[aKeyInstance];
          const bValue = b[aKeyInstance];
          if (aValue !== bValue && !equals(aValue, bValue)) {
            loopObjectFlag = false;
          }
        }
      });
      return loopObjectFlag;
    }
    return false;
  }
  function eqPropsFn(prop, obj1, obj2) {
    if (!obj1 || !obj2) {
      throw new Error("wrong object inputs are passed to R.eqProps");
    }
    return equals(obj1[prop], obj2[prop]);
  }
  var eqProps = curry(eqPropsFn);
  function filterObject(fn, obj) {
    const willReturn = {};
    for (const prop in obj) {
      if (fn(obj[prop], prop, obj)) {
        willReturn[prop] = obj[prop];
      }
    }
    return willReturn;
  }
  function filterArray(predicate, list, indexed = false) {
    let index = 0;
    const len = list.length;
    const willReturn = [];
    while (index < len) {
      const predicateResult = indexed ? predicate(list[index], index) : predicate(list[index]);
      if (predicateResult) {
        willReturn.push(list[index]);
      }
      index++;
    }
    return willReturn;
  }
  function filter(predicate, iterable) {
    if (arguments.length === 1) {
      return (_iterable) => filter(predicate, _iterable);
    }
    if (!iterable)
      return [];
    if (_isArray(iterable))
      return filterArray(predicate, iterable);
    return filterObject(predicate, iterable);
  }
  function path(pathInput, obj) {
    if (arguments.length === 1)
      return (_obj) => path(pathInput, _obj);
    if (obj === null || obj === void 0) {
      return void 0;
    }
    let willReturn = obj;
    let counter = 0;
    const pathArrValue = typeof pathInput === "string" ? pathInput.split(".") : pathInput;
    while (counter < pathArrValue.length) {
      if (willReturn === null || willReturn === void 0) {
        return void 0;
      }
      willReturn = willReturn[pathArrValue[counter]];
      counter++;
    }
    return willReturn;
  }
  function ifElseFn(condition, onTrue, onFalse) {
    return (...input) => {
      const conditionResult = typeof condition === "boolean" ? condition : condition(...input);
      if (conditionResult === true) {
        return onTrue(...input);
      }
      return onFalse(...input);
    };
  }
  var ifElse = curry(ifElseFn);
  function baseSlice(array, start, end) {
    let index = -1;
    let {
      length
    } = array;
    end = end > length ? length : end;
    if (end < 0) {
      end += length;
    }
    length = start > end ? 0 : end - start >>> 0;
    start >>>= 0;
    const result = Array(length);
    while (++index < length) {
      result[index] = array[index + start];
    }
    return result;
  }
  function is(targetPrototype, x) {
    if (arguments.length === 1)
      return (_x) => is(targetPrototype, _x);
    return x != null && x.constructor === targetPrototype || x instanceof targetPrototype;
  }
  function keys(x) {
    return Object.keys(x);
  }
  function updateFn(index, newValue, list) {
    const arrClone = list.slice();
    return arrClone.fill(newValue, index, index + 1);
  }
  var update = curry(updateFn);
  function maxByFn(compareFn, x, y) {
    return compareFn(y) > compareFn(x) ? y : x;
  }
  var maxBy = curry(maxByFn);
  function minByFn(compareFn, x, y) {
    return compareFn(y) < compareFn(x) ? y : x;
  }
  var minBy = curry(minByFn);
  function moveFn(fromIndex, toIndex, list) {
    if (fromIndex < 0 || toIndex < 0) {
      throw new Error("Rambda.move does not support negative indexes");
    }
    if (fromIndex > list.length - 1 || toIndex > list.length - 1)
      return list;
    const clone = list.slice();
    clone[fromIndex] = list[toIndex];
    clone[toIndex] = list[fromIndex];
    return clone;
  }
  var move = curry(moveFn);
  function multiply(x, y) {
    if (arguments.length === 1)
      return (_y) => multiply(x, _y);
    return x * y;
  }
  var Identity = (x) => ({
    x,
    map: (fn) => Identity(fn(x))
  });
  function overFn(lens, fn, object) {
    return lens((x) => Identity(fn(x)))(object).x;
  }
  var over = curry(overFn);
  function pathEqFn(pathToSearch, target, input) {
    return equals(path(pathToSearch, input), target);
  }
  var pathEq = curry(pathEqFn);
  function pathOrFn(defaultValue, list, obj) {
    return defaultTo(defaultValue, path(list, obj));
  }
  var pathOr = curry(pathOrFn);
  function pipe(...fns) {
    if (fns.length === 0)
      throw new Error("pipe requires at least one argument");
    return (...args) => {
      const list = fns.slice();
      if (list.length > 0) {
        const fn = list.shift();
        let result = fn(...args);
        while (list.length > 0) {
          result = list.shift()(result);
        }
        return result;
      }
    };
  }
  var product = reduce(multiply, 1);
  function propEqFn(propToFind, valueToMatch, obj) {
    if (!obj)
      return false;
    return obj[propToFind] === valueToMatch;
  }
  var propEq = curry(propEqFn);
  function propIsFn(targetPrototype, property, obj) {
    return is(targetPrototype, obj[property]);
  }
  var propIs = curry(propIsFn);
  function propOrFn(defaultValue, property, obj) {
    if (!obj)
      return defaultValue;
    return defaultTo(defaultValue, obj[property]);
  }
  var propOr = curry(propOrFn);
  function reject(predicate, list) {
    if (arguments.length === 1)
      return (_list) => reject(predicate, _list);
    return filter((x) => !predicate(x), list);
  }
  function replaceFn(pattern, replacer, str) {
    return str.replace(pattern, replacer);
  }
  var replace = curry(replaceFn);
  function setFn(lens, replacer, x) {
    return over(lens, always(replacer), x);
  }
  var set = curry(setFn);
  function sliceFn(from, to, list) {
    return list.slice(from, to);
  }
  var slice = curry(sliceFn);
  function take(howMany, listOrString) {
    if (arguments.length === 1)
      return (_listOrString) => take(howMany, _listOrString);
    if (howMany < 0)
      return listOrString.slice();
    if (typeof listOrString === "string")
      return listOrString.slice(0, howMany);
    return baseSlice(listOrString, 0, howMany);
  }
  function whenFn(predicate, whenTrueFn, input) {
    if (!predicate(input))
      return input;
    return whenTrueFn(input);
  }
  var when = curry(whenFn);
  function zipWithFn(fn, x, y) {
    return take(x.length > y.length ? y.length : x.length, x).map((xInstance, i) => fn(xInstance, y[i]));
  }
  var zipWith = curry(zipWithFn);

  // src/lib/number.mod.ts
  Number.prototype.mod = function(n) {
    return knuth_mod(this, n);
  };
  function knuth_mod(dividend, divisor) {
    return dividend - divisor * Math.floor(dividend / divisor);
  }

  // src/lib/nearley_utils.ts
  var nearley = __toModule(require_nearley());
  var Parser2 = class {
    constructor(grammar2) {
      this.parser = new nearley.Parser(nearley.Grammar.fromCompiled(grammar2));
      this.initial_state = this.parser.save();
    }
    feedUntilError(input) {
      let lastResult;
      let consumedIndex = 0;
      try {
        for (const val of input) {
          this.parser.feed(val);
          lastResult = this.parser.results[0];
          consumedIndex++;
        }
      } finally {
        this.reset();
        if (lastResult === void 0) {
          throw new Error("Error: no result!");
        } else {
          return [lastResult, input.slice(consumedIndex)];
        }
      }
    }
    reset() {
      this.parser.restore(this.initial_state);
    }
  };

  // src/grammars/.bracketexpr.generated.ts
  function id(d) {
    return d[0];
  }
  var grammar = {
    Lexer: void 0,
    ParserRules: [
      { "name": "BracketExpr", "symbols": [{ "literal": "<" }, "Modifier", "ModKey", { "literal": ">" }], "postprocess": (bexpr) => bexpr.slice(1, -1) },
      { "name": "BracketExpr", "symbols": [{ "literal": "<" }, "Key", { "literal": ">" }], "postprocess": (bexpr) => [{}].concat(bexpr.slice(1, -1)) },
      { "name": "Modifier$ebnf$1", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$1", "symbols": [], "postprocess": () => null },
      { "name": "Modifier$ebnf$2", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$2", "symbols": [], "postprocess": () => null },
      { "name": "Modifier$ebnf$3", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$3", "symbols": [], "postprocess": () => null },
      { "name": "Modifier$ebnf$4", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$4", "symbols": [], "postprocess": () => null },
      {
        "name": "Modifier",
        "symbols": ["Modifier$ebnf$1", "Modifier$ebnf$2", "Modifier$ebnf$3", "Modifier$ebnf$4", { "literal": "-" }],
        "postprocess": (mods, _, reject2) => {
          const longNames = new Map([
            ["A", "altKey"],
            ["C", "ctrlKey"],
            ["M", "metaKey"],
            ["S", "shiftKey"]
          ]);
          let modifiersObj = {};
          for (let mod of mods) {
            if (mod === null || mod === "-")
              continue;
            let longName = longNames.get(mod.toUpperCase());
            if (longName) {
              if (longName in modifiersObj)
                return reject2;
              else
                modifiersObj[longName] = true;
            }
          }
          return modifiersObj;
        }
      },
      { "name": "ModKey", "symbols": [{ "literal": "<" }], "postprocess": id },
      { "name": "ModKey", "symbols": [{ "literal": ">" }], "postprocess": id },
      { "name": "ModKey", "symbols": [{ "literal": "-" }], "postprocess": id },
      { "name": "ModKey", "symbols": ["Key"], "postprocess": id },
      { "name": "Key$ebnf$1", "symbols": [/[^\s<>-]/] },
      { "name": "Key$ebnf$1", "symbols": ["Key$ebnf$1", /[^\s<>-]/], "postprocess": (d) => d[0].concat([d[1]]) },
      { "name": "Key", "symbols": ["Key$ebnf$1"], "postprocess": (key) => key[0].join("") }
    ],
    ParserStart: "BracketExpr"
  };
  var bracketexpr_generated_default = grammar;

  // src/lib/keyseq.ts
  var bracketexpr_grammar = bracketexpr_generated_default;
  var bracketexpr_parser = new Parser2(bracketexpr_grammar);
  var KEYMAP_CACHE = {};
  browser.storage.onChanged.addListener((changes) => {
    if ("userconfig" in changes) {
      KEYMAP_CACHE = {};
    }
  });

  // src/lib/binding.ts
  var mode2maps = new Map([
    ["normal", "nmaps"],
    ["ignore", "ignoremaps"],
    ["insert", "imaps"],
    ["input", "inputmaps"],
    ["ex", "exmaps"],
    ["hint", "hintmaps"],
    ["visual", "vmaps"],
    ["browser", "browsermaps"]
  ]);
  var maps2mode = new Map(Array.from(mode2maps.keys()).map((k) => [mode2maps.get(k), k]));
  var modes = Array.from(mode2maps.keys());
  var modeMaps = Array.from(maps2mode.keys());

  // src/lib/platform.ts
  function getPlatformOs() {
    const platform2 = navigator.platform;
    const mapping = {
      win: "Win",
      openbsd: "BSD",
      mac: "Mac",
      linux: "Linux"
    };
    return keys(filter((x) => platform2.includes(x), mapping))[0];
  }

  // src/lib/config.ts
  var removeNull = when(is(Object), pipe(reject((val) => val === null), map((a) => removeNull(a))));
  var CONFIGNAME = "userconfig";
  var WAITERS = [];
  var INITIALISED = false;
  function o(object) {
    return Object.assign(Object.create(null), object);
  }
  function schlepp(settings) {
    Object.assign(USERCONFIG, settings);
  }
  var USERCONFIG = o({});
  var default_config = class {
    constructor() {
      this.configversion = "0.0";
      this.subconfigs = {
        "www.google.com": {
          followpagepatterns: {
            next: "Next",
            prev: "Previous"
          }
        },
        "^https://web.whatsapp.com": {
          nmaps: {
            f: "hint -c [tabindex]:not(.two)>div,a",
            F: "hint -bc [tabindex]:not(.two)>div,a"
          }
        }
      };
      this.priority = 0;
      this.exmaps = {
        "<Enter>": "ex.accept_line",
        "<C-Enter>": "ex.execute_ex_on_completion",
        "<C-j>": "ex.accept_line",
        "<C-m>": "ex.accept_line",
        "<Escape>": "ex.hide_and_clear",
        "<C-[>": "ex.hide_and_clear",
        "<ArrowUp>": "ex.prev_history",
        "<ArrowDown>": "ex.next_history",
        "<S-Del>": "ex.execute_ex_on_completion_args tabclose",
        "<A-b>": "text.backward_word",
        "<A-f>": "text.forward_word",
        "<C-e>": "text.end_of_line",
        "<A-d>": "text.kill_word",
        "<S-Backspace>": "text.backward_kill_word",
        "<C-u>": "text.backward_kill_line",
        "<C-k>": "text.kill_line",
        "<C-f>": "ex.complete",
        "<Tab>": "ex.next_completion",
        "<S-Tab>": "ex.prev_completion",
        "<Space>": "ex.insert_space_or_completion",
        "<C-o>yy": "ex.execute_ex_on_completion_args clipboard yank"
      };
      this.ignoremaps = {
        "<S-Insert>": "mode normal",
        "<AC-Escape>": "mode normal",
        "<AC-`>": "mode normal",
        "<S-Escape>": "mode normal",
        "<C-o>": "nmode normal 1 mode ignore"
      };
      this.imaps = {
        "<Escape>": "composite unfocus | mode normal",
        "<C-[>": "composite unfocus | mode normal",
        "<C-i>": "editor",
        "<AC-Escape>": "mode normal",
        "<AC-`>": "mode normal",
        "<S-Escape>": "mode ignore"
      };
      this.inputmaps = {
        "<Tab>": "focusinput -n",
        "<S-Tab>": "focusinput -N",
        "\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}": "imaps"
      };
      this.nmaps = {
        "<A-p>": "pin",
        "<A-m>": "mute toggle",
        "<F1>": "help",
        o: "fillcmdline open",
        O: "current_url open",
        w: "fillcmdline winopen",
        W: "current_url winopen",
        t: "fillcmdline tabopen",
        "]]": "followpage next",
        "[[": "followpage prev",
        "[c": "urlincrement -1",
        "]c": "urlincrement 1",
        "<C-x>": "urlincrement -1",
        "<C-a>": "urlincrement 1",
        T: "current_url tabopen",
        yy: "clipboard yank",
        ys: "clipboard yankshort",
        yc: "clipboard yankcanon",
        ym: "clipboard yankmd",
        yo: "clipboard yankorg",
        yt: "clipboard yanktitle",
        gh: "home",
        gH: "home true",
        p: "clipboard open",
        P: "clipboard tabopen",
        j: "scrollline 10",
        "<C-e>": "scrollline 10",
        k: "scrollline -10",
        "<C-y>": "scrollline -10",
        h: "scrollpx -50",
        l: "scrollpx 50",
        G: "scrollto 100",
        gg: "scrollto 0",
        "<C-u>": "scrollpage -0.5",
        "<C-d>": "scrollpage 0.5",
        "<C-f>": "scrollpage 1",
        "<C-b>": "scrollpage -1",
        "<C-v>": "nmode ignore 1 mode normal",
        $: "scrollto 100 x",
        "^": "scrollto 0 x",
        H: "back",
        L: "forward",
        "<C-o>": "jumpprev",
        "<C-i>": "jumpnext",
        d: "tabclose",
        D: "composite tabprev; tabclose #",
        gx0: "tabclosealltoleft",
        gx$: "tabclosealltoright",
        "<<": "tabmove -1",
        ">>": "tabmove +1",
        u: "undo",
        U: "undo window",
        r: "reload",
        R: "reloadhard",
        x: "stop",
        gi: "focusinput -l",
        "g?": "rot13",
        "g!": "jumble",
        "g;": "changelistjump -1",
        J: "tabprev",
        K: "tabnext",
        gt: "tabnext_gt",
        gT: "tabprev",
        "g^": "tabfirst",
        g0: "tabfirst",
        g$: "tablast",
        ga: "tabaudio",
        gr: "reader",
        gu: "urlparent",
        gU: "urlroot",
        gf: "viewsource",
        ":": "fillcmdline_notrail",
        s: "fillcmdline open search",
        S: "fillcmdline tabopen search",
        M: "gobble 1 quickmark",
        B: "fillcmdline taball",
        b: "fillcmdline tab",
        ZZ: "qall",
        f: "hint",
        F: "hint -b",
        gF: "hint -qb",
        ";i": "hint -i",
        ";b": "hint -b",
        ";o": "hint",
        ";I": "hint -I",
        ";k": "hint -k",
        ";K": "hint -K",
        ";y": "hint -y",
        ";Y": "hint -cF img i => tri.excmds.yankimage(tri.urlutils.getAbsoluteURL(i.src))",
        ";p": "hint -p",
        ";h": "hint -h",
        v: "hint -h",
        ";P": "hint -P",
        ";r": "hint -r",
        ";s": "hint -s",
        ";S": "hint -S",
        ";a": "hint -a",
        ";A": "hint -A",
        ";;": "hint -; *",
        ";#": "hint -#",
        ";v": "hint -W mpvsafe",
        ";V": "hint -V",
        ";w": "hint -w",
        ";t": "hint -W tabopen",
        ";O": "hint -W fillcmdline_notrail open ",
        ";W": "hint -W fillcmdline_notrail winopen ",
        ";T": "hint -W fillcmdline_notrail tabopen ",
        ";z": "hint -z",
        ";m": "composite hint -Jpipe img src | open images.google.com/searchbyimage?image_url=",
        ";M": "composite hint -Jpipe img src | tabopen images.google.com/searchbyimage?image_url=",
        ";gi": "hint -qi",
        ";gI": "hint -qI",
        ";gk": "hint -qk",
        ";gy": "hint -qy",
        ";gp": "hint -qp",
        ";gP": "hint -qP",
        ";gr": "hint -qr",
        ";gs": "hint -qs",
        ";gS": "hint -qS",
        ";ga": "hint -qa",
        ";gA": "hint -qA",
        ";g;": "hint -q;",
        ";g#": "hint -q#",
        ";gv": "hint -qW mpvsafe",
        ";gw": "hint -qw",
        ";gb": "hint -qb",
        ";gF": "hint -qb",
        ";gf": "hint -q",
        "<S-Insert>": "mode ignore",
        "<AC-Escape>": "mode ignore",
        "<AC-`>": "mode ignore",
        "<S-Escape>": "mode ignore",
        "<Escape>": "composite mode normal ; hidecmdline",
        "<C-[>": "composite mode normal ; hidecmdline",
        a: "current_url bmark",
        A: "bmark",
        zi: "zoom 0.1 true",
        zo: "zoom -0.1 true",
        zm: "zoom 0.5 true",
        zr: "zoom -0.5 true",
        zM: "zoom 0.5 true",
        zR: "zoom -0.5 true",
        zz: "zoom 1",
        zI: "zoom 3",
        zO: "zoom 0.3",
        ".": "repeat",
        "<AS-ArrowUp><AS-ArrowUp><AS-ArrowDown><AS-ArrowDown><AS-ArrowLeft><AS-ArrowRight><AS-ArrowLeft><AS-ArrowRight>ba": "open https://www.youtube.com/watch?v=M3iOROuTuMA"
      };
      this.vmaps = {
        "<Escape>": "composite js document.getSelection().empty(); mode normal; hidecmdline",
        "<C-[>": "composite js document.getSelection().empty(); mode normal ; hidecmdline",
        y: "composite js document.getSelection().toString() | clipboard yank",
        s: "composite js document.getSelection().toString() | fillcmdline open search",
        S: "composite js document.getSelection().toString() | fillcmdline tabopen search",
        l: 'js document.getSelection().modify("extend","forward","character")',
        h: 'js document.getSelection().modify("extend","backward","character")',
        e: 'js document.getSelection().modify("extend","forward","word")',
        w: 'js document.getSelection().modify("extend","forward","word"); document.getSelection().modify("extend","forward","word"); document.getSelection().modify("extend","backward","word"); document.getSelection().modify("extend","forward","character")',
        b: 'js document.getSelection().modify("extend","backward","character"); document.getSelection().modify("extend","backward","word"); document.getSelection().modify("extend","forward","character")',
        j: 'js document.getSelection().modify("extend","forward","line")',
        k: 'js document.getSelection().modify("extend","backward","line")',
        $: 'js document.getSelection().modify("extend","forward","lineboundary")',
        "0": 'js document.getSelection().modify("extend","backward","lineboundary")',
        "=": "js let n = document.getSelection().anchorNode.parentNode; let s = window.getSelection(); let r = document.createRange(); s.removeAllRanges(); r.selectNodeContents(n); s.addRange(r)",
        o: "js tri.visual.reverseSelection(document.getSelection())",
        "\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}": "nmaps"
      };
      this.hintmaps = {
        "<Backspace>": "hint.popKey",
        "<Escape>": "hint.reset",
        "<C-[>": "hint.reset",
        "<Tab>": "hint.focusNextHint",
        "<S-Tab>": "hint.focusPreviousHint",
        "<ArrowUp>": "hint.focusTopHint",
        "<ArrowDown>": "hint.focusBottomHint",
        "<ArrowLeft>": "hint.focusLeftHint",
        "<ArrowRight>": "hint.focusRightHint",
        "<Enter>": "hint.selectFocusedHint",
        "<Space>": "hint.selectFocusedHint"
      };
      this.browsermaps = {
        "<C-,>": "escapehatch",
        "<C-6>": "tab #",
        "<CS-6>": "tab #"
      };
      this.leavegithubalone = "false";
      this.blacklistkeys = ["/"];
      this.autocmds = {
        DocStart: {},
        DocLoad: {
          "^https://github.com/tridactyl/tridactyl/issues/new$": "issue"
        },
        DocEnd: {},
        TriStart: {
          ".*": "source_quiet"
        },
        TabEnter: {},
        TabLeft: {},
        FullscreenChange: {},
        FullscreenEnter: {},
        FullscreenLeft: {}
      };
      this.keytranslatemap = {};
      this.keytranslatemodes = {
        nmaps: "true",
        imaps: "false",
        inputmaps: "false",
        ignoremaps: "false",
        exmaps: "false",
        hintmaps: "false"
      };
      this.autocontain = o({});
      this.autocontainmode = "strict";
      this.exaliases = {
        alias: "command",
        au: "autocmd",
        aucon: "autocontain",
        audel: "autocmddelete",
        audelete: "autocmddelete",
        blacklistremove: "autocmddelete DocStart",
        b: "tab",
        clsh: "clearsearchhighlight",
        nohlsearch: "clearsearchhighlight",
        noh: "clearsearchhighlight",
        o: "open",
        w: "winopen",
        t: "tabopen",
        tabnew: "tabopen",
        tabm: "tabmove",
        tabo: "tabonly",
        tn: "tabnext_gt",
        bn: "tabnext_gt",
        tnext: "tabnext_gt",
        bnext: "tabnext_gt",
        tp: "tabprev",
        tN: "tabprev",
        bp: "tabprev",
        bN: "tabprev",
        tprev: "tabprev",
        bprev: "tabprev",
        tabfirst: "tab 1",
        tablast: "tab 0",
        bfirst: "tabfirst",
        blast: "tablast",
        tfirst: "tabfirst",
        tlast: "tablast",
        buffer: "tab",
        bufferall: "taball",
        bd: "tabclose",
        bdelete: "tabclose",
        quit: "tabclose",
        q: "tabclose",
        qa: "qall",
        sanitize: "sanitise",
        "saveas!": "saveas --cleanup --overwrite",
        tutorial: "tutor",
        h: "help",
        unmute: "mute unmute",
        authors: "credits",
        openwith: "hint -W",
        "!": "exclaim",
        "!s": "exclaim_quiet",
        containerremove: "containerdelete",
        colours: "colourscheme",
        colorscheme: "colourscheme",
        colors: "colourscheme",
        man: "help",
        "!js": "fillcmdline_tmp 3000 !js is deprecated. Please use js instead",
        "!jsb": "fillcmdline_tmp 3000 !jsb is deprecated. Please use jsb instead",
        get_current_url: "js document.location.href",
        current_url: "composite get_current_url | fillcmdline_notrail ",
        stop: "js window.stop()",
        zo: "zoom",
        installnative: "nativeinstall",
        nativeupdate: "updatenative",
        mkt: "mktridactylrc",
        "mkt!": "mktridactylrc -f",
        "mktridactylrc!": "mktridactylrc -f",
        mpvsafe: "js -p tri.excmds.shellescape(JS_ARG).then(url => tri.excmds.exclaim_quiet('mpv --no-terminal ' + url))",
        drawingstop: "no_mouse_mode",
        exto: "extoptions",
        extpreferences: "extoptions",
        extp: "extpreferences",
        prefset: "setpref",
        prefremove: "removepref",
        tabclosealltoright: "tabcloseallto right",
        tabclosealltoleft: "tabcloseallto left",
        reibadailty: "jumble"
      };
      this.followpagepatterns = {
        next: "^(next|newer)\\b|\xBB|>>|more",
        prev: "^(prev(ious)?|older)\\b|\xAB|<<"
      };
      this.searchengine = "";
      this.searchurls = {
        google: "https://www.google.com/search?q=",
        googlelucky: "https://www.google.com/search?btnI=I'm+Feeling+Lucky&q=",
        scholar: "https://scholar.google.com/scholar?q=",
        googleuk: "https://www.google.co.uk/search?q=",
        bing: "https://www.bing.com/search?q=",
        duckduckgo: "https://duckduckgo.com/?q=",
        yahoo: "https://search.yahoo.com/search?p=",
        twitter: "https://twitter.com/search?q=",
        wikipedia: "https://en.wikipedia.org/wiki/Special:Search/",
        youtube: "https://www.youtube.com/results?search_query=",
        amazon: "https://www.amazon.com/s/ref=nb_sb_noss?url=search-alias%3Daps&field-keywords=",
        amazonuk: "https://www.amazon.co.uk/s/ref=nb_sb_noss?url=search-alias%3Daps&field-keywords=",
        startpage: "https://startpage.com/do/search?language=english&cat=web&query=",
        github: "https://github.com/search?utf8=\u2713&q=",
        searx: "https://searx.me/?category_general=on&q=",
        cnrtl: "http://www.cnrtl.fr/lexicographie/",
        osm: "https://www.openstreetmap.org/search?query=",
        mdn: "https://developer.mozilla.org/en-US/search?q=",
        gentoo_wiki: "https://wiki.gentoo.org/index.php?title=Special%3ASearch&profile=default&fulltext=Search&search=",
        qwant: "https://www.qwant.com/?q="
      };
      this.newtab = "";
      this.viewsource = "tridactyl";
      this.homepages = [];
      this.hintchars = "hjklasdfgyuiopqwertnmzxcvb";
      this.hintfiltermode = "simple";
      this.hintnames = "short";
      this.hintuppercase = "true";
      this.hintdelay = 300;
      this.hintshift = "false";
      this.hintautoselect = "true";
      this.allowautofocus = "true";
      this.preventautofocusjackhammer = "false";
      this.smoothscroll = "false";
      this.scrollduration = 100;
      this.tabopenpos = "next";
      this.tabclosepinned = "true";
      this.tabsort = "default";
      this.relatedopenpos = "related";
      this.ttsvoice = "default";
      this.ttsvolume = 1;
      this.ttsrate = 1;
      this.ttspitch = 1;
      this.gimode = "nextinput";
      this.cursorpos = "end";
      this.theme = "default";
      this.customthemes = {};
      this.modeindicator = "true";
      this.modeindicatormodes = {
        normal: "true",
        insert: "true",
        input: "true",
        ignore: "true",
        ex: "true",
        hint: "true",
        visual: "true"
      };
      this.jumpdelay = 3e3;
      this.logging = {
        cmdline: "warning",
        containers: "warning",
        controller: "warning",
        excmd: "error",
        hinting: "warning",
        messaging: "warning",
        native: "warning",
        performance: "warning",
        state: "warning",
        styling: "warning",
        autocmds: "warning"
      };
      this.noiframe = "false";
      this.noiframeon = [];
      this.editorcmd = "auto";
      this.rsscmd = "yank %u";
      this.browser = "firefox";
      this.yankto = "clipboard";
      this.putfrom = "clipboard";
      this.externalclipboardcmd = "auto";
      this.downloadsskiphistory = "false";
      this.nativeinstallcmd = "curl -fsSl https://raw.githubusercontent.com/tridactyl/native_messenger/master/installers/install.sh -o /tmp/trinativeinstall.sh && sh /tmp/trinativeinstall.sh %TAG";
      this.update = {
        nag: true,
        nagwait: 7,
        lastnaggedversion: "1.14.0",
        lastchecktime: 0,
        checkintervalsecs: 60 * 60 * 24
      };
      this.profiledir = "auto";
      this.tabopencontaineraware = "false";
      this.containerindicator = "true";
      this.auconcreatecontainer = "true";
      this.historyresults = 50;
      this.bmarkweight = 100;
      this.completions = {
        Tab: {
          autoselect: "true"
        },
        TabAll: {
          autoselect: "true"
        },
        Rss: {
          autoselect: "true"
        },
        Bmark: {
          autoselect: "true"
        },
        Sessions: {
          autoselect: "true"
        }
      };
      this.findresults = -1;
      this.findcontextlen = 100;
      this.findcase = "smart";
      this.incsearch = "false";
      this.minincsearchlen = 3;
      this.csp = "untouched";
      this.wordpattern = "[^\\s]+";
      this.perfcounters = "false";
      this.perfsamples = "10000";
      this.modeindicatorshowkeys = "false";
      this.urlparenttrailingslash = "true";
      this.visualenterauto = "true";
      this.visualexitauto = "true";
      this.escapehatchsidebarhack = "true";
      this.completionfuzziness = 0.3;
    }
  };
  var platform_defaults = {
    win: {
      browsermaps: {
        "<C-6>": null,
        "<A-6>": "buffer #"
      },
      nmaps: {
        "<C-6>": "buffer #"
      },
      imaps: {
        "<C-6>": "buffer #"
      },
      inputmaps: {
        "<C-6>": "buffer #"
      },
      ignoremaps: {
        "<C-6>": "buffer #"
      },
      nativeinstallcmd: `powershell -ExecutionPolicy Bypass -NoProfile -Command "[Net.ServicePointManager]::SecurityProtocol = [Net.ServicePointManager]::SecurityProtocol -bor [Net.SecurityProtocolType]::Tls12;(New-Object System.Net.WebClient).DownloadFile('https://raw.githubusercontent.com/tridactyl/native_messenger/master/installers/windows.ps1', '%TEMP%/tridactyl_installnative.ps1');& '%TEMP%/tridactyl_installnative.ps1' -Tag %TAG;Remove-Item '%TEMP%/tridactyl_installnative.ps1'"`
    },
    linux: {
      nmaps: {
        ";x": 'hint -F e => { const pos = tri.dom.getAbsoluteCentre(e); tri.excmds.exclaim_quiet("xdotool mousemove --sync " + window.devicePixelRatio * pos.x + " " + window.devicePixelRatio * pos.y + "; xdotool click 1")}',
        ";X": 'hint -F e => { const pos = tri.dom.getAbsoluteCentre(e); tri.excmds.exclaim_quiet("xdotool mousemove --sync " + window.devicePixelRatio * pos.x + " " + window.devicePixelRatio * pos.y + "; xdotool keydown ctrl+shift; xdotool click 1; xdotool keyup ctrl+shift")}'
      }
    }
  };
  var mergeDeepCull = pipe(mergeDeep, removeNull);
  var DEFAULTS = mergeDeepCull(o(new default_config()), platform_defaults[getPlatformOs()]);
  function getDeepProperty(obj, target) {
    if (obj !== void 0 && obj !== null && target.length) {
      if (obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"] === void 0) {
        return getDeepProperty(obj[target[0]], target.slice(1));
      } else {
        return getDeepProperty(mergeDeepCull(get(obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"]), obj)[target[0]], target.slice(1));
      }
    } else {
      if (obj === void 0 || obj === null)
        return obj;
      if (obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"] !== void 0) {
        return mergeDeepCull(get(obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"]), obj);
      } else {
        return obj;
      }
    }
  }
  function mergeDeep(o1, o2) {
    if (o1 === null)
      return Object.assign({}, o2);
    const r = Array.isArray(o1) ? o1.slice() : Object.create(o1);
    Object.assign(r, o1, o2);
    if (o2 === void 0)
      return r;
    Object.keys(o1).filter((key) => typeof o1[key] === "object" && typeof o2[key] === "object").forEach((key) => r[key] == null ? null : Object.assign(r[key], mergeDeep(o1[key], o2[key])));
    return r;
  }
  function getURL(url, target) {
    function _getURL(conf, url2, target2) {
      if (!conf.subconfigs)
        return void 0;
      return Object.keys(conf.subconfigs).filter((k) => url2.match(k) && getDeepProperty(conf.subconfigs[k], target2) !== void 0).sort((k1, k2) => (conf.subconfigs[k1].priority || 10) - (conf.subconfigs[k2].priority || 10)).reduce((acc, curKey) => {
        const curVal = getDeepProperty(conf.subconfigs[curKey], target2);
        if (acc instanceof Object && curVal instanceof Object)
          return mergeDeep(acc, curVal);
        return curVal;
      }, void 0);
    }
    const user = _getURL(USERCONFIG, url, target);
    const deflt = _getURL(DEFAULTS, url, target);
    if (user === void 0 || user === null)
      return deflt;
    if (typeof user !== "object" || typeof deflt !== "object")
      return user;
    return mergeDeepCull(deflt, user);
  }
  function get(target_typed, ...target) {
    if (target_typed === void 0) {
      target = [];
    } else {
      target = [target_typed].concat(target);
    }
    let loc = window.location;
    if (window.tri && window.tri.contentLocation)
      loc = window.tri.contentLocation;
    const site = getURL(loc.href, target);
    const user = getDeepProperty(USERCONFIG, target);
    const defult = getDeepProperty(DEFAULTS, target);
    if (typeof defult === "object") {
      return mergeDeepCull(mergeDeepCull(defult, user), site);
    } else {
      if (site !== void 0) {
        return site;
      } else if (user !== void 0) {
        return user;
      } else {
        return defult;
      }
    }
  }
  async function getAsyncDynamic(...target) {
    return getAsync(target[0], ...target.slice(1));
  }
  async function getAsync(target_typed, ...target) {
    if (INITIALISED) {
      const browserconfig = await browser.storage.local.get(CONFIGNAME);
      USERCONFIG = browserconfig[CONFIGNAME] || o({});
      return get(target_typed, ...target);
    } else {
      return new Promise((resolve) => WAITERS.push(() => resolve(get(target_typed, ...target))));
    }
  }
  async function init() {
    const localConfig = await browser.storage.local.get(CONFIGNAME);
    schlepp(localConfig[CONFIGNAME]);
    INITIALISED = true;
    for (const waiter of WAITERS) {
      waiter();
    }
  }
  var changeListeners = new Map();
  function addChangeListener(name, listener) {
    let arr = changeListeners.get(name);
    if (!arr) {
      arr = [];
      changeListeners.set(name, arr);
    }
    arr.push(listener);
  }
  browser.storage.onChanged.addListener((changes, areaname) => {
    if (CONFIGNAME in changes) {
      let triggerChangeListeners = function(key, value = newValue[key]) {
        const arr = changeListeners.get(key);
        if (arr) {
          const v = old[key] === void 0 ? DEFAULTS[key] : old[key];
          arr.forEach((f) => f(v, value));
        }
      };
      const { newValue, oldValue } = changes[CONFIGNAME];
      const old = oldValue || {};
      if (areaname === "sync") {
      } else if (newValue !== void 0) {
        const unsetKeys = Object.keys(old).filter((k) => newValue[k] === void 0 && JSON.stringify(old[k]) !== JSON.stringify(DEFAULTS[k]));
        const changedKeys = Object.keys(newValue).filter((k) => JSON.stringify(old[k] !== void 0 ? old[k] : DEFAULTS[k]) !== JSON.stringify(newValue[k]));
        changedKeys.forEach((key) => USERCONFIG[key] = newValue[key]);
        unsetKeys.forEach((key) => delete USERCONFIG[key]);
        unsetKeys.forEach((key) => triggerChangeListeners(key, DEFAULTS[key]));
        changedKeys.forEach((key) => triggerChangeListeners(key));
      } else {
        USERCONFIG = o({});
        Object.keys(old).filter((key) => old[key] !== DEFAULTS[key]).forEach((key) => triggerChangeListeners(key));
      }
    }
  });
  init();

  // src/help.ts
  function initTridactylSettingElem(elem, kind) {
    let bindingNode = elem.getElementsByClassName(`Tridactyl${kind}`)[0];
    if (bindingNode) {
      Array.from(bindingNode.children).filter((e) => e.tagName === "SPAN").forEach((e) => e.parentNode.removeChild(e));
    } else {
      bindingNode = document.createElement("p");
      bindingNode.className = `TridactylSetting Tridactyl${kind}`;
      bindingNode.textContent = kind + ":\xA0";
      elem.insertBefore(bindingNode, elem.children[2]);
    }
    return bindingNode;
  }
  function getCommandElements() {
    return Array.from(document.querySelectorAll(".tsd-panel.tsd-member.tsd-kind-function.tsd-parent-kind-external-module")).reduce((all, elem) => {
      const fnName = Array.from(elem.children).find((e) => e.tagName === "H3");
      if (fnName)
        all[fnName.textContent] = elem;
      return all;
    }, {});
  }
  async function addSetting(settingName) {
    const commandElems = getCommandElements();
    delete commandElems.composite;
    const settingElems = Object.keys(commandElems).reduce((settingElems2, cmdName) => {
      settingElems2[cmdName] = initTridactylSettingElem(commandElems[cmdName], settingName);
      return settingElems2;
    }, {});
    const settings = await getAsyncDynamic(settingName);
    for (const setting of Object.keys(settings)) {
      let excmd = settings[setting].split(" ");
      excmd = ["composite", "fillcmdline", "current_url"].includes(excmd[0]) ? excmd[1] : excmd[0];
      while (settings[excmd]) {
        excmd = settings[excmd].split(" ");
        excmd = ["fillcmdline", "current_url"].includes(excmd[0]) ? excmd[1] : excmd[0];
      }
      if (settingElems[excmd]) {
        const settingSpan = document.createElement("span");
        settingSpan.innerText = setting;
        settingSpan.title = settings[setting];
        settingElems[excmd].appendChild(settingSpan);
        settingElems[excmd].appendChild(document.createTextNode(" "));
      }
    }
    Object.values(settingElems).filter((e) => !Array.from(e.children).find((c) => c.tagName === "SPAN")).forEach((e) => e.parentNode.removeChild(e));
  }
  async function onExcmdPageLoad() {
    browser.storage.onChanged.addListener((changes) => {
      if ("userconfig" in changes) {
        ;
        [...modeMaps, "exaliases"].forEach((kind) => {
          if (JSON.stringify(changes.userconfig.newValue[kind]) !== JSON.stringify(changes.userconfig.oldValue[kind]))
            addSetting(kind);
        });
      }
    });
    await Promise.all([...modeMaps, "exaliases"].map(addSetting));
    if (document.location.hash) {
      document.location.hash = document.location.hash;
    }
  }
  function addSettingInputs() {
    const inputClassName = " TridactylSettingInput ";
    const inputClassNameModified = inputClassName + " TridactylSettingInputModified ";
    const onKeyUp = async (ev) => {
      const input = ev.target;
      if (ev.key === "Enter") {
        ;
        window.tri.messaging.message("controller_background", "acceptExCmd", ["set " + input.name + " " + input.value]);
      } else {
        if (input.value === await getAsync(input.name.split("."))) {
          input.className = inputClassName;
        } else {
          input.className = inputClassNameModified;
        }
      }
    };
    return Promise.all(Array.from(document.querySelectorAll("a.tsd-anchor")).map(async (a) => {
      const section = a.parentNode;
      const settingName = a.name.split(".");
      const value = await getAsyncDynamic(...settingName);
      if (!value)
        return console.log("Failed to grab value of ", a);
      if (!["number", "boolean", "string"].includes(typeof value))
        return console.log("Not embedding value of ", a, value, " because not easily represented as string");
      const input = document.createElement("input");
      input.name = a.name;
      input.value = value;
      input.id = "TridactylSettingInput_" + input.name;
      input.className = inputClassName;
      input.addEventListener("keyup", onKeyUp);
      const div = document.createElement("div");
      div.appendChild(document.createTextNode("Current value:"));
      div.appendChild(input);
      section.appendChild(div);
      addChangeListener(input.name, (_, newValue) => {
        input.value = newValue;
        input.className = inputClassName;
      });
    })).then((_) => {
      if (document.location.hash) {
        document.location.hash = document.location.hash;
      }
    });
  }
  function addResetConfigButton() {
    const button = document.createElement("button");
    button.innerText = "Reset Tridactyl config";
    button.style.margin = "auto 50%";
    button.style.minWidth = "200pt";
    button.addEventListener("click", () => {
      const sentence = "sanitise tridactylsync tridactyllocal tridactylhistory";
      const p = prompt(`Please write '${sentence}' without quotes in the following input field if you really want to reset your Tridactyl config.`);
      if (p === sentence) {
        ;
        window.tri.messaging.message("controller_background", "acceptExCmd", [sentence]).then((_) => alert("Config reset!"));
      } else {
        alert(`Config not reset because '${p}' !== '${sentence}'`);
      }
    });
    document.querySelector("div.container.container-main").appendChild(button);
  }
  function onSettingsPageLoad() {
    addResetConfigButton();
    return addSettingInputs();
  }
  addEventListener("load", (() => {
    switch (document.location.pathname) {
      case "/static/docs/modules/_src_excmds_.html":
        return onExcmdPageLoad;
      case "/static/docs/classes/_src_lib_config_.default_config.html":
        return onSettingsPageLoad;
    }
    return () => {
    };
  })());
})();
//# sourceMappingURL=help.js.map
