(() => {
  var __create = Object.create;
  var __freeze = Object.freeze;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
  var __commonJS = (cb2, mod) => function __require() {
    return mod || (0, cb2[Object.keys(cb2)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __export = (target, all2) => {
    for (var name in all2)
      __defProp(target, name, { get: all2[name], enumerable: true });
  };
  var __reExport = (target, module, desc) => {
    if (module && typeof module === "object" || typeof module === "function") {
      for (let key of __getOwnPropNames(module))
        if (!__hasOwnProp.call(target, key) && key !== "default")
          __defProp(target, key, { get: () => module[key], enumerable: !(desc = __getOwnPropDesc(module, key)) || desc.enumerable });
    }
    return target;
  };
  var __toModule = (module) => {
    return __reExport(__markAsModule(__defProp(module != null ? __create(__getProtoOf(module)) : {}, "default", module && module.__esModule && "default" in module ? { get: () => module.default, enumerable: true } : { value: module, enumerable: true })), module);
  };
  var __template = (cooked, raw) => __freeze(__defProp(cooked, "raw", { value: __freeze(raw || cooked.slice()) }));

  // node_modules/nearley/lib/nearley.js
  var require_nearley = __commonJS({
    "node_modules/nearley/lib/nearley.js"(exports, module) {
      (function(root, factory) {
        if (typeof module === "object" && module.exports) {
          module.exports = factory();
        } else {
          root.nearley = factory();
        }
      })(exports, function() {
        function Rule(name, symbols, postprocess) {
          this.id = ++Rule.highestId;
          this.name = name;
          this.symbols = symbols;
          this.postprocess = postprocess;
          return this;
        }
        Rule.highestId = 0;
        Rule.prototype.toString = function(withCursorAt) {
          var symbolSequence = typeof withCursorAt === "undefined" ? this.symbols.map(getSymbolShortDisplay).join(" ") : this.symbols.slice(0, withCursorAt).map(getSymbolShortDisplay).join(" ") + " \u25CF " + this.symbols.slice(withCursorAt).map(getSymbolShortDisplay).join(" ");
          return this.name + " \u2192 " + symbolSequence;
        };
        function State6(rule, dot, reference, wantedBy) {
          this.rule = rule;
          this.dot = dot;
          this.reference = reference;
          this.data = [];
          this.wantedBy = wantedBy;
          this.isComplete = this.dot === rule.symbols.length;
        }
        State6.prototype.toString = function() {
          return "{" + this.rule.toString(this.dot) + "}, from: " + (this.reference || 0);
        };
        State6.prototype.nextState = function(child) {
          var state2 = new State6(this.rule, this.dot + 1, this.reference, this.wantedBy);
          state2.left = this;
          state2.right = child;
          if (state2.isComplete) {
            state2.data = state2.build();
            state2.right = void 0;
          }
          return state2;
        };
        State6.prototype.build = function() {
          var children = [];
          var node = this;
          do {
            children.push(node.right.data);
            node = node.left;
          } while (node.left);
          children.reverse();
          return children;
        };
        State6.prototype.finish = function() {
          if (this.rule.postprocess) {
            this.data = this.rule.postprocess(this.data, this.reference, Parser3.fail);
          }
        };
        function Column(grammar2, index) {
          this.grammar = grammar2;
          this.index = index;
          this.states = [];
          this.wants = {};
          this.scannable = [];
          this.completed = {};
        }
        Column.prototype.process = function(nextColumn) {
          var states = this.states;
          var wants = this.wants;
          var completed = this.completed;
          for (var w = 0; w < states.length; w++) {
            var state2 = states[w];
            if (state2.isComplete) {
              state2.finish();
              if (state2.data !== Parser3.fail) {
                var wantedBy = state2.wantedBy;
                for (var i = wantedBy.length; i--; ) {
                  var left = wantedBy[i];
                  this.complete(left, state2);
                }
                if (state2.reference === this.index) {
                  var exp = state2.rule.name;
                  (this.completed[exp] = this.completed[exp] || []).push(state2);
                }
              }
            } else {
              var exp = state2.rule.symbols[state2.dot];
              if (typeof exp !== "string") {
                this.scannable.push(state2);
                continue;
              }
              if (wants[exp]) {
                wants[exp].push(state2);
                if (completed.hasOwnProperty(exp)) {
                  var nulls = completed[exp];
                  for (var i = 0; i < nulls.length; i++) {
                    var right = nulls[i];
                    this.complete(state2, right);
                  }
                }
              } else {
                wants[exp] = [state2];
                this.predict(exp);
              }
            }
          }
        };
        Column.prototype.predict = function(exp) {
          var rules = this.grammar.byName[exp] || [];
          for (var i = 0; i < rules.length; i++) {
            var r = rules[i];
            var wantedBy = this.wants[exp];
            var s = new State6(r, 0, this.index, wantedBy);
            this.states.push(s);
          }
        };
        Column.prototype.complete = function(left, right) {
          var copy = left.nextState(right);
          this.states.push(copy);
        };
        function Grammar2(rules, start) {
          this.rules = rules;
          this.start = start || this.rules[0].name;
          var byName = this.byName = {};
          this.rules.forEach(function(rule) {
            if (!byName.hasOwnProperty(rule.name)) {
              byName[rule.name] = [];
            }
            byName[rule.name].push(rule);
          });
        }
        Grammar2.fromCompiled = function(rules, start) {
          var lexer = rules.Lexer;
          if (rules.ParserStart) {
            start = rules.ParserStart;
            rules = rules.ParserRules;
          }
          var rules = rules.map(function(r) {
            return new Rule(r.name, r.symbols, r.postprocess);
          });
          var g = new Grammar2(rules, start);
          g.lexer = lexer;
          return g;
        };
        function StreamLexer() {
          this.reset("");
        }
        StreamLexer.prototype.reset = function(data, state2) {
          this.buffer = data;
          this.index = 0;
          this.line = state2 ? state2.line : 1;
          this.lastLineBreak = state2 ? -state2.col : 0;
        };
        StreamLexer.prototype.next = function() {
          if (this.index < this.buffer.length) {
            var ch = this.buffer[this.index++];
            if (ch === "\n") {
              this.line += 1;
              this.lastLineBreak = this.index;
            }
            return { value: ch };
          }
        };
        StreamLexer.prototype.save = function() {
          return {
            line: this.line,
            col: this.index - this.lastLineBreak
          };
        };
        StreamLexer.prototype.formatError = function(token, message2) {
          var buffer = this.buffer;
          if (typeof buffer === "string") {
            var lines = buffer.split("\n").slice(Math.max(0, this.line - 5), this.line);
            var nextLineBreak = buffer.indexOf("\n", this.index);
            if (nextLineBreak === -1)
              nextLineBreak = buffer.length;
            var col = this.index - this.lastLineBreak;
            var lastLineDigits = String(this.line).length;
            message2 += " at line " + this.line + " col " + col + ":\n\n";
            message2 += lines.map(function(line, i) {
              return pad(this.line - lines.length + i + 1, lastLineDigits) + " " + line;
            }, this).join("\n");
            message2 += "\n" + pad("", lastLineDigits + col) + "^\n";
            return message2;
          } else {
            return message2 + " at index " + (this.index - 1);
          }
          function pad(n, length2) {
            var s = String(n);
            return Array(length2 - s.length + 1).join(" ") + s;
          }
        };
        function Parser3(rules, start, options) {
          if (rules instanceof Grammar2) {
            var grammar2 = rules;
            var options = start;
          } else {
            var grammar2 = Grammar2.fromCompiled(rules, start);
          }
          this.grammar = grammar2;
          this.options = {
            keepHistory: false,
            lexer: grammar2.lexer || new StreamLexer()
          };
          for (var key in options || {}) {
            this.options[key] = options[key];
          }
          this.lexer = this.options.lexer;
          this.lexerState = void 0;
          var column = new Column(grammar2, 0);
          var table = this.table = [column];
          column.wants[grammar2.start] = [];
          column.predict(grammar2.start);
          column.process();
          this.current = 0;
        }
        Parser3.fail = {};
        Parser3.prototype.feed = function(chunk) {
          var lexer = this.lexer;
          lexer.reset(chunk, this.lexerState);
          var token;
          while (true) {
            try {
              token = lexer.next();
              if (!token) {
                break;
              }
            } catch (e) {
              var nextColumn = new Column(this.grammar, this.current + 1);
              this.table.push(nextColumn);
              var err = new Error(this.reportLexerError(e));
              err.offset = this.current;
              err.token = e.token;
              throw err;
            }
            var column = this.table[this.current];
            if (!this.options.keepHistory) {
              delete this.table[this.current - 1];
            }
            var n = this.current + 1;
            var nextColumn = new Column(this.grammar, n);
            this.table.push(nextColumn);
            var literal = token.text !== void 0 ? token.text : token.value;
            var value = lexer.constructor === StreamLexer ? token.value : token;
            var scannable = column.scannable;
            for (var w = scannable.length; w--; ) {
              var state2 = scannable[w];
              var expect = state2.rule.symbols[state2.dot];
              if (expect.test ? expect.test(value) : expect.type ? expect.type === token.type : expect.literal === literal) {
                var next = state2.nextState({ data: value, token, isToken: true, reference: n - 1 });
                nextColumn.states.push(next);
              }
            }
            nextColumn.process();
            if (nextColumn.states.length === 0) {
              var err = new Error(this.reportError(token));
              err.offset = this.current;
              err.token = token;
              throw err;
            }
            if (this.options.keepHistory) {
              column.lexerState = lexer.save();
            }
            this.current++;
          }
          if (column) {
            this.lexerState = lexer.save();
          }
          this.results = this.finish();
          return this;
        };
        Parser3.prototype.reportLexerError = function(lexerError) {
          var tokenDisplay, lexerMessage;
          var token = lexerError.token;
          if (token) {
            tokenDisplay = "input " + JSON.stringify(token.text[0]) + " (lexer error)";
            lexerMessage = this.lexer.formatError(token, "Syntax error");
          } else {
            tokenDisplay = "input (lexer error)";
            lexerMessage = lexerError.message;
          }
          return this.reportErrorCommon(lexerMessage, tokenDisplay);
        };
        Parser3.prototype.reportError = function(token) {
          var tokenDisplay = (token.type ? token.type + " token: " : "") + JSON.stringify(token.value !== void 0 ? token.value : token);
          var lexerMessage = this.lexer.formatError(token, "Syntax error");
          return this.reportErrorCommon(lexerMessage, tokenDisplay);
        };
        Parser3.prototype.reportErrorCommon = function(lexerMessage, tokenDisplay) {
          var lines = [];
          lines.push(lexerMessage);
          var lastColumnIndex = this.table.length - 2;
          var lastColumn = this.table[lastColumnIndex];
          var expectantStates = lastColumn.states.filter(function(state2) {
            var nextSymbol = state2.rule.symbols[state2.dot];
            return nextSymbol && typeof nextSymbol !== "string";
          });
          if (expectantStates.length === 0) {
            lines.push("Unexpected " + tokenDisplay + ". I did not expect any more input. Here is the state of my parse table:\n");
            this.displayStateStack(lastColumn.states, lines);
          } else {
            lines.push("Unexpected " + tokenDisplay + ". Instead, I was expecting to see one of the following:\n");
            var stateStacks = expectantStates.map(function(state2) {
              return this.buildFirstStateStack(state2, []) || [state2];
            }, this);
            stateStacks.forEach(function(stateStack) {
              var state2 = stateStack[0];
              var nextSymbol = state2.rule.symbols[state2.dot];
              var symbolDisplay = this.getSymbolDisplay(nextSymbol);
              lines.push("A " + symbolDisplay + " based on:");
              this.displayStateStack(stateStack, lines);
            }, this);
          }
          lines.push("");
          return lines.join("\n");
        };
        Parser3.prototype.displayStateStack = function(stateStack, lines) {
          var lastDisplay;
          var sameDisplayCount = 0;
          for (var j = 0; j < stateStack.length; j++) {
            var state2 = stateStack[j];
            var display = state2.rule.toString(state2.dot);
            if (display === lastDisplay) {
              sameDisplayCount++;
            } else {
              if (sameDisplayCount > 0) {
                lines.push("    ^ " + sameDisplayCount + " more lines identical to this");
              }
              sameDisplayCount = 0;
              lines.push("    " + display);
            }
            lastDisplay = display;
          }
        };
        Parser3.prototype.getSymbolDisplay = function(symbol) {
          return getSymbolLongDisplay(symbol);
        };
        Parser3.prototype.buildFirstStateStack = function(state2, visited) {
          if (visited.indexOf(state2) !== -1) {
            return null;
          }
          if (state2.wantedBy.length === 0) {
            return [state2];
          }
          var prevState = state2.wantedBy[0];
          var childVisited = [state2].concat(visited);
          var childResult = this.buildFirstStateStack(prevState, childVisited);
          if (childResult === null) {
            return null;
          }
          return [state2].concat(childResult);
        };
        Parser3.prototype.save = function() {
          var column = this.table[this.current];
          column.lexerState = this.lexerState;
          return column;
        };
        Parser3.prototype.restore = function(column) {
          var index = column.index;
          this.current = index;
          this.table[index] = column;
          this.table.splice(index + 1);
          this.lexerState = column.lexerState;
          this.results = this.finish();
        };
        Parser3.prototype.rewind = function(index) {
          if (!this.options.keepHistory) {
            throw new Error("set option `keepHistory` to enable rewinding");
          }
          this.restore(this.table[index]);
        };
        Parser3.prototype.finish = function() {
          var considerations = [];
          var start = this.grammar.start;
          var column = this.table[this.table.length - 1];
          column.states.forEach(function(t) {
            if (t.rule.name === start && t.dot === t.rule.symbols.length && t.reference === 0 && t.data !== Parser3.fail) {
              considerations.push(t);
            }
          });
          return considerations.map(function(c) {
            return c.data;
          });
        };
        function getSymbolLongDisplay(symbol) {
          var type2 = typeof symbol;
          if (type2 === "string") {
            return symbol;
          } else if (type2 === "object") {
            if (symbol.literal) {
              return JSON.stringify(symbol.literal);
            } else if (symbol instanceof RegExp) {
              return "character matching " + symbol;
            } else if (symbol.type) {
              return symbol.type + " token";
            } else if (symbol.test) {
              return "token matching " + String(symbol.test);
            } else {
              throw new Error("Unknown symbol type: " + symbol);
            }
          }
        }
        function getSymbolShortDisplay(symbol) {
          var type2 = typeof symbol;
          if (type2 === "string") {
            return symbol;
          } else if (type2 === "object") {
            if (symbol.literal) {
              return JSON.stringify(symbol.literal);
            } else if (symbol instanceof RegExp) {
              return symbol.toString();
            } else if (symbol.type) {
              return "%" + symbol.type;
            } else if (symbol.test) {
              return "<" + String(symbol.test) + ">";
            } else {
              throw new Error("Unknown symbol type: " + symbol);
            }
          }
        }
        return {
          Parser: Parser3,
          Grammar: Grammar2,
          Rule
        };
      });
    }
  });

  // node_modules/semver-compare/index.js
  var require_semver_compare = __commonJS({
    "node_modules/semver-compare/index.js"(exports, module) {
      module.exports = function cmp(a, b) {
        var pa = a.split(".");
        var pb = b.split(".");
        for (var i = 0; i < 3; i++) {
          var na = Number(pa[i]);
          var nb = Number(pb[i]);
          if (na > nb)
            return 1;
          if (nb > na)
            return -1;
          if (!isNaN(na) && isNaN(nb))
            return 1;
          if (isNaN(na) && !isNaN(nb))
            return -1;
        }
        return 0;
      };
    }
  });

  // src/lib/html-tagged-template.js
  (function(window2) {
    "use strict";
    try {
      (function testSpreadOpAndTemplate() {
        const tag = function tag2() {
          return;
        };
        tag`test`;
      })();
      if (!("content" in document.createElement("template") && "from" in Array)) {
        throw new Error();
      }
    } catch (e) {
      console.log("Your browser does not support the needed functionality to use the html tagged template");
      return;
    }
    if (typeof window2.html === "undefined") {
      let encodeAttributeHTMLEntities = function(str) {
        return str.replace(ENCODINGS_REGEX.attribute, function(match2) {
          return ENCODINGS.attribute[match2];
        });
      }, encodeURIEntities = function(str) {
        return str.replace(ENCODINGS_REGEX.uri, function(match2) {
          return ENCODINGS.uri[match2];
        });
      };
      const SUBSTITUTION_INDEX = "substitutionindex:";
      const SUBSTITUTION_REGEX = new RegExp(SUBSTITUTION_INDEX + "([0-9]+):", "g");
      const REJECTION_STRING = "zXssPreventedz";
      const ENCODINGS = {
        attribute: {
          "&": "&amp;",
          "<": "&lt;",
          ">": "&gt;"
        },
        uri: {
          "&": "&amp;"
        }
      };
      const DOM_EVENTS = [
        "onclick",
        "ondblclick",
        "onmousedown",
        "onmouseup",
        "onmouseover",
        "onmousemove",
        "onmouseout",
        "ondragstart",
        "ondrag",
        "ondragenter",
        "ondragleave",
        "ondragover",
        "ondrop",
        "ondragend",
        "onkeydown",
        "onkeypress",
        "onkeyup",
        "onload",
        "onunload",
        "onabort",
        "onerror",
        "onresize",
        "onscroll",
        "onselect",
        "onchange",
        "onsubmit",
        "onreset",
        "onfocus",
        "onblur",
        "onpointerdown",
        "onpointerup",
        "onpointercancel",
        "onpointermove",
        "onpointerover",
        "onpointerout",
        "onpointerenter",
        "onpointerleave",
        "ongotpointercapture",
        "onlostpointercapture",
        "oncut",
        "oncopy",
        "onpaste",
        "onbeforecut",
        "onbeforecopy",
        "onbeforepaste",
        "onafterupdate",
        "onbeforeupdate",
        "oncellchange",
        "ondataavailable",
        "ondatasetchanged",
        "ondatasetcomplete",
        "onerrorupdate",
        "onrowenter",
        "onrowexit",
        "onrowsdelete",
        "onrowinserted",
        "oncontextmenu",
        "ondrag",
        "ondragstart",
        "ondragenter",
        "ondragover",
        "ondragleave",
        "ondragend",
        "ondrop",
        "onselectstart",
        "help",
        "onbeforeunload",
        "onstop",
        "beforeeditfocus",
        "onstart",
        "onfinish",
        "onbounce",
        "onbeforeprint",
        "onafterprint",
        "onpropertychange",
        "onfilterchange",
        "onreadystatechange",
        "onlosecapture",
        "DOMMouseScroll",
        "ondragdrop",
        "ondragenter",
        "ondragexit",
        "ondraggesture",
        "ondragover",
        "onclose",
        "oncommand",
        "oninput",
        "DOMMenuItemActive",
        "DOMMenuItemInactive",
        "oncontextmenu",
        "onoverflow",
        "onoverflowchanged",
        "onunderflow",
        "onpopuphidden",
        "onpopuphiding",
        "onpopupshowing",
        "onpopupshown",
        "onbroadcast",
        "oncommandupdate"
      ];
      const URI_ATTRIBUTES = [
        "action",
        "background",
        "cite",
        "classid",
        "codebase",
        "data",
        "href",
        "longdesc",
        "profile",
        "src",
        "usemap"
      ];
      const ENCODINGS_REGEX = {
        attribute: new RegExp("[" + Object.keys(ENCODINGS.attribute).join("") + "]", "g"),
        uri: new RegExp("[" + Object.keys(ENCODINGS.uri).join("") + "]", "g")
      };
      const ATTRIBUTE_PARSER_REGEX = /\s([^">=\s]+)(?:="[^"]+")?/g;
      const WRAPPED_WITH_QUOTES_REGEX = /^('|")[\s\S]*\1$/;
      const CUSTOM_URI_ATTRIBUTES_REGEX = /\bur[il]|ur[il]s?$/i;
      window2.html = function(strings, ...values2) {
        if (!strings[0] && values2.length === 0) {
          return;
        }
        function replaceSubstitution(match2, index) {
          return values2[parseInt(index, 10)];
        }
        let str = strings[0];
        for (let i = 0; i < values2.length; i++) {
          str += SUBSTITUTION_INDEX + i + ":" + strings[i + 1];
        }
        const template = document.createElement("template");
        template.innerHTML = str;
        const walker = document.createNodeIterator(template.content, NodeFilter.SHOW_ALL);
        let node;
        while (node = walker.nextNode()) {
          let tag = null;
          const attributesToRemove = [];
          let nodeName = node.nodeName.toLowerCase();
          if (nodeName.indexOf(SUBSTITUTION_INDEX) !== -1) {
            nodeName = nodeName.replace(SUBSTITUTION_REGEX, replaceSubstitution);
            tag = document.createElement(nodeName);
            node._replacedWith = tag;
            node.parentNode.insertBefore(tag, node);
          } else if (node.nodeName === "SCRIPT") {
            const script = document.createElement("script");
            tag = script;
            node._replacedWith = script;
            node.parentNode.insertBefore(script, node);
          }
          let attributes;
          if (node.attributes) {
            if (!(node.attributes instanceof NamedNodeMap)) {
              const temp2 = node.cloneNode();
              const attributeMatches = temp2.outerHTML.match(ATTRIBUTE_PARSER_REGEX);
              attributes = [];
              for (const attribute of attributeMatches.length) {
                const attributeName = attribute.trim().split("=")[0];
                const attributeValue = node.getAttribute(attributeName);
                attributes.push({
                  name: attributeName,
                  value: attributeValue
                });
              }
            } else {
              attributes = Array.from(node.attributes);
            }
            for (const attribute of attributes) {
              let name = attribute.name;
              let value = attribute.value;
              let hasSubstitution = false;
              if (name.indexOf(SUBSTITUTION_INDEX) !== -1) {
                name = name.replace(SUBSTITUTION_REGEX, replaceSubstitution);
                if (name && typeof name === "string") {
                  hasSubstitution = true;
                }
                attributesToRemove.push(attribute.name);
              }
              if (name && value.indexOf(SUBSTITUTION_INDEX) !== -1) {
                hasSubstitution = true;
                let isRejected = false;
                value = value.replace(SUBSTITUTION_REGEX, function(match2, index, offset) {
                  if (isRejected) {
                    return "";
                  }
                  let substitutionValue = values2[parseInt(index, 10)];
                  if (DOM_EVENTS.indexOf(name) !== -1 && typeof substitutionValue === "string" && !WRAPPED_WITH_QUOTES_REGEX.test(substitutionValue)) {
                    substitutionValue = '"' + substitutionValue + '"';
                  } else if (URI_ATTRIBUTES.indexOf(name) !== -1 || CUSTOM_URI_ATTRIBUTES_REGEX.test(name)) {
                    const queryParamIndex = value.indexOf("=");
                    if (queryParamIndex !== -1 && offset > queryParamIndex) {
                      substitutionValue = encodeURIComponent(substitutionValue);
                    } else {
                      substitutionValue = encodeURI(encodeURIEntities(substitutionValue));
                      if (offset === 0 && substitutionValue.indexOf(":") !== -1) {
                        const authorized_protocols = [
                          "http://",
                          "https://",
                          "moz-extension://",
                          "about://",
                          "data:image/png;base64",
                          "data:image/gif;base64",
                          "data:image/jpg;base64",
                          "data:image/jpeg;base64",
                          "data:image/x-icon;base64"
                        ];
                        if (!authorized_protocols.find((p) => substitutionValue.startsWith(p))) {
                          isRejected = true;
                        }
                      }
                    }
                  } else if (typeof substitutionValue === "string") {
                    substitutionValue = encodeAttributeHTMLEntities(substitutionValue);
                  }
                  return substitutionValue;
                });
                if (isRejected) {
                  value = "#" + REJECTION_STRING;
                }
              }
              if (tag || hasSubstitution) {
                const el = tag || node;
                if (name.substr(-1) === "?") {
                  el.removeAttribute(name);
                  if (value === "true") {
                    name = name.slice(0, -1);
                    el.setAttribute(name, "");
                  }
                } else {
                  el.setAttribute(name, value);
                }
              }
            }
          }
          attributesToRemove.forEach(function(attribute) {
            node.removeAttribute(attribute);
          });
          let parentNode;
          if (node.parentNode && node.parentNode._replacedWith) {
            parentNode = node.parentNode;
            node.parentNode._replacedWith.appendChild(node);
          }
          if (node._replacedWith && node.childNodes.length === 0 || parentNode && parentNode.childNodes.length === 0) {
            (parentNode || node).remove();
          }
          if (node.nodeType === 3 && node.nodeValue.indexOf(SUBSTITUTION_INDEX) !== -1) {
            const nodeValue = node.nodeValue.replace(SUBSTITUTION_REGEX, replaceSubstitution);
            const text = document.createTextNode(nodeValue);
            node.parentNode.replaceChild(text, node);
          }
        }
        if (template.content.childNodes.length > 1) {
          return template.content;
        }
        return template.content.firstChild;
      };
    }
  })(window);

  // src/lib/config.ts
  var config_exports = {};
  __export(config_exports, {
    DEFAULTS: () => DEFAULTS,
    INITIALISED: () => INITIALISED,
    USERCONFIG: () => USERCONFIG,
    addChangeListener: () => addChangeListener,
    default_config: () => default_config,
    get: () => get,
    getAsync: () => getAsync,
    getAsyncDynamic: () => getAsyncDynamic,
    getDeepProperty: () => getDeepProperty,
    getDynamic: () => getDynamic,
    getURL: () => getURL,
    mergeDeep: () => mergeDeep,
    mergeDeepCull: () => mergeDeepCull,
    o: () => o,
    parseConfig: () => parseConfig,
    pull: () => pull,
    push: () => push,
    removeChangeListener: () => removeChangeListener,
    save: () => save,
    set: () => set2,
    setURL: () => setURL,
    unset: () => unset,
    unsetURL: () => unsetURL,
    update: () => update2
  });

  // node_modules/rambda/dist/rambda.esm.js
  var rambda_esm_exports = {};
  __export(rambda_esm_exports, {
    F: () => F,
    T: () => T,
    add: () => add,
    adjust: () => adjust,
    all: () => all,
    allPass: () => allPass,
    always: () => always,
    and: () => and,
    any: () => any,
    anyPass: () => anyPass,
    append: () => append,
    applySpec: () => applySpec,
    assoc: () => assoc,
    assocPath: () => assocPath,
    both: () => both,
    chain: () => chain,
    clamp: () => clamp,
    clone: () => clone,
    complement: () => complement,
    compose: () => compose,
    concat: () => concat,
    cond: () => cond,
    converge: () => converge,
    curry: () => curry,
    curryN: () => curryN,
    dec: () => dec,
    defaultTo: () => defaultTo,
    difference: () => difference,
    dissoc: () => dissoc,
    divide: () => divide,
    drop: () => drop,
    dropLast: () => dropLast,
    dropLastWhile: () => dropLastWhile,
    dropRepeats: () => dropRepeats,
    dropRepeatsWith: () => dropRepeatsWith,
    dropWhile: () => dropWhile,
    either: () => either,
    endsWith: () => endsWith,
    eqProps: () => eqProps,
    equals: () => equals,
    evolve: () => evolve,
    evolveArray: () => evolveArray,
    evolveObject: () => evolveObject,
    filter: () => filter,
    filterArray: () => filterArray,
    filterObject: () => filterObject,
    find: () => find,
    findIndex: () => findIndex,
    findLast: () => findLast,
    findLastIndex: () => findLastIndex,
    flatten: () => flatten,
    flip: () => flip,
    forEach: () => forEach,
    fromPairs: () => fromPairs,
    groupBy: () => groupBy,
    groupWith: () => groupWith,
    has: () => has,
    hasPath: () => hasPath,
    head: () => head,
    identical: () => identical,
    identity: () => identity,
    ifElse: () => ifElse,
    inc: () => inc,
    includes: () => includes,
    includesArray: () => includesArray,
    indexBy: () => indexBy,
    indexOf: () => indexOf,
    init: () => init,
    intersection: () => intersection,
    intersperse: () => intersperse,
    is: () => is,
    isEmpty: () => isEmpty,
    isNil: () => isNil,
    join: () => join,
    keys: () => keys,
    last: () => last,
    lastIndexOf: () => lastIndexOf,
    length: () => length,
    lens: () => lens,
    lensIndex: () => lensIndex,
    lensPath: () => lensPath,
    lensProp: () => lensProp,
    map: () => map,
    mapArray: () => mapArray,
    mapObject: () => mapObject,
    match: () => match,
    mathMod: () => mathMod,
    max: () => max,
    maxBy: () => maxBy,
    maxByFn: () => maxByFn,
    mean: () => mean,
    median: () => median,
    merge: () => merge,
    mergeAll: () => mergeAll,
    mergeDeepRight: () => mergeDeepRight,
    mergeLeft: () => mergeLeft,
    min: () => min,
    minBy: () => minBy,
    minByFn: () => minByFn,
    modulo: () => modulo,
    move: () => move,
    multiply: () => multiply,
    negate: () => negate,
    none: () => none,
    not: () => not,
    nth: () => nth,
    of: () => of,
    omit: () => omit,
    once: () => once,
    or: () => or,
    over: () => over,
    partial: () => partial,
    partition: () => partition,
    partitionArray: () => partitionArray,
    partitionObject: () => partitionObject,
    path: () => path,
    pathEq: () => pathEq,
    pathOr: () => pathOr,
    paths: () => paths,
    pick: () => pick,
    pickAll: () => pickAll,
    pipe: () => pipe,
    pluck: () => pluck,
    prepend: () => prepend,
    product: () => product,
    prop: () => prop,
    propEq: () => propEq,
    propIs: () => propIs,
    propOr: () => propOr,
    props: () => props,
    range: () => range,
    reduce: () => reduce,
    reject: () => reject,
    repeat: () => repeat,
    replace: () => replace,
    reverse: () => reverse,
    set: () => set,
    slice: () => slice,
    sort: () => sort,
    sortBy: () => sortBy,
    split: () => split,
    splitAt: () => splitAt,
    splitEvery: () => splitEvery,
    splitWhen: () => splitWhen,
    startsWith: () => startsWith,
    subtract: () => subtract,
    sum: () => sum,
    symmetricDifference: () => symmetricDifference,
    tail: () => tail,
    take: () => take,
    takeLast: () => takeLast,
    takeLastWhile: () => takeLastWhile,
    takeWhile: () => takeWhile,
    tap: () => tap,
    test: () => test,
    times: () => times,
    toLower: () => toLower,
    toPairs: () => toPairs,
    toString: () => toString,
    toUpper: () => toUpper,
    transpose: () => transpose,
    trim: () => trim,
    tryCatch: () => tryCatch,
    type: () => type,
    union: () => union,
    uniq: () => uniq,
    uniqWith: () => uniqWith,
    unless: () => unless,
    update: () => update,
    values: () => values,
    view: () => view,
    when: () => when,
    where: () => where,
    whereEq: () => whereEq,
    without: () => without,
    xor: () => xor,
    zip: () => zip,
    zipObj: () => zipObj,
    zipWith: () => zipWith
  });
  function F() {
    return false;
  }
  function T() {
    return true;
  }
  function add(a, b) {
    if (arguments.length === 1)
      return (_b) => add(a, _b);
    return Number(a) + Number(b);
  }
  function curry(fn, args = []) {
    return (..._args) => ((rest) => rest.length >= fn.length ? fn(...rest) : curry(fn, rest))([...args, ..._args]);
  }
  function adjustFn(index, replaceFn2, list) {
    const actualIndex = index < 0 ? list.length + index : index;
    if (index >= list.length || actualIndex < 0)
      return list;
    const clone2 = list.slice();
    clone2[actualIndex] = replaceFn2(clone2[actualIndex]);
    return clone2;
  }
  var adjust = curry(adjustFn);
  function all(predicate, list) {
    if (arguments.length === 1)
      return (_list) => all(predicate, _list);
    for (let i = 0; i < list.length; i++) {
      if (!predicate(list[i]))
        return false;
    }
    return true;
  }
  function allPass(predicates) {
    return (input) => {
      let counter = 0;
      while (counter < predicates.length) {
        if (!predicates[counter](input)) {
          return false;
        }
        counter++;
      }
      return true;
    };
  }
  function always(x) {
    return () => x;
  }
  function and(a, b) {
    if (arguments.length === 1)
      return (_b) => and(a, _b);
    return a && b;
  }
  function any(predicate, list) {
    if (arguments.length === 1)
      return (_list) => any(predicate, _list);
    let counter = 0;
    while (counter < list.length) {
      if (predicate(list[counter], counter)) {
        return true;
      }
      counter++;
    }
    return false;
  }
  function anyPass(predicates) {
    return (input) => {
      let counter = 0;
      while (counter < predicates.length) {
        if (predicates[counter](input)) {
          return true;
        }
        counter++;
      }
      return false;
    };
  }
  function append(x, input) {
    if (arguments.length === 1)
      return (_input) => append(x, _input);
    if (typeof input === "string")
      return input.split("").concat(x);
    const clone2 = input.slice();
    clone2.push(x);
    return clone2;
  }
  var _isArray = Array.isArray;
  function __findHighestArity(spec, max2 = 0) {
    for (const key in spec) {
      if (spec.hasOwnProperty(key) === false || key === "constructor")
        continue;
      if (typeof spec[key] === "object") {
        max2 = Math.max(max2, __findHighestArity(spec[key]));
      }
      if (typeof spec[key] === "function") {
        max2 = Math.max(max2, spec[key].length);
      }
    }
    return max2;
  }
  function __filterUndefined() {
    const defined = [];
    let i = 0;
    const l = arguments.length;
    while (i < l) {
      if (typeof arguments[i] === "undefined")
        break;
      defined[i] = arguments[i];
      i++;
    }
    return defined;
  }
  function __applySpecWithArity(spec, arity, cache) {
    const remaining = arity - cache.length;
    if (remaining === 1)
      return (x) => __applySpecWithArity(spec, arity, __filterUndefined(...cache, x));
    if (remaining === 2)
      return (x, y) => __applySpecWithArity(spec, arity, __filterUndefined(...cache, x, y));
    if (remaining === 3)
      return (x, y, z) => __applySpecWithArity(spec, arity, __filterUndefined(...cache, x, y, z));
    if (remaining === 4)
      return (x, y, z, a) => __applySpecWithArity(spec, arity, __filterUndefined(...cache, x, y, z, a));
    if (remaining > 4)
      return (...args) => __applySpecWithArity(spec, arity, __filterUndefined(...cache, ...args));
    if (_isArray(spec)) {
      const ret2 = [];
      let i = 0;
      const l = spec.length;
      for (; i < l; i++) {
        if (typeof spec[i] === "object" || _isArray(spec[i])) {
          ret2[i] = __applySpecWithArity(spec[i], arity, cache);
        }
        if (typeof spec[i] === "function") {
          ret2[i] = spec[i](...cache);
        }
      }
      return ret2;
    }
    const ret = {};
    for (const key in spec) {
      if (spec.hasOwnProperty(key) === false || key === "constructor")
        continue;
      if (typeof spec[key] === "object") {
        ret[key] = __applySpecWithArity(spec[key], arity, cache);
        continue;
      }
      if (typeof spec[key] === "function") {
        ret[key] = spec[key](...cache);
      }
    }
    return ret;
  }
  function applySpec(spec, ...args) {
    const arity = __findHighestArity(spec);
    if (arity === 0) {
      return () => ({});
    }
    const toReturn = __applySpecWithArity(spec, arity, args);
    return toReturn;
  }
  function assocFn(prop2, newValue, obj) {
    return Object.assign({}, obj, {
      [prop2]: newValue
    });
  }
  var assoc = curry(assocFn);
  function _isInteger(n) {
    return n << 0 === n;
  }
  var _isInteger$1 = Number.isInteger || _isInteger;
  function assocPathFn(path2, newValue, input) {
    const pathArrValue = typeof path2 === "string" ? path2.split(".").map((x) => _isInteger(Number(x)) ? Number(x) : x) : path2;
    if (pathArrValue.length === 0) {
      return newValue;
    }
    const index = pathArrValue[0];
    if (pathArrValue.length > 1) {
      const condition = typeof input !== "object" || input === null || !input.hasOwnProperty(index);
      const nextinput = condition ? _isInteger(pathArrValue[1]) ? [] : {} : input[index];
      newValue = assocPathFn(Array.prototype.slice.call(pathArrValue, 1), newValue, nextinput);
    }
    if (_isInteger(index) && _isArray(input)) {
      const arr = input.slice();
      arr[index] = newValue;
      return arr;
    }
    return assoc(index, newValue, input);
  }
  var assocPath = curry(assocPathFn);
  function both(f, g) {
    if (arguments.length === 1)
      return (_g) => both(f, _g);
    return (...input) => f(...input) && g(...input);
  }
  function chain(fn, list) {
    if (arguments.length === 1) {
      return (_list) => chain(fn, _list);
    }
    return [].concat(...list.map(fn));
  }
  function clampFn(min2, max2, input) {
    if (min2 > max2) {
      throw new Error("min must not be greater than max in clamp(min, max, value)");
    }
    if (input >= min2 && input <= max2)
      return input;
    if (input > max2)
      return max2;
    if (input < min2)
      return min2;
  }
  var clamp = curry(clampFn);
  function clone(input) {
    const out = _isArray(input) ? Array(input.length) : {};
    if (input && input.getTime)
      return new Date(input.getTime());
    for (const key in input) {
      const v = input[key];
      out[key] = typeof v === "object" && v !== null ? v.getTime ? new Date(v.getTime()) : clone(v) : v;
    }
    return out;
  }
  function complement(fn) {
    return (...input) => !fn(...input);
  }
  function compose(...fns) {
    if (fns.length === 0) {
      throw new Error("compose requires at least one argument");
    }
    return (...args) => {
      const list = fns.slice();
      if (list.length > 0) {
        const fn = list.pop();
        let result = fn(...args);
        while (list.length > 0) {
          result = list.pop()(result);
        }
        return result;
      }
    };
  }
  function concat(x, y) {
    if (arguments.length === 1)
      return (_y) => concat(x, _y);
    return typeof x === "string" ? `${x}${y}` : [...x, ...y];
  }
  function cond(conditions) {
    return (input) => {
      let done = false;
      let toReturn;
      conditions.forEach(([predicate, resultClosure]) => {
        if (!done && predicate(input)) {
          done = true;
          toReturn = resultClosure(input);
        }
      });
      return toReturn;
    };
  }
  function _curryN(n, cache, fn) {
    return function() {
      let ci = 0;
      let ai = 0;
      const cl = cache.length;
      const al = arguments.length;
      const args = new Array(cl + al);
      while (ci < cl) {
        args[ci] = cache[ci];
        ci++;
      }
      while (ai < al) {
        args[cl + ai] = arguments[ai];
        ai++;
      }
      const remaining = n - args.length;
      return args.length >= n ? fn.apply(this, args) : _arity(remaining, _curryN(n, args, fn));
    };
  }
  function _arity(n, fn) {
    switch (n) {
      case 0:
        return function() {
          return fn.apply(this, arguments);
        };
      case 1:
        return function(_1) {
          return fn.apply(this, arguments);
        };
      case 2:
        return function(_1, _2) {
          return fn.apply(this, arguments);
        };
      case 3:
        return function(_1, _2, _3) {
          return fn.apply(this, arguments);
        };
      case 4:
        return function(_1, _2, _3, _4) {
          return fn.apply(this, arguments);
        };
      case 5:
        return function(_1, _2, _3, _4, _5) {
          return fn.apply(this, arguments);
        };
      case 6:
        return function(_1, _2, _3, _4, _5, _6) {
          return fn.apply(this, arguments);
        };
      case 7:
        return function(_1, _2, _3, _4, _5, _6, _7) {
          return fn.apply(this, arguments);
        };
      case 8:
        return function(_1, _2, _3, _4, _5, _6, _7, _8) {
          return fn.apply(this, arguments);
        };
      case 9:
        return function(_1, _2, _3, _4, _5, _6, _7, _8, _9) {
          return fn.apply(this, arguments);
        };
      default:
        return function(_1, _2, _3, _4, _5, _6, _7, _8, _9, _10) {
          return fn.apply(this, arguments);
        };
    }
  }
  function curryN(n, fn) {
    if (arguments.length === 1)
      return (_fn) => curryN(n, _fn);
    if (n > 10) {
      throw new Error("First argument to _arity must be a non-negative integer no greater than ten");
    }
    return _arity(n, _curryN(n, [], fn));
  }
  var _keys = Object.keys;
  function mapArray(fn, list, isIndexed = false) {
    let index = 0;
    const willReturn = Array(list.length);
    while (index < list.length) {
      willReturn[index] = isIndexed ? fn(list[index], index) : fn(list[index]);
      index++;
    }
    return willReturn;
  }
  function mapObject(fn, obj) {
    let index = 0;
    const keys2 = _keys(obj);
    const len = keys2.length;
    const willReturn = {};
    while (index < len) {
      const key = keys2[index];
      willReturn[key] = fn(obj[key], key, obj);
      index++;
    }
    return willReturn;
  }
  function map(fn, list) {
    if (arguments.length === 1)
      return (_list) => map(fn, _list);
    if (list === void 0)
      return [];
    if (_isArray(list))
      return mapArray(fn, list);
    return mapObject(fn, list);
  }
  function max(x, y) {
    if (arguments.length === 1)
      return (_y) => max(x, _y);
    return y > x ? y : x;
  }
  function reduceFn(reducer, acc, list) {
    if (!_isArray(list)) {
      throw new TypeError("reduce: list must be array or iterable");
    }
    let index = 0;
    const len = list.length;
    while (index < len) {
      acc = reducer(acc, list[index], index, list);
      index++;
    }
    return acc;
  }
  var reduce = curry(reduceFn);
  function converge(fn, transformers) {
    if (arguments.length === 1)
      return (_transformers) => converge(fn, _transformers);
    const highestArity = reduce((a, b) => max(a, b.length), 0, transformers);
    return curryN(highestArity, function() {
      return fn.apply(this, map((g) => g.apply(this, arguments), transformers));
    });
  }
  var dec = (x) => x - 1;
  function isFalsy(input) {
    return input === void 0 || input === null || Number.isNaN(input) === true;
  }
  function defaultTo(defaultArgument, input) {
    if (arguments.length === 1) {
      return (_input) => defaultTo(defaultArgument, _input);
    }
    return isFalsy(input) ? defaultArgument : input;
  }
  function type(input) {
    const typeOf = typeof input;
    if (input === null) {
      return "Null";
    } else if (input === void 0) {
      return "Undefined";
    } else if (typeOf === "boolean") {
      return "Boolean";
    } else if (typeOf === "number") {
      return Number.isNaN(input) ? "NaN" : "Number";
    } else if (typeOf === "string") {
      return "String";
    } else if (_isArray(input)) {
      return "Array";
    } else if (typeOf === "symbol") {
      return "Symbol";
    } else if (input instanceof RegExp) {
      return "RegExp";
    }
    const asStr = input && input.toString ? input.toString() : "";
    if (["true", "false"].includes(asStr))
      return "Boolean";
    if (!Number.isNaN(Number(asStr)))
      return "Number";
    if (asStr.startsWith("async"))
      return "Async";
    if (asStr === "[object Promise]")
      return "Promise";
    if (typeOf === "function")
      return "Function";
    if (input instanceof String)
      return "String";
    return "Object";
  }
  function parseError(maybeError) {
    const typeofError = maybeError.__proto__.toString();
    if (!["Error", "TypeError"].includes(typeofError))
      return [];
    return [typeofError, maybeError.message];
  }
  function parseDate(maybeDate) {
    if (!maybeDate.toDateString)
      return [false];
    return [true, maybeDate.getTime()];
  }
  function parseRegex(maybeRegex) {
    if (maybeRegex.constructor !== RegExp)
      return [false];
    return [true, maybeRegex.toString()];
  }
  function equals(a, b) {
    if (arguments.length === 1)
      return (_b) => equals(a, _b);
    const aType = type(a);
    if (aType !== type(b))
      return false;
    if (aType === "Function") {
      return a.name === void 0 ? false : a.name === b.name;
    }
    if (["NaN", "Undefined", "Null"].includes(aType))
      return true;
    if (aType === "Number") {
      if (Object.is(-0, a) !== Object.is(-0, b))
        return false;
      return a.toString() === b.toString();
    }
    if (["String", "Boolean"].includes(aType)) {
      return a.toString() === b.toString();
    }
    if (aType === "Array") {
      const aClone = Array.from(a);
      const bClone = Array.from(b);
      if (aClone.toString() !== bClone.toString()) {
        return false;
      }
      let loopArrayFlag = true;
      aClone.forEach((aCloneInstance, aCloneIndex) => {
        if (loopArrayFlag) {
          if (aCloneInstance !== bClone[aCloneIndex] && !equals(aCloneInstance, bClone[aCloneIndex])) {
            loopArrayFlag = false;
          }
        }
      });
      return loopArrayFlag;
    }
    const aRegex = parseRegex(a);
    const bRegex = parseRegex(b);
    if (aRegex[0]) {
      return bRegex[0] ? aRegex[1] === bRegex[1] : false;
    } else if (bRegex[0])
      return false;
    const aDate = parseDate(a);
    const bDate = parseDate(b);
    if (aDate[0]) {
      return bDate[0] ? aDate[1] === bDate[1] : false;
    } else if (bDate[0])
      return false;
    const aError = parseError(a);
    const bError = parseError(b);
    if (aError[0]) {
      return bError[0] ? aError[0] === bError[0] && aError[1] === bError[1] : false;
    }
    if (aType === "Object") {
      const aKeys = Object.keys(a);
      if (aKeys.length !== Object.keys(b).length) {
        return false;
      }
      let loopObjectFlag = true;
      aKeys.forEach((aKeyInstance) => {
        if (loopObjectFlag) {
          const aValue = a[aKeyInstance];
          const bValue = b[aKeyInstance];
          if (aValue !== bValue && !equals(aValue, bValue)) {
            loopObjectFlag = false;
          }
        }
      });
      return loopObjectFlag;
    }
    return false;
  }
  function includesArray(valueToFind, input) {
    let index = -1;
    while (++index < input.length) {
      if (equals(input[index], valueToFind)) {
        return true;
      }
    }
    return false;
  }
  function includes(valueToFind, input) {
    if (arguments.length === 1)
      return (_input) => includes(valueToFind, _input);
    if (typeof input === "string") {
      return input.includes(valueToFind);
    }
    if (!input) {
      throw new TypeError(`Cannot read property 'indexOf' of ${input}`);
    }
    if (!_isArray(input))
      return false;
    return includesArray(valueToFind, input);
  }
  function uniq(list) {
    let index = -1;
    const willReturn = [];
    while (++index < list.length) {
      const value = list[index];
      if (!includes(value, willReturn)) {
        willReturn.push(value);
      }
    }
    return willReturn;
  }
  function difference(a, b) {
    if (arguments.length === 1)
      return (_b) => difference(a, _b);
    return uniq(a).filter((aInstance) => !includes(aInstance, b));
  }
  function dissoc(prop2, obj) {
    if (arguments.length === 1)
      return (_obj) => dissoc(prop2, _obj);
    if (obj === null || obj === void 0)
      return {};
    const willReturn = {};
    for (const p in obj) {
      willReturn[p] = obj[p];
    }
    delete willReturn[prop2];
    return willReturn;
  }
  function divide(a, b) {
    if (arguments.length === 1)
      return (_b) => divide(a, _b);
    return a / b;
  }
  function drop(howManyToDrop, listOrString) {
    if (arguments.length === 1)
      return (_list) => drop(howManyToDrop, _list);
    return listOrString.slice(howManyToDrop > 0 ? howManyToDrop : 0);
  }
  function dropLast(howManyToDrop, listOrString) {
    if (arguments.length === 1) {
      return (_listOrString) => dropLast(howManyToDrop, _listOrString);
    }
    return howManyToDrop > 0 ? listOrString.slice(0, -howManyToDrop) : listOrString.slice();
  }
  function dropLastWhile(predicate, iterable) {
    if (arguments.length === 1) {
      return (_iterable) => dropLastWhile(predicate, _iterable);
    }
    if (iterable.length === 0)
      return iterable;
    const isArray = _isArray(iterable);
    if (typeof predicate !== "function") {
      throw new Error(`'predicate' is from wrong type ${typeof predicate}`);
    }
    if (!isArray && typeof iterable !== "string") {
      throw new Error(`'iterable' is from wrong type ${typeof iterable}`);
    }
    let found = false;
    const toReturn = [];
    let counter = iterable.length;
    while (counter > 0) {
      counter--;
      if (!found && predicate(iterable[counter]) === false) {
        found = true;
        toReturn.push(iterable[counter]);
      } else if (found) {
        toReturn.push(iterable[counter]);
      }
    }
    return isArray ? toReturn.reverse() : toReturn.reverse().join("");
  }
  function dropRepeats(list) {
    if (!_isArray(list)) {
      throw new Error(`${list} is not a list`);
    }
    const toReturn = [];
    list.reduce((prev, current) => {
      if (!equals(prev, current)) {
        toReturn.push(current);
      }
      return current;
    }, void 0);
    return toReturn;
  }
  function dropRepeatsWith(predicate, list) {
    if (arguments.length === 1) {
      return (_iterable) => dropRepeatsWith(predicate, _iterable);
    }
    if (!_isArray(list)) {
      throw new Error(`${list} is not a list`);
    }
    const toReturn = [];
    list.reduce((prev, current) => {
      if (prev === void 0) {
        toReturn.push(current);
        return current;
      }
      if (!predicate(prev, current)) {
        toReturn.push(current);
      }
      return current;
    }, void 0);
    return toReturn;
  }
  function dropWhile(predicate, iterable) {
    if (arguments.length === 1) {
      return (_iterable) => dropWhile(predicate, _iterable);
    }
    const isArray = _isArray(iterable);
    if (!isArray && typeof iterable !== "string") {
      throw new Error("`iterable` is neither list nor a string");
    }
    let flag = false;
    const holder = [];
    let counter = -1;
    while (counter++ < iterable.length - 1) {
      if (flag) {
        holder.push(iterable[counter]);
      } else if (!predicate(iterable[counter])) {
        if (!flag)
          flag = true;
        holder.push(iterable[counter]);
      }
    }
    return isArray ? holder : holder.join("");
  }
  function either(firstPredicate, secondPredicate) {
    if (arguments.length === 1) {
      return (_secondPredicate) => either(firstPredicate, _secondPredicate);
    }
    return (...input) => Boolean(firstPredicate(...input) || secondPredicate(...input));
  }
  function endsWith(target, str) {
    if (arguments.length === 1)
      return (_str) => endsWith(target, _str);
    return str.endsWith(target);
  }
  function eqPropsFn(prop2, obj1, obj2) {
    if (!obj1 || !obj2) {
      throw new Error("wrong object inputs are passed to R.eqProps");
    }
    return equals(obj1[prop2], obj2[prop2]);
  }
  var eqProps = curry(eqPropsFn);
  function evolveArray(rules, list) {
    return mapArray((x, i) => {
      if (type(rules[i]) === "Function") {
        return rules[i](x);
      }
      return x;
    }, list, true);
  }
  function evolveObject(rules, iterable) {
    return mapObject((x, prop2) => {
      if (type(x) === "Object") {
        const typeRule = type(rules[prop2]);
        if (typeRule === "Function") {
          return rules[prop2](x);
        }
        if (typeRule === "Object") {
          return evolve(rules[prop2], x);
        }
        return x;
      }
      if (type(rules[prop2]) === "Function") {
        return rules[prop2](x);
      }
      return x;
    }, iterable);
  }
  function evolve(rules, iterable) {
    if (arguments.length === 1) {
      return (_iterable) => evolve(rules, _iterable);
    }
    const rulesType = type(rules);
    const iterableType = type(iterable);
    if (iterableType !== rulesType) {
      throw new Error("iterableType !== rulesType");
    }
    if (!["Object", "Array"].includes(rulesType)) {
      throw new Error(`'iterable' and 'rules' are from wrong type ${rulesType}`);
    }
    if (iterableType === "Object") {
      return evolveObject(rules, iterable);
    }
    return evolveArray(rules, iterable);
  }
  function filterObject(fn, obj) {
    const willReturn = {};
    for (const prop2 in obj) {
      if (fn(obj[prop2], prop2, obj)) {
        willReturn[prop2] = obj[prop2];
      }
    }
    return willReturn;
  }
  function filterArray(predicate, list, indexed = false) {
    let index = 0;
    const len = list.length;
    const willReturn = [];
    while (index < len) {
      const predicateResult = indexed ? predicate(list[index], index) : predicate(list[index]);
      if (predicateResult) {
        willReturn.push(list[index]);
      }
      index++;
    }
    return willReturn;
  }
  function filter(predicate, iterable) {
    if (arguments.length === 1) {
      return (_iterable) => filter(predicate, _iterable);
    }
    if (!iterable)
      return [];
    if (_isArray(iterable))
      return filterArray(predicate, iterable);
    return filterObject(predicate, iterable);
  }
  function find(predicate, list) {
    if (arguments.length === 1)
      return (_list) => find(predicate, _list);
    let index = 0;
    const len = list.length;
    while (index < len) {
      const x = list[index];
      if (predicate(x)) {
        return x;
      }
      index++;
    }
  }
  function findIndex(predicate, list) {
    if (arguments.length === 1)
      return (_list) => findIndex(predicate, _list);
    const len = list.length;
    let index = -1;
    while (++index < len) {
      if (predicate(list[index])) {
        return index;
      }
    }
    return -1;
  }
  function findLast(predicate, list) {
    if (arguments.length === 1)
      return (_list) => findLast(predicate, _list);
    let index = list.length;
    while (--index >= 0) {
      if (predicate(list[index])) {
        return list[index];
      }
    }
    return void 0;
  }
  function findLastIndex(fn, list) {
    if (arguments.length === 1)
      return (_list) => findLastIndex(fn, _list);
    let index = list.length;
    while (--index >= 0) {
      if (fn(list[index])) {
        return index;
      }
    }
    return -1;
  }
  function flatten(list, input) {
    const willReturn = input === void 0 ? [] : input;
    for (let i = 0; i < list.length; i++) {
      if (_isArray(list[i])) {
        flatten(list[i], willReturn);
      } else {
        willReturn.push(list[i]);
      }
    }
    return willReturn;
  }
  function flipFn(fn) {
    return (...input) => {
      if (input.length === 1) {
        return (holder) => fn(holder, input[0]);
      } else if (input.length === 2) {
        return fn(input[1], input[0]);
      } else if (input.length === 3) {
        return fn(input[1], input[0], input[2]);
      } else if (input.length === 4) {
        return fn(input[1], input[0], input[2], input[3]);
      }
      throw new Error("R.flip doesn't work with arity > 4");
    };
  }
  function flip(fn) {
    return flipFn(fn);
  }
  function forEach(fn, list) {
    if (arguments.length === 1)
      return (_list) => forEach(fn, _list);
    if (list === void 0) {
      return;
    }
    if (_isArray(list)) {
      let index = 0;
      const len = list.length;
      while (index < len) {
        fn(list[index]);
        index++;
      }
    } else {
      let index = 0;
      const keys2 = _keys(list);
      const len = keys2.length;
      while (index < len) {
        const key = keys2[index];
        fn(list[key], key, list);
        index++;
      }
    }
    return list;
  }
  function fromPairs(listOfPairs) {
    const toReturn = {};
    listOfPairs.forEach(([prop2, value]) => toReturn[prop2] = value);
    return toReturn;
  }
  function groupBy(groupFn, list) {
    if (arguments.length === 1)
      return (_list) => groupBy(groupFn, _list);
    const result = {};
    for (let i = 0; i < list.length; i++) {
      const item = list[i];
      const key = groupFn(item);
      if (!result[key]) {
        result[key] = [];
      }
      result[key].push(item);
    }
    return result;
  }
  function groupWith(compareFn, list) {
    if (!_isArray(list))
      throw new TypeError("list.reduce is not a function");
    const clone2 = list.slice();
    if (list.length === 1)
      return [clone2];
    const toReturn = [];
    let holder = [];
    clone2.reduce((prev, current, i) => {
      if (i === 0)
        return current;
      const okCompare = compareFn(prev, current);
      const holderIsEmpty = holder.length === 0;
      const lastCall = i === list.length - 1;
      if (okCompare) {
        if (holderIsEmpty)
          holder.push(prev);
        holder.push(current);
        if (lastCall)
          toReturn.push(holder);
        return current;
      }
      if (holderIsEmpty) {
        toReturn.push([prev]);
        if (lastCall)
          toReturn.push([current]);
        return current;
      }
      toReturn.push(holder);
      if (lastCall)
        toReturn.push([current]);
      holder = [];
      return current;
    }, void 0);
    return toReturn;
  }
  function has(prop2, obj) {
    if (arguments.length === 1)
      return (_obj) => has(prop2, _obj);
    if (!obj)
      return false;
    return obj[prop2] !== void 0;
  }
  function path(pathInput, obj) {
    if (arguments.length === 1)
      return (_obj) => path(pathInput, _obj);
    if (obj === null || obj === void 0) {
      return void 0;
    }
    let willReturn = obj;
    let counter = 0;
    const pathArrValue = typeof pathInput === "string" ? pathInput.split(".") : pathInput;
    while (counter < pathArrValue.length) {
      if (willReturn === null || willReturn === void 0) {
        return void 0;
      }
      willReturn = willReturn[pathArrValue[counter]];
      counter++;
    }
    return willReturn;
  }
  function hasPath(maybePath, obj) {
    if (arguments.length === 1) {
      return (objHolder) => hasPath(maybePath, objHolder);
    }
    return path(maybePath, obj) !== void 0;
  }
  function head(listOrString) {
    if (typeof listOrString === "string")
      return listOrString[0] || "";
    return listOrString[0];
  }
  function _objectIs(a, b) {
    if (a === b) {
      return a !== 0 || 1 / a === 1 / b;
    }
    return a !== a && b !== b;
  }
  var _objectIs$1 = Object.is || _objectIs;
  function identical(a, b) {
    if (arguments.length === 1)
      return (_b) => identical(a, _b);
    return _objectIs$1(a, b);
  }
  function identity(input) {
    return input;
  }
  function ifElseFn(condition, onTrue, onFalse) {
    return (...input) => {
      const conditionResult = typeof condition === "boolean" ? condition : condition(...input);
      if (conditionResult === true) {
        return onTrue(...input);
      }
      return onFalse(...input);
    };
  }
  var ifElse = curry(ifElseFn);
  var inc = (x) => x + 1;
  function indexByPath(pathInput, list) {
    const toReturn = {};
    for (let i = 0; i < list.length; i++) {
      const item = list[i];
      toReturn[path(pathInput, item)] = item;
    }
    return toReturn;
  }
  function indexBy(condition, list) {
    if (arguments.length === 1) {
      return (_list) => indexBy(condition, _list);
    }
    if (typeof condition === "string") {
      return indexByPath(condition, list);
    }
    const toReturn = {};
    for (let i = 0; i < list.length; i++) {
      const item = list[i];
      toReturn[condition(item)] = item;
    }
    return toReturn;
  }
  function indexOf(valueToFind, list) {
    if (arguments.length === 1) {
      return (_list) => indexOf(valueToFind, _list);
    }
    let index = -1;
    const {
      length: length2
    } = list;
    while (++index < length2) {
      if (list[index] === valueToFind) {
        return index;
      }
    }
    return -1;
  }
  function baseSlice(array, start, end) {
    let index = -1;
    let {
      length: length2
    } = array;
    end = end > length2 ? length2 : end;
    if (end < 0) {
      end += length2;
    }
    length2 = start > end ? 0 : end - start >>> 0;
    start >>>= 0;
    const result = Array(length2);
    while (++index < length2) {
      result[index] = array[index + start];
    }
    return result;
  }
  function init(listOrString) {
    if (typeof listOrString === "string")
      return listOrString.slice(0, -1);
    return listOrString.length ? baseSlice(listOrString, 0, -1) : [];
  }
  function intersection(listA, listB) {
    if (arguments.length === 1)
      return (_list) => intersection(listA, _list);
    return filter((value) => includes(value, listB), listA);
  }
  function intersperse(separator, list) {
    if (arguments.length === 1)
      return (_list) => intersperse(separator, _list);
    let index = -1;
    const len = list.length;
    const willReturn = [];
    while (++index < len) {
      if (index === len - 1) {
        willReturn.push(list[index]);
      } else {
        willReturn.push(list[index], separator);
      }
    }
    return willReturn;
  }
  function is(targetPrototype, x) {
    if (arguments.length === 1)
      return (_x) => is(targetPrototype, _x);
    return x != null && x.constructor === targetPrototype || x instanceof targetPrototype;
  }
  function isEmpty(input) {
    const inputType = type(input);
    if (["Undefined", "NaN", "Number", "Null"].includes(inputType))
      return false;
    if (!input)
      return true;
    if (inputType === "Object") {
      return Object.keys(input).length === 0;
    }
    if (inputType === "Array") {
      return input.length === 0;
    }
    return false;
  }
  function isNil(x) {
    return x === void 0 || x === null;
  }
  function join(glue, list) {
    if (arguments.length === 1)
      return (_list) => join(glue, _list);
    return list.join(glue);
  }
  function keys(x) {
    return Object.keys(x);
  }
  function last(listOrString) {
    if (typeof listOrString === "string") {
      return listOrString[listOrString.length - 1] || "";
    }
    return listOrString[listOrString.length - 1];
  }
  function lastIndexOf(target, list) {
    if (arguments.length === 1)
      return (_list) => lastIndexOf(target, _list);
    let index = list.length;
    while (--index > 0) {
      if (equals(list[index], target)) {
        return index;
      }
    }
    return -1;
  }
  function length(x) {
    if (!x && x !== "" || x.length === void 0) {
      return NaN;
    }
    return x.length;
  }
  function lens(getter, setter) {
    return function(functor) {
      return function(target) {
        return functor(getter(target)).map((focus3) => setter(focus3, target));
      };
    };
  }
  function nth(index, list) {
    if (arguments.length === 1)
      return (_list) => nth(index, _list);
    const idx = index < 0 ? list.length + index : index;
    return Object.prototype.toString.call(list) === "[object String]" ? list.charAt(idx) : list[idx];
  }
  function updateFn(index, newValue, list) {
    const arrClone = list.slice();
    return arrClone.fill(newValue, index, index + 1);
  }
  var update = curry(updateFn);
  function lensIndex(index) {
    return lens(nth(index), update(index));
  }
  function lensPath(key) {
    return lens(path(key), assocPath(key));
  }
  function prop(propToFind, obj) {
    if (arguments.length === 1)
      return (_obj) => prop(propToFind, _obj);
    if (!obj)
      return void 0;
    return obj[propToFind];
  }
  function lensProp(key) {
    return lens(prop(key), assoc(key));
  }
  function match(pattern, input) {
    if (arguments.length === 1)
      return (_input) => match(pattern, _input);
    const willReturn = input.match(pattern);
    return willReturn === null ? [] : willReturn;
  }
  function mathMod(x, y) {
    if (arguments.length === 1)
      return (_y) => mathMod(x, _y);
    if (!_isInteger$1(x) || !_isInteger$1(y) || y < 1)
      return NaN;
    return (x % y + y) % y;
  }
  function maxByFn(compareFn, x, y) {
    return compareFn(y) > compareFn(x) ? y : x;
  }
  var maxBy = curry(maxByFn);
  function sum(list) {
    return list.reduce((prev, current) => prev + current, 0);
  }
  function mean(list) {
    return sum(list) / list.length;
  }
  function median(list) {
    const len = list.length;
    if (len === 0)
      return NaN;
    const width = 2 - len % 2;
    const idx = (len - width) / 2;
    return mean(Array.prototype.slice.call(list, 0).sort((a, b) => {
      if (a === b)
        return 0;
      return a < b ? -1 : 1;
    }).slice(idx, idx + width));
  }
  function merge(target, newProps) {
    if (arguments.length === 1)
      return (_newProps) => merge(target, _newProps);
    return Object.assign({}, target || {}, newProps || {});
  }
  function mergeAll(arr) {
    let willReturn = {};
    map((val) => {
      willReturn = merge(willReturn, val);
    }, arr);
    return willReturn;
  }
  function mergeDeepRight(target, source2) {
    if (arguments.length === 1) {
      return (sourceHolder) => mergeDeepRight(target, sourceHolder);
    }
    const willReturn = JSON.parse(JSON.stringify(target));
    Object.keys(source2).forEach((key) => {
      if (type(source2[key]) === "Object") {
        if (type(target[key]) === "Object") {
          willReturn[key] = mergeDeepRight(target[key], source2[key]);
        } else {
          willReturn[key] = source2[key];
        }
      } else {
        willReturn[key] = source2[key];
      }
    });
    return willReturn;
  }
  function mergeLeft(x, y) {
    if (arguments.length === 1)
      return (_y) => mergeLeft(x, _y);
    return merge(y, x);
  }
  function min(x, y) {
    if (arguments.length === 1)
      return (_y) => min(x, _y);
    return y < x ? y : x;
  }
  function minByFn(compareFn, x, y) {
    return compareFn(y) < compareFn(x) ? y : x;
  }
  var minBy = curry(minByFn);
  function modulo(x, y) {
    if (arguments.length === 1)
      return (_y) => modulo(x, _y);
    return x % y;
  }
  function moveFn(fromIndex, toIndex, list) {
    if (fromIndex < 0 || toIndex < 0) {
      throw new Error("Rambda.move does not support negative indexes");
    }
    if (fromIndex > list.length - 1 || toIndex > list.length - 1)
      return list;
    const clone2 = list.slice();
    clone2[fromIndex] = list[toIndex];
    clone2[toIndex] = list[fromIndex];
    return clone2;
  }
  var move = curry(moveFn);
  function multiply(x, y) {
    if (arguments.length === 1)
      return (_y) => multiply(x, _y);
    return x * y;
  }
  function negate(x) {
    return -x;
  }
  function none(predicate, list) {
    if (arguments.length === 1)
      return (_list) => none(predicate, _list);
    for (let i = 0; i < list.length; i++) {
      if (!predicate(list[i]))
        return true;
    }
    return false;
  }
  function not(input) {
    return !input;
  }
  function of(value) {
    return [value];
  }
  function omit(propsToOmit, obj) {
    if (arguments.length === 1)
      return (_obj) => omit(propsToOmit, _obj);
    if (obj === null || obj === void 0) {
      return void 0;
    }
    const propsToOmitValue = typeof propsToOmit === "string" ? propsToOmit.split(",") : propsToOmit;
    const willReturn = {};
    for (const key in obj) {
      if (!propsToOmitValue.includes(key)) {
        willReturn[key] = obj[key];
      }
    }
    return willReturn;
  }
  function onceFn(fn, context) {
    let result;
    return function() {
      if (fn) {
        result = fn.apply(context || this, arguments);
        fn = null;
      }
      return result;
    };
  }
  function once(fn, context) {
    if (arguments.length === 1) {
      const wrap = onceFn(fn, context);
      return curry(wrap);
    }
    return onceFn(fn, context);
  }
  function or(a, b) {
    if (arguments.length === 1)
      return (_b) => or(a, _b);
    return a || b;
  }
  var Identity = (x) => ({
    x,
    map: (fn) => Identity(fn(x))
  });
  function overFn(lens2, fn, object) {
    return lens2((x) => Identity(fn(x)))(object).x;
  }
  var over = curry(overFn);
  function partial(fn, ...args) {
    const len = fn.length;
    return (...rest) => {
      if (args.length + rest.length >= len) {
        return fn(...args, ...rest);
      }
      return partial(fn, ...[...args, ...rest]);
    };
  }
  function partitionObject(predicate, iterable) {
    const yes = {};
    const no = {};
    Object.entries(iterable).forEach(([prop2, value]) => {
      if (predicate(value, prop2)) {
        yes[prop2] = value;
      } else {
        no[prop2] = value;
      }
    });
    return [yes, no];
  }
  function partitionArray(predicate, list) {
    const yes = [];
    const no = [];
    let counter = -1;
    while (counter++ < list.length - 1) {
      if (predicate(list[counter])) {
        yes.push(list[counter]);
      } else {
        no.push(list[counter]);
      }
    }
    return [yes, no];
  }
  function partition(predicate, iterable) {
    if (arguments.length === 1) {
      return (listHolder) => partition(predicate, listHolder);
    }
    if (!_isArray(iterable))
      return partitionObject(predicate, iterable);
    return partitionArray(predicate, iterable);
  }
  function pathEqFn(pathToSearch, target, input) {
    return equals(path(pathToSearch, input), target);
  }
  var pathEq = curry(pathEqFn);
  function pathOrFn(defaultValue, list, obj) {
    return defaultTo(defaultValue, path(list, obj));
  }
  var pathOr = curry(pathOrFn);
  function paths(pathsToSearch, obj) {
    if (arguments.length === 1) {
      return (_obj) => paths(pathsToSearch, _obj);
    }
    return pathsToSearch.map((singlePath) => path(singlePath, obj));
  }
  function pick(propsToPick, input) {
    if (arguments.length === 1)
      return (_input) => pick(propsToPick, _input);
    if (input === null || input === void 0) {
      return void 0;
    }
    const keys2 = typeof propsToPick === "string" ? propsToPick.split(",") : propsToPick;
    const willReturn = {};
    let counter = 0;
    while (counter < keys2.length) {
      if (keys2[counter] in input) {
        willReturn[keys2[counter]] = input[keys2[counter]];
      }
      counter++;
    }
    return willReturn;
  }
  function pickAll(propsToPick, obj) {
    if (arguments.length === 1)
      return (_obj) => pickAll(propsToPick, _obj);
    if (obj === null || obj === void 0) {
      return void 0;
    }
    const keysValue = typeof propsToPick === "string" ? propsToPick.split(",") : propsToPick;
    const willReturn = {};
    let counter = 0;
    while (counter < keysValue.length) {
      if (keysValue[counter] in obj) {
        willReturn[keysValue[counter]] = obj[keysValue[counter]];
      } else {
        willReturn[keysValue[counter]] = void 0;
      }
      counter++;
    }
    return willReturn;
  }
  function pipe(...fns) {
    if (fns.length === 0)
      throw new Error("pipe requires at least one argument");
    return (...args) => {
      const list = fns.slice();
      if (list.length > 0) {
        const fn = list.shift();
        let result = fn(...args);
        while (list.length > 0) {
          result = list.shift()(result);
        }
        return result;
      }
    };
  }
  function pluck(property, list) {
    if (arguments.length === 1)
      return (_list) => pluck(property, _list);
    const willReturn = [];
    map((x) => {
      if (x[property] !== void 0) {
        willReturn.push(x[property]);
      }
    }, list);
    return willReturn;
  }
  function prepend(x, input) {
    if (arguments.length === 1)
      return (_input) => prepend(x, _input);
    if (typeof input === "string")
      return [x].concat(input.split(""));
    return [x].concat(input);
  }
  var product = reduce(multiply, 1);
  function propEqFn(propToFind, valueToMatch, obj) {
    if (!obj)
      return false;
    return obj[propToFind] === valueToMatch;
  }
  var propEq = curry(propEqFn);
  function propIsFn(targetPrototype, property, obj) {
    return is(targetPrototype, obj[property]);
  }
  var propIs = curry(propIsFn);
  function propOrFn(defaultValue, property, obj) {
    if (!obj)
      return defaultValue;
    return defaultTo(defaultValue, obj[property]);
  }
  var propOr = curry(propOrFn);
  function props(propsToPick, obj) {
    if (arguments.length === 1) {
      return (_obj) => props(propsToPick, _obj);
    }
    if (!_isArray(propsToPick)) {
      throw new Error("propsToPick is not a list");
    }
    return mapArray((prop2) => obj[prop2], propsToPick);
  }
  function range(start, end) {
    if (arguments.length === 1)
      return (_end) => range(start, _end);
    if (Number.isNaN(Number(start)) || Number.isNaN(Number(end))) {
      throw new TypeError("Both arguments to range must be numbers");
    }
    if (end < start)
      return [];
    const len = end - start;
    const willReturn = Array(len);
    for (let i = 0; i < len; i++) {
      willReturn[i] = start + i;
    }
    return willReturn;
  }
  function reject(predicate, list) {
    if (arguments.length === 1)
      return (_list) => reject(predicate, _list);
    return filter((x) => !predicate(x), list);
  }
  function repeat(x, timesToRepeat) {
    if (arguments.length === 1) {
      return (_timesToRepeat) => repeat(x, _timesToRepeat);
    }
    return Array(timesToRepeat).fill(x);
  }
  function replaceFn(pattern, replacer, str) {
    return str.replace(pattern, replacer);
  }
  var replace = curry(replaceFn);
  function reverse(listOrString) {
    if (typeof listOrString === "string") {
      return listOrString.split("").reverse().join("");
    }
    const clone2 = listOrString.slice();
    return clone2.reverse();
  }
  function setFn(lens2, replacer, x) {
    return over(lens2, always(replacer), x);
  }
  var set = curry(setFn);
  function sliceFn(from, to, list) {
    return list.slice(from, to);
  }
  var slice = curry(sliceFn);
  function sort(sortFn, list) {
    if (arguments.length === 1)
      return (_list) => sort(sortFn, _list);
    const clone2 = list.slice();
    return clone2.sort(sortFn);
  }
  function sortBy(sortFn, list) {
    if (arguments.length === 1)
      return (_list) => sortBy(sortFn, _list);
    const clone2 = list.slice();
    return clone2.sort((a, b) => {
      const aSortResult = sortFn(a);
      const bSortResult = sortFn(b);
      if (aSortResult === bSortResult)
        return 0;
      return aSortResult < bSortResult ? -1 : 1;
    });
  }
  function split(separator, str) {
    if (arguments.length === 1)
      return (_str) => split(separator, _str);
    return str.split(separator);
  }
  function maybe(ifRule, whenIf, whenElse) {
    const whenIfInput = ifRule && type(whenIf) === "Function" ? whenIf() : whenIf;
    const whenElseInput = !ifRule && type(whenElse) === "Function" ? whenElse() : whenElse;
    return ifRule ? whenIfInput : whenElseInput;
  }
  function take(howMany, listOrString) {
    if (arguments.length === 1)
      return (_listOrString) => take(howMany, _listOrString);
    if (howMany < 0)
      return listOrString.slice();
    if (typeof listOrString === "string")
      return listOrString.slice(0, howMany);
    return baseSlice(listOrString, 0, howMany);
  }
  function splitAt(index, input) {
    if (arguments.length === 1) {
      return (_list) => splitAt(index, _list);
    }
    if (!input)
      throw new TypeError(`Cannot read property 'slice' of ${input}`);
    if (!_isArray(input) && typeof input !== "string")
      return [[], []];
    const correctIndex = maybe(index < 0, input.length + index < 0 ? 0 : input.length + index, index);
    return [take(correctIndex, input), drop(correctIndex, input)];
  }
  function splitEvery(sliceLength, listOrString) {
    if (arguments.length === 1) {
      return (_listOrString) => splitEvery(sliceLength, _listOrString);
    }
    if (sliceLength < 1) {
      throw new Error("First argument to splitEvery must be a positive integer");
    }
    const willReturn = [];
    let counter = 0;
    while (counter < listOrString.length) {
      willReturn.push(listOrString.slice(counter, counter += sliceLength));
    }
    return willReturn;
  }
  function splitWhen(predicate, input) {
    if (arguments.length === 1) {
      return (_input) => splitWhen(predicate, _input);
    }
    if (!input)
      throw new TypeError(`Cannot read property 'length' of ${input}`);
    const preFound = [];
    const postFound = [];
    let found = false;
    let counter = -1;
    while (counter++ < input.length - 1) {
      if (found) {
        postFound.push(input[counter]);
      } else if (predicate(input[counter])) {
        postFound.push(input[counter]);
        found = true;
      } else {
        preFound.push(input[counter]);
      }
    }
    return [preFound, postFound];
  }
  function startsWith(target, str) {
    if (arguments.length === 1)
      return (_str) => startsWith(target, _str);
    return str.startsWith(target);
  }
  function subtract(a, b) {
    if (arguments.length === 1)
      return (_b) => subtract(a, _b);
    return a - b;
  }
  function symmetricDifference(x, y) {
    if (arguments.length === 1) {
      return (_y) => symmetricDifference(x, _y);
    }
    return concat(filter((value) => !includes(value, y), x), filter((value) => !includes(value, x), y));
  }
  function tail(listOrString) {
    return drop(1, listOrString);
  }
  function takeLast(howMany, listOrString) {
    if (arguments.length === 1)
      return (_listOrString) => takeLast(howMany, _listOrString);
    const len = listOrString.length;
    if (howMany < 0)
      return listOrString.slice();
    let numValue = howMany > len ? len : howMany;
    if (typeof listOrString === "string")
      return listOrString.slice(len - numValue);
    numValue = len - numValue;
    return baseSlice(listOrString, numValue, len);
  }
  function takeLastWhile(predicate, input) {
    if (arguments.length === 1) {
      return (_input) => takeLastWhile(predicate, _input);
    }
    if (input.length === 0)
      return input;
    let found = false;
    const toReturn = [];
    let counter = input.length;
    while (!found || counter === 0) {
      counter--;
      if (predicate(input[counter]) === false) {
        found = true;
      } else if (!found) {
        toReturn.push(input[counter]);
      }
    }
    return _isArray(input) ? toReturn.reverse() : toReturn.reverse().join("");
  }
  function takeWhile(predicate, iterable) {
    if (arguments.length === 1) {
      return (_iterable) => takeWhile(predicate, _iterable);
    }
    const isArray = _isArray(iterable);
    if (!isArray && typeof iterable !== "string") {
      throw new Error("`iterable` is neither list nor a string");
    }
    let flag = true;
    const holder = [];
    let counter = -1;
    while (counter++ < iterable.length - 1) {
      if (!predicate(iterable[counter])) {
        if (flag)
          flag = false;
      } else if (flag) {
        holder.push(iterable[counter]);
      }
    }
    return isArray ? holder : holder.join("");
  }
  function tap(fn, x) {
    if (arguments.length === 1)
      return (_x) => tap(fn, _x);
    fn(x);
    return x;
  }
  function test(pattern, str) {
    if (arguments.length === 1)
      return (_str) => test(pattern, _str);
    if (typeof pattern === "string") {
      throw new TypeError(`\u2018test\u2019 requires a value of type RegExp as its first argument; received "${pattern}"`);
    }
    return str.search(pattern) !== -1;
  }
  function times(fn, howMany) {
    if (arguments.length === 1)
      return (_howMany) => times(fn, _howMany);
    if (!Number.isInteger(howMany) || howMany < 0) {
      throw new RangeError("n must be an integer");
    }
    return map(fn, range(0, howMany));
  }
  function toLower(str) {
    return str.toLowerCase();
  }
  function toPairs(obj) {
    return Object.entries(obj);
  }
  function toString(x) {
    return x.toString();
  }
  function toUpper(str) {
    return str.toUpperCase();
  }
  function transpose(array) {
    return array.reduce((acc, el) => {
      el.forEach((nestedEl, i) => _isArray(acc[i]) ? acc[i].push(nestedEl) : acc.push([nestedEl]));
      return acc;
    }, []);
  }
  function trim(str) {
    return str.trim();
  }
  function isFunction(fn) {
    return ["Async", "Function"].includes(type(fn));
  }
  function tryCatch(fn, fallback) {
    if (!isFunction(fn)) {
      throw new Error(`R.tryCatch | fn '${fn}'`);
    }
    const passFallback = isFunction(fallback);
    return (...inputs) => {
      try {
        return fn(...inputs);
      } catch (e) {
        return passFallback ? fallback(e, ...inputs) : fallback;
      }
    };
  }
  function union(x, y) {
    if (arguments.length === 1)
      return (_y) => union(x, _y);
    const toReturn = x.slice();
    y.forEach((yInstance) => {
      if (!includes(yInstance, x))
        toReturn.push(yInstance);
    });
    return toReturn;
  }
  function uniqWith(predicate, list) {
    if (arguments.length === 1)
      return (_list) => uniqWith(predicate, _list);
    let index = -1;
    const len = list.length;
    const willReturn = [];
    while (++index < len) {
      const value = list[index];
      const flag = any((willReturnInstance) => predicate(value, willReturnInstance), willReturn);
      if (!flag) {
        willReturn.push(value);
      }
    }
    return willReturn;
  }
  function unless(predicate, whenFalse) {
    if (arguments.length === 1) {
      return (_whenFalse) => unless(predicate, _whenFalse);
    }
    return (input) => {
      if (predicate(input))
        return input;
      return whenFalse(input);
    };
  }
  function values(obj) {
    if (type(obj) !== "Object")
      return [];
    return Object.values(obj);
  }
  var Const = (x) => ({
    x,
    map: (fn) => Const(x)
  });
  function view(lens2, target) {
    if (arguments.length === 1)
      return (_target) => view(lens2, _target);
    return lens2(Const)(target).x;
  }
  function whenFn(predicate, whenTrueFn, input) {
    if (!predicate(input))
      return input;
    return whenTrueFn(input);
  }
  var when = curry(whenFn);
  function where(conditions, input) {
    if (input === void 0) {
      return (_input) => where(conditions, _input);
    }
    let flag = true;
    for (const prop2 in conditions) {
      const result = conditions[prop2](input[prop2]);
      if (flag && result === false) {
        flag = false;
      }
    }
    return flag;
  }
  function whereEq(condition, input) {
    if (arguments.length === 1) {
      return (_input) => whereEq(condition, _input);
    }
    const result = filter((conditionValue, conditionProp) => equals(conditionValue, input[conditionProp]), condition);
    return Object.keys(result).length === Object.keys(condition).length;
  }
  function without(matchAgainst, source2) {
    if (source2 === void 0) {
      return (_source) => without(matchAgainst, _source);
    }
    return reduce((prev, current) => includesArray(current, matchAgainst) ? prev : prev.concat(current), [], source2);
  }
  function xor(a, b) {
    if (arguments.length === 1)
      return (_b) => xor(a, _b);
    return Boolean(a) && !b || Boolean(b) && !a;
  }
  function zip(left, right) {
    if (arguments.length === 1)
      return (_right) => zip(left, _right);
    const result = [];
    const length2 = Math.min(left.length, right.length);
    for (let i = 0; i < length2; i++) {
      result[i] = [left[i], right[i]];
    }
    return result;
  }
  function zipObj(keys2, values2) {
    if (arguments.length === 1)
      return (yHolder) => zipObj(keys2, yHolder);
    return take(values2.length, keys2).reduce((prev, xInstance, i) => {
      prev[xInstance] = values2[i];
      return prev;
    }, {});
  }
  function zipWithFn(fn, x, y) {
    return take(x.length > y.length ? y.length : x.length, x).map((xInstance, i) => fn(xInstance, y[i]));
  }
  var zipWith = curry(zipWithFn);

  // src/lib/keyseq.ts
  var keyseq_exports = {};
  __export(keyseq_exports, {
    MinimalKey: () => MinimalKey,
    bracketexprToKey: () => bracketexprToKey,
    commandKey2jsKey: () => commandKey2jsKey,
    completions: () => completions,
    hasModifiers: () => hasModifiers,
    hasNonShiftModifiers: () => hasNonShiftModifiers,
    isSimpleKey: () => isSimpleKey,
    keyMap: () => keyMap,
    mapstrMapToKeyMap: () => mapstrMapToKeyMap,
    mapstrToKeyseq: () => mapstrToKeyseq,
    minimalKeyToMozMap: () => minimalKeyToMozMap,
    mozMapToMinimalKey: () => mozMapToMinimalKey,
    parse: () => parse,
    stripOnlyModifiers: () => stripOnlyModifiers,
    translateKeysInPlace: () => translateKeysInPlace,
    translateKeysUsingKeyTranslateMap: () => translateKeysUsingKeyTranslateMap
  });

  // src/lib/itertools.ts
  var itertools_exports = {};
  __export(itertools_exports, {
    chain: () => chain2,
    dropwhile: () => dropwhile,
    enumerate: () => enumerate,
    filter: () => filter2,
    find: () => find2,
    head: () => head2,
    islice: () => islice,
    iterEq: () => iterEq,
    izip: () => izip,
    map: () => map2,
    permutationsWithReplacement: () => permutationsWithReplacement,
    range: () => range2,
    tail: () => tail2,
    takewhile: () => takewhile,
    unique: () => unique,
    uniqueBy: () => uniqueBy,
    zeros: () => zeros,
    zip: () => zip2
  });

  // src/lib/number.mod.ts
  Number.prototype.mod = function(n) {
    return knuth_mod(this, n);
  };
  function knuth_mod(dividend, divisor) {
    return dividend - divisor * Math.floor(dividend / divisor);
  }

  // src/lib/itertools.ts
  function head2(iterable) {
    const iterator = iterable[Symbol.iterator]();
    const result = iterator.next();
    if (result.done)
      throw RangeError("Empty iterator has no head/tail");
    else
      return result.value;
  }
  function tail2(iter) {
    if (Array.isArray(iter)) {
      if (iter.length < 1)
        throw RangeError("Empty iterator has no head/tail");
      return iter[iter.length - 1];
    } else {
      let last2 = head2(iter);
      for (last2 of iter)
        ;
      return last2;
    }
  }
  function* filter2(iter, predicate) {
    for (const v of iter) {
      if (predicate(v))
        yield v;
    }
  }
  function find2(iter, predicate) {
    return head2(filter2(iter, predicate));
  }
  function zip2(...arrays) {
    return [...Array(arrays[0].length)].map((_, i) => arrays.map((a) => a[i]));
  }
  function* range2(length2) {
    if (length2 < 0)
      return;
    for (let index = 0; index < length2; index++) {
      yield index;
    }
  }
  function* enumerate(iterable) {
    let index = 0;
    for (const element of iterable) {
      yield [index, element];
      index++;
    }
  }
  function* izip(...arrays) {
    const iterators = arrays.map((e) => e[Symbol.iterator]());
    const box = Array(arrays.length);
    for (let v of iterators[0]) {
      box[0] = v;
      let i;
      try {
        for ([i, v] of enumerate(iterators.slice(1))) {
          box[i + 1] = head2(v);
        }
        yield [...box];
      } catch (e) {
        return;
      }
    }
  }
  function iterEq(...arrays) {
    for (const a of zip2(...arrays)) {
      if (!a.reduce((x, y) => x === y))
        return false;
    }
    return true;
  }
  function zeros(n) {
    return new Array(n).fill(0);
  }
  function* islice(iterable, start, stop) {
    const iter = iterable[Symbol.iterator]();
    if (stop === void 0) {
      stop = start;
      start = 0;
    }
    for (const _ of range2(start)) {
      const res = iter.next();
      if (res.done)
        return;
    }
    if (stop === null) {
      yield* iter;
    } else {
      for (let i = start; i < stop; i++) {
        const res = iter.next();
        if (res.done)
          return;
        else
          yield res.value;
      }
    }
  }
  function* chain2(...iterables) {
    for (const iter of iterables) {
      yield* iter[Symbol.iterator]();
    }
  }
  function* permutationsWithReplacement(arr, n) {
    const len = arr.length;
    const counters = zeros(n);
    let index = 1;
    for (const _ of range2(Math.pow(len, n))) {
      yield counters.map((i) => arr[i]);
      for (const i of range2(counters.length)) {
        if (index.mod(Math.pow(len, counters.length - 1 - i)) === 0)
          counters[i] = (counters[i] + 1).mod(len);
      }
      index++;
    }
  }
  function* map2(arr, func) {
    for (const v of arr)
      yield func(v);
  }
  function unique(arr) {
    return arr.reduce((acc, cur) => {
      if (!acc.includes(cur))
        acc.push(cur);
      return acc;
    }, []);
  }
  function* uniqueBy(arr, hasher) {
    const hashes = new Set();
    for (const e of arr) {
      const hash = hasher(e);
      if (!hashes.has(hash)) {
        yield e;
        hashes.add(hash);
      }
    }
  }
  function* dropwhile(iterable, predicate) {
    let allmatched = true;
    for (const elem of iterable) {
      if (!(allmatched && predicate(elem))) {
        allmatched = false;
        yield elem;
      }
    }
  }
  function* takewhile(iterable, predicate) {
    for (const elem of iterable) {
      if (predicate(elem)) {
        yield elem;
      } else {
        return;
      }
    }
  }

  // src/lib/nearley_utils.ts
  var nearley = __toModule(require_nearley());
  var Parser2 = class {
    constructor(grammar2) {
      this.parser = new nearley.Parser(nearley.Grammar.fromCompiled(grammar2));
      this.initial_state = this.parser.save();
    }
    feedUntilError(input) {
      let lastResult;
      let consumedIndex = 0;
      try {
        for (const val of input) {
          this.parser.feed(val);
          lastResult = this.parser.results[0];
          consumedIndex++;
        }
      } finally {
        this.reset();
        if (lastResult === void 0) {
          throw new Error("Error: no result!");
        } else {
          return [lastResult, input.slice(consumedIndex)];
        }
      }
    }
    reset() {
      this.parser.restore(this.initial_state);
    }
  };

  // src/grammars/.bracketexpr.generated.ts
  function id(d) {
    return d[0];
  }
  var grammar = {
    Lexer: void 0,
    ParserRules: [
      { "name": "BracketExpr", "symbols": [{ "literal": "<" }, "Modifier", "ModKey", { "literal": ">" }], "postprocess": (bexpr) => bexpr.slice(1, -1) },
      { "name": "BracketExpr", "symbols": [{ "literal": "<" }, "Key", { "literal": ">" }], "postprocess": (bexpr) => [{}].concat(bexpr.slice(1, -1)) },
      { "name": "Modifier$ebnf$1", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$1", "symbols": [], "postprocess": () => null },
      { "name": "Modifier$ebnf$2", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$2", "symbols": [], "postprocess": () => null },
      { "name": "Modifier$ebnf$3", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$3", "symbols": [], "postprocess": () => null },
      { "name": "Modifier$ebnf$4", "symbols": [/[acmsACMS]/], "postprocess": id },
      { "name": "Modifier$ebnf$4", "symbols": [], "postprocess": () => null },
      {
        "name": "Modifier",
        "symbols": ["Modifier$ebnf$1", "Modifier$ebnf$2", "Modifier$ebnf$3", "Modifier$ebnf$4", { "literal": "-" }],
        "postprocess": (mods, _, reject2) => {
          const longNames = new Map([
            ["A", "altKey"],
            ["C", "ctrlKey"],
            ["M", "metaKey"],
            ["S", "shiftKey"]
          ]);
          let modifiersObj = {};
          for (let mod of mods) {
            if (mod === null || mod === "-")
              continue;
            let longName = longNames.get(mod.toUpperCase());
            if (longName) {
              if (longName in modifiersObj)
                return reject2;
              else
                modifiersObj[longName] = true;
            }
          }
          return modifiersObj;
        }
      },
      { "name": "ModKey", "symbols": [{ "literal": "<" }], "postprocess": id },
      { "name": "ModKey", "symbols": [{ "literal": ">" }], "postprocess": id },
      { "name": "ModKey", "symbols": [{ "literal": "-" }], "postprocess": id },
      { "name": "ModKey", "symbols": ["Key"], "postprocess": id },
      { "name": "Key$ebnf$1", "symbols": [/[^\s<>-]/] },
      { "name": "Key$ebnf$1", "symbols": ["Key$ebnf$1", /[^\s<>-]/], "postprocess": (d) => d[0].concat([d[1]]) },
      { "name": "Key", "symbols": ["Key$ebnf$1"], "postprocess": (key) => key[0].join("") }
    ],
    ParserStart: "BracketExpr"
  };
  var bracketexpr_generated_default = grammar;

  // src/lib/keyseq.ts
  var bracketexpr_grammar = bracketexpr_generated_default;
  var bracketexpr_parser = new Parser2(bracketexpr_grammar);
  var MinimalKey = class {
    constructor(key, modifiers) {
      this.key = key;
      this.altKey = false;
      this.ctrlKey = false;
      this.metaKey = false;
      this.shiftKey = false;
      if (modifiers !== void 0) {
        for (const mod of Object.keys(modifiers)) {
          this[mod] = modifiers[mod];
        }
      }
    }
    match(keyevent) {
      for (const attr in this) {
        if (attr === "shiftKey" && this.key.length === 1)
          continue;
        if (this[attr] !== keyevent[attr])
          return false;
      }
      return true;
    }
    toMapstr() {
      let str = "";
      let needsBrackets = this.key.length > 1;
      const modifiers = new Map([
        ["A", "altKey"],
        ["C", "ctrlKey"],
        ["M", "metaKey"],
        ["S", "shiftKey"]
      ]);
      for (const [letter, attr] of modifiers.entries()) {
        if (this[attr]) {
          str += letter;
          needsBrackets = true;
        }
      }
      if (str) {
        str += "-";
      }
      let key = this.key;
      if (key === " ") {
        key = "Space";
        needsBrackets = true;
      }
      str += key;
      if (needsBrackets) {
        str = "<" + str + ">";
      }
      return str;
    }
  };
  function splitNumericPrefix(keyseq4) {
    if (!hasModifiers(keyseq4[0]) && [1, 2, 3, 4, 5, 6, 7, 8, 9].includes(Number(keyseq4[0].key))) {
      const prefix = [keyseq4[0]];
      for (const ke of keyseq4.slice(1)) {
        if (!hasModifiers(ke) && [0, 1, 2, 3, 4, 5, 6, 7, 8, 9].includes(Number(ke.key)))
          prefix.push(ke);
        else
          break;
      }
      const rest = keyseq4.slice(prefix.length);
      return [prefix, rest];
    } else {
      return [[], keyseq4];
    }
  }
  function stripOnlyModifiers(keyseq4) {
    return keyseq4.filter((key) => !["Control", "Shift", "Alt", "AltGraph", "Meta"].includes(key.key));
  }
  function parse(keyseq4, map3) {
    keyseq4 = stripOnlyModifiers(keyseq4);
    if (keyseq4.length === 0)
      return { keys: [], isMatch: false };
    let numericPrefix;
    [numericPrefix, keyseq4] = splitNumericPrefix(keyseq4);
    let possibleMappings = completions(keyseq4, map3);
    while (possibleMappings.size === 0 && keyseq4.length > 0) {
      keyseq4.shift();
      numericPrefix = [];
      possibleMappings = completions(keyseq4, map3);
    }
    if (possibleMappings.size > 0) {
      try {
        const perfect = find2(possibleMappings, ([k, _v]) => k.length === keyseq4.length);
        return {
          value: perfect[1],
          exstr: perfect[1] + numericPrefixToExstrSuffix(numericPrefix),
          isMatch: true,
          numericPrefix: numericPrefix.length ? Number(numericPrefix.map((ke) => ke.key).join("")) : void 0,
          keys: []
        };
      } catch (e) {
        if (!(e instanceof RangeError))
          throw e;
      }
    }
    return { keys: numericPrefix.concat(keyseq4), isMatch: keyseq4.length > 0 };
  }
  function prefixes(seq1, seq2) {
    if (seq1.length > seq2.length) {
      return false;
    } else {
      for (const [key1, key2] of izip(seq1, seq2)) {
        if (!key2.match(key1))
          return false;
      }
      return true;
    }
  }
  function completions(keyseq4, map3) {
    return new Map(filter2(map3.entries(), ([ks, _maptarget]) => prefixes(keyseq4, ks)));
  }
  function expandAliases(key) {
    const aliases2 = {
      cr: "Enter",
      esc: "Escape",
      return: "Enter",
      enter: "Enter",
      space: " ",
      bar: "|",
      del: "Delete",
      bs: "Backspace",
      lt: "<"
    };
    if (key.toLowerCase() in aliases2)
      return aliases2[key.toLowerCase()];
    else
      return key;
  }
  function bracketexprToKey(inputStr) {
    if (inputStr.indexOf(">") > 0) {
      try {
        const [
          [modifiers, key],
          remainder
        ] = bracketexpr_parser.feedUntilError(inputStr);
        return [new MinimalKey(expandAliases(key), modifiers), remainder];
      } catch (e) {
        return [new MinimalKey("<"), inputStr.slice(1)];
      }
    } else {
      return [new MinimalKey("<"), inputStr.slice(1)];
    }
  }
  function mapstrToKeyseq(mapstr) {
    const keyseq4 = [];
    let key;
    while (mapstr.length) {
      if (mapstr[0] === "<") {
        ;
        [key, mapstr] = bracketexprToKey(mapstr);
        keyseq4.push(key);
      } else {
        keyseq4.push(new MinimalKey(mapstr[0]));
        mapstr = mapstr.slice(1);
      }
    }
    return keyseq4;
  }
  var commandKey2jsKey = {
    Comma: ",",
    Period: ".",
    Up: "ArrowUp",
    Down: "ArrowDown",
    Left: "ArrowLeft",
    Right: "ArrowRight",
    Space: " "
  };
  function mozMapToMinimalKey(mozmap) {
    const arr = mozmap.split("+");
    const modifiers = {
      altKey: arr.includes("Alt"),
      ctrlKey: arr.includes("MacCtrl"),
      shiftKey: arr.includes("Shift"),
      metaKey: arr.includes("Command")
    };
    let key = arr[arr.length - 1];
    key = propOr(key.toLowerCase(), key, commandKey2jsKey);
    return new MinimalKey(key, modifiers);
  }
  function minimalKeyToMozMap(key) {
    const mozMap = [];
    key.altKey && mozMap.push("Alt");
    key.ctrlKey && mozMap.push("MacCtrl");
    key.shiftKey && mozMap.push("Shift");
    key.metaKey && mozMap.push("Command");
    const jsKey2commandKey = Object.fromEntries(Object.entries(commandKey2jsKey).map(([key2, value]) => [value, key2]));
    mozMap.push(propOr(key.key.toUpperCase(), key.key, jsKey2commandKey));
    return mozMap.join("+");
  }
  function mapstrMapToKeyMap(mapstrMap) {
    const newKeyMap = new Map();
    for (const [mapstr, target] of mapstrMap.entries()) {
      newKeyMap.set(mapstrToKeyseq(mapstr), target);
    }
    return newKeyMap;
  }
  var KEYMAP_CACHE = {};
  function translateKeysInPlace(keys2, conf) {
    if (get("keytranslatemodes")[conf] === "true") {
      const translationmap = get("keytranslatemap");
      translateKeysUsingKeyTranslateMap(keys2, translationmap);
    }
  }
  function keyMap(conf) {
    if (KEYMAP_CACHE[conf])
      return KEYMAP_CACHE[conf];
    if (!INITIALISED)
      return new Map();
    const mapobj = get(conf);
    if (mapobj === void 0)
      throw new Error("No binds defined for this mode. Reload page with <C-r> and add binds, e.g. :bind --mode=[mode] <Esc> mode normal");
    const maps = new Map(Object.entries(mapobj));
    KEYMAP_CACHE[conf] = mapstrMapToKeyMap(maps);
    return KEYMAP_CACHE[conf];
  }
  function hasModifiers(keyEvent) {
    return keyEvent.ctrlKey || keyEvent.altKey || keyEvent.metaKey || keyEvent.shiftKey;
  }
  function hasNonShiftModifiers(keyEvent) {
    return keyEvent.ctrlKey || keyEvent.altKey || keyEvent.metaKey;
  }
  function isSimpleKey(keyEvent) {
    return !(keyEvent.key.length > 1 || hasNonShiftModifiers(keyEvent));
  }
  function numericPrefixToExstrSuffix(numericPrefix) {
    if (numericPrefix.length > 0) {
      return " " + numericPrefix.map((k) => k.key).join("");
    } else {
      return "";
    }
  }
  function translateKeysUsingKeyTranslateMap(keyEvents, keytranslatemap) {
    for (let index = 0; index < keyEvents.length; index++) {
      const keyEvent = keyEvents[index];
      const newkey = keytranslatemap[keyEvent.key];
      const neverTranslated = keyEvent instanceof KeyboardEvent;
      if (neverTranslated && newkey !== void 0) {
        keyEvents[index] = new MinimalKey(newkey, {
          altKey: keyEvent.altKey,
          ctrlKey: keyEvent.ctrlKey,
          metaKey: keyEvent.metaKey,
          shiftKey: keyEvent.shiftKey
        });
      }
    }
  }
  browser.storage.onChanged.addListener((changes) => {
    if ("userconfig" in changes) {
      KEYMAP_CACHE = {};
    }
  });

  // src/lib/binding.ts
  var mode2maps = new Map([
    ["normal", "nmaps"],
    ["ignore", "ignoremaps"],
    ["insert", "imaps"],
    ["input", "inputmaps"],
    ["ex", "exmaps"],
    ["hint", "hintmaps"],
    ["visual", "vmaps"],
    ["browser", "browsermaps"]
  ]);
  var maps2mode = new Map(Array.from(mode2maps.keys()).map((k) => [mode2maps.get(k), k]));
  var modes = Array.from(mode2maps.keys());
  var modeMaps = Array.from(maps2mode.keys());

  // src/lib/platform.ts
  function getPlatformOs() {
    const platform2 = navigator.platform;
    const mapping = {
      win: "Win",
      openbsd: "BSD",
      mac: "Mac",
      linux: "Linux"
    };
    return keys(filter((x) => platform2.includes(x), mapping))[0];
  }

  // src/lib/config.ts
  var removeNull = when(is(Object), pipe(reject((val) => val === null), map((a) => removeNull(a))));
  var CONFIGNAME = "userconfig";
  var WAITERS = [];
  var INITIALISED = false;
  function o(object) {
    return Object.assign(Object.create(null), object);
  }
  function schlepp(settings) {
    Object.assign(USERCONFIG, settings);
  }
  var USERCONFIG = o({});
  var default_config = class {
    constructor() {
      this.configversion = "0.0";
      this.subconfigs = {
        "www.google.com": {
          followpagepatterns: {
            next: "Next",
            prev: "Previous"
          }
        },
        "^https://web.whatsapp.com": {
          nmaps: {
            f: "hint -c [tabindex]:not(.two)>div,a",
            F: "hint -bc [tabindex]:not(.two)>div,a"
          }
        }
      };
      this.priority = 0;
      this.exmaps = {
        "<Enter>": "ex.accept_line",
        "<C-Enter>": "ex.execute_ex_on_completion",
        "<C-j>": "ex.accept_line",
        "<C-m>": "ex.accept_line",
        "<Escape>": "ex.hide_and_clear",
        "<C-[>": "ex.hide_and_clear",
        "<ArrowUp>": "ex.prev_history",
        "<ArrowDown>": "ex.next_history",
        "<S-Del>": "ex.execute_ex_on_completion_args tabclose",
        "<A-b>": "text.backward_word",
        "<A-f>": "text.forward_word",
        "<C-e>": "text.end_of_line",
        "<A-d>": "text.kill_word",
        "<S-Backspace>": "text.backward_kill_word",
        "<C-u>": "text.backward_kill_line",
        "<C-k>": "text.kill_line",
        "<C-f>": "ex.complete",
        "<Tab>": "ex.next_completion",
        "<S-Tab>": "ex.prev_completion",
        "<Space>": "ex.insert_space_or_completion",
        "<C-o>yy": "ex.execute_ex_on_completion_args clipboard yank"
      };
      this.ignoremaps = {
        "<S-Insert>": "mode normal",
        "<AC-Escape>": "mode normal",
        "<AC-`>": "mode normal",
        "<S-Escape>": "mode normal",
        "<C-o>": "nmode normal 1 mode ignore"
      };
      this.imaps = {
        "<Escape>": "composite unfocus | mode normal",
        "<C-[>": "composite unfocus | mode normal",
        "<C-i>": "editor",
        "<AC-Escape>": "mode normal",
        "<AC-`>": "mode normal",
        "<S-Escape>": "mode ignore"
      };
      this.inputmaps = {
        "<Tab>": "focusinput -n",
        "<S-Tab>": "focusinput -N",
        "\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}": "imaps"
      };
      this.nmaps = {
        "<A-p>": "pin",
        "<A-m>": "mute toggle",
        "<F1>": "help",
        o: "fillcmdline open",
        O: "current_url open",
        w: "fillcmdline winopen",
        W: "current_url winopen",
        t: "fillcmdline tabopen",
        "]]": "followpage next",
        "[[": "followpage prev",
        "[c": "urlincrement -1",
        "]c": "urlincrement 1",
        "<C-x>": "urlincrement -1",
        "<C-a>": "urlincrement 1",
        T: "current_url tabopen",
        yy: "clipboard yank",
        ys: "clipboard yankshort",
        yc: "clipboard yankcanon",
        ym: "clipboard yankmd",
        yo: "clipboard yankorg",
        yt: "clipboard yanktitle",
        gh: "home",
        gH: "home true",
        p: "clipboard open",
        P: "clipboard tabopen",
        j: "scrollline 10",
        "<C-e>": "scrollline 10",
        k: "scrollline -10",
        "<C-y>": "scrollline -10",
        h: "scrollpx -50",
        l: "scrollpx 50",
        G: "scrollto 100",
        gg: "scrollto 0",
        "<C-u>": "scrollpage -0.5",
        "<C-d>": "scrollpage 0.5",
        "<C-f>": "scrollpage 1",
        "<C-b>": "scrollpage -1",
        "<C-v>": "nmode ignore 1 mode normal",
        $: "scrollto 100 x",
        "^": "scrollto 0 x",
        H: "back",
        L: "forward",
        "<C-o>": "jumpprev",
        "<C-i>": "jumpnext",
        d: "tabclose",
        D: "composite tabprev; tabclose #",
        gx0: "tabclosealltoleft",
        gx$: "tabclosealltoright",
        "<<": "tabmove -1",
        ">>": "tabmove +1",
        u: "undo",
        U: "undo window",
        r: "reload",
        R: "reloadhard",
        x: "stop",
        gi: "focusinput -l",
        "g?": "rot13",
        "g!": "jumble",
        "g;": "changelistjump -1",
        J: "tabprev",
        K: "tabnext",
        gt: "tabnext_gt",
        gT: "tabprev",
        "g^": "tabfirst",
        g0: "tabfirst",
        g$: "tablast",
        ga: "tabaudio",
        gr: "reader",
        gu: "urlparent",
        gU: "urlroot",
        gf: "viewsource",
        ":": "fillcmdline_notrail",
        s: "fillcmdline open search",
        S: "fillcmdline tabopen search",
        M: "gobble 1 quickmark",
        B: "fillcmdline taball",
        b: "fillcmdline tab",
        ZZ: "qall",
        f: "hint",
        F: "hint -b",
        gF: "hint -qb",
        ";i": "hint -i",
        ";b": "hint -b",
        ";o": "hint",
        ";I": "hint -I",
        ";k": "hint -k",
        ";K": "hint -K",
        ";y": "hint -y",
        ";Y": "hint -cF img i => tri.excmds.yankimage(tri.urlutils.getAbsoluteURL(i.src))",
        ";p": "hint -p",
        ";h": "hint -h",
        v: "hint -h",
        ";P": "hint -P",
        ";r": "hint -r",
        ";s": "hint -s",
        ";S": "hint -S",
        ";a": "hint -a",
        ";A": "hint -A",
        ";;": "hint -; *",
        ";#": "hint -#",
        ";v": "hint -W mpvsafe",
        ";V": "hint -V",
        ";w": "hint -w",
        ";t": "hint -W tabopen",
        ";O": "hint -W fillcmdline_notrail open ",
        ";W": "hint -W fillcmdline_notrail winopen ",
        ";T": "hint -W fillcmdline_notrail tabopen ",
        ";z": "hint -z",
        ";m": "composite hint -Jpipe img src | open images.google.com/searchbyimage?image_url=",
        ";M": "composite hint -Jpipe img src | tabopen images.google.com/searchbyimage?image_url=",
        ";gi": "hint -qi",
        ";gI": "hint -qI",
        ";gk": "hint -qk",
        ";gy": "hint -qy",
        ";gp": "hint -qp",
        ";gP": "hint -qP",
        ";gr": "hint -qr",
        ";gs": "hint -qs",
        ";gS": "hint -qS",
        ";ga": "hint -qa",
        ";gA": "hint -qA",
        ";g;": "hint -q;",
        ";g#": "hint -q#",
        ";gv": "hint -qW mpvsafe",
        ";gw": "hint -qw",
        ";gb": "hint -qb",
        ";gF": "hint -qb",
        ";gf": "hint -q",
        "<S-Insert>": "mode ignore",
        "<AC-Escape>": "mode ignore",
        "<AC-`>": "mode ignore",
        "<S-Escape>": "mode ignore",
        "<Escape>": "composite mode normal ; hidecmdline",
        "<C-[>": "composite mode normal ; hidecmdline",
        a: "current_url bmark",
        A: "bmark",
        zi: "zoom 0.1 true",
        zo: "zoom -0.1 true",
        zm: "zoom 0.5 true",
        zr: "zoom -0.5 true",
        zM: "zoom 0.5 true",
        zR: "zoom -0.5 true",
        zz: "zoom 1",
        zI: "zoom 3",
        zO: "zoom 0.3",
        ".": "repeat",
        "<AS-ArrowUp><AS-ArrowUp><AS-ArrowDown><AS-ArrowDown><AS-ArrowLeft><AS-ArrowRight><AS-ArrowLeft><AS-ArrowRight>ba": "open https://www.youtube.com/watch?v=M3iOROuTuMA"
      };
      this.vmaps = {
        "<Escape>": "composite js document.getSelection().empty(); mode normal; hidecmdline",
        "<C-[>": "composite js document.getSelection().empty(); mode normal ; hidecmdline",
        y: "composite js document.getSelection().toString() | clipboard yank",
        s: "composite js document.getSelection().toString() | fillcmdline open search",
        S: "composite js document.getSelection().toString() | fillcmdline tabopen search",
        l: 'js document.getSelection().modify("extend","forward","character")',
        h: 'js document.getSelection().modify("extend","backward","character")',
        e: 'js document.getSelection().modify("extend","forward","word")',
        w: 'js document.getSelection().modify("extend","forward","word"); document.getSelection().modify("extend","forward","word"); document.getSelection().modify("extend","backward","word"); document.getSelection().modify("extend","forward","character")',
        b: 'js document.getSelection().modify("extend","backward","character"); document.getSelection().modify("extend","backward","word"); document.getSelection().modify("extend","forward","character")',
        j: 'js document.getSelection().modify("extend","forward","line")',
        k: 'js document.getSelection().modify("extend","backward","line")',
        $: 'js document.getSelection().modify("extend","forward","lineboundary")',
        "0": 'js document.getSelection().modify("extend","backward","lineboundary")',
        "=": "js let n = document.getSelection().anchorNode.parentNode; let s = window.getSelection(); let r = document.createRange(); s.removeAllRanges(); r.selectNodeContents(n); s.addRange(r)",
        o: "js tri.visual.reverseSelection(document.getSelection())",
        "\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}": "nmaps"
      };
      this.hintmaps = {
        "<Backspace>": "hint.popKey",
        "<Escape>": "hint.reset",
        "<C-[>": "hint.reset",
        "<Tab>": "hint.focusNextHint",
        "<S-Tab>": "hint.focusPreviousHint",
        "<ArrowUp>": "hint.focusTopHint",
        "<ArrowDown>": "hint.focusBottomHint",
        "<ArrowLeft>": "hint.focusLeftHint",
        "<ArrowRight>": "hint.focusRightHint",
        "<Enter>": "hint.selectFocusedHint",
        "<Space>": "hint.selectFocusedHint"
      };
      this.browsermaps = {
        "<C-,>": "escapehatch",
        "<C-6>": "tab #",
        "<CS-6>": "tab #"
      };
      this.leavegithubalone = "false";
      this.blacklistkeys = ["/"];
      this.autocmds = {
        DocStart: {},
        DocLoad: {
          "^https://github.com/tridactyl/tridactyl/issues/new$": "issue"
        },
        DocEnd: {},
        TriStart: {
          ".*": "source_quiet"
        },
        TabEnter: {},
        TabLeft: {},
        FullscreenChange: {},
        FullscreenEnter: {},
        FullscreenLeft: {}
      };
      this.keytranslatemap = {};
      this.keytranslatemodes = {
        nmaps: "true",
        imaps: "false",
        inputmaps: "false",
        ignoremaps: "false",
        exmaps: "false",
        hintmaps: "false"
      };
      this.autocontain = o({});
      this.autocontainmode = "strict";
      this.exaliases = {
        alias: "command",
        au: "autocmd",
        aucon: "autocontain",
        audel: "autocmddelete",
        audelete: "autocmddelete",
        blacklistremove: "autocmddelete DocStart",
        b: "tab",
        clsh: "clearsearchhighlight",
        nohlsearch: "clearsearchhighlight",
        noh: "clearsearchhighlight",
        o: "open",
        w: "winopen",
        t: "tabopen",
        tabnew: "tabopen",
        tabm: "tabmove",
        tabo: "tabonly",
        tn: "tabnext_gt",
        bn: "tabnext_gt",
        tnext: "tabnext_gt",
        bnext: "tabnext_gt",
        tp: "tabprev",
        tN: "tabprev",
        bp: "tabprev",
        bN: "tabprev",
        tprev: "tabprev",
        bprev: "tabprev",
        tabfirst: "tab 1",
        tablast: "tab 0",
        bfirst: "tabfirst",
        blast: "tablast",
        tfirst: "tabfirst",
        tlast: "tablast",
        buffer: "tab",
        bufferall: "taball",
        bd: "tabclose",
        bdelete: "tabclose",
        quit: "tabclose",
        q: "tabclose",
        qa: "qall",
        sanitize: "sanitise",
        "saveas!": "saveas --cleanup --overwrite",
        tutorial: "tutor",
        h: "help",
        unmute: "mute unmute",
        authors: "credits",
        openwith: "hint -W",
        "!": "exclaim",
        "!s": "exclaim_quiet",
        containerremove: "containerdelete",
        colours: "colourscheme",
        colorscheme: "colourscheme",
        colors: "colourscheme",
        man: "help",
        "!js": "fillcmdline_tmp 3000 !js is deprecated. Please use js instead",
        "!jsb": "fillcmdline_tmp 3000 !jsb is deprecated. Please use jsb instead",
        get_current_url: "js document.location.href",
        current_url: "composite get_current_url | fillcmdline_notrail ",
        stop: "js window.stop()",
        zo: "zoom",
        installnative: "nativeinstall",
        nativeupdate: "updatenative",
        mkt: "mktridactylrc",
        "mkt!": "mktridactylrc -f",
        "mktridactylrc!": "mktridactylrc -f",
        mpvsafe: "js -p tri.excmds.shellescape(JS_ARG).then(url => tri.excmds.exclaim_quiet('mpv --no-terminal ' + url))",
        drawingstop: "no_mouse_mode",
        exto: "extoptions",
        extpreferences: "extoptions",
        extp: "extpreferences",
        prefset: "setpref",
        prefremove: "removepref",
        tabclosealltoright: "tabcloseallto right",
        tabclosealltoleft: "tabcloseallto left",
        reibadailty: "jumble"
      };
      this.followpagepatterns = {
        next: "^(next|newer)\\b|\xBB|>>|more",
        prev: "^(prev(ious)?|older)\\b|\xAB|<<"
      };
      this.searchengine = "";
      this.searchurls = {
        google: "https://www.google.com/search?q=",
        googlelucky: "https://www.google.com/search?btnI=I'm+Feeling+Lucky&q=",
        scholar: "https://scholar.google.com/scholar?q=",
        googleuk: "https://www.google.co.uk/search?q=",
        bing: "https://www.bing.com/search?q=",
        duckduckgo: "https://duckduckgo.com/?q=",
        yahoo: "https://search.yahoo.com/search?p=",
        twitter: "https://twitter.com/search?q=",
        wikipedia: "https://en.wikipedia.org/wiki/Special:Search/",
        youtube: "https://www.youtube.com/results?search_query=",
        amazon: "https://www.amazon.com/s/ref=nb_sb_noss?url=search-alias%3Daps&field-keywords=",
        amazonuk: "https://www.amazon.co.uk/s/ref=nb_sb_noss?url=search-alias%3Daps&field-keywords=",
        startpage: "https://startpage.com/do/search?language=english&cat=web&query=",
        github: "https://github.com/search?utf8=\u2713&q=",
        searx: "https://searx.me/?category_general=on&q=",
        cnrtl: "http://www.cnrtl.fr/lexicographie/",
        osm: "https://www.openstreetmap.org/search?query=",
        mdn: "https://developer.mozilla.org/en-US/search?q=",
        gentoo_wiki: "https://wiki.gentoo.org/index.php?title=Special%3ASearch&profile=default&fulltext=Search&search=",
        qwant: "https://www.qwant.com/?q="
      };
      this.newtab = "";
      this.viewsource = "tridactyl";
      this.homepages = [];
      this.hintchars = "hjklasdfgyuiopqwertnmzxcvb";
      this.hintfiltermode = "simple";
      this.hintnames = "short";
      this.hintuppercase = "true";
      this.hintdelay = 300;
      this.hintshift = "false";
      this.hintautoselect = "true";
      this.allowautofocus = "true";
      this.preventautofocusjackhammer = "false";
      this.smoothscroll = "false";
      this.scrollduration = 100;
      this.tabopenpos = "next";
      this.tabclosepinned = "true";
      this.tabsort = "default";
      this.relatedopenpos = "related";
      this.ttsvoice = "default";
      this.ttsvolume = 1;
      this.ttsrate = 1;
      this.ttspitch = 1;
      this.gimode = "nextinput";
      this.cursorpos = "end";
      this.theme = "default";
      this.customthemes = {};
      this.modeindicator = "true";
      this.modeindicatormodes = {
        normal: "true",
        insert: "true",
        input: "true",
        ignore: "true",
        ex: "true",
        hint: "true",
        visual: "true"
      };
      this.jumpdelay = 3e3;
      this.logging = {
        cmdline: "warning",
        containers: "warning",
        controller: "warning",
        excmd: "error",
        hinting: "warning",
        messaging: "warning",
        native: "warning",
        performance: "warning",
        state: "warning",
        styling: "warning",
        autocmds: "warning"
      };
      this.noiframe = "false";
      this.noiframeon = [];
      this.editorcmd = "auto";
      this.rsscmd = "yank %u";
      this.browser = "firefox";
      this.yankto = "clipboard";
      this.putfrom = "clipboard";
      this.externalclipboardcmd = "auto";
      this.downloadsskiphistory = "false";
      this.nativeinstallcmd = "curl -fsSl https://raw.githubusercontent.com/tridactyl/native_messenger/master/installers/install.sh -o /tmp/trinativeinstall.sh && sh /tmp/trinativeinstall.sh %TAG";
      this.update = {
        nag: true,
        nagwait: 7,
        lastnaggedversion: "1.14.0",
        lastchecktime: 0,
        checkintervalsecs: 60 * 60 * 24
      };
      this.profiledir = "auto";
      this.tabopencontaineraware = "false";
      this.containerindicator = "true";
      this.auconcreatecontainer = "true";
      this.historyresults = 50;
      this.bmarkweight = 100;
      this.completions = {
        Tab: {
          autoselect: "true"
        },
        TabAll: {
          autoselect: "true"
        },
        Rss: {
          autoselect: "true"
        },
        Bmark: {
          autoselect: "true"
        },
        Sessions: {
          autoselect: "true"
        }
      };
      this.findresults = -1;
      this.findcontextlen = 100;
      this.findcase = "smart";
      this.incsearch = "false";
      this.minincsearchlen = 3;
      this.csp = "untouched";
      this.wordpattern = "[^\\s]+";
      this.perfcounters = "false";
      this.perfsamples = "10000";
      this.modeindicatorshowkeys = "false";
      this.urlparenttrailingslash = "true";
      this.visualenterauto = "true";
      this.visualexitauto = "true";
      this.escapehatchsidebarhack = "true";
      this.completionfuzziness = 0.3;
    }
  };
  var platform_defaults = {
    win: {
      browsermaps: {
        "<C-6>": null,
        "<A-6>": "buffer #"
      },
      nmaps: {
        "<C-6>": "buffer #"
      },
      imaps: {
        "<C-6>": "buffer #"
      },
      inputmaps: {
        "<C-6>": "buffer #"
      },
      ignoremaps: {
        "<C-6>": "buffer #"
      },
      nativeinstallcmd: `powershell -ExecutionPolicy Bypass -NoProfile -Command "[Net.ServicePointManager]::SecurityProtocol = [Net.ServicePointManager]::SecurityProtocol -bor [Net.SecurityProtocolType]::Tls12;(New-Object System.Net.WebClient).DownloadFile('https://raw.githubusercontent.com/tridactyl/native_messenger/master/installers/windows.ps1', '%TEMP%/tridactyl_installnative.ps1');& '%TEMP%/tridactyl_installnative.ps1' -Tag %TAG;Remove-Item '%TEMP%/tridactyl_installnative.ps1'"`
    },
    linux: {
      nmaps: {
        ";x": 'hint -F e => { const pos = tri.dom.getAbsoluteCentre(e); tri.excmds.exclaim_quiet("xdotool mousemove --sync " + window.devicePixelRatio * pos.x + " " + window.devicePixelRatio * pos.y + "; xdotool click 1")}',
        ";X": 'hint -F e => { const pos = tri.dom.getAbsoluteCentre(e); tri.excmds.exclaim_quiet("xdotool mousemove --sync " + window.devicePixelRatio * pos.x + " " + window.devicePixelRatio * pos.y + "; xdotool keydown ctrl+shift; xdotool click 1; xdotool keyup ctrl+shift")}'
      }
    }
  };
  var mergeDeepCull = pipe(mergeDeep, removeNull);
  var DEFAULTS = mergeDeepCull(o(new default_config()), platform_defaults[getPlatformOs()]);
  function getDeepProperty(obj, target) {
    if (obj !== void 0 && obj !== null && target.length) {
      if (obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"] === void 0) {
        return getDeepProperty(obj[target[0]], target.slice(1));
      } else {
        return getDeepProperty(mergeDeepCull(get(obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"]), obj)[target[0]], target.slice(1));
      }
    } else {
      if (obj === void 0 || obj === null)
        return obj;
      if (obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"] !== void 0) {
        return mergeDeepCull(get(obj["\u{1F577}\u{1F577}INHERITS\u{1F577}\u{1F577}"]), obj);
      } else {
        return obj;
      }
    }
  }
  function setDeepProperty(obj, value, target) {
    if (target.length > 1) {
      if (obj[target[0]] === void 0) {
        obj[target[0]] = o({});
      }
      return setDeepProperty(obj[target[0]], value, target.slice(1));
    } else {
      obj[target[0]] = value;
    }
  }
  function mergeDeep(o1, o2) {
    if (o1 === null)
      return Object.assign({}, o2);
    const r = Array.isArray(o1) ? o1.slice() : Object.create(o1);
    Object.assign(r, o1, o2);
    if (o2 === void 0)
      return r;
    Object.keys(o1).filter((key) => typeof o1[key] === "object" && typeof o2[key] === "object").forEach((key) => r[key] == null ? null : Object.assign(r[key], mergeDeep(o1[key], o2[key])));
    return r;
  }
  function getURL(url, target) {
    function _getURL(conf, url2, target2) {
      if (!conf.subconfigs)
        return void 0;
      return Object.keys(conf.subconfigs).filter((k) => url2.match(k) && getDeepProperty(conf.subconfigs[k], target2) !== void 0).sort((k1, k2) => (conf.subconfigs[k1].priority || 10) - (conf.subconfigs[k2].priority || 10)).reduce((acc, curKey) => {
        const curVal = getDeepProperty(conf.subconfigs[curKey], target2);
        if (acc instanceof Object && curVal instanceof Object)
          return mergeDeep(acc, curVal);
        return curVal;
      }, void 0);
    }
    const user = _getURL(USERCONFIG, url, target);
    const deflt = _getURL(DEFAULTS, url, target);
    if (user === void 0 || user === null)
      return deflt;
    if (typeof user !== "object" || typeof deflt !== "object")
      return user;
    return mergeDeepCull(deflt, user);
  }
  function get(target_typed, ...target) {
    if (target_typed === void 0) {
      target = [];
    } else {
      target = [target_typed].concat(target);
    }
    let loc = window.location;
    if (window.tri && window.tri.contentLocation)
      loc = window.tri.contentLocation;
    const site = getURL(loc.href, target);
    const user = getDeepProperty(USERCONFIG, target);
    const defult = getDeepProperty(DEFAULTS, target);
    if (typeof defult === "object") {
      return mergeDeepCull(mergeDeepCull(defult, user), site);
    } else {
      if (site !== void 0) {
        return site;
      } else if (user !== void 0) {
        return user;
      } else {
        return defult;
      }
    }
  }
  function getDynamic(...target) {
    return get(target[0], ...target.slice(1));
  }
  async function getAsyncDynamic(...target) {
    return getAsync(target[0], ...target.slice(1));
  }
  async function getAsync(target_typed, ...target) {
    if (INITIALISED) {
      const browserconfig = await browser.storage.local.get(CONFIGNAME);
      USERCONFIG = browserconfig[CONFIGNAME] || o({});
      return get(target_typed, ...target);
    } else {
      return new Promise((resolve) => WAITERS.push(() => resolve(get(target_typed, ...target))));
    }
  }
  async function push() {
    const local_conf = await browser.storage.local.get(CONFIGNAME);
    delete local_conf[CONFIGNAME]["customthemes"];
    return browser.storage.sync.set(local_conf);
  }
  async function pull() {
    return browser.storage.local.set(await browser.storage.sync.get(CONFIGNAME));
  }
  function setURL(pattern, ...args) {
    try {
      new RegExp(pattern);
      return set2("subconfigs", pattern, ...args);
    } catch (err) {
      if (err instanceof SyntaxError)
        throw new SyntaxError(`invalid pattern: ${err.message}`);
      throw err;
    }
  }
  async function set2(...args) {
    if (args.length < 2) {
      throw new Error("You must provide at least two arguments!");
    }
    const target = args.slice(0, args.length - 1);
    const value = args[args.length - 1];
    if (INITIALISED) {
      setDeepProperty(USERCONFIG, value, target);
      return save();
    } else {
      setDeepProperty(USERCONFIG, value, target);
    }
  }
  function unsetURL(pattern, ...target) {
    return unset("subconfigs", pattern, ...target);
  }
  function unset(...target) {
    const parent = getDeepProperty(USERCONFIG, target.slice(0, -1));
    if (parent !== void 0)
      delete parent[target[target.length - 1]];
    return save();
  }
  async function save() {
    const settingsobj = o({});
    settingsobj[CONFIGNAME] = USERCONFIG;
    return browser.storage.local.set(settingsobj);
  }
  async function update2() {
    const updateAll = (setting, fn) => {
      const val = getDeepProperty(USERCONFIG, setting);
      if (val) {
        set2(...setting, fn(val));
      }
      const subconfigs = getDeepProperty(USERCONFIG, ["subconfigs"]);
      if (subconfigs) {
        Object.keys(subconfigs).map((pattern) => [pattern, getURL(pattern, setting)]).filter(([_pattern, value]) => value).forEach(([pattern, value]) => setURL(pattern, ...setting, fn(value)));
      }
    };
    if (!get("configversion"))
      set2("configversion", "0.0");
    let updated = false;
    switch (get("configversion")) {
      case "0.0": {
        try {
          const legacy_nmaps = await browser.storage.sync.get("nmaps");
          if (Object.keys(legacy_nmaps).length > 0) {
            USERCONFIG.nmaps = Object.assign(legacy_nmaps.nmaps, USERCONFIG.nmaps);
          }
        } finally {
          set2("configversion", "1.0");
        }
      }
      case "1.0": {
        const vimiumgi = getDeepProperty(USERCONFIG, ["vimium-gi"]);
        if (vimiumgi === true || vimiumgi === "true")
          set2("gimode", "nextinput");
        else if (vimiumgi === false || vimiumgi === "false")
          set2("gimode", "firefox");
        unset("vimium-gi");
        set2("configversion", "1.1");
      }
      case "1.1": {
        const leveltostr = {
          0: "never",
          1: "error",
          2: "warning",
          3: "info",
          4: "debug"
        };
        const logging2 = getDeepProperty(USERCONFIG, ["logging"]);
        if (logging2)
          Object.keys(logging2).forEach((l) => set2("logging", l, leveltostr[logging2[l]]));
        set2("configversion", "1.2");
      }
      case "1.2": {
        ;
        ["ignoremaps", "inputmaps", "imaps", "nmaps"].map((mapname) => [
          mapname,
          getDeepProperty(USERCONFIG, [mapname])
        ]).filter(([_mapname, mapobj]) => mapobj).forEach(([mapname, mapobj]) => {
          Object.keys(mapobj).filter((key) => {
            var _a2;
            return ((_a2 = mapobj[key]) == null ? void 0 : _a2.search("^im_|([^a-zA-Z0-9_-])im_")) >= 0;
          }).forEach((key) => setDeepProperty(USERCONFIG, mapobj[key].replace(new RegExp("^im_|([^a-zA-Z0-9_-])im_"), "$1text."), [mapname, key]));
        });
        set2("configversion", "1.3");
      }
      case "1.3": {
        ;
        [
          "priority",
          "hintdelay",
          "scrollduration",
          "ttsvolume",
          "ttsrate",
          "ttspitch",
          "jumpdelay",
          "historyresults"
        ].forEach((setting) => updateAll([setting], parseInt));
        set2("configversion", "1.4");
      }
      case "1.4": {
        ;
        (getDeepProperty(USERCONFIG, ["noiframeon"]) || []).forEach((site) => {
          setURL(site, "noiframe", "true");
        });
        set2("configversion", "1.5");
      }
      case "1.5": {
        unset("exaliases", "tab");
        set2("configversion", "1.6");
      }
      case "1.6": {
        const updateSetting = (mapObj) => {
          if (!mapObj)
            return mapObj;
          if (mapObj[" "] !== void 0) {
            mapObj["<Space>"] = mapObj[" "];
            delete mapObj[" "];
          }
          ;
          [
            "<A- >",
            "<C- >",
            "<M- >",
            "<S- >",
            "<AC- >",
            "<AM- >",
            "<AS- >",
            "<CM- >",
            "<CS- >",
            "<MS- >"
          ].forEach((binding2) => {
            if (mapObj[binding2] !== void 0) {
              const key = binding2.replace(" ", "Space");
              mapObj[key] = mapObj[binding2];
              delete mapObj[binding2];
            }
          });
          return mapObj;
        };
        [
          "nmaps",
          "exmaps",
          "imaps",
          "inputmaps",
          "ignoremaps"
        ].forEach((settingName) => updateAll([settingName], updateSetting));
        set2("configversion", "1.7");
      }
      case "1.7": {
        const autocontain2 = getDeepProperty(USERCONFIG, ["autocontain"]);
        unset("autocontain");
        if (autocontain2 !== void 0) {
          Object.entries(autocontain2).forEach(([domain, container]) => {
            set2("autocontain", `^https?://([^/]*\\.|)*${domain}/`, container);
          });
        }
        set2("configversion", "1.8");
      }
      case "1.8": {
        const updateSetting = (mapObj) => {
          if (!mapObj)
            return mapObj;
          return map((val) => {
            if (val === "")
              return null;
            return val;
          }, mapObj);
        };
        [
          "nmaps",
          "exmaps",
          "imaps",
          "inputmaps",
          "ignoremaps",
          "hintmaps",
          "vmaps"
        ].forEach((settingName) => updateAll([settingName], updateSetting));
        set2("configversion", "1.9");
      }
      case "1.9": {
        const local = (await browser.storage.local.get(CONFIGNAME))[CONFIGNAME];
        const sync = (await browser.storage.sync.get(CONFIGNAME))[CONFIGNAME];
        const current_storageloc = (local == null ? void 0 : local.storageloc) !== void 0 ? local.storageloc : (sync == null ? void 0 : sync.storageloc) !== void 0 ? sync.storageloc : "sync";
        if (current_storageloc == "sync") {
          await pull();
        } else if (current_storageloc != "local") {
          throw new Error("storageloc was set to something weird: " + current_storageloc + ", automatic migration of settings was not possible.");
        }
        set2("configversion", "2.0");
        updated = true;
      }
    }
    return updated;
  }
  async function init2() {
    const localConfig = await browser.storage.local.get(CONFIGNAME);
    schlepp(localConfig[CONFIGNAME]);
    INITIALISED = true;
    for (const waiter of WAITERS) {
      waiter();
    }
  }
  var changeListeners = new Map();
  function addChangeListener(name, listener) {
    let arr = changeListeners.get(name);
    if (!arr) {
      arr = [];
      changeListeners.set(name, arr);
    }
    arr.push(listener);
  }
  function removeChangeListener(name, listener) {
    const arr = changeListeners.get(name);
    if (!arr)
      return;
    const i = arr.indexOf(listener);
    if (i >= 0)
      arr.splice(i, 1);
  }
  function parseConfig() {
    let p = {
      conf: [],
      binds: [],
      aliases: [],
      subconfigs: [],
      aucmds: [],
      aucons: [],
      logging: [],
      nulls: []
    };
    p = parseConfigHelper(USERCONFIG, p);
    const s = {
      general: ``,
      binds: ``,
      aliases: ``,
      aucmds: ``,
      aucons: ``,
      subconfigs: ``,
      logging: ``,
      nulls: ``
    };
    if (p.conf.length > 0)
      s.general = `" General Settings
${p.conf.join("\n")}

`;
    if (p.binds.length > 0)
      s.binds = `" Binds
${p.binds.join("\n")}

`;
    if (p.aliases.length > 0)
      s.aliases = `" Aliases
${p.aliases.join("\n")}

`;
    if (p.aucmds.length > 0)
      s.aucmds = `" Autocmds
${p.aucmds.join("\n")}

`;
    if (p.aucons.length > 0)
      s.aucons = `" Autocontainers
${p.aucons.join("\n")}

`;
    if (p.subconfigs.length > 0)
      s.subconfigs = `" Subconfig Settings
${p.subconfigs.join("\n")}

`;
    if (p.logging.length > 0)
      s.logging = `" Logging
${p.logging.join("\n")}

`;
    if (p.nulls.length > 0)
      s.nulls = `" Removed settings
${p.nulls.join("\n")}

`;
    const ftdetect = `" For syntax highlighting see https://github.com/tridactyl/vim-tridactyl
" vim: set filetype=tridactyl`;
    return `${s.general}${s.binds}${s.subconfigs}${s.aliases}${s.aucmds}${s.aucons}${s.logging}${s.nulls}${ftdetect}`;
  }
  var parseConfigHelper = (pconf, parseobj, prefix = []) => {
    for (const i of Object.keys(pconf)) {
      if (typeof pconf[i] !== "object") {
        if (prefix[0] === "subconfigs") {
          prefix.shift();
          const pattern = prefix.shift();
          parseobj.subconfigs.push(`seturl ${pattern} ${[...prefix, i].join(".")} ${pconf[i]}`);
        } else {
          parseobj.conf.push(`set ${[...prefix, i].join(".")} ${pconf[i]}`);
        }
      } else if (pconf[i] === null) {
        parseobj.nulls.push(`setnull ${[...prefix, i].join(".")}`);
      } else {
        for (const e of Object.keys(pconf[i])) {
          if (modeMaps.includes(i)) {
            let cmd = "bind";
            if (prefix[0] === "subconfigs")
              cmd = cmd + "url " + prefix[1];
            if (i !== "nmaps") {
              const mode2 = maps2mode.get(i);
              cmd += ` --mode=${mode2}`;
            }
            if (pconf[i][e] === null) {
              parseobj.binds.push(`un${cmd} ${e}`);
              continue;
            }
            if (pconf[i][e].length > 0) {
              parseobj.binds.push(`${cmd} ${e} ${pconf[i][e]}`);
            } else {
              parseobj.binds.push(`un${cmd} ${e}`);
            }
          } else if (pconf[i][e] === null) {
            parseobj.nulls.push(`setnull ${i}.${e}`);
          } else if (i === "exaliases") {
            if (e === "alias") {
              parseobj.aliases.push(`command ${e} ${pconf[i][e]}`);
            } else {
              parseobj.aliases.push(`alias ${e} ${pconf[i][e]}`);
            }
          } else if (i === "autocmds") {
            for (const a of Object.keys(pconf[i][e])) {
              parseobj.aucmds.push(`autocmd ${e} ${a} ${pconf[i][e][a]}`);
            }
          } else if (i === "autocontain") {
            parseobj.aucons.push(`autocontain ${e} ${pconf[i][e]}`);
          } else if (i === "logging") {
            let level;
            if (pconf[i][e] === 0)
              level = "never";
            if (pconf[i][e] === 1)
              level = "error";
            if (pconf[i][e] === 2)
              level = "warning";
            if (pconf[i][e] === 3)
              level = "info";
            if (pconf[i][e] === 4)
              level = "debug";
            parseobj.logging.push(`set logging.${e} ${level}`);
          } else if (i === "customthemes") {
          } else {
            parseConfigHelper(pconf[i], parseobj, [...prefix, i]);
            break;
          }
        }
      }
    }
    return parseobj;
  };
  browser.storage.onChanged.addListener((changes, areaname) => {
    if (CONFIGNAME in changes) {
      let triggerChangeListeners = function(key, value = newValue[key]) {
        const arr = changeListeners.get(key);
        if (arr) {
          const v = old[key] === void 0 ? DEFAULTS[key] : old[key];
          arr.forEach((f) => f(v, value));
        }
      };
      const { newValue, oldValue } = changes[CONFIGNAME];
      const old = oldValue || {};
      if (areaname === "sync") {
      } else if (newValue !== void 0) {
        const unsetKeys = Object.keys(old).filter((k) => newValue[k] === void 0 && JSON.stringify(old[k]) !== JSON.stringify(DEFAULTS[k]));
        const changedKeys = Object.keys(newValue).filter((k) => JSON.stringify(old[k] !== void 0 ? old[k] : DEFAULTS[k]) !== JSON.stringify(newValue[k]));
        changedKeys.forEach((key) => USERCONFIG[key] = newValue[key]);
        unsetKeys.forEach((key) => delete USERCONFIG[key]);
        unsetKeys.forEach((key) => triggerChangeListeners(key, DEFAULTS[key]));
        changedKeys.forEach((key) => triggerChangeListeners(key));
      } else {
        USERCONFIG = o({});
        Object.keys(old).filter((key) => old[key] !== DEFAULTS[key]).forEach((key) => triggerChangeListeners(key));
      }
    }
  });
  init2();

  // src/lib/logging.ts
  var LevelToNum = new Map();
  LevelToNum.set("never", 0);
  LevelToNum.set("error", 1);
  LevelToNum.set("warning", 2);
  LevelToNum.set("info", 3);
  LevelToNum.set("debug", 4);
  var Logger = class {
    constructor(logModule) {
      this.logModule = logModule;
    }
    log(level) {
      const configedLevel = get("logging", this.logModule);
      if (LevelToNum.get(level) <= LevelToNum.get(configedLevel)) {
        switch (level) {
          case "error":
            return async (...message2) => {
              console.error(...message2);
              return browser.runtime.sendMessage({
                type: "controller_background",
                command: "acceptExCmd",
                args: [
                  "fillcmdline_nofocus # " + message2.join(" ")
                ]
              });
            };
          case "warning":
            return console.warn;
          case "info":
            return console.log;
          case "debug":
            return console.debug;
        }
      }
      return function() {
      };
    }
    get debug() {
      return this.log("debug");
    }
    get info() {
      return this.log("info");
    }
    get warning() {
      return this.log("warning");
    }
    get error() {
      return this.log("error");
    }
  };
  var logging_default = Logger;

  // src/content/state_content.ts
  var logger = new logging_default("state");
  var onChangedListeners = [];
  function addContentStateChangedListener(callback) {
    onChangedListeners.push(callback);
  }
  var contentState = new Proxy({ mode: "normal" }, {
    get(target, property) {
      return target[property];
    },
    set(target, property, newValue) {
      logger.debug("Content state changed!", property, newValue);
      const oldValue = target[property];
      const mode2 = target.mode;
      target[property] = newValue;
      for (const listener of onChangedListeners) {
        listener(property, mode2, oldValue, newValue);
      }
      return true;
    }
  });

  // src/lib/controller.ts
  var controller_exports = {};
  __export(controller_exports, {
    acceptExCmd: () => acceptExCmd,
    setExCmds: () => setExCmds
  });

  // src/.metadata.generated.ts
  var metadata_generated_exports = {};
  __export(metadata_generated_exports, {
    everything: () => everything,
    staticThemes: () => staticThemes
  });

  // compiler/types/AnyType.ts
  var AnyType = class {
    constructor(isDotDotDot = false, isQuestion = false) {
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "any";
    }
    toConstructor() {
      return `new AnyType(${!this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return this.kind;
    }
    convert(argument) {
      return argument;
    }
  };

  // compiler/types/BooleanType.ts
  var BooleanType = class {
    constructor(isDotDotDot = false, isQuestion = false) {
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "boolean";
    }
    toConstructor() {
      return `new BooleanType(${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return this.kind;
    }
    convert(argument) {
      if (argument === "true") {
        return true;
      } else if (argument === "false") {
        return false;
      }
      throw new Error("Can't convert ${argument} to boolean");
    }
  };

  // compiler/types/FunctionType.ts
  var FunctionType = class {
    constructor(args, ret, isDotDotDot = false, isQuestion = false) {
      this.args = args;
      this.ret = ret;
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "function";
    }
    toConstructor() {
      return `new FunctionType([` + this.args.map((cur) => cur.toConstructor()) + `], ${this.ret.toConstructor()}, ${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return `(${this.args.map((a) => a.toString()).join(", ")}) => ${this.ret.toString()}`;
    }
    convert(argument) {
      throw new Error(`Conversion to function not implemented: ${argument}`);
    }
  };

  // compiler/types/NumberType.ts
  var NumberType = class {
    constructor(isDotDotDot = false, isQuestion = false) {
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "number";
    }
    toConstructor() {
      return `new NumberType(${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return this.kind;
    }
    convert(argument) {
      const n = parseFloat(argument);
      if (!Number.isNaN(n)) {
        return n;
      }
      throw new Error(`Can't convert to number: ${argument}`);
    }
  };

  // compiler/types/ObjectType.ts
  var ObjectType = class {
    constructor(members = new Map(), isDotDotDot = false, isQuestion = false) {
      this.members = members;
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "object";
    }
    toConstructor() {
      return `new ObjectType(new Map<string, Type>([` + Array.from(this.members.entries()).map(([n, m]) => `[${JSON.stringify(n)}, ${m.toConstructor()}]`).join(", ") + `]), ${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return this.kind;
    }
    convertMember(memberName, memberValue) {
      let type2 = this.members.get(memberName[0]);
      if (!type2) {
        type2 = this.members.get("");
        if (!type2) {
          return memberValue;
        }
      }
      if (type2.kind === "object") {
        return type2.convertMember(memberName.slice(1), memberValue);
      }
      return type2.convert(memberValue);
    }
    convert(argument) {
      try {
        return JSON.parse(argument);
      } catch (e) {
        throw new Error(`Can't convert to object: ${argument}`);
      }
    }
  };

  // compiler/types/StringType.ts
  var StringType = class {
    constructor(isDotDotDot = false, isQuestion = false) {
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "string";
    }
    toConstructor() {
      return `new StringType(${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return this.kind;
    }
    convert(argument) {
      if (typeof argument === "string") {
        return argument;
      }
      throw new Error(`Can't convert to string: ${argument}`);
    }
  };

  // compiler/types/TypeReferenceType.ts
  var TypeReferenceType = class {
    constructor(kind, args, isDotDotDot = false, isQuestion = false) {
      this.kind = kind;
      this.args = args;
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
    }
    toConstructor() {
      return `new TypeReferenceType(${JSON.stringify(this.kind)}, [` + this.args.map((cur) => cur.toConstructor()).join(",\n") + `], ${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return `${this.kind}<${this.args.map((a) => a.toString()).join(", ")}>`;
    }
    convert(argument) {
      throw new Error("Conversion of simple type references not implemented.");
    }
  };

  // compiler/types/VoidType.ts
  var VoidType = class {
    constructor(isDotDotDot = false, isQuestion = false) {
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "void";
    }
    toConstructor() {
      return `new VoidType(${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return this.kind;
    }
    convert(argument) {
      return null;
    }
  };

  // compiler/types/ArrayType.ts
  var ArrayType = class {
    constructor(elemType, isDotDotDot = false, isQuestion = false) {
      this.elemType = elemType;
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "array";
    }
    toConstructor() {
      return `new ArrayType(${this.elemType.toConstructor()}, ${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return `${this.elemType.toString()}[]`;
    }
    convert(argument) {
      if (!Array.isArray(argument)) {
        try {
          argument = JSON.parse(argument);
        } catch (e) {
          throw new Error(`Can't convert ${argument} to array:`);
        }
        if (!Array.isArray(argument)) {
          throw new Error(`Can't convert ${argument} to array:`);
        }
      }
      return argument.map((v) => this.elemType.convert(v));
    }
  };

  // compiler/types/LiteralTypeType.ts
  var LiteralTypeType = class {
    constructor(value, isDotDotDot = false, isQuestion = false) {
      this.value = value;
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "LiteralType";
    }
    toConstructor() {
      return `new LiteralTypeType(${JSON.stringify(this.value)}, ${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return JSON.stringify(this.value);
    }
    convert(argument) {
      if (argument === this.value) {
        return argument;
      }
      throw new Error(`Argument does not match expected value (${this.value}): ${argument}`);
    }
  };

  // compiler/types/TupleType.ts
  var TupleType = class {
    constructor(elemTypes, isDotDotDot = false, isQuestion = false) {
      this.elemTypes = elemTypes;
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "tuple";
    }
    toConstructor() {
      return `new TupleType([` + this.elemTypes.map((cur) => cur.toConstructor()).join(",\n") + `], ${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return `[${this.elemTypes.map((e) => e.toString()).join(", ")}]`;
    }
    convert(argument) {
      if (!Array.isArray(argument)) {
        try {
          argument = JSON.parse(argument);
        } catch (e) {
          throw new Error(`Can't convert to tuple: ${argument}`);
        }
        if (!Array.isArray(argument)) {
          throw new Error(`Can't convert to tuple: ${argument}`);
        }
      }
      if (argument.length !== this.elemTypes.length) {
        throw new Error(`Error converting tuple: number of elements and type mismatch ${argument}`);
      }
      return argument.map((v, i) => this.elemTypes[i].convert(v));
    }
  };

  // compiler/types/UnionType.ts
  var UnionType = class {
    constructor(types, isDotDotDot = false, isQuestion = false) {
      this.types = types;
      this.isDotDotDot = isDotDotDot;
      this.isQuestion = isQuestion;
      this.kind = "union";
    }
    toConstructor() {
      return `new UnionType([` + this.types.map((cur) => cur.toConstructor()).join(",\n") + `], ${this.isDotDotDot}, ${this.isQuestion})`;
    }
    toString() {
      return this.types.map((t) => t.toString()).join(" | ");
    }
    convert(argument) {
      for (const t of this.types) {
        try {
          return t.convert(argument);
        } catch (e) {
        }
      }
      throw new Error(`Can't convert "${argument}" to any of: ${this.types}`);
    }
  };

  // compiler/metadata/SymbolMetadata.ts
  var SymbolMetadata = class {
    constructor(doc, type2, hidden = false) {
      this.doc = doc;
      this.type = type2;
      this.hidden = hidden;
    }
    toConstructor() {
      return `new SymbolMetadata(${JSON.stringify(this.doc)}, ${this.type.toConstructor()}, ${this.hidden})`;
    }
  };

  // compiler/metadata/ClassMetadata.ts
  var ClassMetadata = class {
    constructor(members = new Map()) {
      this.members = members;
    }
    setMember(name, s) {
      this.members.set(name, s);
    }
    getMember(name) {
      return this.members.get(name);
    }
    getMembers() {
      return this.members.keys();
    }
    toConstructor() {
      return `new ClassMetadata(new Map<string, SymbolMetadata>([` + Array.from(this.members.entries()).map(([n, m]) => `[${JSON.stringify(n)}, ${m.toConstructor()}]`).join(",\n") + `]))`;
    }
  };

  // compiler/metadata/FileMetadata.ts
  var FileMetadata = class {
    constructor(classes = new Map(), functions3 = new Map()) {
      this.classes = classes;
      this.functions = functions3;
    }
    setClass(name, c) {
      this.classes.set(name, c);
    }
    getClass(name) {
      return this.classes.get(name);
    }
    getClasses() {
      return Array.from(this.classes.keys());
    }
    setFunction(name, f) {
      this.functions.set(name, f);
    }
    getFunction(name) {
      return this.functions.get(name);
    }
    getFunctions() {
      return Array.from(this.functions.entries());
    }
    getFunctionNames() {
      return Array.from(this.functions.keys());
    }
    toConstructor() {
      return `new FileMetadata(new Map<string, ClassMetadata>([` + Array.from(this.classes.entries()).map(([n, c]) => `[${JSON.stringify(n)}, ${c.toConstructor()}]`).join(",\n") + `]), new Map<string, SymbolMetadata>([` + Array.from(this.functions.entries()).map(([n, f]) => `[${JSON.stringify(n)}, ${f.toConstructor()}]`).join(",\n") + `]))`;
    }
  };

  // compiler/metadata/ProgramMetadata.ts
  var ProgramMetadata = class {
    constructor(files = new Map()) {
      this.files = files;
    }
    setFile(name, file) {
      this.files.set(name, file);
    }
    getFile(name) {
      return this.files.get(name);
    }
    toConstructor() {
      return `new ProgramMetadata(new Map<string, FileMetadata>([` + Array.from(this.files.entries()).map(([n, f]) => `[${JSON.stringify(n)}, ${f.toConstructor()}]`).join(",\n") + `]))`;
    }
  };

  // src/.metadata.generated.ts
  var everything = new ProgramMetadata(new Map([
    ["src/excmds.ts", new FileMetadata(new Map([]), new Map([
      ["getNativeVersion", new SymbolMetadata("", new FunctionType([], new TypeReferenceType("Promise", [new StringType(false, false)], false, false), false, false), true)],
      ["getRssLinks", new SymbolMetadata("", new FunctionType([], new TypeReferenceType("Promise", [new ArrayType(new ObjectType(new Map([]), false, false), false, false)], false, false), false, false), true)],
      ["rssexec", new SymbolMetadata("Execute [[rsscmd]] for an rss link.\n\nIf `url` is undefined, Tridactyl will look for rss links in the current\npage. If it doesn't find any, it will display an error message. If it finds\nmultiple urls, it will offer completions in order for you to select the link\nyou're interested in. If a single rss feed is found, it will automatically\nbe selected.", new FunctionType([new StringType(false, false), new StringType(false, true), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["fillinput", new SymbolMetadata("Fills the element matched by `selector` with content and falls back to the last used input if the element can't be found. You probably don't want this; it's used internally for [[editor]].\n\nThat said, `bind gs fillinput null [Tridactyl](https://addons.mozilla.org/en-US/firefox/addon/tridactyl-vim/) is my favourite add-on` could probably come in handy.", new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new VoidType(false, false), false, false), false)],
      ["getInput", new SymbolMetadata("", new FunctionType([new TypeReferenceType("HTMLElement", [], false, false)], new StringType(false, false), false, false), true)],
      ["getinput", new SymbolMetadata("", new FunctionType([], new StringType(false, false), false, false), true)],
      ["getInputSelector", new SymbolMetadata("", new FunctionType([], new AnyType(true, false), false, false), true)],
      ["addTridactylEditorClass", new SymbolMetadata("", new FunctionType([new StringType(false, false)], new TypeReferenceType("Element", [], false, false), false, false), true)],
      ["removeTridactylEditorClass", new SymbolMetadata("", new FunctionType([new StringType(false, false)], new VoidType(false, false), false, false), true)],
      ["editor", new SymbolMetadata("Opens your favourite editor (which is currently gVim) and fills the last used input with whatever you write into that file.\n**Requires that the native messenger is installed, see [[native]] and [[nativeinstall]]**.\n\nUses the `editorcmd` config option, default = `auto` looks through a list defined in lib/native.ts try find a sensible combination. If it's a bit slow, or chooses the wrong editor, or gives up completely, set editorcmd to something you want. The command must stay in the foreground until the editor exits.\n\nThe editorcmd needs to accept a filename, stay in the foreground while it's edited, save the file and exit. By default the filename is added to the end of editorcmd, if you require control over the position of that argument, the first occurrence of %f in editorcmd is replaced with the filename. %l, if it exists, is replaced with the line number of the cursor and %c with the column number. For example:\n```\nset editorcmd terminator -u -e \"vim %f '+normal!%lGzv%c|'\"\n```\n\nYou're probably better off using the default insert mode bind of `<C-i>` (Ctrl-i) to access this.\n\nThis function returns a tuple containing the path to the file that was opened by the editor and its content. This enables creating commands such as the following one, which deletes the temporary file created by the editor:\n```\nalias editor_rm composite editor | jsb -p tri.native.run(`rm -f '${JS_ARG[0]}'`)\nbind --mode=insert <C-i> editor_rm\nbind --mode=input <C-i> editor_rm\n```", new FunctionType([], new TypeReferenceType("Promise", [new UnionType([
        new VoidType(false, false),
        new ArrayType(new AnyType(true, false), false, false)
      ], false, false)], false, false), false, false), false)],
      ["guiset_quiet", new SymbolMetadata("Like [[guiset]] but quieter.", new FunctionType([new StringType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["guiset", new SymbolMetadata("Change which parts of the Firefox user interface are shown. **NB: This feature is experimental and might break stuff.**\n\nMight mangle your userChrome. Requires native messenger, and you must restart Firefox each time to see any changes (this can be done using [[restart]]). <!-- (unless you enable addon debugging and refresh using the browser toolbox) -->\n\nAlso flips the preference `toolkit.legacyUserProfileCustomizations.stylesheets` to true so that FF will read your userChrome.\n\nView available rules and options [here](/static/docs/modules/_src_lib_css_util_.html#potentialrules) and [here](/static/docs/modules/_src_lib_css_util_.html#metarules).\n\nExample usage: `guiset gui none`, `guiset gui full`, `guiset tabs autohide`.\n\nSome of the available options:\n\n- gui\n      - full\n      - none\n\n- tabs\n      - always\n      - autohide\n\n- navbar\n      - always\n      - autohide\n      - none\n\n- hoverlink (the little link that appears when you hover over a link)\n      - none\n      - left\n      - right\n      - top-left\n      - top-right\n\n- statuspanel (hoverlink + the indicator that appears when a website is loading)\n      - none\n      - left\n      - right\n      - top-left\n      - top-right\n\nIf you want to use guiset in your tridactylrc, you might want to use [[guiset_quiet]] instead.", new FunctionType([new StringType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["cssparse", new SymbolMetadata("", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new VoidType(false, false), false, false), true)],
      ["loadtheme", new SymbolMetadata("", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), true)],
      ["unloadtheme", new SymbolMetadata("", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), true)],
      ["colourscheme", new SymbolMetadata("Changes the current theme.\n\nIf THEMENAME is any of the themes that can be found in the [Tridactyl repo](https://github.com/tridactyl/tridactyl/tree/master/src/static/themes) (e.g. 'dark'), the theme will be loaded from Tridactyl's internal storage.\n\nIf THEMENAME is set to any other value except `--url`, Tridactyl will attempt to use its native binary (see [[native]]) in order to load a CSS file named THEMENAME from disk. The CSS file has to be in a directory named \"themes\" and this directory has to be in the same directory as your tridactylrc. If this fails, Tridactyl will attempt to load the theme from its internal storage.\n\nLastly, themes can be loaded from URLs with `:colourscheme --url [url] [themename]`. They are stored internally - if you want to update the theme run the whole command again.\n\nNote that the theme name should NOT contain any dot.\n\nExample: `:colourscheme mysupertheme`\nOn linux, this will load ~/.config/tridactyl/themes/mysupertheme.css\n\n__NB__: due to Tridactyl's architecture, the theme will take a small amount of time to apply as each page is loaded. If this annoys you, you may use [userContent.css](http://kb.mozillazine.org/index.php?title=UserContent.css&printable=yes) to make changes to Tridactyl earlier. For example, users using the dark theme may like to put\n\n```\n:root {\n     --tridactyl-bg: black !important;\n     --tridactyl-fg: white !important;\n}\n```\n\nin their `userContent.css`. Follow [issue #2510](https://github.com/tridactyl/tridactyl/issues/2510) if you would like to find out when we have made a more user-friendly solution.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["setpref", new SymbolMetadata("Write a setting to your user.js file. Requires a [[restart]] after running to take effect.", new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["removepref", new SymbolMetadata("Remove a setting from your user.js file.", new FunctionType([new StringType(false, false)], new AnyType(true, false), false, false), false)],
      ["fixamo_quiet", new SymbolMetadata("Like [[fixamo]] but quieter.\n\nNow purely a placebo as [[fixamo]] has been removed.", new FunctionType([], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["fixamo", new SymbolMetadata('Used to simply set\n```js\n  "privacy.resistFingerprinting.block_mozAddonManager":true\n  "extensions.webextensions.restrictedDomains":""\n```\nin about:config via user.js so that Tridactyl (and other extensions!) can be used on addons.mozilla.org and other sites.\n\nRemoved at the request of the Firefox Security team. Replacements exist in our exemplar RC file.\n\nRequires `native` and a `restart`.', new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["nativeopen", new SymbolMetadata("Uses the native messenger to open URLs.\n\n**Be *seriously* careful with this:**\n\n1. the implementation basically execs `firefox --new-tab <your shell escaped string here>`\n2. you can use it to open any URL you can open in the Firefox address bar,\n    including ones that might cause side effects (firefox does not guarantee\n    that about: pages ignore query strings).\n\nYou've been warned.\n\nThis uses the [[browser]] setting to know which binary to call. If you need to pass additional arguments to firefox (e.g. '--new-window'), make sure they appear before the url.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["exclaim", new SymbolMetadata('Run command in /bin/sh (unless you\'re on Windows), and print the output in the command line. Non-zero exit codes and stderr are ignored, currently.\n\nRequires the native messenger, obviously.\n\nIf you want to use a different shell, just prepend your command with whatever the invocation is and keep in mind that most shells require quotes around the command to be executed, e.g. `:exclaim xonsh -c "1+2"`.\n\nAliased to `!` but the exclamation mark **must be followed with a space**.', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["exclaim_quiet", new SymbolMetadata("Like exclaim, but without any output to the command line.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new StringType(false, false)], false, false), false, false), false)],
      ["native", new SymbolMetadata("Tells you if the native messenger is installed and its version.", new FunctionType([], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["nativeinstall", new SymbolMetadata("Copies the installation command for the native messenger to the clipboard and asks the user to run it in their shell.\n\nThe native messenger's source code may be found here: https://github.com/tridactyl/native_messenger/blob/master/src/native_main.nim\n\nIf your corporate IT policy disallows execution of binaries which have not been whitelisted but allows Python scripts, you may instead use the old native messenger by running `install.sh` or `win_install.ps1` from https://github.com/tridactyl/tridactyl/tree/master/native - the main downside is that it is significantly slower.", new FunctionType([], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["mktridactylrc", new SymbolMetadata("Writes current config to a file.\n\nNB: an RC file is not required for your settings to persist: all settings are stored in a local Firefox storage database by default as soon as you set them.\n\nWith no arguments supplied the excmd will try to find an appropriate\nconfig path and write the rc file to there. Any argument given to the\nexcmd excluding the `-f` flag will be treated as a path to write the rc\nfile to relative to the native messenger's location (`~/.local/share/tridactyl/`). By default, it silently refuses to overwrite existing files.\n\nThe RC file will be split into sections that will be created if a config\nproperty is discovered within one of them:\n- General settings\n- Binds\n- Aliases\n- Autocmds\n- Autocontainers\n- Logging\n\nNote:\n- Subconfig paths fall back to using `js tri.config.set(key: obj)` notation.\n- This method is also used as a fallback mechanism for objects that didn't hit\n  any of the heuristics.\n\nAvailable flags:\n- `-f` will overwrite the config file if it exists.\n- `--clipboard` write config to clipboard - no [[native]] required", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["source", new SymbolMetadata("Runs an RC file from disk or a URL\n\nThis function accepts a flag: `--url` to load a RC from a URL.\n\nIf no argument given, it will try to open ~/.tridactylrc, ~/.config/tridactyl/tridactylrc or $XDG_CONFIG_HOME/tridactyl/tridactylrc in reverse order. You may use a `_` in place of a leading `.` if you wish, e.g, if you use Windows.\n\nIf no url is specified with the `--url` flag, the current page's URL is used to locate the RC file. Ensure the URL you pass (or page you are on) is a \"raw\" RC file, e.g. https://raw.githubusercontent.com/tridactyl/tridactyl/master/.tridactylrc and not https://github.com/tridactyl/tridactyl/blob/master/.tridactylrc.\n\nTridactyl won't run on many raw pages due to a Firefox bug with Content Security Policy, so you may need to use the `source --url [URL]` form.\n\nOn Windows, the `~` expands to `%USERPROFILE%`.\n\nThe RC file is just a bunch of Tridactyl excmds (i.e, the stuff on this help page). Settings persist in local storage. There's an [example file](https://raw.githubusercontent.com/tridactyl/tridactyl/master/.tridactylrc) if you want it.\n\nThere is a [bug](https://github.com/tridactyl/tridactyl/issues/1409) where not all lines of the RC file are executed if you use `sanitise` at the top of it. We instead recommend you put `:bind ZZ composite sanitise tridactyllocal; qall` in your RC file and use `ZZ` to exit Firefox.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["source_quiet", new SymbolMetadata("Same as [[source]] but suppresses all errors", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["updatenative", new SymbolMetadata("Updates the native messenger if it is installed, using our GitHub repo. This is run every time Tridactyl is updated.\n\nIf you want to disable this, or point it to your own native messenger, edit the `nativeinstallcmd` setting.", new FunctionType([new BooleanType(false, true)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["restart", new SymbolMetadata("Restarts firefox with the same commandline arguments.\n\nWarning: This can kill your tabs, especially if you :restart several times\nin a row", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["saveas", new SymbolMetadata("Download the current document.\n\nIf you have the native messenger v>=0.1.9 installed, the function accepts an optional argument, filename, which can be:\n- An absolute path\n- A path starting with ~, which will be expanded to your home directory\n- A relative path, relative to the native messenger executable (e.g. ~/.local/share/tridactyl on linux).\nIf filename is not given, a download dialogue will be opened. If filename is a directory, the file will be saved inside of it, its name being inferred from the URL. If the directories mentioned in the path do not exist or if a file already exists at this path, the file will be kept in your downloads folder and an error message will be given.\n\n**NB**: if a non-default save location is chosen, Firefox's download manager will say the file is missing. It is not - it is where you asked it to be saved.\n\nFlags:\n- `--overwrite`: overwrite the destination file.\n- `--cleanup`: removes the downloaded source file e.g. `$HOME/Downlods/downloaded.doc` if moving it to the desired directory fails.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["tabSetActive", new SymbolMetadata("", new FunctionType([new NumberType(false, false)], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), true)],
      ["getJumpPageId", new SymbolMetadata("This is used as an ID for the current page in the jumplist.\nIt has a potentially confusing behavior: if you visit site A, then site B, then visit site A again, the jumplist that was created for your first visit on A will be re-used for your second visit.\nAn ideal solution would be to have a counter that is incremented every time a new page is visited within the tab and use that as the return value for getJumpPageId but this doesn't seem to be trivial to implement.", new FunctionType([], new StringType(false, false), false, false), true)],
      ["saveJumps", new SymbolMetadata("", new FunctionType([new AnyType(true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), true)],
      ["curJumps", new SymbolMetadata("Returns a promise for an object containing the jumplist of all pages accessed in the current tab.\nThe keys of the object currently are the page's URL, however this might change some day. Use [[getJumpPageId]] to access the jumplist of a specific page.", new FunctionType([], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), true)],
      ["jumpnext", new SymbolMetadata("Calls [[jumpprev]](-n)", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["jumpprev", new SymbolMetadata("Similar to Pentadactyl or vim's jump list.\n\nWhen you scroll on a page, either by using the mouse or Tridactyl's key bindings, your position in the page will be saved after jumpdelay milliseconds (`:get jumpdelay` to know how many milliseconds that is). If you scroll again, you'll be able to go back to your previous position by using `:jumpprev 1`. If you need to go forward in the jumplist, use `:jumpprev -1`.\n\nKnown bug: Tridactyl will use the same jumplist for multiple visits to a same website in the same tab, see [github issue 834](https://github.com/tridactyl/tridactyl/issues/834).", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["addJump", new SymbolMetadata("Called on 'scroll' events.\nIf you want to have a function that moves within the page but doesn't add a\nlocation to the jumplist, make sure to set JUMPED to true before moving\naround.\nThe setTimeout call is required because sometimes a user wants to move\nsomewhere by pressing 'j' multiple times and we don't want to add the\nin-between locations to the jump list", new FunctionType([], new VoidType(false, false), false, false), true)],
      ["unfocus", new SymbolMetadata("Blur (unfocus) the active element", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["scrollpx", new SymbolMetadata("Scrolls the window or any scrollable child element by a pixels on the horizontal axis and b pixels on the vertical axis.", new FunctionType([new NumberType(false, false), new NumberType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["scrollto", new SymbolMetadata("If two numbers are given, treat as x and y values to give to window.scrollTo\nIf one number is given, scroll to that percentage along a chosen axis, defaulting to the y-axis. If the number has 'c' appended to it, it will be interpreted in radians.\n\nNote that if `a` is 0 or 100 and if the document is not scrollable in the given direction, Tridactyl will attempt to scroll the first scrollable element until it reaches the very bottom of that element.\n\nExamples:\n\n- `scrollto 50` -> scroll halfway down the page.\n- `scrollto 3.14c` -> scroll approximately 49.97465213% of the way down the page.", new FunctionType([new UnionType([
        new StringType(false, false),
        new NumberType(false, false)
      ], false, false), new UnionType([
        new NumberType(false, false),
        new LiteralTypeType("x", false, false),
        new LiteralTypeType("y", false, false)
      ], false, true)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["scrollline", new SymbolMetadata("Scrolls the document of its first scrollable child element by n lines.\n\nThe height of a line is defined by the site's CSS. If Tridactyl can't get it, it'll default to 22 pixels.", new FunctionType([new NumberType(false, true), new NumberType(false, true)], new AnyType(true, false), false, false), false)],
      ["scrollpage", new SymbolMetadata("Scrolls the document by n pages.\nThe height of a page is the current height of the window.", new FunctionType([new NumberType(false, true), new NumberType(false, true)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["find", new SymbolMetadata('Rudimentary find mode, left unbound by default as we don\'t currently support `incsearch`. Suggested binds:\n\n     bind / fillcmdline find\n     bind ? fillcmdline find -?\n     bind n findnext 1\n     bind N findnext -1\n     bind ,<Space> nohlsearch\n\nArgument: A string you want to search for.\n\nThis function accepts two flags: `-?` to search from the bottom rather than the top and `-: n` to jump directly to the nth match.\n\nThe behavior of this function is affected by the following setting:\n\n`findcase`: either "smart", "sensitive" or "insensitive". If "smart", find will be case-sensitive if the pattern contains uppercase letters.\n\nKnown bugs: find will currently happily jump to a non-visible element, and pressing n or N without having searched for anything will cause an error.', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["findnext", new SymbolMetadata("Jump to the next searched pattern.", new FunctionType([new NumberType(false, true)], new AnyType(true, false), false, false), false)],
      ["clearsearchhighlight", new SymbolMetadata("", new FunctionType([], new AnyType(true, false), false, false), false)],
      ["history", new SymbolMetadata("", new FunctionType([new NumberType(false, false)], new VoidType(false, false), false, false), true)],
      ["forward", new SymbolMetadata("Navigate forward one page in history.", new FunctionType([new NumberType(false, true)], new VoidType(false, false), false, false), false)],
      ["back", new SymbolMetadata("Navigate back one page in history.", new FunctionType([new NumberType(false, true)], new VoidType(false, false), false, false), false)],
      ["reload", new SymbolMetadata("Reload the next n tabs, starting with activeTab, possibly bypassingCache", new FunctionType([new NumberType(false, true), new BooleanType(false, true)], new TypeReferenceType("Promise", [new ArrayType(new VoidType(false, false), false, false)], false, false), false, false), false)],
      ["reloadall", new SymbolMetadata("Reloads all tabs, bypassing the cache if hard is set to true", new FunctionType([new BooleanType(false, true)], new TypeReferenceType("Promise", [new ArrayType(new VoidType(false, false), false, false)], false, false), false, false), false)],
      ["reloadallbut", new SymbolMetadata("Reloads all tabs except the current one, bypassing the cache if hard is set to true\nYou probably want to use [[reloaddead]] instead if you just want to be able to ensure Tridactyl is loaded in all tabs where it can be", new FunctionType([new BooleanType(false, true)], new TypeReferenceType("Promise", [new ArrayType(new VoidType(false, false), false, false)], false, false), false, false), false)],
      ["reloaddead", new SymbolMetadata("Reloads all tabs which Tridactyl isn't loaded in", new FunctionType([new BooleanType(false, true)], new TypeReferenceType("Promise", [new TupleType([
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false),
        new AnyType(true, false)
      ], false, false)], false, false), false, false), false)],
      ["reloadhard", new SymbolMetadata("Reload the next n tabs, starting with activeTab. bypass cache for all", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new ArrayType(new VoidType(false, false), false, false)], false, false), false, false), false)],
      ["open", new SymbolMetadata("Open a new page in the current tab.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["bmarks", new SymbolMetadata("Works exactly like [[open]], but only suggests bookmarks.\n\nIf you want to use optional flags, you should run `:set completions.Bmark.autoselect false` to prevent the spacebar from inserting the URL of the top bookmark.", new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["open_quiet", new SymbolMetadata("Like [[open]] but doesn't make a new entry in history.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["url2args", new SymbolMetadata('If the url of the current document matches one of your search engines, will convert it to a list of arguments that open/tabopen will understand. If the url doesn\'t match any search engine, returns the url without modifications.\n\nFor example, if you have searchurls.gi set to "https://www.google.com/search?q=%s&tbm=isch", using this function on a page you opened using "gi butterflies" will return "gi butterflies".\n\nThis is useful when combined with fillcmdline, for example like this: `bind O composite url2args | fillcmdline open`.\n\nNote that this might break with search engines that redirect you to other pages/add GET parameters that do not exist in your searchurl.', new FunctionType([], new TypeReferenceType("Promise", [new StringType(false, false)], false, false), false, false), false)],
      ["removeSource", new SymbolMetadata("", new FunctionType([], new VoidType(false, false), false, false), true)],
      ["viewsource", new SymbolMetadata("Display the (HTML) source of the current page.\n\nBehaviour can be changed by the 'viewsource' setting.\n\nIf the 'viewsource' setting is set to 'default' rather than 'tridactyl',\nthe url the source of which should be displayed can be given as argument.\nOtherwise, the source of the current document will be displayed.", new FunctionType([new StringType(false, true)], new VoidType(false, false), false, false), false)],
      ["home", new SymbolMetadata('Go to the homepages you have set with `set homepages ["url1", "url2"]`.', new FunctionType([new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, true)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["help", new SymbolMetadata('Show this page.\n\n`:help something` jumps to the entry for something. Something can be an excmd, an alias for an excmd, a binding or a setting.\n\nOn the ex command page, the "nmaps" list is a list of all the bindings for the command you\'re seeing and the "exaliases" list lists all its aliases.\n\nIf there\'s a conflict (e.g. you have a "go" binding that does something, a "go" excmd that does something else and a "go" setting that does a third thing), the binding is chosen first, then the setting, then the excmd. In such situations, if you want to let Tridactyl know you\'re looking for something specfic, you can specify the following flags as first arguments:\n\n`-a`: look for an alias\n`-b`: look for a binding\n`-e`: look for an ex command\n`-s`: look for a setting\n\nIf the keyword you gave to `:help` is actually an alias for a composite command (see [[composite]]) , you will be taken to the help section for the first command of the pipeline. You will be able to see the whole pipeline by hovering your mouse over the alias in the "exaliases" list. Unfortunately there currently is no way to display these HTML tooltips from the keyboard.\n\ne.g. `:help bind`', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["apropos", new SymbolMetadata("Search through the help pages. Accepts the same flags as [[help]]. Only useful in interactive usage with completions; the command itself is just a wrapper for [[help]].", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["tutor", new SymbolMetadata("Start the tutorial", new FunctionType([new StringType(false, true)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["credits", new SymbolMetadata("Display Tridactyl's contributors in order of commits in a user-friendly fashion", new FunctionType([], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["no_mouse_mode", new SymbolMetadata('Cover the current page in an overlay to prevent clicking on links with the mouse to force yourself to use hint mode. Get rid of it by reloading the page.\n\nTo bring back mouse control, use [[mouse_mode]] or refresh the page.\n\nSuggested usage: `autocmd DocLoad .* no_mouse_mode`\n\n"There is no mouse".', new FunctionType([], new VoidType(false, false), false, false), false)],
      ["neo_mouse_mode", new SymbolMetadata('Matrix variant of [[no_mouse_mode]]\n\n"There is no mouse".\n\nCoincidentally added to Tridactyl at the same time as we reached 1337 stars on GitHub.', new FunctionType([], new VoidType(false, false), false, false), false)],
      ["snow_mouse_mode", new SymbolMetadata("Christmas variant of [[no_mouse_mode]] (if you live in $DEFAULT hemisphere).", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["pied_piper_mouse_mode", new SymbolMetadata("Music variant of [[no_mouse_mode]].", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["drawingstart", new SymbolMetadata("Drawable variant of [[no_mouse_mode]]\nIn this mode, you can use the mouse or a digital stylus to draw. To switch to an eraser, use [[drawingerasertoggle]]\nUse [[mouse_mode]] to return, or refresh page.\nSuggested usage: `autocmd DocLoad .* drawingstart\n\n**Warning**: Windows Ink enabled input devices don't work, disable it for your browser, or use a mouse.", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["drawingerasertoggle", new SymbolMetadata("Switch between pen and eraser for [[drawingstart]]\nSuggested usage: `bind e drawingerasertoggle`. If you have a digital pen, map the button to `e` to switch easily.", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["mouse_mode", new SymbolMetadata("Revert any variant of the [[no_mouse_mode]]\n\nSuggested usage: `bind <C-\\> mouse_mode` with the autocmd mentioned in [[no_mouse_mode]] or [[drawingstart]].", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["findRelLink", new SymbolMetadata("", new FunctionType([new TypeReferenceType("RegExp", [], false, false)], new TypeReferenceType("HTMLAnchorElement", [], false, false), false, false), true)],
      ["selectLast", new SymbolMetadata("", new FunctionType([new StringType(false, false)], new TypeReferenceType("HTMLElement", [], false, false), false, false), true)],
      ["followpage", new SymbolMetadata("Find a likely next/previous link and follow it\n\nIf a link or anchor element with rel=rel exists, use that, otherwise fall back to:\n\n    1) find the last anchor on the page with innerText matching the appropriate `followpagepattern`.\n    2) call [[urlincrement]] with 1 or -1\n\nIf you want to support e.g. French:\n\n```\nset followpagepatterns.next ^(next|newer|prochain)\\b|\xBB|>>\nset followpagepatterns.prev ^(prev(ious)?|older|pr\xE9c\xE9dent)\\b|\xAB|<<\n```", new FunctionType([new UnionType([
        new LiteralTypeType("next", false, false),
        new LiteralTypeType("prev", false, false)
      ], false, true)], new VoidType(false, false), false, false), false)],
      ["urlincrement", new SymbolMetadata("Increment the current tab URL", new FunctionType([new NumberType(false, true), new NumberType(false, true)], new VoidType(false, false), false, false), false)],
      ["urlroot", new SymbolMetadata("Go to the root domain of the current URL", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["urlparent", new SymbolMetadata("Go to the parent URL of the current tab's URL", new FunctionType([new NumberType(false, true)], new VoidType(false, false), false, false), false)],
      ["urlmodify", new SymbolMetadata('Open a URL made by modifying the current URL\n\nThere are several modes:\n\n* Text replace mode:   `urlmodify -t <old> <new>`\n\n   Replaces the first instance of the text `old` with `new`.\n      * `http://example.com` -> (`-t exa peta`) -> `http://petample.com`\n\n* Regex replacment mode: `urlmodify -r <regexp> <new> [flags]`\n\n   Replaces the first match of the `regexp` with `new`. You can use\n   flags `i` and `g` to match case-insensitively and to match\n   all instances respectively\n      * `http://example.com` -> (`-r [ea] X g`) -> `http://XxXmplX.com`\n\n* Query set mode: `urlmodify -s <query> <value>`\n\n   Sets the value of a query to be a specific one. If the query already\n   exists, it will be replaced.\n      * `http://e.com?id=abc` -> (`-s foo bar`) -> `http://e.com?id=abc&foo=bar\n\n* Query replace mode: `urlmodify -q <query> <new_val>`\n\n   Replace the value of a query with a new one:\n      * `http://e.com?id=foo` -> (`-q id bar`) -> `http://e.com?id=bar\n\n* Query delete mode: `urlmodify -Q <query>`\n\n   Deletes the given query (and the value if any):\n      * `http://e.com?id=foo&page=1` -> (`-Q id`) -> `http://e.com?page=1`\n\n* Graft mode: `urlmodify -g <graft_point> <new_path_tail>`\n\n   "Grafts" a new tail on the URL path, possibly removing some of the old\n   tail. Graft point indicates where the old URL is truncated before adding\n   the new path.\n\n   * `graft_point` >= 0 counts path levels, starting from the left\n   (beginning). 0 will append from the "root", and no existing path will\n   remain, 1 will keep one path level, and so on.\n   * `graft_point` < 0 counts from the right (i.e. the end of the current\n   path). -1 will append to the existing path, -2 will remove the last path\n   level, and so on.\n\n   ```plaintext\n   http://website.com/this/is/the/path/component\n   Graft point:       ^    ^  ^   ^    ^        ^\n   From left:         0    1  2   3    4        5\n   From right:       -6   -5 -4  -3   -2       -1\n   ```\n\n   Examples:\n\n   * `http://e.com/issues/42` -> (`-g 0 foo`) -> `http://e.com/foo`\n   * `http://e.com/issues/42` -> (`-g 1 foo`) -> `http://e.com/issues/foo`\n   * `http://e.com/issues/42` -> (`-g -1 foo`) -> `http://e.com/issues/42/foo`\n   * `http://e.com/issues/42` -> (`-g -2 foo`) -> `http://e.com/issues/foo`\n\n\n* URL Input: `urlmodify -*u <arguments> <URL>`\n\n   Each mode can be augmented to accept a URL as the last argument instead of\n   the current url.\n\n   Examples:\n\n   * `urlmodify -tu <old> <new> <URL>`\n   * `urlmodify -su <query> <value> <URL>`\n   * `urlmodify -gu <graft_point> <new_path_tail> <URL>`', new FunctionType([new UnionType([
        new LiteralTypeType("-t", false, false),
        new LiteralTypeType("-r", false, false),
        new LiteralTypeType("-s", false, false),
        new LiteralTypeType("-q", false, false),
        new LiteralTypeType("-Q", false, false),
        new LiteralTypeType("-g", false, false),
        new LiteralTypeType("-tu", false, false),
        new LiteralTypeType("-ru", false, false),
        new LiteralTypeType("-su", false, false),
        new LiteralTypeType("-qu", false, false),
        new LiteralTypeType("-Qu", false, false),
        new LiteralTypeType("-gu", false, false)
      ], false, false), new ArrayType(new StringType(false, false), true, false)], new VoidType(false, false), false, false), false)],
      ["urlmodify_js", new SymbolMetadata("Like [[urlmodify]] but returns the modified URL for use with [[js]] and [[composite]]\n\nE.g.\n\n`:composite urlmodify_js -t www. old. | tabopen `", new FunctionType([new UnionType([
        new LiteralTypeType("-t", false, false),
        new LiteralTypeType("-r", false, false),
        new LiteralTypeType("-s", false, false),
        new LiteralTypeType("-q", false, false),
        new LiteralTypeType("-Q", false, false),
        new LiteralTypeType("-g", false, false),
        new LiteralTypeType("-tu", false, false),
        new LiteralTypeType("-ru", false, false),
        new LiteralTypeType("-su", false, false),
        new LiteralTypeType("-qu", false, false),
        new LiteralTypeType("-Qu", false, false),
        new LiteralTypeType("-gu", false, false)
      ], false, false), new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["geturlsforlinks", new SymbolMetadata("Returns the url of links that have a matching rel.\n\nDon't bind to this: it's an internal function.", new FunctionType([new StringType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), true)],
      ["zoom", new SymbolMetadata("Sets the current page's zoom level anywhere between 30% and 300%.\n\nIf you overshoot the level while using relative adjustments i.e. level > 300% or level < 30% the zoom level will be set to it's maximum or minimum position. Relative adjustments are made * in percentage points, i.e. `:zoom +10 true` increases the zoom level from 50% to 60% or from * 200% to 210%.", new FunctionType([new NumberType(false, true), new StringType(false, true), new StringType(false, true)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["reader", new SymbolMetadata("Opens the current page in Firefox's reader mode.\nYou currently cannot use Tridactyl while in reader mode.", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["loadaucmds", new SymbolMetadata("", new FunctionType([new UnionType([
        new LiteralTypeType("UriChange", false, false),
        new LiteralTypeType("DocStart", false, false),
        new LiteralTypeType("DocLoad", false, false),
        new LiteralTypeType("DocEnd", false, false),
        new LiteralTypeType("TabEnter", false, false),
        new LiteralTypeType("TabLeft", false, false),
        new LiteralTypeType("FullscreenEnter", false, false),
        new LiteralTypeType("FullscreenLeft", false, false),
        new LiteralTypeType("FullscreenChange", false, false)
      ], false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["focusinput", new SymbolMetadata("Focus the last used input on the page", new FunctionType([new UnionType([
        new StringType(false, false),
        new NumberType(false, false)
      ], false, false)], new VoidType(false, false), false, false), false)],
      ["changelistjump", new SymbolMetadata("Focus the tab which contains the last focussed input element. If you're lucky, it will focus the right input, too.\n\nCurrently just goes to the last focussed input; being able to jump forwards and backwards is planned.", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["focusbyid", new SymbolMetadata("", new FunctionType([new StringType(false, false)], new VoidType(false, false), false, false), true)],
      ["tabIndexSetActive", new SymbolMetadata("", new FunctionType([new UnionType([
        new StringType(false, false),
        new NumberType(false, false)
      ], false, false)], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), true)],
      ["tabnext", new SymbolMetadata("Switch to the next tab, wrapping round.\n\nIf increment is specified, move that many tabs forwards.", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["tabnext_gt", new SymbolMetadata("Switch to the next tab, wrapping round.\n\nIf an index is specified, go to the tab with that number (this mimics the\nbehaviour of `{count}gt` in vim, except that this command will accept a\ncount that is out of bounds (and will mod it so that it is within bounds as\nper [[tabmove]], etc)).", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["tabprev", new SymbolMetadata("Switch to the previous tab, wrapping round.\n\nIf increment is specified, move that many tabs backwards.", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["tabpush", new SymbolMetadata("Pushes the current tab to another window. Only works for windows of the same type\n(can't push a non-private tab to a private window or a private tab to\na non-private window).\nIf *windowId* is not specified, pushes to the next newest window,\nwrapping around.", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new UnionType([
        new TypeReferenceType("Tab", [], false, false),
        new ArrayType(new TypeReferenceType("Tab", [], false, false), false, false)
      ], false, false)], false, false), false, false), false)],
      ["tabaudio", new SymbolMetadata("Switch to the tab currently playing audio, if any.", new FunctionType([], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["winmerge", new SymbolMetadata("Moves all of the targetted window's tabs to the current window. Only works for windows of the same type\n(can't merge a non-private tab with a private window).", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["parseWinTabIndex", new SymbolMetadata("Given a string of the format windowIndex.tabIndex, returns a tuple of\nnumbers corresponding to the window index and tab index or the current\nwindow and tab if the string doesn't have the right format.", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new ArrayType(new NumberType(false, false), false, false)], false, false), false, false), false)],
      ["tabgrab", new SymbolMetadata("Moves a tab identified by a windowIndex.tabIndex id to the current window.\nOnly works for windows of the same type (can't grab a non-private tab from a\nprivate window and can't grab a private tab from a non-private window).", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new UnionType([
        new TypeReferenceType("Tab", [], false, false),
        new ArrayType(new TypeReferenceType("Tab", [], false, false), false, false)
      ], false, false)], false, false), false, false), false)],
      ["tabopen", new SymbolMetadata('Like [[open]], but in a new tab. If no address is given, it will open the newtab page, which can be set with `set newtab [url]`\n\nUse the `-c` flag followed by a container name to open a tab in said container. Tridactyl will try to fuzzy match a name if an exact match is not found (opening the tab in no container can be enforced with "firefox-default" or "none"). If any autocontainer directives are configured and -c is not set, Tridactyl will try to use the right container automatically using your configurations.\n\nUse the `-b` flag to open the tab in the background.\n\nUse the `-w` flag to wait for the web page to load before "returning". This only makes sense for use with [[composite]], which waits for each command to return before moving on to the next one, e.g. `composite tabopen -b -w news.bbc.co.uk ; tabnext`.\n\nThese three can be combined in any order, but need to be placed as the first arguments.\n\nUnlike Firefox\'s Ctrl-t shortcut, this opens tabs immediately after the\ncurrently active tab rather than at the end of the tab list because that is\nthe authors\' preference.\n\nIf you would rather the Firefox behaviour `set tabopenpos last`. This\npreference also affects the clipboard, quickmarks, home, help, etc.\n\nIf you would rather the URL be opened as if you\'d middle clicked it, `set\ntabopenpos related`.\n\nHinting is controlled by `relatedopenpos`\n\nAlso see the [[searchengine]] and [[searchurls]] settings.', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["tabqueue", new SymbolMetadata("Passes its first argument to `tabopen -b`. Once the tab opened by `tabopen\n-b` is activated/selected/focused, opens its second argument with `tabopen\n-b`. Once the second tab is activated/selected/focused, opens its third\nargument with `tabopen -b` and so on and so forth until all arguments have\nbeen opened in a new tab or until a tab is closed without being\nactivated/selected/focused.\n\nExample usage:\n   `tabqueue http://example.org http://example.com http://example.net`\n   `composite hint -qpipe a href | tabqueue`", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["idFromIndex", new SymbolMetadata("Resolve a tab index to the tab id of the corresponding tab in this window.", new FunctionType([new UnionType([
        new StringType(false, false),
        new NumberType(false, false)
      ], false, true)], new TypeReferenceType("Promise", [new NumberType(false, false)], false, false), false, false), true)],
      ["tabFromIndex", new SymbolMetadata("Like [[idFromIndex]] but returns the whole tab object", new FunctionType([new UnionType([
        new StringType(false, false),
        new NumberType(false, false)
      ], false, true)], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), true)],
      ["tabonly", new SymbolMetadata("Close all other tabs in this window", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["tabduplicate", new SymbolMetadata("Duplicate a tab.", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["tabdetach", new SymbolMetadata("Detach a tab, opening it in a new window.", new FunctionType([new NumberType(false, true)], new TypeReferenceType("Promise", [new TypeReferenceType("Window", [], false, false)], false, false), false, false), false)],
      ["getSortedWinTabs", new SymbolMetadata("Get list of tabs sorted by most recent use", new FunctionType([], new TypeReferenceType("Promise", [new ArrayType(new TypeReferenceType("Tab", [], false, false), false, false)], false, false), false, false), true)],
      ["fullscreen", new SymbolMetadata("Toggle fullscreen state", new FunctionType([], new TypeReferenceType("Promise", [new TypeReferenceType("Window", [], false, false)], false, false), false, false), false)],
      ["tabclose", new SymbolMetadata("Close a tab.\n\nKnown bug: autocompletion will make it impossible to close more than one tab at once if the list of numbers looks enough like an open tab's title or URL.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["tabcloseallto", new SymbolMetadata("Close all tabs to the side specified", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["undo", new SymbolMetadata('Restore the most recently closed item.\nThe default behaviour is to restore the most recently closed tab in the\ncurrent window unless the most recently closed item is a window.\n\nSupplying either "tab" or "window" as an argument will specifically only\nrestore an item of the specified type. Supplying "tab_strict" only restores\ntabs that were open in the current window.', new FunctionType([new StringType(false, true)], new TypeReferenceType("Promise", [new NumberType(false, false)], false, false), false, false), false)],
      ["tabmove", new SymbolMetadata("Move the current tab to be just in front of the index specified.\n\nKnown bug: This supports relative movement with `tabmove +pos` and `tabmove -pos`, but autocomplete doesn't know that yet and will override positive and negative indexes.\n\nPut a space in front of tabmove if you want to disable completion and have the relative indexes at the command line.\n\nBinds are unaffected.", new FunctionType([new StringType(false, true)], new TypeReferenceType("Promise", [new UnionType([
        new TypeReferenceType("Tab", [], false, false),
        new ArrayType(new TypeReferenceType("Tab", [], false, false), false, false)
      ], false, false)], false, false), false, false), false)],
      ["tabsort", new SymbolMetadata("Move tabs in current window according to various criteria:\n\n- `--containers` groups tabs by containers\n- `--title` sorts tabs by title\n- `--url` sorts tabs by url (the default)\n- `(tab1, tab2) => true|false`\n      - sort by arbitrary comparison function. `tab{1,2}` are objects with properties described here: https://developer.mozilla.org/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/Tab", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["pin", new SymbolMetadata("Pin the current tab", new FunctionType([], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["mute", new SymbolMetadata('Mute current tab or all tabs.\n\nPassing "all" to the excmd will operate on  the mute state of all tabs.\nPassing "unmute" to the excmd will unmute.\nPassing "toggle" to the excmd will toggle the state of `browser.tabs.tab.MutedInfo`', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["winopen", new SymbolMetadata("Like [[tabopen]], but in a new window.\n\n`winopen -private [...]` will open the result in a private window (and won't store the command in your ex-history ;) ).\n\n`winopen -popup [...]` will open it in a popup window. You can combine the two for a private popup.\n\n`winopen -c containername [...]` will open the result in a container while ignoring other options given. See [[tabopen]] for more details on containers.\n\nExample: `winopen -popup -private ddg.gg`", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["winclose", new SymbolMetadata("Close a window.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new ArrayType(new VoidType(false, false), false, false)], false, false), false, false), false)],
      ["qall", new SymbolMetadata("Close all windows", new FunctionType([], new TypeReferenceType("Promise", [new ArrayType(new VoidType(false, false), false, false)], false, false), false, false), false)],
      ["containerclose", new SymbolMetadata("Closes all tabs open in the same container across all windows.", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["containercreate", new SymbolMetadata("Creates a new container. Note that container names must be unique and that the checks are case-insensitive.\n\nFurther reading https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/contextualIdentities/ContextualIdentity\n\nExample usage:\n    - `:containercreate tridactyl green dollar`", new FunctionType([new StringType(false, false), new StringType(false, true), new StringType(false, true)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["containerdelete", new SymbolMetadata("Delete a container. Closes all tabs associated with that container beforehand. Note: container names are case-insensitive.", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["containerupdate", new SymbolMetadata("Update a container's information. Note that none of the parameters are optional and that container names are case-insensitive.\n\nExample usage:\n\n- Changing the container name: `:containerupdate banking blockchain green dollar`\n\n- Changing the container icon: `:containerupdate banking banking green briefcase`\n\n- Changing the container color: `:containerupdate banking banking purple dollar`", new FunctionType([new StringType(false, false), new StringType(false, false), new StringType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["viewcontainers", new SymbolMetadata("Shows a list of the current containers in Firefox's native JSON viewer in the current tab.\n\nNB: Tridactyl cannot run on this page!", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["recontain", new SymbolMetadata("Opens the current tab in another container.\n\nThis is probably not a good idea if you care about tracking protection!\nTransfering URLs from one container to another allows websites to track\nyou across those containers.\n\nRead more here:\nhttps://github.com/mozilla/multi-account-containers/wiki/Moving-between-containers", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["version", new SymbolMetadata("", new FunctionType([], new AnyType(true, false), false, false), false)],
      ["mode", new SymbolMetadata("Switch mode.\n\nFor now you probably shouldn't manually switch to other modes than `normal` and `ignore`. Make sure you're aware of the key bindings (ignoremaps) that will allow you to go come back to normal mode from ignore mode before you run `:mode ignore` otherwise you're going to have a hard time re-enabling Tridactyl.\n\nExample:\n     - `mode ignore` to ignore almost all keys.\n\nIf you're looking for a way to temporarily disable Tridactyl, `mode ignore` might be what you're looking for.\n\nNote that when in ignore mode, Tridactyl will not switch to insert mode when focusing text areas/inputs. This is by design.\n\n**New feature:** you can add modes as simply as adding binds with `bind --mode=[newmodename]` and then enter the mode with `mode [newmodename]`.", new FunctionType([new AnyType(true, false)], new VoidType(false, false), false, false), false)],
      ["getnexttabs", new SymbolMetadata("", new FunctionType([new NumberType(false, false), new NumberType(false, true)], new TypeReferenceType("Promise", [new ArrayType(new NumberType(false, false), false, false)], false, false), false, false), true)],
      ["repeat", new SymbolMetadata("Repeats a `cmd` `n` times.\nIf `cmd` doesn't exist, re-executes the last exstr that was executed in the tab.\nExecutes the command once if `n` isn't defined either.\n\nThis re-executes the last *exstr*, not the last *excmd*. Some excmds operate internally by constructing and evaluating exstrs, others by directly invoking excmds without going through the exstr parser. For example, aucmds and keybindings evaluate exstrs and are repeatable, while commands like `:bmarks` directly invoke `:tabopen` and you'll repeat the `:bmarks` rather than the internal `:tabopen`.\n\nIt's difficult to execute this in the background script (`:jsb`, `:run_excmd`, `:autocmd TriStart`, `:source`), but if you you do, it will re-execute the last exstr that was executed in the background script. What this may have been is unpredictable and not precisely encouraged.", new FunctionType([new NumberType(false, true), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["composite", new SymbolMetadata("Split `cmds` on pipes (|) and treat each as its own command. Return values are passed as the last argument of the next ex command, e.g,\n\n`composite echo yes | fillcmdline` becomes `fillcmdline yes`. A more complicated example is the ex alias, `command current_url composite get_current_url | fillcmdline_notrail `, which is used in, e.g. `bind T current_url tabopen`.\n\nWorkaround: this should clearly be in the parser, but we haven't come up with a good way to deal with |s in URLs, search terms, etc. yet.\n\n`cmds` are also split with semicolons (;) and don't pass things along to each other.\n\nIf you wish to have a command that has semi-colons in it (e.g. some JavaScript or `hint -;`), first bind a [[command]] to it. For example, `command hint_focus -;`, and then `composite hint_focus; !s xdotool key Menu`.\n\nThe behaviour of combining ; and | in the same composite command is left as an exercise for the reader.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["shellescape", new SymbolMetadata("Escape command for safe use in shell with composite. E.g: `composite js MALICIOUS_WEBSITE_FUNCTION() | shellescape | exclaim ls`", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["escapehatch", new SymbolMetadata("Magic escape hatch: if Tridactyl can't run in the current tab, return to a tab in the current window where Tridactyl can run, making such a tab if it doesn't currently exist. If Tridactyl can run in the current tab, return focus to the document body from e.g. the URL bar or a video player.\n\nOnly useful if called from a background context, e.g. at the end of an RC file to ensure that when you start the browser you don't get trapped on an about: page, or via `bind --mode=browser escapehatch` (bound to `<C-,>` by default).\n\nNB: when called via `bind --mode=browser`, we return focus from the address bar by opening and closing the \"sidebar\" (which is used exclusively for this purpose). If escapehatch is called in any other way, we cannot do this as Mozilla thinks it might [spook](https://extensionworkshop.com/documentation/publish/add-on-policies/#no-surprises) [you](https://developer.mozilla.org/en-US/docs/Mozilla/Add-ons/WebExtensions/User_actions) : ).\n\nThis sidebar hack will close other sidebars such a TreestyleTabs. You can disable it with `:set escapehatchsidebarhack false`, but Tridactyl will no longer be able to get focus back from certain places such as the address bar.", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["sleep", new SymbolMetadata("Sleep time_ms milliseconds.\nThis is probably only useful for composite commands that need to wait until the previous asynchronous command has finished running.", new FunctionType([new NumberType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["showcmdline", new SymbolMetadata("", new FunctionType([new BooleanType(false, true)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["hidecmdline", new SymbolMetadata("", new FunctionType([], new VoidType(false, false), false, false), true)],
      ["fillcmdline", new SymbolMetadata("Set the current value of the commandline to string *with* a trailing space", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["fillcmdline_notrail", new SymbolMetadata("Set the current value of the commandline to string *without* a trailing space", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["fillcmdline_nofocus", new SymbolMetadata("Show and fill the command line without focusing it", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["fillcmdline_tmp", new SymbolMetadata("Shows str in the command line for ms milliseconds. Recommended duration: 3000ms.", new FunctionType([new NumberType(false, false), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["yank", new SymbolMetadata('Copy `content` to clipboard without feedback. Use `clipboard yank` for interactive use.\n\ne.g. `yank bob` puts "bob" in the clipboard; `composite js document.title | yank` puts the document title in the clipboard.', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new ArrayType(new AnyType(true, false), false, false)], false, false), false, false), false)],
      ["setclip", new SymbolMetadata("Copies a string to the clipboard/selection buffer depending on the user's preferences.", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new ArrayType(new AnyType(true, false), false, false)], false, false), false, false), true)],
      ["setclip_webapi", new SymbolMetadata("Copies a string to the clipboard using the Clipboard API.", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["getclip", new SymbolMetadata("Fetches the content of the clipboard/selection buffer depending on user's preferences\n\nExposed for use with [[composite]], e.g. `composite getclip | fillcmdline`", new FunctionType([new UnionType([
        new LiteralTypeType("clipboard", false, false),
        new LiteralTypeType("selection", false, false)
      ], false, true)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["getclip_webapi", new SymbolMetadata("Gets the clipboard content using the Clipboard API.", new FunctionType([], new TypeReferenceType("Promise", [new StringType(false, false)], false, false), false, false), true)],
      ["clipboard", new SymbolMetadata('Use the system clipboard.\n\nIf `excmd === "open"`, call [[open]] with the contents of the clipboard. Similarly for [[tabopen]].\n\nIf `excmd === "yank"`, copy the current URL, or if given, the value of toYank, into the system clipboard.\n\nIf `excmd === "yankcanon"`, copy the canonical URL of the current page if it exists, otherwise copy the current URL.\n\nIf `excmd === "yankshort"`, copy the shortlink version of the current URL, and fall back to the canonical then actual URL. Known to work on https://yankshort.neocities.org/.\n\nIf `excmd === "yanktitle"`, copy the title of the open page.\n\nIf `excmd === "yankmd"`, copy the title and url of the open page formatted in Markdown for easy use on sites such as reddit. `yankorg` is similar but for Emacs orgmode.\n\nIf you\'re on Linux and the native messenger is installed, Tridactyl will call an external binary (either xclip or xsel) to read or write to your X selection buffer. If you want another program to be used, set "externalclipboardcmd" to its name and make sure it has the same interface as xsel/xclip ("-i"/"-o" and reading from stdin).\n\nWhen doing a read operation (i.e. open or tabopen), if "putfrom" is set to "selection", the X selection buffer will be read instead of the clipboard. Set "putfrom" to "clipboard" to use the clipboard.\n\nWhen doing a write operation, if "yankto" is set to "selection", only the X selection buffer will be written to. If "yankto" is set to "both", both the X selection and the clipboard will be written to. If "yankto" is set to "clipboard", only the clipboard will be written to.', new FunctionType([new UnionType([
        new LiteralTypeType("open", false, false),
        new LiteralTypeType("yank", false, false),
        new LiteralTypeType("yankshort", false, false),
        new LiteralTypeType("yankcanon", false, false),
        new LiteralTypeType("yanktitle", false, false),
        new LiteralTypeType("yankmd", false, false),
        new LiteralTypeType("yankorg", false, false),
        new LiteralTypeType("xselpaste", false, false),
        new LiteralTypeType("tabopen", false, false)
      ], false, true), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["yankimage", new SymbolMetadata("Copy an image to the clipboard.", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["tab", new SymbolMetadata("Change active tab.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["taball", new SymbolMetadata("Wrapper for [[tab]] with multi-window completions", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["tab_helper", new SymbolMetadata("Helper to change active tab. Used by [[tab]] and [[taball]].", new FunctionType([new BooleanType(false, false), new BooleanType(false, false), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["command", new SymbolMetadata("Similar to vim's `:command`. Maps one ex-mode command to another.\nIf command already exists, this will override it, and any new commands\nadded in a future release will be SILENTLY overridden. Aliases are\nexpanded recursively.\n\nExamples:\n  - `command t tabopen`\n  - `command tn tabnext_gt`\n  - `command hello t` This will expand recursively into 'hello'->'tabopen'\n\nCommands/aliases are expanded as in a shell, so, given the commands above,\nentering `:tn 43` will expand to `:tabnext_gt 43`. You can use this to create\nyour own ex-commands in conjunction with [[js]], specifically `js -p` and `js -d`.\n\nNote that this is only for excmd -> excmd mappings. To map a normal-mode\ncommand to an excommand, see [[bind]].\n\nSee also:\n  - [[comclear]]", new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["comclear", new SymbolMetadata("Similar to vim's `comclear` command. Clears an excmd alias defined by\n`command`.\n\nFor example: `comclear helloworld` will reverse any changes caused\nby `command helloworld xxx`\n\nSee also:\n  - [[command]]", new FunctionType([new StringType(false, false)], new VoidType(false, false), false, false), false)],
      ["bind", new SymbolMetadata("Bind a sequence of keys to an excmd or view bound sequence.\n\nThis is an easier-to-implement bodge while we work on vim-style maps.\n\nExamples:\n\n    - `bind G fillcmdline tabopen google`\n    - `bind D composite tabclose | tab #` -> close current tab and switch to most recent previous tab\n    - `bind j scrollline 20`\n    - `bind F hint -b`\n\nYou can view binds by omitting the command line:\n\n    - `bind j`\n    - `bind k`\n\nYou can bind to modifiers and special keys by enclosing them with angle brackets, for example `bind <C-\\>z fullscreen`, `unbind <F1>` (a favourite of people who use TreeStyleTabs :) ), or `bind <Backspace> forward`.\n\nModifiers are truncated to a single character, so Ctrl -> C, Alt -> A, and Shift -> S. Shift is a bit special as it is only required if Shift does not change the key inputted, e.g. `<S-ArrowDown>` is OK, but `<S-a>` should just be `A`.\n\nYou can view all special key names here: https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values\n\nUse [[composite]] if you want to execute multiple excmds. Use\n[[fillcmdline]] to put a string in the cmdline and focus the cmdline\n(otherwise the string is executed immediately).\n\nYou can bind to other modes with `bind --mode={insert|ignore|normal|input|ex|hint} ...`, e.g, `bind --mode=insert emacs qall` (NB: unlike vim, all preceeding characters will not be input), or `bind --mode=hint <C-[> hint.reset`.\n\n`bind --mode=browser [key sequence] [ex command]` binds to a special mode which can be accessed all the time in all browser tabs - even tabs in which Tridactyl cannot run. It comes with a few caveats:\n\n- you may only have a few browser-mode binds at once. At the time of writing, this is 8, with 3 initially taken by Tridactyl. If you desperately need more, file an [[issue]].\n- the key sequence must consist of a single, simple key with at least one and no more than two modifiers. An error will be thrown if you try to bind to an invalid key sequence.\n- the `ex command` you bind to may not work fully unless you are on a tab which Tridactyl has access to. Generally, browser-wide actions like making or closing tabs will work but tab-specific actions like scrolling down or entering hint mode will not.\n\nA list of editor functions can be found\n[here](/static/docs/modules/_src_lib_editor_.html).\n\nSee also:\n\n    - [[unbind]]\n    - [[reset]]", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["bindurl", new SymbolMetadata("Like [[bind]] but for a specific url pattern (also see [[seturl]]).", new FunctionType([new StringType(false, false), new StringType(false, false), new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["keymap", new SymbolMetadata("Makes one key equivalent to another for the purposes of most of our parsers. Useful for international keyboard layouts. See user-provided examples for various layouts on our wiki: https://github.com/tridactyl/tridactyl/wiki/Internationalisation\n\ne.g,\n     keymap \u0119 e\n\nSee `:help keytranslatemodes` to enable keymaps in modes other than normal mode.", new FunctionType([new StringType(false, false), new StringType(false, false)], new AnyType(true, false), false, false), false)],
      ["searchsetkeyword", new SymbolMetadata("", new FunctionType([], new VoidType(false, false), false, false), true)],
      ["validateSetArgs", new SymbolMetadata("Validates arguments for set/seturl", new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), false, false)], new ArrayType(new AnyType(true, false), false, false), false, false), true)],
      ["seturl", new SymbolMetadata("Usage: `seturl [pattern] key values`", new FunctionType([new StringType(false, false), new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["set", new SymbolMetadata('Set a key value pair in config.\n\nUse to set any values found [here](/static/docs/classes/_src_lib_config_.default_config.html).\n\nArrays should be set using JS syntax, e.g. `:set blacklistkeys ["/",","]`.\n\ne.g.\n    set searchurls.google https://www.google.com/search?q=\n    set logging.messaging info\n\nIf no value is given, the value of the of the key will be displayed.\n\nSee also: [[unset]]', new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["firefoxsyncpull", new SymbolMetadata("Replaces your local configuration with that stored in the Firefox Sync area.\n\nIt does not merge your configurations: it overwrites.\n\nAlso see [[firefoxsyncpush]].", new FunctionType([], new AnyType(true, false), false, false), false)],
      ["firefoxsyncpush", new SymbolMetadata("Pushes your local configuration to the Firefox Sync area.\n\nIt does not merge your configurations: it overwrites.\n\nAlso see [[firefoxsyncpull]].", new FunctionType([], new AnyType(true, false), false, false), false)],
      ["autocmd", new SymbolMetadata("Set autocmds to run when certain events happen.", new FunctionType([new StringType(false, false), new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["autocontain", new SymbolMetadata("Automatically open a domain and all its subdomains in a specified container.\n\n__NB:__ You should use this command with an -s (sane mode) or -u (URL mode) flag. Usage without a flag uses an incorrect regular expression which may cause weird behaviour and has been left in for compatibility reasons.\n\nThis function accepts a `-u` flag to treat the pattern as a URL rather than a domain.\nFor example: `autocontain -u ^https?://([^/]*\\.|)youtube\\.com/ google` is equivalent to `autocontain -s youtube\\.com google`\n\nFor declaring containers that do not yet exist, consider using `auconcreatecontainer true` in your tridactylrc.\nThis allows Tridactyl to automatically create containers from your autocontain directives. Note that they will be random icons and colors.\n\nThe domain is passed through as a regular expression so there are a few gotchas to be aware of:\n* Unescaped periods will match *anything*. `autocontain -s google.co.uk work` will match `google!co$uk`. Escape your periods  (i.e. `\\.`) or accept that you might get some false positives.\n* You can use regex in your pattern. `autocontain -s google\\.(co\\.uk|com) work` will match either `google.co.uk` or `google.com`.\n\nThis *should* now peacefully coexist with the Temporary Containers and Multi-Account Containers addons. Do not trust this claim. If a fight starts the participants will try to open infinite tabs. It is *strongly* recommended that you use a tridactylrc so that you can abort a sorceror's-apprentice scenario by killing firefox, commenting out all of autocontainer directives in your rc file, and restarting firefox to clean up the mess. There are a number of strange behaviors resulting from limited coordination between extensions. Redirects can be particularly surprising; for example, with `:autocontain -s will-redirect.example.org example` set and `will-redirect.example.org` redirecting to `redirected.example.org`, navigating to `will-redirect.example.org` will result in the new tab being in the `example` container under some conditions and in the `firefox-default` container under others.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["autocmddelete", new SymbolMetadata("Remove autocmds", new FunctionType([new StringType(false, false), new StringType(false, false)], new AnyType(true, false), false, false), false)],
      ["blacklistadd", new SymbolMetadata("Helper function to put Tridactyl into ignore mode on the provided URL.\n\nSimply creates a DocStart [[autocmd]] that runs `mode ignore`. NB: ignore mode does have a few keybinds by default - see `:viewconfig ignoremaps`. These can be unbound with, e.g. `:unbind --mode=ignore <C-o>`, or `:unbindurl [url] --mode=ignore <C-o>`.\n\nRemove sites from the blacklist with `blacklistremove [url]` or `autocmddelete DocStart [url]`.\n\nIf you're looking for a way to temporarily disable Tridactyl, this might be what you're looking for.\n\n<!-- this should probably be moved to an ex alias once configuration has better help --!>", new FunctionType([new StringType(false, false)], new AnyType(true, false), false, false), false)],
      ["unbind", new SymbolMetadata("Unbind a sequence of keys so that they do nothing at all.\n\nSee also:\n\n    - [[bind]]\n    - [[reset]]", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["unbindurl", new SymbolMetadata("Unbind a sequence of keys you have set with [[bindurl]]. Note that this **kills** a bind, which means Tridactyl will pass it to the page on `pattern`. If instead you want to use the default setting again, use [[reseturl]].", new FunctionType([new StringType(false, false), new StringType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["reset", new SymbolMetadata("Restores a sequence of keys to their default value.", new FunctionType([new StringType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["reseturl", new SymbolMetadata("Restores a sequence of keys to their value in the global config for a specific URL pattern.\n\nSee also:\n  - [[bind]]\n  - [[unbind]]\n  - [[reset]]\n  - [[bindurl]]\n  - [[unbindurl]]\n  - [[seturl]]\n  - [[unseturl]]", new FunctionType([new StringType(false, false), new StringType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["sanitise", new SymbolMetadata("Deletes various bits of Firefox or Tridactyl data\n\nThe list of possible arguments can be found here:\nhttps://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/browsingData/DataTypeSet\n\nAdditional Tridactyl-specific arguments are:\n- `commandline`: Removes the in-memory commandline history.\n- `tridactyllocal`: Removes all tridactyl storage local to this machine. Use it with\n    commandline if you want to delete your commandline history.\n- `tridactylsync`: Removes all tridactyl storage associated with your Firefox Account (i.e, all user configuration, by default).\nThese arguments aren't affected by the timespan parameter.\n\nTimespan parameter:\n-t [0-9]+(m|h|d|w)\n\nExamples:\n\n- `sanitise all` -> Deletes __everything__, including any saved usernames / passwords(!)\n- `sanitise history` -> Deletes all history\n- `sanitise commandline tridactyllocal tridactylsync` -> Deletes every bit of data Tridactyl holds\n- `sanitise cookies -t 3d` -> Deletes cookies that were set during the last three days.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["quickmark", new SymbolMetadata("Bind a quickmark for the current URL or space-separated list of URLs to a key on the keyboard.\n\nAfterwards use go[key], gn[key], or gw[key] to [[open]], [[tabopen]], or\n[[winopen]] the URL respectively.\n\nExample:\n- `quickmark m https://mail.google.com/mail/u/0/#inbox`", new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["get", new SymbolMetadata("Puts the contents of config value with keys `keys` into the commandline and the background page console\n\nIt's a bit rubbish, but we don't have a good way to provide feedback to the commandline yet.\n\nYou can view the log entry in the browser console (Ctrl-Shift-j).\n\nFor example, you might try `get nmaps` to see all of your current binds.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["viewconfig", new SymbolMetadata("Opens the current configuration in Firefox's native JSON viewer in a new tab.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new VoidType(false, false), false, false), false)],
      ["jsonview", new SymbolMetadata("View a JSON object in Firefox's JSON viewer.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new ArrayType(new AnyType(true, false), false, false)], false, false), false, false), false)],
      ["unseturl", new SymbolMetadata("Reset a site-specific setting.\n\nusage: `unseturl [pattern] key`", new FunctionType([new StringType(false, false), new StringType(false, false)], new AnyType(true, false), false, false), false)],
      ["unset", new SymbolMetadata("Reset a config setting to default", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["setnull", new SymbolMetadata('"Delete" a default setting. E.g. `setnull searchurls.github` means `open github test` would search your default search engine for "github test".', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["hint", new SymbolMetadata("Hint a page.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["rot13", new SymbolMetadata("Perform rot13.\n\nTransforms all text nodes in the current tab via rot13. Only characters in\nthe ASCII range are considered.", new FunctionType([new NumberType(false, false)], new VoidType(false, false), false, false), false)],
      ["jumble", new SymbolMetadata("Perform text jumbling (reibadailty).\n\nShuffles letters except for first and last in all words in text nodes in the current tab. Only characters in\nthe ASCII range are considered.\n\nInspired by: https://www.newscientist.com/letter/mg16221887-600-reibadailty/", new FunctionType([], new VoidType(false, false), false, false), false)],
      ["run_exstr", new SymbolMetadata("Hacky ex string parser.\n\nUse it for fire-and-forget running of background commands in content.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["gobble", new SymbolMetadata("Initialize gobble mode.\n\nIt will read `nChars` input keys, append them to `endCmd` and execute that\nstring.", new FunctionType([new NumberType(false, false), new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["nmode", new SymbolMetadata("Initialize n [mode] mode.\n\nIn this special mode, a series of key sequences are executed as bindings from a different mode, as specified by the\n`mode` argument. After the count of accepted sequences is `n`, the finalizing ex command given as the `endexArr`\nargument is executed, which defaults to `mode ignore`.\n\nExample: `:nmode normal 1 mode ignore`\nThis looks up the next key sequence in the normal mode bindings, executes it, and switches the mode to `ignore`.\nIf the key sequence does not match a binding, it will be silently passed through to Firefox, but it will be counted\nfor the termination condition.", new FunctionType([new StringType(false, false), new NumberType(false, false), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["tssReadFromCss", new SymbolMetadata("Read text content of elements matching the given selector", new FunctionType([new StringType(false, false)], new VoidType(false, false), false, false), false)],
      ["ttsread", new SymbolMetadata("Read the given text using the browser's text to speech functionality and\nthe settings currently set", new FunctionType([new UnionType([
        new LiteralTypeType("-t", false, false),
        new LiteralTypeType("-c", false, false)
      ], false, false), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["ttsvoices", new SymbolMetadata("Show a list of the voices available to the TTS system. These can be\nset in the config using `ttsvoice`", new FunctionType([], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["ttscontrol", new SymbolMetadata("Cancel current reading and clear pending queue\n\nArguments:\n   - stop:    cancel current and pending utterances", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["buildFilterConfigs", new SymbolMetadata("Build a set of FilterConfigs from a list of human-input filter\nspecs.", new FunctionType([new ArrayType(new StringType(false, false), false, false)], new ArrayType(new AnyType(true, false), false, false), false, false), true)],
      ["perfdump", new SymbolMetadata('Dump the raw json for our performance counters. Filters with\ntrailing slashes are class names, :start | :end | :measure specify\nwhat type of sample to pass through, and all others are function\nnames. All filters must match for a sample to be dumped.\n\nTridactyl does not collect performance information by default. To\nget this data you\'ll have to set the configuration option\n`perfcounters` to `"true"`. You may also want to examine the value\nof `perfsamples`.', new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["perfhistogram", new SymbolMetadata("Pretty-print a histogram of execution durations for you. Arguments\nare as above, with the addition that this automatically filters to\ncounter samples of type :measure.\n\nNote that this will display its output by opening a data: url with\ntext in the place of your current tab.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["bmark", new SymbolMetadata("Add or remove a bookmark.\n\nOptionally, you may give the bookmark a title. If no URL is given, a bookmark is added for the current page.\n\nIf a bookmark already exists for the URL, it is removed, even if a title is given.\n\nDoes not support creation of folders: you'll need to use the Firefox menus for that.", new FunctionType([new StringType(false, true), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new TypeReferenceType("BookmarkTreeNode", [], false, false)], false, false), false, false), false)],
      ["echo", new SymbolMetadata("", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new StringType(false, false), false, false), false)],
      ["js_helper", new SymbolMetadata("helper function for js and jsb\n\n-p to take a single extra argument located at the end of str[]\n-d[delimiter character] to take a space-separated array of arguments after the delimiter\n-s to load js script of a source file from the config path", new FunctionType([new ArrayType(new StringType(false, false), false, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), true)],
      ["js", new SymbolMetadata("Lets you execute JavaScript in the page context. If you want to get the result back, use\n\n     `composite js ... | fillcmdline`", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["jsb", new SymbolMetadata("Lets you execute JavaScript in the background context. All the help from [[js]] applies. Gives you a different `tri` object which has access to more excmds and web-extension APIs.", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["issue", new SymbolMetadata('Opens a new tab the url of which is "https://github.com/tridactyl/tridactyl/issues/new" and automatically fill add tridactyl, firefox and os version to the issue.', new FunctionType([], new TypeReferenceType("Promise", [new TypeReferenceType("Tab", [], false, false)], false, false), false, false), false)],
      ["updatecheck", new SymbolMetadata("Checks if there are any stable updates available for Tridactyl.\n\nRelated settings:\n\n- `update.nag = true | false` - checks for updates on Tridactyl start.\n- `update.nagwait = 7` - waits 7 days before nagging you to update.\n- `update.checkintervalsecs = 86400` - waits 24 hours between checking for an update.", new FunctionType([new UnionType([
        new LiteralTypeType("manual", false, false),
        new LiteralTypeType("auto_polite", false, false),
        new LiteralTypeType("auto_impolite", false, false)
      ], false, true)], new TypeReferenceType("Promise", [new BooleanType(false, false)], false, false), false, false), false)],
      ["keyfeed", new SymbolMetadata("Feed some keys to Tridactyl's parser. E.g. `keyfeed jkjkjkjkjkjkjkjkjkjkjkjkjkjkjkjkjkjkjkjkjkjjkj`.\n\nNB:\n\n- Does _not_ function like Vim's noremap - `bind j keyfeed j` will cause an infinite loop.\n- Doesn't work in exmode - i.e. `keyfeed t<CR>` won't work.", new FunctionType([new StringType(false, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["extoptions", new SymbolMetadata("Opens optionsUrl for the selected extension in a popup window.\n\nNB: Tridactyl cannot run on this page!", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["elementunhide", new SymbolMetadata("Restore the most recently hidden element. Repeated invocations restore the next-most-recently-hidden element.\n\n(Elements can be hidden with `;K` and `:hint -K`.)", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)]
    ]))],
    ["src/lib/config.ts", new FileMetadata(new Map([["default_config", new ClassMetadata(new Map([
      ["configversion", new SymbolMetadata("Internal version number Tridactyl uses to know whether it needs to update from old versions of the configuration.\n\nChanging this might do weird stuff.", new StringType(false, false), false)],
      ["subconfigs", new SymbolMetadata("Internal field to handle site-specific configs. Use :seturl/:unseturl to change these values.", new ObjectType(new Map([["", new TypeReferenceType("DeepPartial", [new TypeReferenceType("default_config", [], false, false)], false, false)]]), false, false), false)],
      ["priority", new SymbolMetadata("Internal field to handle site-specific config priorities. Use :seturl/:unseturl to change this value.", new NumberType(false, false), false)],
      ["exmaps", new SymbolMetadata("exmaps contains all of the bindings for the command line.\nYou can of course bind regular ex commands but also [editor functions](/static/docs/modules/_src_lib_editor_.html) and [commandline-specific functions](/static/docs/modules/_src_commandline_frame_.html).", new ObjectType(new Map([]), false, false), false)],
      ["ignoremaps", new SymbolMetadata('ignoremaps contain all of the bindings for "ignore mode".\n\nThey consist of key sequences mapped to ex commands.', new ObjectType(new Map([]), false, false), false)],
      ["imaps", new SymbolMetadata('imaps contain all of the bindings for "insert mode".\n\nOn top of regular ex commands, you can also bind [editor functions](/static/docs/modules/_src_lib_editor_.html) in insert mode.\n\nThey consist of key sequences mapped to ex commands.', new ObjectType(new Map([]), false, false), false)],
      ["inputmaps", new SymbolMetadata('inputmaps contain all of the bindings for "input mode".\n\nOn top of regular ex commands, you can also bind [editor functions](/static/docs/modules/_src_lib_editor_.html) in input mode.\n\nThey consist of key sequences mapped to ex commands.', new ObjectType(new Map([]), false, false), false)],
      ["nmaps", new SymbolMetadata('nmaps contain all of the bindings for "normal mode".\n\nThey consist of key sequences mapped to ex commands.', new ObjectType(new Map([]), false, false), false)],
      ["vmaps", new SymbolMetadata("", new ObjectType(new Map([]), false, false), false)],
      ["hintmaps", new SymbolMetadata("", new ObjectType(new Map([]), false, false), false)],
      ["browsermaps", new SymbolMetadata('Browser-wide binds accessible in all modes and on pages where Tridactyl "cannot run".\n<!-- Note to developers: binds here need to also be listed in manifest.json -->', new ObjectType(new Map([]), false, false), false)],
      ["leavegithubalone", new SymbolMetadata("Whether to allow pages (not necessarily github) to override `/`, which is a default Firefox binding.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["blacklistkeys", new SymbolMetadata("Which keys to protect from pages that try to override them. Requires [[leavegithubalone]] to be set to false.", new ArrayType(new StringType(false, false), false, false), false)],
      ["autocmds", new SymbolMetadata("Autocommands that run when certain events happen, and other conditions are met.\n\nRelated ex command: `autocmd`.", new ObjectType(new Map([]), false, false), false)],
      ["keytranslatemap", new SymbolMetadata('Map for translating keys directly into other keys in normal-ish modes. For example, if you have an entry in this config option mapping `\u043F` to `g`, then you could type `\u043F\u043F` instead of `gg` or `\u043Fi` instead of `gi` or `;\u043F` instead of `;g`. This is primarily useful for international users who don\'t want to deal with rebuilding their bindings every time tridactyl ships a new default keybind. It\'s not as good as shipping properly internationalized sets of default bindings, but it\'s probably as close as we\'re going to get on a small open-source project like this.\n\nNote that the current implementation does not allow you to "chain" keys, for example, "a"=>"b" and "b"=>"c" for "a"=>"c". You can, however, swap or rotate keys, so "a"=>"b" and "b"=>"a" will work the way you\'d expect, as will "a"=>"b" and "b"=>"c" and "c"=>"a".', new ObjectType(new Map([]), false, false), false)],
      ["keytranslatemodes", new SymbolMetadata("Whether to use the keytranslatemap in various maps.", new ObjectType(new Map([["", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false)]]), false, false), false)],
      ["autocontain", new SymbolMetadata("Automatically place these sites in the named container.\n\nEach key corresponds to a URL fragment which, if contained within the page URL, the site will be opened in a container tab instead.", new AnyType(true, false), false)],
      ["autocontainmode", new SymbolMetadata("Strict mode will always ensure a domain is open in the correct container, replacing the current tab if necessary.\n\nRelaxed mode is less aggressive and instead treats container domains as a default when opening a new tab.", new UnionType([
        new LiteralTypeType("strict", false, false),
        new LiteralTypeType("relaxed", false, false)
      ], false, false), false)],
      ["exaliases", new SymbolMetadata("Aliases for the commandline.\n\nYou can make a new one with `command alias ex-command`.", new ObjectType(new Map([]), false, false), false)],
      ["followpagepatterns", new SymbolMetadata("Used by `]]` and `[[` to look for links containing these words.\n\nEdit these if you want to add, e.g. other language support.", new ObjectType(new Map([]), false, false), false)],
      ["searchengine", new SymbolMetadata("The default search engine used by `open search`. If empty string, your browser's default search engine will be used. If set to something, Tridactyl will first look at your [[searchurls]] and then at the search engines for which you have defined a keyword on `about:preferences#search`.", new StringType(false, false), false)],
      ["searchurls", new SymbolMetadata('Definitions of search engines for use via `open [keyword]`.\n\n`%s` will be replaced with your whole query and `%s1`, `%s2`, ..., `%sn` will be replaced with the first, second and nth word of your query. If there are none of these patterns in your search urls, your query will simply be appended to the searchurl.\n\nExamples:\n- When running `open gi cute puppies`, with a `gi` searchurl defined with `set searchurls.gi https://www.google.com/search?q=%s&tbm=isch`, tridactyl will navigate to `https://www.google.com/search?q=cute puppies&tbm=isch`.\n- When running `tabopen translate en ja Tridactyl`, with a `translate` searchurl defined with `set searchurls.translate https://translate.google.com/#view=home&op=translate&sl=%s1&tl=%s2&text=%s3`, tridactyl will navigate to `https://translate.google.com/#view=home&op=translate&sl=en&tl=ja&text=Tridactyl`.\n\n[[setnull]] can be used to "delete" the default search engines. E.g. `setnull searchurls.google`.', new ObjectType(new Map([]), false, false), false)],
      ["newtab", new SymbolMetadata("URL the newtab will redirect to.\n\nAll usual rules about things you can open with `open` apply, with the caveat that you'll get interesting results if you try to use something that needs `nativeopen`: so don't try `about:newtab` or a `file:///` URI. You should instead use a data URI - https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs - or host a local webserver (e.g. Caddy).", new StringType(false, false), false)],
      ["viewsource", new SymbolMetadata("Whether `:viewsource` will use our own page that you can use Tridactyl binds on, or Firefox's default viewer, which you cannot use Tridactyl on.", new UnionType([
        new LiteralTypeType("tridactyl", false, false),
        new LiteralTypeType("default", false, false)
      ], false, false), false)],
      ["homepages", new SymbolMetadata('Pages opened with `gH`. In order to set this value, use `:set homepages ["example.org", "example.net", "example.com"]` and so on.', new ArrayType(new StringType(false, false), false, false), false)],
      ["hintchars", new SymbolMetadata("Characters to use in hint mode.\n\nThey are used preferentially from left to right.", new StringType(false, false), false)],
      ["hintfiltermode", new SymbolMetadata("The type of hinting to use. `vimperator` will allow you to filter links based on their names by typing non-hint chars. It is recommended that you use this in conjuction with the [[hintchars]] setting, which you should probably set to e.g, `5432167890`. \xB4vimperator-reflow\xB4 additionally updates the hint labels after filtering.", new UnionType([
        new LiteralTypeType("simple", false, false),
        new LiteralTypeType("vimperator", false, false),
        new LiteralTypeType("vimperator-reflow", false, false)
      ], false, false), false)],
      ["hintnames", new SymbolMetadata("Whether to optimise for the shortest possible names for each hint, or to use a simple numerical ordering. If set to `numeric`, overrides `hintchars` setting.", new UnionType([
        new LiteralTypeType("short", false, false),
        new LiteralTypeType("numeric", false, false),
        new LiteralTypeType("uniform", false, false)
      ], false, false), false)],
      ["hintuppercase", new SymbolMetadata("Whether to display the names for hints in uppercase.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["hintdelay", new SymbolMetadata("The delay in milliseconds in `vimperator` style hint modes after selecting a hint before you are returned to normal mode.\n\nThe point of this is to prevent accidental execution of normal mode binds due to people typing more than is necessary to choose a hint.", new NumberType(false, false), false)],
      ["hintshift", new SymbolMetadata("Controls whether hints should be shifted in quick-hints mode.\n\nHere's what it means: let's say you have hints from a to z but are only\ninterested in every second hint. You first press `a`, then `c`.\nTridactyl will realize that you skipped over `b`, and so that the next\nhint you're going to trigger is probably `e`. Tridactyl will shift all\nhint names so that `e` becomes `c`, `d` becomes `b`, `c` becomes `a` and\nso on.\nThis means that once you pressed `c`, you can keep on pressing `c` to\ntrigger every second hint. Only makes sense with hintnames = short.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["hintautoselect", new SymbolMetadata("Controls whether hints should be followed automatically.\n\nIf set to `false`, hints will only be followed upon confirmation. This applies to cases when there is only a single match or only one link on the page.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["allowautofocus", new SymbolMetadata("Controls whether the page can focus elements for you via js\n\nNB: will break fancy editors such as CodeMirror on Jupyter. Simply use `seturl` to whitelist pages you need it on.\n\nBest used in conjunction with browser.autofocus in `about:config`", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["preventautofocusjackhammer", new SymbolMetadata("Uses a loop to prevent focus until you interact with a page. Only recommended for use via `seturl` for problematic sites as it can be a little heavy on CPU if running on all tabs. Should be used in conjuction with [[allowautofocus]]", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["smoothscroll", new SymbolMetadata("Whether to use Tridactyl's (bad) smooth scrolling.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["scrollduration", new SymbolMetadata("How viscous you want smooth scrolling to feel.", new NumberType(false, false), false)],
      ["tabopenpos", new SymbolMetadata("Where to open tabs opened with `tabopen` - to the right of the current tab, or at the end of the tabs.", new UnionType([
        new LiteralTypeType("next", false, false),
        new LiteralTypeType("last", false, false),
        new LiteralTypeType("related", false, false)
      ], false, false), false)],
      ["tabclosepinned", new SymbolMetadata("When enabled (the default), running tabclose will close the tabs whether they are pinned or not. When disabled, tabclose will fail with an error if a tab is pinned.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["tabsort", new SymbolMetadata("Controls which tab order to use when opening the tab/buffer list. Either mru = sort by most recent tab or default = by tab index", new UnionType([
        new LiteralTypeType("default", false, false),
        new LiteralTypeType("mru", false, false)
      ], false, false), false)],
      ["relatedopenpos", new SymbolMetadata("Where to open tabs opened with hinting - as if it had been middle clicked, to the right of the current tab, or at the end of the tabs.", new UnionType([
        new LiteralTypeType("next", false, false),
        new LiteralTypeType("last", false, false),
        new LiteralTypeType("related", false, false)
      ], false, false), false)],
      ["ttsvoice", new SymbolMetadata('The name of the voice to use for text-to-speech. You can get the list of installed voices by running the following snippet: `js alert(window.speechSynthesis.getVoices().reduce((a, b) => a + " " + b.name))`', new StringType(false, false), false)],
      ["ttsvolume", new SymbolMetadata("Controls text-to-speech volume. Has to be a number between 0 and 1.", new NumberType(false, false), false)],
      ["ttsrate", new SymbolMetadata("Controls text-to-speech speed. Has to be a number between 0.1 and 10.", new NumberType(false, false), false)],
      ["ttspitch", new SymbolMetadata("Controls text-to-speech pitch. Has to be between 0 and 2.", new NumberType(false, false), false)],
      ["gimode", new SymbolMetadata('When set to "nextinput", pressing `<Tab>` after gi selects the next input.\n\nWhen set to "firefox", `<Tab>` behaves like normal, focusing the next tab-indexed element regardless of type.', new UnionType([
        new LiteralTypeType("nextinput", false, false),
        new LiteralTypeType("firefox", false, false)
      ], false, false), false)],
      ["cursorpos", new SymbolMetadata("Decides where to place the cursor when selecting non-empty input fields", new UnionType([
        new LiteralTypeType("beginning", false, false),
        new LiteralTypeType("end", false, false)
      ], false, false), false)],
      ["theme", new SymbolMetadata("The theme to use.\n\nPermitted values: run `:composite js tri.styling.THEMES | fillcmdline` to find out.", new StringType(false, false), false)],
      ["customthemes", new SymbolMetadata("Storage for custom themes\n\nMaps theme names to CSS. Predominantly used automatically by [[colourscheme]] to store themes read from disk, as documented by [[colourscheme]]. Setting this manually is untested but might work provided that [[colourscheme]] is then used to change the theme to the right theme name.", new ObjectType(new Map([]), false, false), false)],
      ["modeindicator", new SymbolMetadata("Whether to display the mode indicator or not.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["modeindicatormodes", new SymbolMetadata("Whether to display the mode indicator in various modes. Ignored if modeindicator set to false.", new ObjectType(new Map([["", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false)]]), false, false), false)],
      ["jumpdelay", new SymbolMetadata("Milliseconds before registering a scroll in the jumplist", new NumberType(false, false), false)],
      ["logging", new SymbolMetadata("Logging levels. Unless you're debugging Tridactyl, it's unlikely you'll ever need to change these.", new ObjectType(new Map([["", new UnionType([
        new LiteralTypeType("never", false, false),
        new LiteralTypeType("error", false, false),
        new LiteralTypeType("warning", false, false),
        new LiteralTypeType("info", false, false),
        new LiteralTypeType("debug", false, false)
      ], false, false)]]), false, false), false)],
      ["noiframe", new SymbolMetadata(`Disables the commandline iframe. Dangerous setting, use [[seturl]] to set it. If you ever set this setting to "true" globally and then want to set it to false again, you can do this by opening Tridactyl's preferences page from about:addons.`, new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["noiframeon", new SymbolMetadata("", new ArrayType(new StringType(false, false), false, false), false)],
      ["editorcmd", new SymbolMetadata('Insert / input mode edit-in-$EDITOR command to run\nThis has to be a command that stays in the foreground for the whole editing session\n"auto" will attempt to find a sane editor in your path.\nPlease send your requests to have your favourite terminal moved further up the list to /dev/null.\n          (but we are probably happy to add your terminal to the list if it isn\'t already there.)\n\nExample values:\n- linux: `xterm -e vim`\n- windows: `start cmd.exe /c \\"vim\\"`.\n\nAlso see [:editor](/static/docs/modules/_src_excmds_.html#editor).', new StringType(false, false), false)],
      ["rsscmd", new SymbolMetadata('Command that should be run by the [[rssexec]] ex command. Has the\nfollowing format:\n- %u: url\n- %t: title\n- %y: type (rss, atom, xml...)\nWarning: This is a very large footgun. %u will be inserted without any\nkind of escaping, hence you must obey the following rules if you care\nabout security:\n- Do not use a composite command. If you need a composite command,\ncreate an alias.\n- Do not use `js` or `jsb`. If you need to use them, create an alias.\n- Do not insert any %u, %t or %y in shell commands run by the native\nmessenger. Use pipes instead.\n\nHere\'s an example of how to save an rss url in a file on your disk\nsafely:\n`alias save_rss jsb -p tri.native.run("cat >> ~/.config.newsboat/urls", JS_ARG)`\n`set rsscmd save_rss %u`\nThis is safe because the url is passed to jsb as an argument rather than\nbeing expanded inside of the string it will execute and because it is\npiped to the shell command rather than being expanded inside of it.', new StringType(false, false), false)],
      ["browser", new SymbolMetadata("The browser executable to look for in commands such as `restart`. Not as mad as it seems if you have multiple versions of Firefox...", new StringType(false, false), false)],
      ["yankto", new SymbolMetadata("Which clipboard to store items in. Requires the native messenger to be installed.", new UnionType([
        new LiteralTypeType("clipboard", false, false),
        new LiteralTypeType("selection", false, false),
        new LiteralTypeType("both", false, false)
      ], false, false), false)],
      ["putfrom", new SymbolMetadata("Which clipboard to retrieve items from. Requires the native messenger to be installed.\n\nPermitted values: `clipboard`, or `selection`.", new UnionType([
        new LiteralTypeType("clipboard", false, false),
        new LiteralTypeType("selection", false, false)
      ], false, false), false)],
      ["externalclipboardcmd", new SymbolMetadata("Clipboard command to try to get the selection from (e.g. `xsel` or `xclip`)", new StringType(false, false), false)],
      ["downloadsskiphistory", new SymbolMetadata("Whether downloads (e.g. via ;s hint modes) appear in your download history.\n\nNB: will cause downloads to fail silently if Tridactyl is not allowed to run in private windows (regardless of whether you are trying to call it in a private window).", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["nativeinstallcmd", new SymbolMetadata('Set this to something weird if you want to have fun every time Tridactyl tries to update its native messenger.\n\n%TAG will be replaced with your version of Tridactyl for stable builds, or "master" for beta builds\n\nNB: Windows has its own platform-specific default.', new StringType(false, false), false)],
      ["update", new SymbolMetadata("Used by :updatecheck and related built-in functionality to automatically check for updates and prompt users to upgrade.", new ObjectType(new Map([]), false, false), false)],
      ["profiledir", new SymbolMetadata("Profile directory to use with native messenger with e.g, `guiset`.", new StringType(false, false), false)],
      ["tabopencontaineraware", new SymbolMetadata("If enabled, tabopen opens a new tab in the currently active tab's container.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["containerindicator", new SymbolMetadata("If moodeindicator is enabled, containerindicator will color the border of the mode indicator with the container color.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["auconcreatecontainer", new SymbolMetadata("Autocontain directives create a container if it doesn't exist already.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["historyresults", new SymbolMetadata("Number of most recent results to ask Firefox for. We display the top 20 or so most frequently visited ones.", new NumberType(false, false), false)],
      ["bmarkweight", new SymbolMetadata("When displaying bookmarks in history completions, how many page views to pretend they have.", new NumberType(false, false), false)],
      ["completions", new SymbolMetadata("General completions options - NB: options are set according to our internal completion source name - see - `src/completions/[name].ts` in the Tridactyl source.", new ObjectType(new Map([]), false, false), false)],
      ["findresults", new SymbolMetadata("Number of results that should be shown in completions. -1 for unlimited", new NumberType(false, false), false)],
      ["findcontextlen", new SymbolMetadata("Number of characters to use as context for the matches shown in completions", new NumberType(false, false), false)],
      ["findcase", new SymbolMetadata("Whether find should be case-sensitive", new UnionType([
        new LiteralTypeType("smart", false, false),
        new LiteralTypeType("sensitive", false, false),
        new LiteralTypeType("insensitive", false, false)
      ], false, false), false)],
      ["incsearch", new SymbolMetadata("Whether Tridactyl should jump to the first match when using `:find`", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["minincsearchlen", new SymbolMetadata("How many characters should be typed before triggering incsearch/completions", new NumberType(false, false), false)],
      ["csp", new SymbolMetadata('Deprecated.\nChange this to "clobber" to ruin the "Content Security Policy" of all sites a bit and make Tridactyl run a bit better on some of them, e.g. raw.github*', new UnionType([
        new LiteralTypeType("untouched", false, false),
        new LiteralTypeType("clobber", false, false)
      ], false, false), false)],
      ["wordpattern", new SymbolMetadata("JavaScript RegExp used to recognize words in text.* functions (e.g. text.transpose_words). Should match any character belonging to a word.", new StringType(false, false), false)],
      ["perfcounters", new SymbolMetadata("Activate tridactyl's performance counters. These have a\nmeasurable performance impact, since every sample is a few\nhundred bytes and we sample tridactyl densely, but they're good\nwhen you're trying to optimize things.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["perfsamples", new SymbolMetadata(`How many samples to store from the perf counters.

Each performance entry is two numbers (16 bytes), an entryType
of either "mark" or "measure" (js strings are utf-16 ad we have
two marks for each measure, so amortize to about 10 bytes per
entry), and a string name that for Tridactyl object will be
about 40 (utf-16) characters (80 bytes), plus object overhead
roughly proportional to the string-length of the name of the
constructor (in this case something like 30 bytes), for a total
of what we'll call 128 bytes for ease of math.

We want to store, by default, about 1MB of performance
statistics, so somewhere around 10k samples.`, new StringType(false, false), false)],
      ["modeindicatorshowkeys", new SymbolMetadata("Show (partial) command in the mode indicator.\nCorresponds to 'showcmd' option of vi.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["urlparenttrailingslash", new SymbolMetadata("Whether a trailing slash is appended when we get the parent of a url with\ngu (or other means).", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["visualenterauto", new SymbolMetadata("Whether to enter visual mode when text is selected. Visual mode can always be entered with `:mode visual`.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["visualexitauto", new SymbolMetadata("Whether to return to visual mode when text is deselected.", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["escapehatchsidebarhack", new SymbolMetadata("Whether to open and close the sidebar quickly to get focus back to the page when <C-,> is pressed.\n\nDisable if the fact that it closes TreeStyleTabs gets on your nerves too much : )\n\nNB: when disabled, <C-,> can't get focus back from the address bar, but it can still get it back from lots of other places (e.g. Flash-style video players)", new UnionType([
        new LiteralTypeType("false", false, false),
        new LiteralTypeType("true", false, false)
      ], false, false), false)],
      ["completionfuzziness", new SymbolMetadata("Threshold for fuzzy matching on completions. Lower => stricter matching. Range between 0 and 1: 0 corresponds to perfect matches only. 1 will match anything.\n\nhttps://fusejs.io/api/options.html#threshold", new NumberType(false, false), false)]
    ]))]]), new Map([
      ["o", new SymbolMetadata("", new FunctionType([new AnyType(true, false)], new AnyType(true, false), false, false), true)],
      ["schlepp", new SymbolMetadata("", new FunctionType([new AnyType(true, false)], new VoidType(false, false), false, false), true)],
      ["getDeepProperty", new SymbolMetadata("Given an object and a target, extract the target if it exists, else return undefined", new FunctionType([new AnyType(true, false), new ArrayType(new StringType(false, false), false, false)], new AnyType(true, false), false, false), true)],
      ["setDeepProperty", new SymbolMetadata("Create the key path target if it doesn't exist and set the final property to value.\n\nIf the path is an empty array, replace the obj.", new FunctionType([new AnyType(true, false), new AnyType(true, false), new AnyType(true, false)], new AnyType(true, false), false, false), true)],
      ["mergeDeep", new SymbolMetadata("", new FunctionType([new AnyType(true, false), new AnyType(true, false)], new AnyType(true, false), false, false), true)],
      ["getURL", new SymbolMetadata("", new FunctionType([new StringType(false, false), new ArrayType(new StringType(false, false), false, false)], new AnyType(true, false), false, false), true)],
      ["get", new SymbolMetadata("Get the value of the key target.\n\nIf the user has not specified a key, use the corresponding key from\ndefaults, if one exists, else undefined.", new FunctionType([new UnionType([
        new LiteralTypeType("rsscmd", false, false),
        new LiteralTypeType("noiframeon", false, false),
        new LiteralTypeType("csp", false, false),
        new LiteralTypeType("theme", false, false),
        new LiteralTypeType("autocmds", false, false),
        new LiteralTypeType("exaliases", false, false),
        new LiteralTypeType("autocontain", false, false),
        new LiteralTypeType("update", false, false),
        new LiteralTypeType("imaps", false, false),
        new LiteralTypeType("viewsource", false, false),
        new LiteralTypeType("nmaps", false, false),
        new LiteralTypeType("configversion", false, false),
        new LiteralTypeType("subconfigs", false, false),
        new LiteralTypeType("priority", false, false),
        new TypeReferenceType("... 70 more ...", [], false, false),
        new LiteralTypeType("completionfuzziness", false, false)
      ], false, true), new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), true)],
      ["getDynamic", new SymbolMetadata("Get the value of the key target.\n\nPlease only use this with targets that will be used at runtime - it skips static checks. Prefer [[get]].", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new AnyType(true, false), false, false), false)],
      ["getAsyncDynamic", new SymbolMetadata("Get the value of the key target.\n\nPlease only use this with targets that will be used at runtime - it skips static checks. Prefer [[getAsync]].", new FunctionType([new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new AnyType(true, false)], false, false), false, false), false)],
      ["getAsync", new SymbolMetadata("Get the value of the key target, but wait for config to be loaded from the\ndatabase first if it has not been at least once before.\n\nThis is useful if you are a content script and you've just been loaded.", new FunctionType([new UnionType([
        new LiteralTypeType("rsscmd", false, false),
        new LiteralTypeType("noiframeon", false, false),
        new LiteralTypeType("csp", false, false),
        new LiteralTypeType("theme", false, false),
        new LiteralTypeType("autocmds", false, false),
        new LiteralTypeType("exaliases", false, false),
        new LiteralTypeType("autocontain", false, false),
        new LiteralTypeType("update", false, false),
        new LiteralTypeType("imaps", false, false),
        new LiteralTypeType("viewsource", false, false),
        new LiteralTypeType("nmaps", false, false),
        new LiteralTypeType("configversion", false, false),
        new LiteralTypeType("subconfigs", false, false),
        new LiteralTypeType("priority", false, false),
        new TypeReferenceType("... 70 more ...", [], false, false),
        new LiteralTypeType("completionfuzziness", false, false)
      ], false, true), new ArrayType(new StringType(false, false), true, false)], new TypeReferenceType("Promise", [new TypeReferenceType("...", [], false, false)], false, false), false, false), true)],
      ["push", new SymbolMetadata("", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["pull", new SymbolMetadata("", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), false)],
      ["setURL", new SymbolMetadata("", new FunctionType([new AnyType(true, false), new ArrayType(new AnyType(true, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["set", new SymbolMetadata('Full target specification, then value\n\ne.g.\n    set("nmaps", "o", "open")\n    set("search", "default", "google")\n    set("aucmd", "BufRead", "memrise.com", "open memrise.com")', new FunctionType([new ArrayType(new AnyType(true, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["unsetURL", new SymbolMetadata("", new FunctionType([new AnyType(true, false), new ArrayType(new AnyType(true, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["unset", new SymbolMetadata("Delete the key at target in USERCONFIG if it exists", new FunctionType([new ArrayType(new AnyType(true, false), true, false)], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["save", new SymbolMetadata("Save the config back to storage API.\n\nConfig is not synchronised between different instances of this module until\nsometime after this happens.", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["update", new SymbolMetadata(`Updates the config to the latest version.
Proposed semantic for config versionning:
- x.y -> x+1.0 : major architectural changes
- x.y -> x.y+1 : renaming settings/changing their types
There's no need for an updater if you're only adding a new setting/changing
a default setting

When adding updaters, don't forget to set("configversion", newversionnumber)!`, new FunctionType([], new TypeReferenceType("Promise", [new BooleanType(false, false)], false, false), false, false), true)],
      ["init", new SymbolMetadata("Read all user configuration from storage API then notify any waiting asynchronous calls\n\nasynchronous calls generated by getAsync.", new FunctionType([], new TypeReferenceType("Promise", [new VoidType(false, false)], false, false), false, false), true)],
      ["addChangeListener", new SymbolMetadata("", new FunctionType([new TypeReferenceType("P", [], false, false), new FunctionType([new AnyType(true, false), new AnyType(true, false)], new VoidType(false, false), false, false)], new VoidType(false, false), false, false), true)],
      ["removeChangeListener", new SymbolMetadata("", new FunctionType([new TypeReferenceType("P", [], false, false), new FunctionType([new AnyType(true, false), new AnyType(true, false)], new VoidType(false, false), false, false)], new VoidType(false, false), false, false), true)],
      ["parseConfig", new SymbolMetadata('Parse the config into a string representation of a .tridactylrc config file.\nTries to parse the config into sectionable chunks based on keywords.\nBinds, aliases, autocmds and logging settings each have their own section while the rest are dumped into "General Settings".', new FunctionType([], new StringType(false, false), false, false), false)]
    ]))]
  ]));
  var staticThemes = ["dark", "default", "greenmat", "halloween", "midnight", "quake", "quakelight", "shydactyl"];

  // src/lib/aliases.ts
  function expandExstr(exstr, aliases2 = get("exaliases"), prevExpansions = []) {
    const [command2] = exstr.trim().split(/\s+/);
    if (aliases2[command2] === void 0) {
      return exstr;
    }
    if (prevExpansions.includes(command2)) {
      throw new Error(`Infinite loop detected while expanding aliases. Stack: ${prevExpansions}.`);
    }
    prevExpansions.push(command2);
    return expandExstr(exstr.replace(command2, aliases2[command2]), aliases2, prevExpansions);
  }

  // src/parsers/exmode.ts
  var logger2 = new Logger("exmode");
  function convertArgs(types, argv) {
    const typedArgs = [];
    for (let itypes = 0, iargv = 0; itypes < types.length && iargv < argv.length; ++itypes && ++iargv) {
      const curType = types[itypes];
      const curArg = argv[iargv];
      if (curType.isDotDotDot || curType.kind === "array") {
        return typedArgs.concat(curType.convert(argv.slice(iargv)));
      }
      typedArgs.push(curType.convert(curArg));
    }
    return typedArgs;
  }
  function parser(exstr, all_excmds) {
    const expandedExstr = expandExstr(exstr);
    const [func, ...args] = expandedExstr.trim().split(/\s+/);
    const dotIndex = func.indexOf(".");
    const namespce = func.substring(0, dotIndex);
    const funcName = func.substring(dotIndex + 1);
    const excmds = all_excmds[namespce];
    if (excmds === void 0) {
      throw new Error(`Unknown namespace: ${namespce}.`);
    }
    let converted_args;
    if (namespce == "" && args.length > 0) {
      let types;
      try {
        types = everything.getFile("src/excmds.ts").getFunction(funcName).type.args;
      } catch (e) {
        types = null;
        converted_args = args;
      }
      if (types !== null) {
        try {
          converted_args = convertArgs(types, args);
        } catch (e) {
          logger2.error("Error executing or parsing:", exstr, e);
          throw e;
        }
      }
    } else {
      converted_args = args;
    }
    if (excmds[funcName] === void 0) {
      logger2.error("Not an excmd:", exstr);
      throw new Error(`Not an excmd: ${func}`);
    }
    return [excmds[funcName], converted_args];
  }

  // src/state.ts
  var state_exports = {};
  __export(state_exports, {
    default: () => state,
    getAsync: () => getAsync2
  });

  // src/lib/messaging.ts
  var messaging_exports = {};
  __export(messaging_exports, {
    addListener: () => addListener,
    attributeCaller: () => attributeCaller,
    message: () => message,
    messageActiveTab: () => messageActiveTab,
    messageAllTabs: () => messageAllTabs,
    messageOwnTab: () => messageOwnTab,
    messageTab: () => messageTab,
    setupListener: () => setupListener
  });

  // src/lib/webext.ts
  var webext_exports = {};
  __export(webext_exports, {
    activeTab: () => activeTab,
    activeTabContainer: () => activeTabContainer,
    activeTabContainerId: () => activeTabContainerId,
    activeTabId: () => activeTabId,
    browserBg: () => browserBg,
    firefoxVersionAtLeast: () => firefoxVersionAtLeast,
    getContext: () => getContext,
    getPrettyTriVersion: () => getPrettyTriVersion,
    getTriVersion: () => getTriVersion,
    getWinIdFromIndex: () => getWinIdFromIndex,
    inContentScript: () => inContentScript,
    notBackground: () => notBackground,
    openInNewTab: () => openInNewTab,
    openInNewWindow: () => openInNewWindow,
    openInTab: () => openInTab,
    ownTab: () => ownTab,
    ownTabContainer: () => ownTabContainer,
    ownTabId: () => ownTabId,
    ownWinTriIndex: () => ownWinTriIndex,
    queryAndURLwrangler: () => queryAndURLwrangler
  });

  // src/lib/convert.ts
  var convert_exports = {};
  __export(convert_exports, {
    toBoolean: () => toBoolean,
    toNumber: () => toNumber
  });
  function toBoolean(s) {
    if (s === "true")
      return true;
    else if (s === "false")
      return false;
    else
      throw new Error("Not a boolean");
  }
  function toNumber(s) {
    const n = Number(s);
    if (isNaN(n))
      throw new Error("Not a number! " + s);
    else
      return n;
  }

  // src/lib/browser_proxy.ts
  var browserProxy = new Proxy(Object.create(null), {
    get(target, api) {
      return new Proxy({}, {
        get(_, func) {
          return (...args) => message("browser_proxy_background", "shim", api, func, args);
        }
      });
    }
  });
  var browser_proxy_default = browserProxy;

  // src/lib/url_util.ts
  var url_util_exports = {};
  __export(url_util_exports, {
    deleteQuery: () => deleteQuery,
    getAbsoluteURL: () => getAbsoluteURL,
    getDownloadFilenameForUrl: () => getDownloadFilenameForUrl,
    getUrlParent: () => getUrlParent,
    getUrlRoot: () => getUrlRoot,
    graftUrlPath: () => graftUrlPath,
    incrementUrl: () => incrementUrl,
    interpolateSearchItem: () => interpolateSearchItem,
    replaceQueryValue: () => replaceQueryValue,
    setQueryValue: () => setQueryValue
  });
  function incrementUrl(url, count) {
    const matches = url.match(/(.*?)(\d+)(\D*)$/);
    if (matches === null) {
      return null;
    }
    const [, pre, number, post] = matches;
    const newNumber = parseInt(number, 10) + count;
    let newNumberStr = String(newNumber > 0 ? newNumber : 0);
    if (number.match(/^0/)) {
      while (newNumberStr.length < number.length) {
        newNumberStr = "0" + newNumberStr;
      }
    }
    return pre + newNumberStr + post;
  }
  function getUrlRoot(url) {
    if (/(about|mailto):/.test(url.protocol)) {
      return null;
    }
    return new URL(url.protocol + "//" + (url.host || ""));
  }
  function getUrlParent(url, trailingSlash, count = 1) {
    function gup(parent2, trailingSlash2, count2) {
      if (count2 < 1) {
        if (!trailingSlash2) {
          parent2.pathname = parent2.pathname.replace(/\/+$/, "");
        }
        return parent2;
      }
      if (parent2.hash) {
        parent2.hash = "";
        return gup(parent2, trailingSlash2, count2 - 1);
      }
      if (parent2.search) {
        parent2.search = "";
        return gup(parent2, trailingSlash2, count2 - 1);
      }
      if (parent2.pathname !== "/") {
        parent2.pathname = parent2.pathname.replace(/\/[^\/]*?\/*$/, "/");
        return gup(parent2, trailingSlash2, count2 - 1);
      }
      {
        const domains = parent2.host.split(".");
        if (domains.length > 2) {
          parent2.host = domains.slice(1).join(".");
          return gup(parent2, trailingSlash2, count2 - 1);
        }
      }
      return null;
    }
    if (/(about|mailto):/.test(url.protocol)) {
      return null;
    }
    const parent = new URL(url);
    return gup(parent, trailingSlash, count);
  }
  function getExtensionForMimetype(mime) {
    const types = {
      "image/png": ".png",
      "image/jpeg": ".jpg",
      "image/gif": ".gif",
      "image/x-icon": ".ico",
      "image/svg+xml": ".svg",
      "image/tiff": ".tiff",
      "image/webp": ".webp",
      "text/plain": ".txt",
      "text/html": ".html",
      "text/css": ".css",
      "text/csv": ".csv",
      "text/calendar": ".ics",
      "application/octet-stream": ".bin",
      "application/javascript": ".js",
      "application/xhtml+xml": ".xhtml",
      "font/otf": ".otf",
      "font/woff": ".woff",
      "font/woff2": ".woff2",
      "font/ttf": ".ttf"
    };
    return types[mime] || "";
  }
  function getDownloadFilenameForUrl(url) {
    if (url.protocol === "data:") {
      const [prefix, data] = url.pathname.split(",", 2);
      const [mediatype, b64] = prefix.split(";", 2);
      let filename = data.slice(0, 15).replace(/[^a-zA-Z0-9_\-]/g, "_").replace(/_{2,}/g, "_");
      filename = (b64 ? b64 + "-" : "") + filename + getExtensionForMimetype(mediatype);
      return filename;
    }
    if (url.pathname !== "/") {
      const paths2 = url.pathname.split("/").slice(1);
      while (paths2.length && !paths2[paths2.length - 1]) {
        paths2.pop();
      }
      if (paths2.length) {
        return paths2.slice(-1)[0];
      }
    }
    return url.hostname || "download";
  }
  function getUrlQueries(url) {
    let qys = [];
    if (url.search) {
      qys = url.search.slice(1).split("&");
    }
    return qys;
  }
  function setUrlQueries(url, qys) {
    url.search = "";
    if (qys.length) {
      url.search = "?" + qys.join("&");
    }
  }
  function deleteQuery(url, matchQuery) {
    const newUrl = new URL(url.href);
    const qys = getUrlQueries(url);
    const new_qys = qys.filter((q) => q.split("=")[0] !== matchQuery);
    setUrlQueries(newUrl, new_qys);
    return newUrl;
  }
  function setQueryValue(url, matchQuery, value) {
    const newUrl = new URL(url.href);
    const qys = getUrlQueries(url);
    if (qys.map((q) => q.split("=")[0]).includes(matchQuery)) {
      return replaceQueryValue(url, matchQuery, value);
    }
    qys.push(matchQuery + "=" + value);
    setUrlQueries(newUrl, qys);
    return newUrl;
  }
  function replaceQueryValue(url, matchQuery, newVal) {
    const newUrl = new URL(url.href);
    const qys = getUrlQueries(url);
    const new_qys = qys.map((q) => {
      const [key] = q.split("=");
      if (q.split("=")[0] === matchQuery) {
        if (newVal) {
          return key + "=" + newVal;
        } else {
          return key;
        }
      }
      return q;
    });
    setUrlQueries(newUrl, new_qys);
    return newUrl;
  }
  function graftUrlPath(url, newTail, level) {
    const newUrl = new URL(url.href);
    const pathParts = url.pathname.split("/").splice(1);
    if (level >= 0 && level > pathParts.length || level < 0 && -level - 1 > pathParts.length) {
      return null;
    }
    const graftPoint = level >= 0 ? level : pathParts.length + level + 1;
    pathParts.splice(graftPoint, pathParts.length - graftPoint);
    pathParts.push(...newTail.split("/"));
    newUrl.pathname = pathParts.join("/");
    return newUrl;
  }
  function interpolateSearchItem(urlPattern, query) {
    const hasInterpolationPoint = urlPattern.href.includes("%s");
    let queryWords = query.split(" ");
    if (hasInterpolationPoint && urlPattern.search.includes("%s") || urlPattern.search !== "") {
      query = encodeURIComponent(query);
      queryWords = queryWords.map((w) => encodeURIComponent(w));
    }
    if (hasInterpolationPoint) {
      const resultingURL = new URL(urlPattern.href.replace(/%s\d+/g, function(x) {
        const index = parseInt(x.slice(2), 10) - 1;
        if (index >= queryWords.length) {
          return "";
        }
        return queryWords[index];
      }));
      return new URL(resultingURL.href.replace("%s", query));
    } else {
      return new URL(urlPattern.href + query);
    }
  }
  function getAbsoluteURL(url, baseURI = document.baseURI) {
    return new URL(url, baseURI).href;
  }

  // src/lib/patience.ts
  var sleep = (duration) => new Promise((res) => setTimeout(res, duration));

  // src/lib/webext.ts
  function inContentScript() {
    return getContext() === "content";
  }
  function getTriVersion() {
    const manifest = browser.runtime.getManifest();
    return manifest.version_name;
  }
  function getPrettyTriVersion() {
    const manifest = browser.runtime.getManifest();
    return manifest.name + " " + getTriVersion();
  }
  function notBackground() {
    return getContext() !== "background";
  }
  function getContext() {
    if (!browser.tabs) {
      return "content";
    } else if (browser.runtime.getURL("_generated_background_page.html") === window.location.href) {
      return "background";
    } else {
      return "extension";
    }
  }
  var browserBg = inContentScript() ? browser_proxy_default : browser;
  async function activeTab() {
    return (await browserBg.tabs.query({
      active: true,
      currentWindow: true
    }))[0];
  }
  async function activeTabId() {
    return (await activeTab()).id;
  }
  async function activeTabContainerId() {
    return (await activeTab()).cookieStoreId;
  }
  async function ownTab() {
    return browser.runtime.sendMessage({ type: "owntab_background" });
  }
  async function ownTabId() {
    return (await ownTab()).id;
  }
  async function windows() {
    return (await browserBg.windows.getAll()).map((w) => w.id).sort((a, b) => a - b);
  }
  async function ownWinTriIndex() {
    return (await windows()).indexOf((await ownTab()).windowId);
  }
  async function getWinIdFromIndex(index) {
    return (await windows())[index];
  }
  async function ownTabContainer() {
    return browserBg.contextualIdentities.get((await ownTab()).cookieStoreId);
  }
  async function activeTabContainer() {
    const containerId = await activeTabContainerId();
    if (containerId !== "firefox-default")
      return browserBg.contextualIdentities.get(containerId);
    else
      throw new Error("firefox-default is not a valid contextualIdentity (activeTabContainer)");
  }
  async function firefoxVersionAtLeast(desiredmajor) {
    const versionstr = (await browserBg.runtime.getBrowserInfo()).version;
    const actualmajor = toNumber(versionstr.split(".")[0]);
    return actualmajor >= desiredmajor;
  }
  async function openInNewTab(url, kwargs = {
    active: true,
    related: false,
    cookieStoreId: void 0
  }, waitForDOM = false) {
    const thisTab = await activeTab();
    const options = {
      active: false,
      url,
      cookieStoreId: kwargs.cookieStoreId
    };
    let pos;
    if (kwargs.related)
      pos = get("relatedopenpos");
    else
      pos = get("tabopenpos");
    switch (pos) {
      case "next":
        options.index = thisTab.index + 1;
        if (kwargs.related && await firefoxVersionAtLeast(57))
          options.openerTabId = thisTab.id;
        break;
      case "last":
        options.index = (await browserBg.tabs.query({
          currentWindow: true
        })).length;
        break;
      case "related":
        if (await firefoxVersionAtLeast(57)) {
          options.openerTabId = thisTab.id;
        } else {
          options.index = thisTab.index + 1;
        }
        break;
    }
    const tabCreateWrapper = async (options2) => {
      const tab2 = await browserBg.tabs.create(options2);
      const answer = new Promise((resolve) => {
        if (waitForDOM) {
          const listener = (message2, sender) => {
            var _a2;
            if (message2 === "dom_loaded_background" && ((_a2 = sender == null ? void 0 : sender.tab) == null ? void 0 : _a2.id) === tab2.id) {
              browserBg.runtime.onMessage.removeListener(listener);
              resolve(tab2);
            }
          };
          browserBg.runtime.onMessage.addListener(listener);
        } else {
          resolve(tab2);
        }
      });
      return Promise.race([
        answer,
        (async () => {
          await sleep(750);
          return tab2;
        })()
      ]);
    };
    if (kwargs.active === false) {
      return tabCreateWrapper(options);
    } else {
      return tabCreateWrapper(options).then((newtab) => browserBg.tabs.update(newtab.id, { active: true }));
    }
  }
  function openInNewWindow(createData = {}) {
    browserBg.windows.create(createData);
  }
  async function queryAndURLwrangler(query) {
    let address = query.join(" ");
    if (address === "") {
      address = get("newtab");
    }
    if (address === "about:newtab") {
      return void 0;
    }
    const index = address.indexOf(" ");
    let firstWord = address;
    if (index > -1)
      firstWord = address.substr(0, index);
    if (firstWord === "") {
      return void 0;
    }
    if (/^[a-zA-Z0-9+.-]+:[^\s:]/.test(address)) {
      try {
        return new URL(address).href;
      } catch (e) {
      }
    }
    const rest = address.substr(firstWord.length + 1);
    const searchurls = get("searchurls");
    if (searchurls[firstWord]) {
      const url = interpolateSearchItem(new URL(searchurls[firstWord]), rest);
      return url.href;
    }
    const searchEngines = await browserBg.search.get();
    let engine = searchEngines.find((engine2) => engine2.alias === firstWord);
    if (engine !== void 0) {
      return { engine: engine.name, query: rest };
    }
    try {
      const url = new URL("http://" + address);
      if (url.hostname.indexOf(".") > 0 || url.port || url.password) {
        return url.href;
      }
    } catch (e) {
    }
    let queryString = address;
    if (firstWord === "search") {
      queryString = rest;
    }
    const enginename = get("searchengine");
    if (enginename) {
      if (searchurls[enginename]) {
        const url = interpolateSearchItem(new URL(searchurls[enginename]), queryString);
        return url.href;
      }
      engine = searchEngines.find((engine2) => engine2.alias === enginename);
      if (engine !== void 0) {
        return { engine: engine.name, query: queryString };
      }
    }
    return { query: queryString };
  }
  async function openInTab(tab2, opts2 = {}, strarr) {
    const maybeURL = await queryAndURLwrangler(strarr);
    if (typeof maybeURL === "string") {
      return browserBg.tabs.update(tab2.id, Object.assign({ url: maybeURL }, opts2));
    }
    if (typeof maybeURL === "object") {
      return browserBg.search.search({ tabId: tab2.id, ...maybeURL });
    }
    return browserBg.tabs.update(tab2.id, Object.assign({ url: "/static/newtab.html" }, opts2));
  }

  // src/lib/messaging.ts
  var logger3 = new logging_default("messaging");
  function attributeCaller(obj) {
    function handler(message2, sender, sendResponse) {
      logger3.debug(message2);
      if (message2.args === void 0)
        message2.args = [];
      try {
        const response = obj[message2.command](...message2.args);
        if (response instanceof Promise) {
          logger3.debug("Returning promise...", response);
          sendResponse(response);
        } else if (response !== void 0) {
          logger3.debug("Returning synchronously...", response);
          sendResponse(response);
        }
      } catch (e) {
        logger3.error(`Error processing ${message2.command}(${message2.args})`, e);
        return Promise.reject(e);
      }
    }
    return handler;
  }
  function backgroundHandler(root, message2) {
    return root[message2.type][message2.command](...message2.args);
  }
  function setupListener(root) {
    browser.runtime.onMessage.addListener((message2) => {
      if (message2.type in root) {
        if (!(message2.command in root[message2.type]))
          throw new Error(`missing handler in protocol ${message2.type} ${message2.command}`);
        if (!Array.isArray(message2.args))
          throw new Error(`wrong arguments in protocol ${message2.type} ${message2.command}`);
        return Promise.resolve(backgroundHandler(root, message2));
      }
    });
  }
  async function message(type2, command2, ...args) {
    const message2 = {
      type: type2,
      command: command2,
      args
    };
    return browser.runtime.sendMessage(message2);
  }
  async function messageActiveTab(type2, command2, args) {
    return messageTab(await activeTabId(), type2, command2, args);
  }
  async function messageTab(tabId, type2, command2, args) {
    const message2 = {
      type: type2,
      command: command2,
      args
    };
    return browserBg.tabs.sendMessage(tabId, message2);
  }
  var _ownTabId;
  async function messageOwnTab(type2, command2, args) {
    if (_ownTabId === void 0) {
      _ownTabId = await ownTabId();
    }
    if (_ownTabId === void 0)
      throw new Error("Can't message own tab: _ownTabId is undefined");
    return messageTab(_ownTabId, type2, command2, args);
  }
  async function messageAllTabs(type2, command2, args) {
    const responses = [];
    for (const tab2 of await browserBg.tabs.query({})) {
      try {
        responses.push(await messageTab(tab2.id, type2, command2, args));
      } catch (e) {
        if (e.message != "Could not establish connection. Receiving end does not exist.") {
          logger3.error(e);
        }
      }
    }
    return responses;
  }
  var listeners = new Map();
  function addListener(type2, callback) {
    if (!listeners.get(type2)) {
      listeners.set(type2, new Set());
    }
    listeners.get(type2).add(callback);
    return () => {
      listeners.get(type2).delete(callback);
    };
  }
  if (getContext() === "background") {
    addListener("owntab_background", (message2, sender, sendResponse) => {
      const x = Object.assign(Object.create(null), sender.tab);
      x.mutedInfo = Object.assign(Object.create(null), sender.tab.mutedInfo);
      x.sharingState = Object.assign(Object.create(null), sender.tab.sharingState);
      sendResponse(Promise.resolve(x));
    });
  }
  function onMessage(message2, sender, sendResponse) {
    if (listeners.get(message2.type)) {
      for (const listener of listeners.get(message2.type)) {
        listener(message2, sender, sendResponse);
      }
    }
  }
  browser.runtime.onMessage.addListener(onMessage);

  // src/state.ts
  var logger4 = new logging_default("state");
  var State = class {
    constructor() {
      this.lastSearchQuery = void 0;
      this.cmdHistory = [];
      this.prevInputs = [
        {
          inputId: void 0,
          tab: void 0,
          jumppos: void 0
        }
      ];
      this.last_ex_str = "echo";
    }
  };
  var PERSISTENT_KEYS = ["cmdHistory"];
  var defaults = Object.freeze(new State());
  var overlay = {};
  browser.storage.local.get("state").then((res) => {
    if ("state" in res) {
      logger4.debug("Loaded initial state:", res.state);
      Object.assign(overlay, res.state);
    }
  }).catch((...args) => logger4.error(...args));
  var state = new Proxy(overlay, {
    get(target, property) {
      if (notBackground())
        throw new Error("State object must be accessed with getAsync in content");
      if (property in target) {
        return target[property];
      } else {
        return defaults[property];
      }
    },
    set(target, property, value) {
      logger4.debug("State changed!", property, value);
      if (notBackground()) {
        browser.runtime.sendMessage({
          type: "state",
          command: "stateUpdate",
          args: { property, value }
        });
        return true;
      }
      target[property] = value;
      if (PERSISTENT_KEYS.includes(property)) {
        if (browser.extension.inIncognitoContext) {
          console.error("Attempted to write to storage in private window.");
          return false;
        }
        browser.storage.local.set({
          state: pick(PERSISTENT_KEYS, target)
        });
      }
      return true;
    }
  });
  async function getAsync2(property) {
    if (notBackground())
      return browser.runtime.sendMessage({
        type: "state",
        command: "stateGet",
        args: [{ prop: property }]
      });
    else
      return state[property];
  }
  notBackground && !notBackground() && addListener("state", (message2, sender, sendResponse) => {
    if (message2.command == "stateUpdate") {
      const property = message2.args.property;
      const value = message2.args.value;
      logger4.debug("State changed!", property, value);
      state[property] = value;
    } else if (message2.command == "stateGet") {
      sendResponse(state[message2.args[0].prop]);
    } else
      throw new Error("Unsupported message to state, type " + message2.command);
  });

  // src/lib/controller.ts
  var logger5 = new logging_default("controller");
  var stored_excmds;
  function setExCmds(excmds) {
    stored_excmds = excmds;
  }
  async function acceptExCmd(exstr) {
    try {
      const [func, args] = parser(exstr, stored_excmds);
      if (func !== stored_excmds[""].repeat && exstr.search("winopen -private") < 0) {
        getAsync2("last_ex_str").then((last_ex_str) => {
          if (last_ex_str != exstr)
            state.last_ex_str = exstr;
        });
      }
      try {
        return await func(...args);
      } catch (e) {
        logger5.error("controller in excmd: ", e);
      }
    } catch (e) {
      logger5.error("controller while accepting: ", e);
    }
  }

  // src/.excmds_content.generated.ts
  var excmds_content_generated_exports = {};
  __export(excmds_content_generated_exports, {
    ABOUT_WHITELIST: () => ABOUT_WHITELIST,
    INPUTTAGS_selectors: () => INPUTTAGS_selectors,
    addJump: () => addJump,
    addTridactylEditorClass: () => addTridactylEditorClass,
    apropos: () => apropos,
    autocmd: () => autocmd,
    autocmddelete: () => autocmddelete,
    autocontain: () => autocontain,
    back: () => back,
    bind: () => bind,
    bindurl: () => bindurl,
    blacklistadd: () => blacklistadd,
    bmark: () => bmark,
    bmarks: () => bmarks,
    changelistjump: () => changelistjump,
    clearsearchhighlight: () => clearsearchhighlight,
    clipboard: () => clipboard2,
    cmd_params: () => cmd_params,
    colourscheme: () => colourscheme,
    comclear: () => comclear,
    command: () => command,
    composite: () => composite,
    containerclose: () => containerclose,
    containercreate: () => containercreate,
    containerdelete: () => containerdelete,
    containerupdate: () => containerupdate,
    credits: () => credits,
    cssparse: () => cssparse,
    curJumps: () => curJumps,
    drawingerasertoggle: () => drawingerasertoggle,
    drawingstart: () => drawingstart,
    echo: () => echo,
    editor: () => editor2,
    elementunhide: () => elementunhide,
    escapehatch: () => escapehatch,
    exclaim: () => exclaim,
    exclaim_quiet: () => exclaim_quiet,
    extoptions: () => extoptions,
    fillcmdline: () => fillcmdline,
    fillcmdline_nofocus: () => fillcmdline_nofocus,
    fillcmdline_notrail: () => fillcmdline_notrail,
    fillcmdline_tmp: () => fillcmdline_tmp,
    fillinput: () => fillinput,
    find: () => find3,
    findnext: () => findnext,
    firefoxsyncpull: () => firefoxsyncpull,
    firefoxsyncpush: () => firefoxsyncpush,
    fixamo: () => fixamo,
    fixamo_quiet: () => fixamo_quiet,
    focusbyid: () => focusbyid,
    focusinput: () => focusinput,
    followpage: () => followpage,
    forward: () => forward,
    fullscreen: () => fullscreen,
    get: () => get2,
    getInput: () => getInput,
    getInputSelector: () => getInputSelector,
    getJumpPageId: () => getJumpPageId,
    getNativeVersion: () => getNativeVersion,
    getRssLinks: () => getRssLinks,
    getclip: () => getclip,
    getinput: () => getinput,
    geturlsforlinks: () => geturlsforlinks,
    gobble: () => gobble,
    guiset: () => guiset,
    guiset_quiet: () => guiset_quiet,
    help: () => help,
    hidecmdline: () => hidecmdline,
    hint: () => hint,
    home: () => home,
    issue: () => issue,
    js: () => js,
    jsb: () => jsb,
    jsonview: () => jsonview,
    jumble: () => jumble2,
    jumpnext: () => jumpnext,
    jumpprev: () => jumpprev,
    keyfeed: () => keyfeed,
    keymap: () => keymap,
    loadaucmds: () => loadaucmds,
    loadtheme: () => loadtheme,
    mktridactylrc: () => mktridactylrc,
    mode: () => mode,
    mouse_mode: () => mouse_mode,
    mute: () => mute,
    native: () => native,
    nativeinstall: () => nativeinstall,
    nativeopen: () => nativeopen,
    neo_mouse_mode: () => neo_mouse_mode,
    nmode: () => nmode2,
    no_mouse_mode: () => no_mouse_mode,
    open: () => open,
    open_quiet: () => open_quiet,
    perfdump: () => perfdump,
    perfhistogram: () => perfhistogram,
    pied_piper_mouse_mode: () => pied_piper_mouse_mode,
    pin: () => pin,
    qall: () => qall,
    quickmark: () => quickmark,
    reader: () => reader,
    recontain: () => recontain,
    reload: () => reload,
    reloadall: () => reloadall,
    reloadallbut: () => reloadallbut,
    reloaddead: () => reloaddead,
    reloadhard: () => reloadhard,
    removeTridactylEditorClass: () => removeTridactylEditorClass,
    removepref: () => removepref,
    repeat: () => repeat2,
    reset: () => reset3,
    reseturl: () => reseturl,
    restart: () => restart,
    rot13: () => rot132,
    rssexec: () => rssexec,
    run_exstr: () => run_exstr,
    sanitise: () => sanitise,
    saveJumps: () => saveJumps,
    saveas: () => saveas,
    scrollline: () => scrollline,
    scrollpage: () => scrollpage,
    scrollpx: () => scrollpx,
    scrollto: () => scrollto,
    searchsetkeyword: () => searchsetkeyword,
    set: () => set3,
    setnull: () => setnull,
    setpref: () => setpref,
    seturl: () => seturl,
    shellescape: () => shellescape,
    showcmdline: () => showcmdline,
    sleep: () => sleep3,
    snow_mouse_mode: () => snow_mouse_mode,
    source: () => source,
    source_quiet: () => source_quiet,
    tab: () => tab,
    tab_helper: () => tab_helper,
    taball: () => taball,
    tabaudio: () => tabaudio,
    tabclose: () => tabclose,
    tabcloseallto: () => tabcloseallto,
    tabdetach: () => tabdetach,
    tabduplicate: () => tabduplicate,
    tabgrab: () => tabgrab,
    tabmove: () => tabmove,
    tabnext: () => tabnext,
    tabnext_gt: () => tabnext_gt,
    tabonly: () => tabonly,
    tabopen: () => tabopen,
    tabprev: () => tabprev,
    tabpush: () => tabpush,
    tabqueue: () => tabqueue,
    tabsort: () => tabsort,
    ttscontrol: () => ttscontrol,
    ttsread: () => ttsread,
    ttsvoices: () => ttsvoices,
    tutor: () => tutor,
    unbind: () => unbind,
    unbindurl: () => unbindurl,
    undo: () => undo,
    unfocus: () => unfocus,
    unloadtheme: () => unloadtheme,
    unset: () => unset2,
    unseturl: () => unseturl,
    updatecheck: () => updatecheck,
    updatenative: () => updatenative,
    url2args: () => url2args,
    urlincrement: () => urlincrement,
    urlmodify: () => urlmodify,
    urlmodify_js: () => urlmodify_js,
    urlparent: () => urlparent,
    urlroot: () => urlroot,
    version: () => version,
    viewconfig: () => viewconfig,
    viewcontainers: () => viewcontainers,
    viewsource: () => viewsource,
    winclose: () => winclose,
    winmerge: () => winmerge,
    winopen: () => winopen,
    yank: () => yank,
    yankimage: () => yankimage,
    zoom: () => zoom
  });

  // src/lib/native.ts
  var native_exports = {};
  __export(native_exports, {
    clipboard: () => clipboard,
    editor: () => editor,
    ff_cmdline: () => ff_cmdline,
    firstinpath: () => firstinpath,
    getBestEditor: () => getBestEditor,
    getConfElsePref: () => getConfElsePref,
    getConfElsePrefElseDefault: () => getConfElsePrefElseDefault,
    getFirefoxDir: () => getFirefoxDir,
    getNativeMessengerVersion: () => getNativeMessengerVersion,
    getPref: () => getPref,
    getPrefs: () => getPrefs,
    getProfile: () => getProfile,
    getProfileDir: () => getProfileDir,
    getProfileName: () => getProfileName,
    getProfileUncached: () => getProfileUncached,
    getenv: () => getenv,
    getrc: () => getrc,
    getrcpath: () => getrcpath,
    inpath: () => inpath,
    listDir: () => listDir,
    loadPrefs: () => loadPrefs,
    mkdir: () => mkdir,
    move: () => move2,
    nativegate: () => nativegate,
    parsePrefs: () => parsePrefs,
    parseProfilesIni: () => parseProfilesIni,
    pyeval: () => pyeval,
    read: () => read,
    removePref: () => removePref,
    run: () => run,
    runAsync: () => runAsync,
    temp: () => temp,
    unfixamo: () => unfixamo,
    winFirefoxRestart: () => winFirefoxRestart,
    write: () => write,
    writePref: () => writePref,
    writerc: () => writerc
  });
  var import_semver_compare = __toModule(require_semver_compare());
  var logger6 = new logging_default("native");
  var NATIVE_NAME = "tridactyl";
  async function sendNativeMsg(cmd, opts2, quiet = false) {
    const send = Object.assign({ cmd }, opts2);
    let resp;
    logger6.info(`Sending message: ${JSON.stringify(send)}`);
    try {
      resp = await browserBg.runtime.sendNativeMessage(NATIVE_NAME, send);
      logger6.info(`Received response:`, resp);
      return resp;
    } catch (e) {
      if (!quiet) {
        throw new Error("Failed to send message to native messenger. If it is correctly installed (run `:native`), please report this bug on https://github.com/tridactyl/tridactyl/issues .");
      }
    }
  }
  async function getrcpath(separator = "auto") {
    const res = await sendNativeMsg("getconfigpath", {});
    if (res.code !== 0)
      throw new Error("getrcpath error: " + res.code);
    if (separator == "unix" && (await browserBg.runtime.getPlatformInfo()).os == "win") {
      return res.content.replace(/\\/g, "/");
    } else {
      return res.content;
    }
  }
  async function getrc() {
    const res = await sendNativeMsg("getconfig", {});
    if (res.content && !res.error) {
      logger6.info(`Successfully retrieved fs config:
${res.content}`);
      return res.content;
    } else {
      logger6.info(`Error in retrieving config: ${res.error}`);
    }
  }
  var NATIVE_VERSION_CACHE;
  async function getNativeMessengerVersion(quiet = false) {
    if (NATIVE_VERSION_CACHE !== void 0) {
      return NATIVE_VERSION_CACHE;
    }
    const res = await sendNativeMsg("version", {}, quiet);
    if (res === void 0) {
      if (quiet)
        return void 0;
      throw new Error(`Error retrieving version: ${res.error}`);
    }
    if (res.version && !res.error) {
      logger6.info(`Native version: ${res.version}`);
      NATIVE_VERSION_CACHE = res.version.toString();
      setTimeout(() => NATIVE_VERSION_CACHE = void 0, 500);
      return NATIVE_VERSION_CACHE;
    }
  }
  async function getBestEditor() {
    const gui_candidates = [];
    const term_emulators = [];
    const tui_editors = [];
    const last_resorts = [];
    const os = (await browserBg.runtime.getPlatformInfo()).os;
    const arg_quote = os === "win" ? '"' : "'";
    const vim_positioning_arg = ` ${arg_quote}+normal!%lGzv%c|${arg_quote}`;
    if (os === "mac") {
      gui_candidates.push(...[
        "/Applications/MacVim.app/Contents/bin/mvim -f" + vim_positioning_arg,
        "/usr/local/bin/vimr --wait --nvim +only"
      ]);
      term_emulators.push(...[
        "/Applications/cool-retro-term.app/Contents/MacOS/cool-retro-term -e"
      ]);
      last_resorts.push(...["open -nWt"]);
    } else {
      gui_candidates.push(...["gvim -f" + vim_positioning_arg]);
      if (os === "linux" || os === "openbsd") {
        term_emulators.push(...[
          "st -c tridactyl_editor",
          "xterm -class tridactyl_editor -e",
          "uxterm -class tridactyl_editor -e",
          "urxvt -e",
          'termite --class tridactyl_editor -e "%c"',
          "sakura --class tridactyl_editor -e",
          "lilyterm -e",
          "mlterm -N tridactyl_editor -e",
          "roxterm -e",
          "cool-retro-term -e",
          'terminator -u -c tridactyl_editor -e "%c"'
        ]);
      }
      if (os === "win") {
        term_emulators.push(...["conemu -run", "mintty --class tridactyl_editor -e"]);
        if (await nativegate("0.2.1", false)) {
          term_emulators.push("start /wait");
        }
      }
      term_emulators.push(...[
        "alacritty --class tridactyl_editor -e"
      ]);
      last_resorts.push(...[
        "emacs",
        "gedit",
        "kate",
        "sublime",
        "atom -w",
        "code -nw",
        "abiword",
        "notepad"
      ]);
    }
    tui_editors.push(...[
      "vim" + vim_positioning_arg,
      "nvim" + vim_positioning_arg,
      "nano %f",
      "emacs -nw %f"
    ]);
    const guicmd = await firstinpath(gui_candidates);
    if (guicmd) {
      return guicmd;
    }
    const termcmd = await firstinpath(term_emulators);
    const tuicmd = await firstinpath(tui_editors);
    if (termcmd && tuicmd) {
      if (termcmd.includes("%c")) {
        return tuicmd.replace("%c", tuicmd);
      } else {
        return termcmd + " " + tuicmd;
      }
    }
    return await firstinpath(last_resorts);
  }
  async function nativegate(version2 = "0", interactive = true, desiredOS = ["mac", "win", "linux", "openbsd"]) {
    if (!desiredOS.includes((await browserBg.runtime.getPlatformInfo()).os)) {
      if (interactive) {
        logger6.error("# Tridactyl's native messenger doesn't support your operating system, yet.");
      }
      return false;
    }
    try {
      const actualVersion = await getNativeMessengerVersion();
      if (actualVersion !== void 0) {
        if ((0, import_semver_compare.default)(version2, actualVersion) > 0) {
          if (interactive)
            logger6.error("# Please update to native messenger " + version2 + ", for example by running `:updatenative`.");
          return false;
        }
        return true;
      } else if (interactive)
        logger6.error("# Native messenger not found. Please run `:installnative` and follow the instructions.");
      return false;
    } catch (e) {
      if (interactive)
        logger6.error("# Native messenger not found. Please run `:installnative` and follow the instructions.");
      return false;
    }
  }
  async function inpath(cmd) {
    const pathcmd = (await browserBg.runtime.getPlatformInfo()).os === "win" ? "where " : "which ";
    return (await run(pathcmd + cmd.split(" ")[0])).code === 0;
  }
  async function firstinpath(cmdarray) {
    let ind = 0;
    let cmd = cmdarray[ind];
    while (!await inpath(cmd.split(" ")[0])) {
      ind++;
      cmd = cmdarray[ind];
      if (cmd === void 0)
        break;
    }
    return cmd;
  }
  async function editor(file, line, col, content) {
    if (content !== void 0)
      await write(file, content);
    const editorcmd = (get("editorcmd") === "auto" ? await getBestEditor() : get("editorcmd")).replace(/%l/, line).replace(/%c/, col);
    let exec;
    if (editorcmd.indexOf("%f") !== -1) {
      exec = await run(editorcmd.replace(/%f/, file));
    } else {
      exec = await run(editorcmd + " " + file);
    }
    if (exec.code != 0)
      return exec;
    return read(file);
  }
  async function read(file) {
    return sendNativeMsg("read", { file }).catch((e) => {
      throw new Error(`Failed to read ${file}. ${e}`);
    });
  }
  async function write(file, content) {
    return sendNativeMsg("write", { file, content }).catch((e) => {
      throw new Error(`Failed to write '${content}' to '${file}'. ${e}`);
    });
  }
  async function writerc(file, force, content) {
    return sendNativeMsg("writerc", { file, force, content }).catch((e) => {
      throw new Error(`Failed to write '${content}' to '${file}'. ${e}`);
    });
  }
  async function mkdir(dir, exist_ok) {
    return sendNativeMsg("mkdir", { dir, exist_ok }).catch((e) => {
      throw new Error(`Failed to create directory '${dir}'. ${e}`);
    });
  }
  async function temp(content, prefix) {
    return sendNativeMsg("temp", { content, prefix }).catch((e) => {
      throw new Error(`Failed to write '${content}' to temp file '${prefix}'. ${e}`);
    });
  }
  async function move2(from, to, overwrite, cleanup) {
    const requiredNativeMessengerVersion = "0.3.0";
    if (await nativegate(requiredNativeMessengerVersion, false)) {
      return sendNativeMsg("move", { from, to, overwrite, cleanup }).catch((e) => {
        throw new Error(`Failed to move '${from}' to '${to}'. ${e}.`);
      });
    } else {
      return sendNativeMsg("move", { from, to }).catch((e) => {
        throw new Error(`Failed to move '${from}' to '${to}'. ${e}.`);
      });
    }
  }
  async function listDir(dir) {
    return sendNativeMsg("list_dir", { path: dir }).catch((e) => {
      throw new Error(`Failed to read directory '${dir}'. ${e}`);
    });
  }
  async function winFirefoxRestart(profiledir, browsercmd) {
    const required_version = "0.1.6";
    if (!await nativegate(required_version, false)) {
      throw new Error(`'restart' on Windows needs native messenger version >= ${required_version}.`);
    }
    return sendNativeMsg("win_firefox_restart", { profiledir, browsercmd });
  }
  async function run(command2, content = "") {
    const msg = await sendNativeMsg("run", { command: command2, content });
    logger6.info(msg);
    return msg;
  }
  async function runAsync(command2) {
    const required_version = "0.3.1";
    if (!await nativegate(required_version, false)) {
      throw new Error(`runAsync needs native messenger version >= ${required_version}.`);
    }
    logger6.info(await sendNativeMsg("run_async", { command: command2 }));
  }
  async function pyeval(command2) {
    return sendNativeMsg("eval", { command: command2 });
  }
  async function getenv(variable) {
    const required_version = "0.1.2";
    if (!await nativegate(required_version, false)) {
      throw new Error(`'getenv' needs native messenger version >= ${required_version}.`);
    }
    return (await sendNativeMsg("env", { var: variable })).content;
  }
  async function clipboard(action, str) {
    let clipcmd = await get("externalclipboardcmd");
    if (clipcmd === "auto")
      clipcmd = await firstinpath(["xsel", "xclip"]);
    if (clipcmd === void 0) {
      throw new Error("Couldn't find an external clipboard executable");
    }
    if (action === "get") {
      const result = await run(clipcmd + " -o");
      if (result.code !== 0) {
        throw new Error(`External command failed with code ${result.code}: ${clipcmd}`);
      }
      return result.content;
    } else if (action === "set") {
      const required_version = "0.1.7";
      if (await nativegate(required_version, false)) {
        const result = await run(`${clipcmd} -i`, str);
        if (result.code !== 0)
          throw new Error(`External command failed with code ${result.code}: ${clipcmd}`);
        return "";
      } else {
        let heredoc = "TRIDACTYL";
        while (str.search(heredoc) !== -1)
          heredoc += Math.round(Math.random() * 10);
        clipcmd = `sed -z 's/.$//' <<'${heredoc}' | ${clipcmd} -i 
${str}
${heredoc}`;
        await run(clipcmd);
        return "";
      }
    }
    throw new Error("Unknown action!");
  }
  async function ff_cmdline() {
    let output;
    if ((await browserBg.runtime.getPlatformInfo()).os === "win") {
      if (!await nativegate("0.3.3", false)) {
        const browser_name = await get("browser");
        output = await run(`powershell -NoProfile -Command "$processes = Get-CimInstance -Property ProcessId,ParentProcessId,Name,CommandLine -ClassName Win32_Process;if (-not ($processes | where { $_.Name -match '^${browser_name}' })) { exit 1; };$ppid = ($processes | where { $_.ProcessId -EQ $PID }).ParentProcessId;$pproc = $processes | where { $_.ProcessId -EQ $ppid };while ($pproc.Name -notmatch '^${browser_name}') {    $ppid = $pproc.ParentProcessId;    $pproc = $processes | where { $_.ProcessId -EQ $ppid };};Write-Output $pproc.CommandLine;"`);
      } else {
        output = await run(`powershell -NoProfile -Command "Get-CimInstance -Property CommandLine,ProcessId -ClassName Win32_Process | where { $_.ProcessId -EQ ${(await sendNativeMsg("ppid", {})).content} } | select -ExpandProperty CommandLine | Write-Output"`);
      }
    } else {
      const actualVersion = await getNativeMessengerVersion();
      if ((0, import_semver_compare.default)("0.2.0", actualVersion) > 0) {
        output = await pyeval('handleMessage({"cmd": "run", "command": "ps -p " + str(os.getppid()) + " -oargs="})["content"]');
      } else {
        const ppid = (await sendNativeMsg("ppid", {})).content.trim();
        output = await run("ps -p " + ppid + " -oargs=");
      }
      output.content = output.content.replace("\n", "");
    }
    return output.content.trim().split(" ");
  }
  async function parseProfilesIni(content, basePath) {
    const lines = content.split("\n");
    let current = "General";
    const result = {};
    for (const line of lines) {
      let match2 = /^\[([^\]]+)\]$/.exec(line);
      if (match2 !== null) {
        current = match2[1];
        result[current] = {};
      } else {
        match2 = /^([^=]+)=([^=]+)$/.exec(line);
        if (match2 !== null) {
          result[current][match2[1]] = match2[2];
        }
      }
    }
    for (const profileName of Object.keys(result)) {
      const profile = result[profileName];
      if (profile.Path == void 0) {
        delete result[profileName];
        continue;
      }
      if ((await browserBg.runtime.getPlatformInfo()).os === "win") {
        profile.Path = profile.Path.replace("/", "\\");
      }
      if (profile.IsRelative === "1") {
        profile.relativePath = profile.Path;
        profile.absolutePath = basePath + profile.relativePath;
      } else if (profile.IsRelative === "0") {
        if (profile.Path.substring(0, basePath.length) !== basePath) {
          throw new Error(`Error parsing profiles ini: basePath "${basePath}" doesn't match profile path ${profile.Path}`);
        }
        profile.relativePath = profile.Path.substring(basePath.length);
        profile.absolutePath = profile.Path;
      }
    }
    return result;
  }
  async function getFirefoxDir() {
    switch ((await browserBg.runtime.getPlatformInfo()).os) {
      case "win":
        return getenv("APPDATA").then((path2) => path2 + "\\Mozilla\\Firefox\\");
      case "mac":
        return getenv("HOME").then((path2) => path2 + "/Library/Application Support/Firefox/");
      default:
        return getenv("HOME").then((path2) => path2 + "/.mozilla/firefox/");
    }
  }
  async function getProfileUncached() {
    const ffDir = await getFirefoxDir();
    const iniPath = ffDir + "profiles.ini";
    let iniObject = {};
    let iniSucceeded = false;
    const iniContent = await read(iniPath);
    if (iniContent.code === 0 && iniContent.content.length > 0) {
      try {
        iniObject = await parseProfilesIni(iniContent.content, ffDir);
        iniSucceeded = true;
      } catch (e) {
      }
    }
    const curProfileDir = get("profiledir");
    if (curProfileDir !== "auto") {
      if (iniSucceeded) {
        for (const profileName of Object.keys(iniObject)) {
          const profile2 = iniObject[profileName];
          if (profile2.absolutePath === curProfileDir) {
            return profile2;
          }
        }
      }
      return {
        Name: void 0,
        IsRelative: "0",
        Path: curProfileDir,
        relativePath: void 0,
        absolutePath: curProfileDir
      };
    }
    const cmdline = await ff_cmdline().catch(() => "");
    let profile = cmdline.indexOf("--profile");
    if (profile === -1)
      profile = cmdline.indexOf("-profile");
    if (profile >= 0 && profile < cmdline.length - 1) {
      const profilePath = cmdline[profile + 1];
      if (iniSucceeded) {
        for (const profileName of Object.keys(iniObject)) {
          const profile2 = iniObject[profileName];
          if (profile2.absolutePath === profilePath) {
            return profile2;
          }
        }
      }
      return {
        Name: void 0,
        IsRelative: "0",
        Path: profilePath,
        relativePath: void 0,
        absolutePath: profilePath
      };
    }
    if (iniSucceeded) {
      let p = cmdline.indexOf("-p");
      if (p === -1)
        p = cmdline.indexOf("-P");
      if (p >= 0 && p < cmdline.length - 1) {
        const pName = cmdline[p + 1];
        for (const profileName of Object.keys(iniObject)) {
          const profile2 = iniObject[profileName];
          if (profile2.Name === pName) {
            return profile2;
          }
        }
        throw new Error(`native.ts:getProfile() : '${cmdline[p]}' found in command line arguments but no matching profile name found in "${iniPath}"`);
      }
    }
    let hacky_profile_finder = `find "${ffDir}" -maxdepth 2 -name lock`;
    if ((await browserBg.runtime.getPlatformInfo()).os === "mac")
      hacky_profile_finder = `find "${ffDir}" -maxdepth 2 -name .parentlock`;
    const profilecmd = await run(hacky_profile_finder);
    if (profilecmd.code === 0 && profilecmd.content.length !== 0) {
      profilecmd.content = profilecmd.content.trim();
      if (profilecmd.content.split("\n").length === 1) {
        const path2 = profilecmd.content.split("/").slice(0, -1).join("/");
        if (iniSucceeded) {
          for (const profileName of Object.keys(iniObject)) {
            const profile2 = iniObject[profileName];
            if (profile2.absolutePath === path2) {
              return profile2;
            }
          }
        }
        return {
          Name: void 0,
          IsRelative: "0",
          Path: path2,
          relativePath: void 0,
          absolutePath: path2
        };
      }
    }
    if (iniSucceeded) {
      for (const profileName of Object.keys(iniObject)) {
        const profile2 = iniObject[profileName];
        if (profile2.Default === 1 || profile2.Default === "1") {
          return profile2;
        }
      }
    }
    throw new Error(`Couldn't deduce which profile you want. See ':help profiledir'`);
  }
  var cachedProfile;
  async function getProfile() {
    if (cachedProfile === void 0)
      cachedProfile = await getProfileUncached();
    return cachedProfile;
  }
  if (getContext() === "background") {
    getProfile();
  }
  addChangeListener("profiledir", () => {
    cachedProfile = void 0;
    getProfile();
  });
  function getProfileName() {
    return getProfile().then((p) => p.Name);
  }
  async function getProfileDir() {
    const profiledir = get("profiledir");
    if (profiledir !== "auto")
      return Promise.resolve(profiledir);
    return getProfile().then((p) => p.absolutePath);
  }
  function parsePrefs(prefFileContent) {
    const regex = new RegExp(/^(user_|sticky_|lock)?[pP]ref\("([^"]+)",\s*"?([^\)]+?)"?\);$/);
    return prefFileContent.split("\n").reduce((prefs, line) => {
      const matches = regex.exec(line);
      if (!matches) {
        return prefs;
      }
      const key = matches[2];
      let value = matches[3];
      if (value === '"')
        value = "";
      prefs[key] = value;
      return prefs;
    }, {});
  }
  async function loadPrefs(filename) {
    const result = await read(filename);
    if (result.code !== 0)
      return {};
    return parsePrefs(result.content);
  }
  var cached_prefs = null;
  async function getPrefs() {
    if (cached_prefs !== null)
      return cached_prefs;
    const profile = await getProfileDir() + "/";
    const prefFiles = [
      "/usr/share/firefox/browser/defaults/preferences/firefox.js",
      "/usr/share/firefox/browser/defaults/preferences/debugger.js",
      "/usr/share/firefox/browser/defaults/preferences/devtools-startup-prefs.js",
      "/usr/share/firefox/browser/defaults/preferences/devtools.js",
      "/usr/share/firefox/browser/defaults/preferences/firefox-branding.js",
      "/usr/share/firefox/browser/defaults/preferences/vendor.js",
      "/usr/share/firefox/browser/defaults/preferences/firefox.js",
      "/etc/firefox/firefox.js",
      profile + "grepref.js",
      profile + "services/common/services-common.js",
      profile + "defaults/pref/services-sync.js",
      profile + "browser/app/profile/channel-prefs.js",
      profile + "browser/app/profile/firefox.js",
      profile + "browser/app/profile/firefox-branding.js",
      profile + "browser/defaults/preferences/firefox-l10n.js",
      profile + "prefs.js",
      profile + "user.js"
    ];
    const promises = [];
    for (const file of prefFiles) {
      promises.push(loadPrefs(file));
    }
    cached_prefs = promises.reduce(async (a, b) => Object.assign(await a, await b));
    return cached_prefs;
  }
  async function getPref(name) {
    return (await getPrefs())[name];
  }
  async function getConfElsePref(confName, prefName) {
    let option = await getAsyncDynamic(confName);
    if (option === void 0) {
      try {
        option = await getPref(prefName);
      } catch (e) {
      }
    }
    return option;
  }
  async function getConfElsePrefElseDefault(confName, prefName, def) {
    const option = await getConfElsePref(confName, prefName);
    if (option === void 0)
      return def;
    return option;
  }
  async function writePref(name, value) {
    if (cached_prefs)
      cached_prefs[name] = value;
    const file = await getProfileDir() + "/user.js";
    const text = (await read(file)).content;
    const prefPos = text.indexOf(`pref("${name}",`);
    if (prefPos < 0) {
      write(file, `${text}
user_pref("${name}", ${value});
`);
    } else {
      let substr = text.substring(prefPos);
      const prefEnd = substr.indexOf(";\n");
      substr = text.substring(prefPos, prefPos + prefEnd);
      write(file, text.replace(substr, `pref("${name}", ${value})`));
    }
  }
  async function removePref(name) {
    const file = await getProfileDir() + "/user.js";
    const text = (await read(file)).content;
    const prefPos = text.indexOf(`user_pref("${name}",`);
    if (prefPos >= 0) {
      let substr = text.substring(prefPos);
      const prefEnd = substr.indexOf(";\n") + 1;
      substr = text.substring(prefPos, prefPos + prefEnd);
      write(file, text.replace(substr, ``));
    }
  }
  async function unfixamo() {
    try {
      if (localStorage.unfixedamo2 === "true") {
        return;
      }
      const profile = await getProfileDir() + "/";
      const userjs = await loadPrefs(profile + "user.js");
      const tridactylPref = "tridactyl.unfixedamo";
      const tridactylPref2 = "tridactyl.unfixedamo_removed";
      const restricted = "extensions.webextensions.restrictedDomains";
      const amoblocker = "privacy.resistFingerprinting.block_mozAddonManager";
      const restrictedDomains = '"accounts-static.cdn.mozilla.net,accounts.firefox.com,addons.cdn.mozilla.net,addons.mozilla.org,api.accounts.firefox.com,content.cdn.mozilla.net,discovery.addons.mozilla.org,install.mozilla.org,oauth.accounts.firefox.com,profile.accounts.firefox.com,support.mozilla.org,sync.services.mozilla.com"';
      if (userjs[tridactylPref2] === "true")
        return;
      if (userjs[restricted] === "" || userjs[restricted] === restrictedDomains) {
        await removePref(tridactylPref);
        await removePref(restricted);
        await removePref(amoblocker);
        await writePref(tridactylPref2, "true");
        browserBg.tabs.create({
          url: browserBg.runtime.getURL("static/unfixamo.html")
        });
      }
      return;
    } catch (e) {
    } finally {
      localStorage.unfixedamo2 = "true";
    }
  }

  // src/lib/text_to_speech.ts
  function getVoiceFromName(name) {
    const voices = window.speechSynthesis.getVoices();
    return voices.find((voice) => voice.name === name);
  }
  function readText(text) {
    if (window.speechSynthesis.getVoices().length === 0) {
      throw new Error("No voice found: cannot use Text-To-Speech API");
    }
    const utterance = new SpeechSynthesisUtterance(text);
    const pitch = get("ttspitch");
    const voice = get("ttsvoice");
    const volume = get("ttsvolume");
    const rate = get("ttsrate");
    if (pitch >= 0 && pitch < 2)
      utterance.pitch = pitch;
    if (volume >= 0 && volume <= 1)
      utterance.volume = volume;
    if (rate >= 0.1 && rate <= 10)
      utterance.rate = rate;
    const voiceObj = getVoiceFromName(voice);
    if (voiceObj) {
      utterance.voice = voiceObj;
    }
    window.speechSynthesis.speak(utterance);
  }
  function doAction(action) {
    const synth = window.speechSynthesis;
    switch (action) {
      case "play":
        synth.resume();
        break;
      case "pause":
        synth.pause();
        break;
      case "playpause":
        synth.paused ? synth.resume() : synth.pause();
        break;
      case "stop":
        synth.cancel();
        break;
    }
  }

  // src/lib/escape.ts
  var sh = (dangerous) => `'${dangerous.replace(/'/g, "'\\''")}'`;
  var windows_cmd = (dangerous) => dangerous.replace(/([()%!^"<>&|])/g, "^$1");

  // src/lib/dom.ts
  var dom_exports = {};
  __export(dom_exports, {
    HINTTAGS_anchor_selectors: () => HINTTAGS_anchor_selectors,
    HINTTAGS_filter_by_text_selectors: () => HINTTAGS_filter_by_text_selectors,
    HINTTAGS_img_selectors: () => HINTTAGS_img_selectors,
    HINTTAGS_killable_selectors: () => HINTTAGS_killable_selectors,
    HINTTAGS_saveable: () => HINTTAGS_saveable,
    HINTTAGS_selectors: () => HINTTAGS_selectors,
    anchors: () => anchors,
    compareElementArea: () => compareElementArea,
    deepestShadowRoot: () => deepestShadowRoot,
    elementsByXPath: () => elementsByXPath,
    elementsWithText: () => elementsWithText,
    focus: () => focus,
    getAbsoluteCentre: () => getAbsoluteCentre,
    getAllDocumentFrames: () => getAllDocumentFrames,
    getElementCentre: () => getElementCentre,
    getElemsBySelector: () => getElemsBySelector,
    getLastUsedInput: () => getLastUsedInput,
    getNthElement: () => getNthElement,
    getSelector: () => getSelector,
    heightMatters: () => heightMatters,
    hijackPageListenerFunctions: () => hijackPageListenerFunctions,
    hintworthy_js_elems: () => hintworthy_js_elems,
    isSubstantial: () => isSubstantial,
    isTextEditable: () => isTextEditable,
    isVisible: () => isVisible,
    isVisibleFilter: () => isVisibleFilter,
    mouseEvent: () => mouseEvent,
    registerEvListenerAction: () => registerEvListenerAction,
    setupFocusHandler: () => setupFocusHandler,
    simulateClick: () => simulateClick,
    widthMatters: () => widthMatters
  });
  var logger7 = new Logger("dom");
  function isTextEditable(element) {
    if (element) {
      if (element.readOnly === true)
        return false;
      if (element.nodeName.toUpperCase() === "INPUT") {
        return isEditableHTMLInput(element);
      }
      if (["SELECT", "TEXTAREA", "OBJECT"].includes(element.nodeName.toUpperCase())) {
        return true;
      }
      if (element instanceof HTMLElement) {
        if (element.contentEditable === void 0) {
          return false;
        }
        if (element.contentEditable.toUpperCase() === "TRUE") {
          return true;
        }
      }
      if (element.hasOwnProperty("attributes")) {
        for (const attr of element.attributes) {
          if (attr.name === "role" && attr.value === "application") {
            return true;
          }
        }
      }
    }
    return false;
  }
  function isEditableHTMLInput(element) {
    if (element.disabled || element.readOnly)
      return false;
    switch (element.type) {
      case void 0:
      case "text":
      case "search":
      case "email":
      case "url":
      case "number":
      case "password":
      case "date":
      case "tel":
        return true;
    }
    return false;
  }
  function mouseEvent(element, type2, modifierKeys = {}) {
    let events = [];
    switch (type2) {
      case "unhover":
        events = ["mousemove", "mouseout", "mouseleave"];
        break;
      case "click":
        events = ["mousedown", "mouseup", "click"];
      case "hover":
        events = ["mouseover", "mouseenter", "mousemove"].concat(events);
        break;
    }
    events.forEach((type3) => {
      const event = new MouseEvent(type3, {
        bubbles: true,
        cancelable: true,
        view: window,
        detail: 1,
        ...modifierKeys
      });
      element.dispatchEvent(event);
    });
  }
  function elementsWithText(includeInvisible = false) {
    return getElemsBySelector("*", [
      isVisibleFilter(includeInvisible),
      (hint2) => hint2.textContent !== ""
    ]);
  }
  function* elementsByXPath(xpath, parent) {
    const query = document.evaluate(xpath, parent || document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
    for (let i = 0, length2 = query.snapshotLength; i < length2; ++i) {
      yield query.snapshotItem(i);
    }
  }
  function isSubstantial(element) {
    const clientRect = element.getClientRects()[0];
    const computedStyle = getComputedStyle(element);
    switch (true) {
      case !clientRect:
      case clientRect.width < 3:
      case clientRect.height < 3:
      case computedStyle.visibility !== "visible":
      case computedStyle.display === "none":
        return false;
    }
    return true;
  }
  function heightMatters(style) {
    switch (style.display) {
      case "inline":
      case "table-column":
      case "table-column-group":
        return false;
    }
    return true;
  }
  function widthMatters(style) {
    switch (style.display) {
      case "inline":
      case "table-column":
      case "table-column-group":
      case "table-header-group":
      case "table-footer-group":
      case "table-row-group":
      case "table-cell":
      case "table-row":
        return false;
    }
    return true;
  }
  function isVisibleFilter(includeInvisible) {
    return (elem) => includeInvisible || isVisible(elem);
  }
  function isVisible(element) {
    while (!(element.getBoundingClientRect instanceof Function)) {
      element = element.parentElement;
    }
    const clientRect = element.getBoundingClientRect();
    switch (true) {
      case !clientRect:
      case clientRect.bottom < 4:
      case clientRect.top >= innerHeight - 4:
      case clientRect.right < 4:
      case clientRect.left >= innerWidth - 4:
        return false;
    }
    const computedStyle = getComputedStyle(element);
    switch (true) {
      case (widthMatters(computedStyle) && clientRect.width < 3):
      case (heightMatters(computedStyle) && clientRect.height < 3):
      case computedStyle.visibility !== "visible":
      case computedStyle.display === "none":
        return false;
    }
    return true;
  }
  function getAllDocumentFrames(doc = document) {
    if (!(doc instanceof HTMLDocument))
      return [];
    const frames = Array.from(doc.getElementsByTagName("iframe")).concat(Array.from(doc.getElementsByTagName("frame"))).filter((frame) => !frame.src.startsWith("moz-extension://"));
    return frames.concat(frames.reduce((acc, f) => {
      let newFrames = [];
      try {
        const doc2 = f.contentDocument || f.contentWindow.document;
        newFrames = getAllDocumentFrames(doc2);
      } catch (e) {
      }
      return acc.concat(newFrames);
    }, []));
  }
  function getSelector(e) {
    function uniqueSelector(e2) {
      if (e2.id && /^[a-zA-Z0-9]+$/.exec(e2.id))
        return "#" + e2.id;
      if (!e2.parentElement)
        return "HTML";
      const index = Array.from(e2.parentElement.children).filter((child) => child.tagName === e2.tagName).indexOf(e2) + 1;
      return uniqueSelector(e2.parentElement) + ` > ${e2.tagName}:nth-of-type(${index})`;
    }
    return uniqueSelector(e);
  }
  function getShadowElementsBySelector(selector) {
    let elems = [];
    document.querySelectorAll("*").forEach((elem) => {
      if (elem.shadowRoot) {
        elems = elems.concat(...elem.shadowRoot.querySelectorAll(selector));
      }
    });
    return elems;
  }
  function getElemsBySelector(selector, filters) {
    let elems = Array.from(document.querySelectorAll(selector));
    elems = elems.concat(...getShadowElementsBySelector(selector));
    const frameElems = getAllDocumentFrames().reduce((acc, frame) => {
      let newElems = [];
      try {
        const doc = frame.contentDocument || frame.contentWindow.document;
        newElems = Array.from(doc.querySelectorAll(selector));
      } catch (e) {
      }
      return acc.concat(newElems);
    }, []);
    elems = elems.concat(frameElems);
    for (const filter3 of filters) {
      elems = elems.filter(filter3);
    }
    return elems;
  }
  function getNthElement(selectors, nth2, filters) {
    const inputs = getElemsBySelector(selectors, filters);
    if (inputs.length) {
      const index = Number(nth2).clamp(-inputs.length, inputs.length - 1).mod(inputs.length);
      return inputs[index];
    }
    return null;
  }
  function compareElementArea(a, b) {
    const aArea = a.offsetWidth * a.offsetHeight;
    const bArea = b.offsetWidth * b.offsetHeight;
    return aArea - bArea;
  }
  var hintworthy_js_elems = new Set();
  function registerEvListenerAction(elem, add2, event) {
    if (!(elem instanceof Element)) {
      return;
    }
    try {
      Node.prototype.hasChildNodes.apply(elem);
    } catch (e) {
      logger7.error("Elem is not a real Node", elem);
      return;
    }
    switch (event) {
      case "click":
      case "mousedown":
      case "mouseup":
      case "mouseover":
        if (add2) {
          hintworthy_js_elems.add(elem);
        } else {
          hintworthy_js_elems.delete(elem);
        }
    }
  }
  function hijackPageListenerFunctions() {
    if (!inContentScript()) {
      return;
    }
    const exportedName = "registerEvListenerAction";
    exportFunction(registerEvListenerAction, window, { defineAs: exportedName });
    const eval_str = ["addEventListener", "removeEventListener"].reduce((acc, cur) => `${acc};
      EventTarget.prototype.${cur} = ((realFunction, register) => {
         return function (...args) {
               let result = realFunction.apply(this, args)
               try {
                  register(this, ${cur === "addEventListener"}, args[0])
               } catch (e) {
                  // Don't let the page know something wrong happened here
               }
               return result
         }
      })(EventTarget.prototype.${cur}, ${exportedName})`, "");
    window.eval(eval_str + `;delete ${exportedName}`);
  }
  function focus(e) {
    e.focus();
    if (e instanceof HTMLInputElement && ["text", "search", "url", "tel", "password"].includes(e.type.toLowerCase())) {
      let pos = 0;
      if (get("cursorpos") === "end")
        pos = e.value.length;
      e.setSelectionRange(pos, pos);
    }
  }
  var LAST_USED_INPUT = null;
  function getLastUsedInput() {
    return LAST_USED_INPUT;
  }
  function onPageFocus(elem) {
    if (isTextEditable(elem)) {
      LAST_USED_INPUT = elem;
    }
    return get("allowautofocus") === "true";
  }
  async function setInput(el) {
    const tab2 = await activeTabId();
    const arr = (await getAsync2("prevInputs")).concat({
      tab: tab2,
      inputId: el.id
    });
    state.prevInputs = arr.slice(Math.max(arr.length - 10, 0));
  }
  function hijackPageFocusFunction() {
    const exportedName = "onPageFocus";
    exportFunction(onPageFocus, window, { defineAs: exportedName });
    const eval_str = `HTMLElement.prototype.focus = ((realFocus, ${exportedName}) => {
        return function (...args) {
            if (${exportedName}(this, args))
                return realFocus.apply(this, args)
        }
     })(HTMLElement.prototype.focus, ${exportedName})`;
    window.eval(eval_str + `;delete ${exportedName}`);
  }
  function setupFocusHandler() {
    document.addEventListener("focusin", (e) => {
      if (isTextEditable(e.target)) {
        LAST_USED_INPUT = e.target;
        setInput(e.target);
      }
    });
    if (inContentScript()) {
      hijackPageFocusFunction();
    }
  }
  var HINTTAGS_selectors = `
input:not([type=hidden]):not([disabled]),
a,
area,
button,
details,
iframe,
label,
select,
summary,
textarea,
[onclick],
[onmouseover],
[onmousedown],
[onmouseup],
[oncommand],
[role='link'],
[role='button'],
[role='checkbox'],
[role='combobox'],
[role='listbox'],
[role='listitem'],
[role='menuitem'],
[role='menuitemcheckbox'],
[role='menuitemradio'],
[role='option'],
[role='radio'],
[role='scrollbar'],
[role='slider'],
[role='spinbutton'],
[role='tab'],
[role='textbox'],
[role='treeitem'],
[class*='button'],
[tabindex]
`;
  var HINTTAGS_filter_by_text_selectors = `
input:not([type=hidden]):not([disabled]),
a,
textarea,
button,
select,
[class*='button']
`;
  var HINTTAGS_img_selectors = `
img,
[src]
`;
  var HINTTAGS_anchor_selectors = `
[id],
[name]
`;
  var HINTTAGS_killable_selectors = `
header,
footer,
nav,
span,
div,
iframe,
img,
button,
article,
summary
`;
  var HINTTAGS_saveable = `
[href]:not([href='#'])
`;
  function anchors(includeInvisible = false) {
    return getElemsBySelector(HINTTAGS_anchor_selectors, [
      isVisibleFilter(includeInvisible)
    ]);
  }
  function simulateClick(target) {
    if (target.target === "_blank" || target.target === "_new") {
      activeTabContainerId().then((containerId) => {
        if (containerId)
          openInNewTab(target.href, {
            related: true,
            cookieStoreId: containerId
          });
        else
          openInNewTab(target.href, {
            related: true
          });
      });
    } else {
      if (target instanceof HTMLDetailsElement) {
        target.open = !target.open;
      }
      mouseEvent(target, "click");
      focus(target);
    }
  }
  function deepestShadowRoot(sr) {
    if (sr === null)
      return sr;
    let shadowRoot = sr;
    while (shadowRoot.activeElement.shadowRoot != null) {
      shadowRoot = shadowRoot.activeElement.shadowRoot;
    }
    return shadowRoot;
  }
  function getElementCentre(el) {
    const pos = el.getBoundingClientRect();
    return { x: 0.5 * (pos.left + pos.right), y: 0.5 * (pos.top + pos.bottom) };
  }
  function getAbsoluteCentre(el) {
    const pos = getElementCentre(el);
    return {
      x: pos.x + window.mozInnerScreenX,
      y: pos.y + window.mozInnerScreenY
    };
  }

  // src/content/hinting.ts
  var hinting_exports = {};
  __export(hinting_exports, {
    getHintCommands: () => getHintCommands,
    hintByText: () => hintByText,
    hintByTextFilter: () => hintByTextFilter,
    hintPage: () => hintPage,
    hintableImages: () => hintableImages,
    hintables: () => hintables,
    killables: () => killables,
    parser: () => parser2,
    saveableElements: () => saveableElements,
    toHintablesArray: () => toHintablesArray,
    vimpHelper: () => vimpHelper
  });

  // src/lib/math.ts
  function log(x, base) {
    return Math.log(x) / Math.log(base);
  }
  function linspace(a, b, n) {
    if (typeof n === "undefined")
      n = Math.max(Math.round(b - a) + 1, 1);
    if (n < 2) {
      return n === 1 ? [a] : [];
    }
    let i;
    const ret = Array(n);
    n--;
    for (i = n; i >= 0; i--) {
      ret[i] = (i * b + (n - i) * a) / n;
    }
    return ret;
  }
  function bucketize(values2, buckets) {
    const result = new Map();
    for (const bucketval of buckets) {
      result.set(bucketval, 0);
    }
    const placeValue = (val) => {
      for (const bucketval of buckets) {
        if (bucketval >= val) {
          result.set(bucketval, result.get(bucketval) + 1);
          return;
        }
      }
    };
    for (const val of values2) {
      placeValue(val);
    }
    return result;
  }

  // src/content/hinting.ts
  var logger8 = new logging_default("hinting");
  function distance(l1, r1, l2, r2) {
    if (l1 < r2 && r1 > l2) {
      return 0;
    } else {
      return Math.min(Math.abs(l1 - r2), Math.abs(l2 - r1));
    }
  }
  var HintState = class {
    constructor(filterFunc, resolve, reject2, rapid) {
      this.filterFunc = filterFunc;
      this.resolve = resolve;
      this.reject = reject2;
      this.rapid = rapid;
      this.hintHost = document.createElement("div");
      this.hints = [];
      this.selectedHints = [];
      this.filter = "";
      this.hintchars = "";
      this.hintHost.classList.add("TridactylHintHost", "cleanslate");
    }
    get activeHints() {
      return this.hints.filter((h) => !h.flag.hidden);
    }
    cleanUpHints() {
      for (const hint2 of this.hints) {
        hint2.hidden = true;
      }
      this.hintHost.remove();
    }
    resolveHinting() {
      this.cleanUpHints();
      if (this.rapid)
        this.resolve(this.selectedHints.map((h) => h.result));
      else
        this.resolve(this.selectedHints[0] ? this.selectedHints[0].result : "");
    }
    deOverlap() {
      this.hints.sort((a, b) => a.y - b.y);
      const visited = [];
      for (const h of this.hints) {
        for (const vh of visited) {
          if (h.overlapsWith(vh)) {
            if (vh.x + vh.width < h.rect.right)
              h.x = vh.x + vh.width;
            else
              h.y = vh.y + vh.height;
          }
        }
        visited.push(h);
      }
    }
    changeFocusedHintIndex(offset) {
      const activeHints = this.activeHints;
      if (!activeHints.length) {
        return;
      }
      const focusedIndex = activeHints.indexOf(this.focusedHint);
      this.focusedHint.focused = false;
      const nextFocusedIndex = (focusedIndex + offset + activeHints.length) % activeHints.length;
      this.focusedHint = activeHints[nextFocusedIndex];
      this.focusedHint.focused = true;
    }
    changeFocusedHintTop() {
      const focusedRect = this.focusedHint.rect;
      const topHints = this.activeHints.filter((h) => h.rect.top < focusedRect.top && h.rect.bottom < focusedRect.bottom);
      if (!topHints.length) {
        return;
      }
      const nextFocusedHint = topHints.reduce((a, b) => {
        const aDistance = distance(a.rect.left, a.rect.right, focusedRect.left, focusedRect.right);
        const bDistance = distance(b.rect.left, b.rect.right, focusedRect.left, focusedRect.right);
        if (aDistance < bDistance) {
          return a;
        } else if (aDistance > bDistance) {
          return b;
        } else {
          if (a.rect.bottom < b.rect.bottom) {
            return b;
          } else {
            return a;
          }
        }
      });
      this.focusedHint.focused = false;
      this.focusedHint = nextFocusedHint;
      this.focusedHint.focused = true;
    }
    changeFocusedHintBottom() {
      const focusedRect = this.focusedHint.rect;
      const bottomHints = this.activeHints.filter((h) => h.rect.top > focusedRect.top && h.rect.bottom > focusedRect.bottom);
      if (!bottomHints.length) {
        return;
      }
      const nextFocusedHint = bottomHints.reduce((a, b) => {
        const aDistance = distance(a.rect.left, a.rect.right, focusedRect.left, focusedRect.right);
        const bDistance = distance(b.rect.left, b.rect.right, focusedRect.left, focusedRect.right);
        if (aDistance < bDistance) {
          return a;
        } else if (aDistance > bDistance) {
          return b;
        } else {
          if (a.rect.top > b.rect.top) {
            return b;
          } else {
            return a;
          }
        }
      });
      this.focusedHint.focused = false;
      this.focusedHint = nextFocusedHint;
      this.focusedHint.focused = true;
    }
    changeFocusedHintLeft() {
      const focusedRect = this.focusedHint.rect;
      const leftHints = this.activeHints.filter((h) => h.rect.left < focusedRect.left && h.rect.right < focusedRect.right);
      if (!leftHints.length) {
        return;
      }
      const nextFocusedHint = leftHints.reduce((a, b) => {
        const aDistance = distance(a.rect.top, a.rect.bottom, focusedRect.top, focusedRect.bottom);
        const bDistance = distance(b.rect.top, b.rect.bottom, focusedRect.top, focusedRect.bottom);
        if (aDistance < bDistance) {
          return a;
        } else if (aDistance > bDistance) {
          return b;
        } else {
          if (a.rect.right < b.rect.right) {
            return b;
          } else {
            return a;
          }
        }
      });
      this.focusedHint.focused = false;
      this.focusedHint = nextFocusedHint;
      this.focusedHint.focused = true;
    }
    changeFocusedHintRight() {
      const focusedRect = this.focusedHint.rect;
      const rightHints = this.activeHints.filter((h) => h.rect.left > focusedRect.left && h.rect.right > focusedRect.right);
      if (!rightHints.length) {
        return;
      }
      const nextFocusedHint = rightHints.reduce((a, b) => {
        const aDistance = distance(a.rect.top, a.rect.bottom, focusedRect.top, focusedRect.bottom);
        const bDistance = distance(b.rect.top, b.rect.bottom, focusedRect.top, focusedRect.bottom);
        if (aDistance < bDistance) {
          return a;
        } else if (aDistance > bDistance) {
          return b;
        } else {
          if (a.rect.left > b.rect.left) {
            return b;
          } else {
            return a;
          }
        }
      });
      this.focusedHint.focused = false;
      this.focusedHint = nextFocusedHint;
      this.focusedHint.focused = true;
    }
    shiftHints() {
      const lastIndex = this.hints.indexOf(this.selectedHints[this.selectedHints.length - 1]);
      const prevIndex = this.hints.indexOf(this.selectedHints[this.selectedHints.length - 2]);
      const distance2 = lastIndex - prevIndex;
      if (distance2 > 0) {
        const savedNames = [];
        for (let i = 0; i < distance2; ++i) {
          savedNames.push(this.hints[this.hints.length - 1 - i].name);
        }
        for (let i = this.hints.length - 1; i >= distance2; --i) {
          this.hints[i].setName(this.hints[i - distance2].name);
        }
        for (let i = savedNames.length - 1; i >= 0; --i) {
          this.hints[i].setName(savedNames[i]);
        }
      } else if (distance2 < 0) {
        const savedNames = [];
        for (let i = 0; i < Math.abs(distance2); ++i) {
          savedNames.push(this.hints[i].name);
        }
        for (let i = 0; i < this.hints.length + distance2; ++i) {
          this.hints[i].setName(this.hints[i - distance2].name);
        }
        for (let i = 0; i < savedNames.length; ++i) {
          this.hints[this.hints.length + distance2 + i].setName(savedNames[i]);
        }
      }
    }
  };
  var modeState;
  function hintPage(hintableElements, onSelect, resolve = () => {
  }, reject2 = () => {
  }, rapid = false) {
    const buildHints = defaultHintBuilder();
    const filterHints = defaultHintFilter();
    contentState.mode = "hint";
    modeState = new HintState(filterHints, resolve, reject2, rapid);
    if (!rapid) {
      for (const hints of hintableElements) {
        buildHints(hints, (hint2) => {
          modeState.cleanUpHints();
          hint2.result = onSelect(hint2.target);
          modeState.selectedHints.push(hint2);
          reset();
        });
      }
    } else {
      for (const hints of hintableElements) {
        buildHints(hints, (hint2) => {
          hint2.result = onSelect(hint2.target);
          modeState.selectedHints.push(hint2);
          if (modeState.selectedHints.length > 1 && get("hintshift") === "true") {
            modeState.shiftHints();
          }
        });
      }
    }
    if (!modeState.hints.length) {
      reset();
      return;
    }
    const firstTarget = modeState.hints[0].target;
    const firstTargetIsSelectable = () => firstTarget instanceof HTMLAnchorElement && firstTarget.href !== "" && !firstTarget.href.startsWith("javascript:");
    const allTargetsAreEqual = () => modeState.hints.find((h) => !(h.target instanceof HTMLAnchorElement) || h.target.href !== firstTarget.href) === void 0;
    if ((modeState.hints.length == 1 || firstTargetIsSelectable() && allTargetsAreEqual()) && get("hintautoselect") === "true") {
      modeState.cleanUpHints();
      modeState.hints[0].select();
      reset();
      return;
    }
    modeState.focusedHint = modeState.hints[0];
    modeState.focusedHint.focused = true;
    document.documentElement.appendChild(modeState.hintHost);
    modeState.deOverlap();
  }
  function defaultHintBuilder() {
    switch (get("hintfiltermode")) {
      case "simple":
        return buildHintsSimple;
      case "vimperator":
        return buildHintsVimperator;
      case "vimperator-reflow":
        return buildHintsVimperator;
    }
  }
  function defaultHintFilter() {
    switch (get("hintfiltermode")) {
      case "simple":
        return filterHintsSimple;
      case "vimperator":
        return filterHintsVimperator;
      case "vimperator-reflow":
        return (fstr) => filterHintsVimperator(fstr, true);
    }
  }
  function defaultHintChars() {
    if (get("hintnames") === "numeric") {
      return "1234567890";
    }
    return get("hintchars");
  }
  function* hintnames_simple(hintchars = defaultHintChars()) {
    for (let taglen = 1; true; taglen++) {
      yield* map2(permutationsWithReplacement(hintchars, taglen), (e) => e.join(""));
    }
  }
  function* hintnames_short(n, hintchars = defaultHintChars()) {
    const source2 = hintnames_simple(hintchars);
    const num2skip = Math.floor(n / hintchars.length);
    yield* islice(source2, num2skip, n + num2skip);
  }
  function* hintnames_uniform(n, hintchars = defaultHintChars()) {
    if (n <= hintchars.length)
      yield* islice(hintchars[Symbol.iterator](), n);
    else {
      const taglen = Math.ceil(log(n, hintchars.length));
      yield* map2(islice(permutationsWithReplacement(hintchars, taglen), n), (perm) => perm.join(""));
    }
  }
  function* hintnames_numeric(n) {
    for (let i = 1; i <= n; i++) {
      yield String(i);
    }
  }
  function* hintnames(n, hintchars = defaultHintChars()) {
    switch (get("hintnames")) {
      case "numeric":
        yield* hintnames_numeric(n);
      case "uniform":
        yield* hintnames_uniform(n, hintchars);
      default:
        yield* hintnames_short(n, hintchars);
    }
  }
  var Hint = class {
    constructor(target, name, filterData, onSelect, classes) {
      this.target = target;
      this.name = name;
      this.filterData = filterData;
      this.onSelect = onSelect;
      this.flag = document.createElement("span");
      this.rect = null;
      this.result = null;
      this.width = 0;
      this.height = 0;
      this._x = 0;
      this._y = 0;
      let offsetTop = 0;
      let offsetLeft = 0;
      const pad = 4;
      if (target.ownerDocument !== document) {
        const iframe = getAllDocumentFrames().find((frame) => frame.contentDocument === target.ownerDocument);
        const rect2 = iframe.getClientRects()[0];
        offsetTop += rect2.top;
        offsetLeft += rect2.left;
      }
      const clientRects = target.getClientRects();
      let rect = clientRects[0];
      for (const recti of clientRects) {
        if (recti.bottom + offsetTop > 0 && recti.right + offsetLeft > 0) {
          rect = recti;
          break;
        }
      }
      this.rect = {
        top: rect.top + offsetTop,
        bottom: rect.bottom + offsetTop,
        left: rect.left + offsetLeft,
        right: rect.right + offsetLeft,
        width: rect.width,
        height: rect.height
      };
      this.flag.textContent = name;
      this.flag.className = "TridactylHint";
      if (get("hintuppercase") === "true") {
        this.flag.classList.add("TridactylHintUppercase");
      }
      this.flag.classList.add("TridactylHint" + target.tagName);
      classes == null ? void 0 : classes.forEach((f) => this.flag.classList.add(f));
      const top = rect.top > 0 ? this.rect.top : offsetTop + pad;
      const left = rect.left > 0 ? this.rect.left : offsetLeft + pad;
      this.x = window.scrollX + left;
      this.y = window.scrollY + top;
      modeState.hintHost.appendChild(this.flag);
      this.hidden = false;
    }
    static isHintable(target) {
      return target.getClientRects().length > 0;
    }
    setName(n) {
      this.name = n;
      this.flag.textContent = this.name;
    }
    set hidden(hide2) {
      this.flag.hidden = hide2;
      if (hide2) {
        this.focused = false;
        this.target.classList.remove("TridactylHintElem");
      } else {
        this.target.classList.add("TridactylHintElem");
      }
    }
    set focused(focus3) {
      if (focus3) {
        this.target.classList.add("TridactylHintActive");
        this.target.classList.remove("TridactylHintElem");
      } else {
        this.target.classList.add("TridactylHintElem");
        this.target.classList.remove("TridactylHintActive");
      }
    }
    select() {
      this.onSelect(this);
    }
    set x(X) {
      this._x = X;
      this.updatePosition();
    }
    get x() {
      return this._x;
    }
    set y(Y) {
      this._y = Y;
      this.updatePosition();
    }
    get y() {
      return this._y;
    }
    overlapsWith(h) {
      if (h.width == 0)
        h.width = h.flag.getClientRects()[0].width;
      if (h.height == 0)
        h.height = h.flag.getClientRects()[0].height;
      if (this.width == 0)
        this.width = this.flag.getClientRects()[0].width;
      if (this.height == 0)
        this.height = this.flag.getClientRects()[0].height;
      return this.x < h.x + h.width && this.x + this.width > h.x && this.y < h.y + h.height && this.y + this.height > h.y;
    }
    updatePosition() {
      this.flag.style.cssText = `
        top: ${this._y}px !important;
        left: ${this._x}px !important;
        `;
    }
  };
  function buildHintsSimple(hintables2, onSelect) {
    const els = hintables2.elements.filter((el) => Hint.isHintable(el));
    const names = Array.from(hintnames(els.length + modeState.hints.length)).slice(modeState.hints.length);
    for (const [el, name] of izip(els, names)) {
      logger8.debug({ el, name });
      modeState.hintchars += name;
      modeState.hints.push(new Hint(el, name, null, onSelect, hintables2.hintclasses));
    }
  }
  var vimpHelper = {
    filterableTextFilter: null,
    sanitiseHintText: function sanitiseHintText(str) {
      if (vimpHelper.filterableTextFilter === null) {
        const escapedHintChars = defaultHintChars().replace(/^\^|[-\\\]]/g, "\\$&");
        const filterableTextFilter = new RegExp("[" + escapedHintChars + "]", "g");
        vimpHelper.filterableTextFilter = filterableTextFilter;
      }
      return str.replace(vimpHelper.filterableTextFilter, "");
    },
    matchHint: function matchHint(str, key) {
      return key.split(/\s+/).every((keyi) => str.includes(keyi));
    }
  };
  function buildHintsVimperator(hintables2, onSelect) {
    const els = hintables2.elements.filter((el) => Hint.isHintable(el));
    const names = Array.from(hintnames(els.length + modeState.hints.length)).slice(modeState.hints.length);
    for (const [el, name] of izip(els, names)) {
      let ft = elementFilterableText(el);
      ft = vimpHelper.sanitiseHintText(ft);
      logger8.debug({ el, name, ft });
      modeState.hintchars += name + ft;
      modeState.hints.push(new Hint(el, name, ft, onSelect, hintables2.hintclasses));
    }
  }
  function elementFilterableText(el) {
    const nodename = el.nodeName.toLowerCase();
    let text;
    if (nodename === "input") {
      text = el.value;
    } else if (0 < el.textContent.length) {
      text = el.textContent;
    } else if (el.hasAttribute("title")) {
      text = el.getAttribute("title");
    } else {
      text = el.innerHTML;
    }
    return text.slice(0, 2048).toLowerCase() || "";
  }
  function filterHintsSimple(fstr) {
    const active = [];
    let foundMatch;
    const hints = get("hintnames") == "numeric" ? sortBy(pipe(prop("name"), parseInt), modeState.hints) : modeState.hints;
    for (const h of hints) {
      if (!h.name.startsWith(fstr))
        h.hidden = true;
      else {
        if (!foundMatch) {
          h.focused = true;
          modeState.focusedHint = h;
          foundMatch = true;
        }
        h.hidden = false;
        active.push(h);
      }
    }
    if (active.length === 1 && get("hintautoselect") === "true") {
      selectFocusedHint();
    }
  }
  function filterHintsVimperator(query, reflow = false) {
    function partitionquery(query2) {
      const peek = (a) => a[a.length - 1];
      const hintChars = defaultHintChars();
      const runs = [];
      for (const char of query2) {
        const isHintChar = hintChars.includes(char);
        if (!peek(runs) || peek(runs).isHintChar !== isHintChar) {
          runs.push({ str: char, isHintChar });
        } else {
          peek(runs).str += char;
        }
      }
      return runs;
    }
    function rename(hints) {
      const names = hintnames(hints.length);
      for (const [hint2, name] of izip(hints, names)) {
        hint2.name = name;
      }
    }
    let active = modeState.hints;
    for (const run2 of partitionquery(query)) {
      if (run2.isHintChar) {
        active = active.filter((hint2) => hint2.name.startsWith(run2.str));
      } else {
        active = active.filter((hint2) => vimpHelper.matchHint(hint2.filterData, run2.str));
        if (reflow)
          rename(active);
      }
    }
    if (modeState.focusedHint) {
      modeState.focusedHint.focused = false;
      modeState.focusedHint = void 0;
    }
    for (const hint2 of modeState.hints) {
      if (active.includes(hint2)) {
        hint2.hidden = false;
        hint2.flag.textContent = hint2.name;
      } else {
        hint2.hidden = true;
      }
    }
    if (active.length) {
      modeState.focusedHint = active[0];
      modeState.focusedHint.focused = true;
    }
    if (active.length === 1 && get("hintautoselect") === "true") {
      selectFocusedHint(true);
    }
  }
  function reset() {
    if (modeState) {
      modeState.cleanUpHints();
      modeState.resolveHinting();
    }
    modeState = void 0;
    contentState.mode = "normal";
  }
  function popKey() {
    modeState.filter = modeState.filter.slice(0, -1);
    modeState.filterFunc(modeState.filter);
  }
  function pushKey(key) {
    const originalFilter = modeState.filter;
    modeState.filter += key;
    modeState.filterFunc(modeState.filter);
    if (modeState && !modeState.activeHints.length) {
      modeState.filter = originalFilter;
      modeState.filterFunc(modeState.filter);
    }
  }
  function pushKeyCodePoint(codepoint) {
    const key = String.fromCodePoint(parseInt(codepoint, 0));
    return pushKey(key);
  }
  function pushSpace() {
    return pushKey(" ");
  }
  function hintables(selectors = HINTTAGS_selectors, withjs = false, includeInvisible = false) {
    const visibleFilter = isVisibleFilter(includeInvisible);
    const elems = changeHintablesToLargestChild(getElemsBySelector(selectors, []).filter(visibleFilter));
    const hintables2 = [{ elements: elems }];
    if (withjs) {
      hintables2.push({
        elements: changeHintablesToLargestChild(Array.from(hintworthy_js_elems).filter((el) => visibleFilter(el) && !elems.includes(el))),
        hintclasses: ["TridactylJSHint"]
      });
    }
    return hintables2;
  }
  function changeHintablesToLargestChild(elements) {
    elements.forEach((element, index) => {
      if (element.childNodes.length === 0)
        return;
      let largestChild;
      element.childNodes.forEach((c) => {
        const currentChild = c;
        if (!largestChild || isElementLargerThan(currentChild, largestChild)) {
          largestChild = currentChild;
        }
      });
      if (isElementLargerThan(largestChild, element)) {
        elements[index] = largestChild;
      }
    });
    return elements;
  }
  function isElementLargerThan(e1, e2) {
    if (typeof e1.getBoundingClientRect !== "function") {
      return false;
    } else if (typeof e2.getBoundingClientRect !== "function") {
      return true;
    }
    const e1BR = e1.getBoundingClientRect();
    const e2BR = e2.getBoundingClientRect();
    return e1BR.height > e2BR.height && e1BR.width > e2BR.width;
  }
  function saveableElements(includeInvisible = false) {
    return getElemsBySelector(HINTTAGS_saveable, [
      isVisibleFilter(includeInvisible)
    ]);
  }
  function hintableImages(includeInvisible = false) {
    return getElemsBySelector(HINTTAGS_img_selectors, [
      isVisibleFilter(includeInvisible)
    ]);
  }
  function hintByText(match2) {
    return getElemsBySelector(HINTTAGS_filter_by_text_selectors, [
      isVisible,
      hintByTextFilter(match2)
    ]);
  }
  function hintByTextFilter(match2) {
    return (hint2) => {
      let text;
      if (hint2 instanceof HTMLInputElement) {
        text = hint2.value;
      } else {
        text = hint2.textContent;
      }
      if (match2 instanceof RegExp) {
        return text.match(match2) !== null;
      } else {
        return text.toUpperCase().includes(match2.toUpperCase());
      }
    };
  }
  function killables(includeInvisible = false) {
    return getElemsBySelector(HINTTAGS_killable_selectors, [
      isVisibleFilter(includeInvisible)
    ]);
  }
  function toHintablesArray(hintablesOrElements) {
    if (!hintablesOrElements.length)
      return [];
    if ("className" in hintablesOrElements[0])
      return [{ elements: hintablesOrElements }];
    if ("elements" in hintablesOrElements[0])
      return hintablesOrElements;
    return [];
  }
  function selectFocusedHint(delay = false) {
    logger8.debug("Selecting hint.", contentState.mode);
    const focused = modeState.focusedHint;
    const selectFocusedHintInternal = () => {
      modeState.filter = "";
      modeState.hints.forEach((h) => h.hidden = false);
      focused.select();
    };
    if (delay)
      setTimeout(selectFocusedHintInternal, get("hintdelay"));
    else
      selectFocusedHintInternal();
  }
  function focusNextHint() {
    logger8.debug("Focusing next hint");
    modeState.changeFocusedHintIndex(1);
  }
  function focusPreviousHint() {
    logger8.debug("Focusing previous hint");
    modeState.changeFocusedHintIndex(-1);
  }
  function focusTopHint() {
    logger8.debug("Focusing top hint");
    modeState.changeFocusedHintTop();
  }
  function focusBottomHint() {
    logger8.debug("Focusing bottom hint");
    modeState.changeFocusedHintBottom();
  }
  function focusLeftHint() {
    logger8.debug("Focusing left hint");
    modeState.changeFocusedHintLeft();
  }
  function focusRightHint() {
    logger8.debug("Focusing right hint");
    modeState.changeFocusedHintRight();
  }
  function parser2(keys2) {
    const parsed = parse(keys2, mapstrMapToKeyMap(new Map(Object.entries(get("hintmaps")).filter(([_key, value]) => value != ""))));
    if (parsed.isMatch === true) {
      return parsed;
    }
    const simplekeys = keys2.filter((key) => !hasModifiers(key));
    let exstr;
    if (simplekeys.length > 1) {
      exstr = simplekeys.reduce((acc, key) => `hint.pushKey ${key.key};`, "composite ");
    } else if (simplekeys.length === 1) {
      exstr = `hint.pushKeyCodePoint ${simplekeys[0].key.codePointAt(0)}`;
    } else {
      return { keys: [], isMatch: false };
    }
    return { exstr, value: exstr, isMatch: true };
  }
  function getHintCommands() {
    return {
      reset,
      focusPreviousHint,
      focusNextHint,
      focusTopHint,
      focusBottomHint,
      focusLeftHint,
      focusRightHint,
      selectFocusedHint,
      pushKey,
      pushSpace,
      pushKeyCodePoint,
      popKey
    };
  }

  // src/lib/hint_util.ts
  var OpenMode;
  (function(OpenMode2) {
    OpenMode2["Default"] = "";
    OpenMode2["Tab"] = "-t";
    OpenMode2["BackgroundTab"] = "-b";
    OpenMode2["Window"] = "-w";
    OpenMode2["WindowPrivate"] = "-wp";
    OpenMode2["Highlight"] = "-h";
    OpenMode2["Images"] = "-i";
    OpenMode2["ImagesTab"] = "-I";
    OpenMode2["Kill"] = "-k";
    OpenMode2["KillTridactyl"] = "-K";
    OpenMode2["Scroll"] = "-z";
    OpenMode2["SaveResource"] = "-s";
    OpenMode2["SaveImage"] = "-S";
    OpenMode2["SaveAsResource"] = "-a";
    OpenMode2["SaveAsImage"] = "-A";
    OpenMode2["ScrollFocus"] = "-;";
    OpenMode2["TTSRead"] = "-r";
    OpenMode2["YankAlt"] = "-P";
    OpenMode2["YankAnchor"] = "-#";
    OpenMode2["YankLink"] = "-y";
    OpenMode2["YankText"] = "-p";
  })(OpenMode || (OpenMode = {}));
  var HintConfig = class {
    constructor() {
      this.rapid = false;
      this.textFilter = null;
      this.openMode = OpenMode.Default;
      this.includeInvisible = false;
      this.immediate = false;
      this.jshints = true;
      this.callback = null;
      this.excmd = null;
      this.pipeAttribute = null;
      this.selectors = [];
      this.warnings = [];
    }
    static parse(args) {
      var State6;
      (function(State7) {
        State7[State7["Initial"] = 0] = "Initial";
        State7[State7["ExpectF"] = 1] = "ExpectF";
        State7[State7["ExpectFR"] = 2] = "ExpectFR";
        State7[State7["ExpectCallback"] = 3] = "ExpectCallback";
        State7[State7["ExpectExcmd"] = 4] = "ExpectExcmd";
        State7[State7["ExpectSelector"] = 5] = "ExpectSelector";
        State7[State7["ExpectPipeSelector"] = 6] = "ExpectPipeSelector";
        State7[State7["ExpectPipeAttribute"] = 7] = "ExpectPipeAttribute";
        State7[State7["ExpectSelectorCallback"] = 8] = "ExpectSelectorCallback";
      })(State6 || (State6 = {}));
      const result = new HintConfig();
      const multiLetterFlags = ["fr", "wp", "br", "pipe"];
      let state2 = 0;
      outer:
        for (let argI = 0; argI < args.length; ++argI) {
          const arg = args[argI];
          switch (state2) {
            case 0:
              if (arg.length >= 2 && arg[0] === "-" && arg[1] !== "-") {
                for (let i = 1; i < arg.length; ++i) {
                  let flag = arg[i];
                  if (i < arg.length - 1) {
                    const multiLetterFlag = multiLetterFlags.find((tlf) => arg.substring(i, i + tlf.length) === tlf);
                    if (multiLetterFlag !== void 0) {
                      flag = multiLetterFlag;
                      i += multiLetterFlag.length - 1;
                    }
                  }
                  let newOpenMode;
                  let newState;
                  switch (flag) {
                    case "br":
                      result.rapid = true;
                      newOpenMode = OpenMode.BackgroundTab;
                      break;
                    case "q":
                      result.rapid = true;
                      break;
                    case "f":
                      newState = 1;
                      break;
                    case "fr":
                      newState = 2;
                      break;
                    case "V":
                      result.includeInvisible = true;
                      break;
                    case "J":
                      result.jshints = false;
                      break;
                    case "!":
                      result.immediate = true;
                      break;
                    case "F":
                      newState = 3;
                      break;
                    case "W":
                      newState = 4;
                      break;
                    case "c":
                      newState = 5;
                      break;
                    case "pipe":
                      newState = 6;
                      break;
                    case "t":
                      newOpenMode = OpenMode.Tab;
                      break;
                    case "b":
                      newOpenMode = OpenMode.BackgroundTab;
                      break;
                    case "w":
                      newOpenMode = OpenMode.Window;
                      break;
                    case "wp":
                      newOpenMode = OpenMode.WindowPrivate;
                      break;
                    case "h":
                      newOpenMode = OpenMode.Highlight;
                      break;
                    case "i":
                      newOpenMode = OpenMode.Images;
                      break;
                    case "I":
                      newOpenMode = OpenMode.ImagesTab;
                      break;
                    case "k":
                      newOpenMode = OpenMode.Kill;
                      break;
                    case "K":
                      newOpenMode = OpenMode.KillTridactyl;
                      break;
                    case "z":
                      newOpenMode = OpenMode.Scroll;
                      break;
                    case "s":
                      newOpenMode = OpenMode.SaveResource;
                      break;
                    case "S":
                      newOpenMode = OpenMode.SaveImage;
                      break;
                    case "a":
                      newOpenMode = OpenMode.SaveAsResource;
                      break;
                    case "A":
                      newOpenMode = OpenMode.SaveAsImage;
                      break;
                    case ";":
                      newOpenMode = OpenMode.ScrollFocus;
                      break;
                    case "r":
                      newOpenMode = OpenMode.TTSRead;
                      break;
                    case "P":
                      newOpenMode = OpenMode.YankAlt;
                      break;
                    case "#":
                      newOpenMode = OpenMode.YankAnchor;
                      break;
                    case "y":
                      newOpenMode = OpenMode.YankLink;
                      break;
                    case "p":
                      newOpenMode = OpenMode.YankText;
                      break;
                    default:
                      result.warnings.push(`unknown flag -${flag}`);
                      break;
                  }
                  if (newOpenMode !== void 0) {
                    if (result.openMode !== OpenMode.Default) {
                      result.warnings.push("multiple open mode flags specified, overriding the previous ones");
                    }
                    result.openMode = newOpenMode;
                  }
                  if (newState !== void 0) {
                    if (state2 === 5 && newState === 3 || state2 === 3 && newState === 5) {
                      newState = 8;
                    }
                    if (state2 !== 0 && newState !== 8) {
                      result.warnings.push(`multiple flags taking a value were specified, only the last one (-${flag}) will be processed`);
                    }
                    state2 = newState;
                  }
                }
              } else {
                result.selectors.push(arg);
              }
              break;
            case 1:
            case 2:
              let filter3 = arg;
              while (filter3.endsWith("\\")) {
                filter3 = filter3.substring(0, filter3.length - 1);
                if (argI + 1 < args.length) {
                  filter3 += " " + args[++argI];
                } else {
                  break;
                }
              }
              if (state2 == 1) {
                result.textFilter = filter3;
              } else {
                result.textFilter = new RegExp(filter3);
              }
              state2 = 0;
              break;
            case 4:
              result.excmd = args.slice(argI).join(" ");
              state2 = 0;
              break outer;
            case 3:
              result.callback = args.slice(argI).join(" ");
              state2 = 0;
              break outer;
            case 5:
              result.selectors.push(arg);
              state2 = 0;
              break;
            case 6:
              result.selectors.push(arg);
              state2 = 7;
              break;
            case 7:
              result.pipeAttribute = arg;
              state2 = 0;
              break;
            case 8:
              result.selectors.push(arg);
              state2 = 3;
              break;
          }
        }
      if (state2 !== 0) {
        result.warnings.push("error parsing options: expected a value");
      }
      return result;
    }
    printWarnings(logger16) {
      for (const warning of this.warnings) {
        logger16.warning(warning);
      }
    }
    defaultHintables() {
      switch (this.openMode) {
        case OpenMode.YankText:
        case OpenMode.Highlight:
        case OpenMode.Scroll:
          return toHintablesArray(elementsWithText(this.includeInvisible));
        case OpenMode.YankAlt:
          return toHintablesArray(getElemsBySelector("[title],[alt]", [
            isVisibleFilter(this.includeInvisible)
          ]));
        case OpenMode.YankAnchor:
          return toHintablesArray(anchors(this.includeInvisible));
        case OpenMode.Images:
        case OpenMode.ImagesTab:
        case OpenMode.SaveImage:
        case OpenMode.SaveAsImage:
          return toHintablesArray(hintableImages(this.includeInvisible));
        case OpenMode.Kill:
        case OpenMode.KillTridactyl:
          return toHintablesArray(killables(this.includeInvisible));
        case OpenMode.SaveResource:
        case OpenMode.SaveAsResource:
          return toHintablesArray(saveableElements(this.includeInvisible));
        default:
          return hintables(HINTTAGS_selectors, this.jshints, this.includeInvisible);
      }
    }
    hintables() {
      const hintables2 = this.selectors.length > 0 ? hintables(this.selectors.join(" "), this.jshints, this.includeInvisible) : this.defaultHintables();
      if (this.textFilter !== null) {
        for (const elements of hintables2) {
          elements.elements = elements.elements.filter(hintByTextFilter(this.textFilter));
        }
      }
      return hintables2;
    }
    get isYank() {
      return this.openMode === OpenMode.YankAnchor || this.openMode === OpenMode.YankAlt || this.openMode === OpenMode.YankLink || this.openMode === OpenMode.YankText;
    }
  };

  // src/parsers/gobblemode.ts
  var GobbleState = class {
    constructor() {
      this.numChars = 0;
      this.chars = "";
      this.endCommand = "";
    }
  };
  var modeState2;
  function init3(numChars, endCommand) {
    contentState.mode = "gobble";
    modeState2 = new GobbleState();
    modeState2.numChars = numChars;
    modeState2.endCommand = endCommand;
  }
  function reset2() {
    modeState2 = void 0;
    contentState.mode = "normal";
  }
  function parser3(keys2) {
    const key = keys2[0].key;
    if (key === "Escape") {
      reset2();
    } else if (isSimpleKey(keys2[0])) {
      modeState2.chars += key;
      if (modeState2.chars.length >= modeState2.numChars) {
        const exstr = modeState2.endCommand + " " + modeState2.chars;
        reset2();
        return { keys: [], exstr };
      }
    }
    return { keys: [], exstr: "", isMatch: true };
  }

  // src/parsers/genericmode.ts
  function parser4(conf, keys2) {
    const maps = keyMap(conf);
    translateKeysInPlace(keys2, conf);
    return parse(keys2, maps);
  }

  // src/parsers/nmode.ts
  var NModeState = class {
    constructor() {
      this.numCommands = 1;
      this.curCommands = 0;
      this.mode = "normal";
      this.endCommand = "";
    }
  };
  var modeState3;
  function init4(endCommand, mode2 = "normal", numCommands = 1) {
    contentState.mode = "nmode";
    modeState3 = new NModeState();
    modeState3.endCommand = endCommand;
    modeState3.numCommands = numCommands;
    modeState3.mode = mode2;
  }
  function parser5(keys2) {
    keys2 = stripOnlyModifiers(keys2);
    if (keys2.length === 0)
      return { keys: [], isMatch: false };
    const conf = mode2maps.get(modeState3.mode) || modeState3.mode + "maps";
    const maps = keyMap(conf);
    translateKeysInPlace(keys2, conf);
    const key = keys2[0].key;
    if (key === "Escape") {
      const exstr = modeState3.endCommand;
      modeState3 = void 0;
      return { keys: [], exstr };
    }
    const response = parse(keys2, maps);
    if (response.exstr !== void 0 && response.isMatch || !response.isMatch)
      modeState3.curCommands += 1;
    if (modeState3.curCommands >= modeState3.numCommands) {
      const prefix = response.exstr === void 0 ? "" : "composite " + response.exstr + "; ";
      response.exstr = prefix + modeState3.endCommand;
      modeState3 = void 0;
    }
    return response;
  }

  // src/content/controller_content.ts
  var logger9 = new logging_default("controller");
  function PrintableKey(k) {
    let result = k.key;
    if (result === "Control" || result === "Meta" || result === "Alt" || result === "Shift" || result === "OS") {
      return "";
    }
    if (k.altKey) {
      result = "A-" + result;
    }
    if (k.ctrlKey) {
      result = "C-" + result;
    }
    if (k.shiftKey) {
      result = "S-" + result;
    }
    if (result.length > 1) {
      result = "<" + result + ">";
    }
    return result;
  }
  var KeyCanceller = class {
    constructor() {
      this.keyPress = [];
      this.keyUp = [];
      this.cancelKeyPress = (ke) => {
        if (!ke.isTrusted)
          return;
        this.cancelKey(ke, this.keyPress);
      };
      this.cancelKeyUp = (ke) => {
        if (!ke.isTrusted)
          return;
        this.cancelKey(ke, this.keyUp);
      };
      this.cancelKeyUp = this.cancelKeyUp.bind(this);
      this.cancelKeyPress = this.cancelKeyPress.bind(this);
    }
    push(ke) {
      this.keyPress.push(ke);
      this.keyUp.push(ke);
    }
    cancelKey(ke, kes) {
      const index = kes.findIndex((ke2) => ke.altKey === ke2.altKey && ke.code === ke2.code && ke.composed === ke2.composed && ke.ctrlKey === ke2.ctrlKey && ke.metaKey === ke2.metaKey && ke.shiftKey === ke2.shiftKey && ke.target === ke2.target);
      if (index >= 0 && ke instanceof KeyboardEvent) {
        ke.preventDefault();
        ke.stopImmediatePropagation();
        kes.splice(index, 1);
      }
    }
  };
  var canceller = new KeyCanceller();
  function* ParserController() {
    const parsers = {
      normal: (keys2) => parser4("nmaps", keys2),
      insert: (keys2) => parser4("imaps", keys2),
      input: (keys2) => parser4("inputmaps", keys2),
      ignore: (keys2) => parser4("ignoremaps", keys2),
      hint: parser2,
      gobble: parser3,
      visual: (keys2) => parser4("vmaps", keys2),
      nmode: parser5
    };
    while (true) {
      let exstr = "";
      let previousSuffix = null;
      let keyEvents = [];
      try {
        while (true) {
          const keyevent = yield;
          const shadowRoot = keyevent instanceof KeyboardEvent ? deepestShadowRoot(keyevent.target.shadowRoot) : null;
          const currentMode = contentState.mode;
          const textEditable = keyevent instanceof KeyboardEvent ? shadowRoot === null ? isTextEditable(keyevent.target) : isTextEditable(shadowRoot.activeElement) : false;
          if (currentMode !== "ignore" && currentMode !== "hint" && currentMode !== "input") {
            if (textEditable) {
              if (currentMode !== "insert") {
                contentState.mode = "insert";
              }
            } else if (currentMode === "insert") {
              contentState.mode = "normal";
            }
          } else if (currentMode === "input" && !textEditable) {
            contentState.mode = "normal";
          }
          const newMode = contentState.mode;
          if (newMode !== currentMode) {
            keyEvents = [];
            previousSuffix = null;
          }
          keyEvents.push(keyevent);
          const response = (parsers[contentState.mode] || ((keys2) => parser4(contentState.mode + "maps", keys2)))(keyEvents);
          logger9.debug(currentMode, contentState.mode, keyEvents, response);
          if (response.isMatch && keyevent instanceof KeyboardEvent) {
            keyevent.preventDefault();
            keyevent.stopImmediatePropagation();
            canceller.push(keyevent);
          }
          if (response.exstr) {
            exstr = response.exstr;
            break;
          } else {
            keyEvents = response.keys;
            const suffix = keyEvents.map((x) => PrintableKey(x)).join("");
            if (previousSuffix !== suffix) {
              contentState.suffix = suffix;
              previousSuffix = suffix;
            }
            logger9.debug("suffix: ", suffix);
          }
        }
        contentState.suffix = "";
        acceptExCmd(exstr);
      } catch (e) {
        logger9.error("An error occurred in the content controller: ", e);
      }
    }
  }
  var generator = ParserController();
  generator.next();
  function acceptKey(keyevent) {
    return generator.next(keyevent);
  }

  // src/lib/number.clamp.ts
  Number.prototype.clamp = function(lo, hi) {
    return Math.max(lo, Math.min(this, hi));
  };

  // src/lib/commandline_cmds.ts
  var sleep2 = (ms) => new Promise((resolve) => setTimeout(resolve, ms));
  async function awaitProxyEq(proxy, a, b) {
    let counter = 0;
    while (proxy[a] != proxy[b] && counter < 50) {
      await sleep2(10);
      counter += 1;
    }
    return proxy[a] == proxy[b];
  }
  function getCommandlineFns(cmdline_state) {
    return {
      complete: async () => {
        const fragment = cmdline_state.clInput.value;
        const matches = (await getAsync2("cmdHistory")).filter((key) => key.startsWith(fragment));
        const mostrecent = matches[matches.length - 1];
        if (mostrecent !== void 0)
          cmdline_state.clInput.value = mostrecent;
        return cmdline_state.refresh_completions(cmdline_state.clInput.value);
      },
      next_completion: async () => {
        await awaitProxyEq(contentState, "current_cmdline", "cmdline_filter");
        if (cmdline_state.activeCompletions)
          cmdline_state.activeCompletions.forEach((comp) => comp.next());
      },
      prev_completion: async () => {
        await awaitProxyEq(contentState, "current_cmdline", "cmdline_filter");
        if (cmdline_state.activeCompletions)
          cmdline_state.activeCompletions.forEach((comp) => comp.prev());
      },
      deselect_completion: () => {
        if (cmdline_state.activeCompletions)
          cmdline_state.activeCompletions.forEach((comp) => comp.deselect());
      },
      insert_completion: async () => {
        await awaitProxyEq(contentState, "current_cmdline", "cmdline_filter");
        const command2 = cmdline_state.getCompletion();
        if (cmdline_state.activeCompletions) {
          cmdline_state.activeCompletions.forEach((comp) => comp.completion = void 0);
        }
        let result = Promise.resolve([]);
        if (command2) {
          cmdline_state.clInput.value = command2 + " ";
          result = cmdline_state.refresh_completions(cmdline_state.clInput.value);
        }
        return result;
      },
      insert_space_or_completion: () => {
        const command2 = cmdline_state.getCompletion();
        if (cmdline_state.activeCompletions) {
          cmdline_state.activeCompletions.forEach((comp) => comp.completion = void 0);
        }
        if (command2) {
          cmdline_state.clInput.value = command2 + " ";
        } else {
          const selectionStart = cmdline_state.clInput.selectionStart;
          const selectionEnd = cmdline_state.clInput.selectionEnd;
          cmdline_state.clInput.value = cmdline_state.clInput.value.substring(0, selectionStart) + " " + cmdline_state.clInput.value.substring(selectionEnd);
          cmdline_state.clInput.selectionStart = cmdline_state.clInput.selectionEnd = selectionStart + 1;
        }
        return cmdline_state.refresh_completions(cmdline_state.clInput.value);
      },
      hide_and_clear: () => {
        cmdline_state.clear(true);
        cmdline_state.keyEvents = [];
        messageOwnTab("commandline_content", "hide");
        messageOwnTab("commandline_content", "blur");
        if (cmdline_state.activeCompletions)
          cmdline_state.activeCompletions.forEach((comp) => cmdline_state.completionsDiv.removeChild(comp.node));
        cmdline_state.activeCompletions = void 0;
        cmdline_state.isVisible = false;
      },
      is_valid_commandline: (command2) => {
        if (command2 === void 0)
          return false;
        const func = command2.trim().split(/\s+/)[0];
        if (func.length === 0 || func.startsWith("#")) {
          return false;
        }
        return true;
      },
      store_ex_string: (command2) => {
        const [func, ...args] = command2.trim().split(/\s+/);
        if (!browser.extension.inIncognitoContext && !(func === "winopen" && args[0] === "-private")) {
          getAsync2("cmdHistory").then((c) => {
            cmdline_state.state.cmdHistory = c.concat([command2]);
          });
          cmdline_state.cmdline_history_position = 0;
        }
      },
      next_history: () => cmdline_state.history(1),
      prev_history: () => cmdline_state.history(-1),
      accept_line: async () => {
        await awaitProxyEq(contentState, "current_cmdline", "cmdline_filter");
        const command2 = cmdline_state.getCompletion() || cmdline_state.clInput.value;
        cmdline_state.fns.hide_and_clear();
        if (cmdline_state.fns.is_valid_commandline(command2) === false)
          return;
        cmdline_state.fns.store_ex_string(command2);
        return messageOwnTab("controller_content", "acceptExCmd", [command2]);
      },
      execute_ex_on_completion_args: (excmd) => execute_ex_on_x(true, cmdline_state, excmd),
      execute_ex_on_completion: (excmd) => execute_ex_on_x(false, cmdline_state, excmd),
      copy_completion: () => {
        const command2 = cmdline_state.getCompletion();
        cmdline_state.fns.hide_and_clear();
        return messageOwnTab("controller_content", "acceptExCmd", [
          "clipboard yank " + command2
        ]);
      }
    };
  }
  function execute_ex_on_x(args_only, cmdline_state, excmd) {
    const args = cmdline_state.getCompletion(args_only) || cmdline_state.clInput.value;
    const cmdToExec = (excmd ? excmd + " " : "") + args;
    cmdline_state.fns.store_ex_string(cmdToExec);
    return messageOwnTab("controller_content", "acceptExCmd", [cmdToExec]);
  }

  // src/background/commandline_cmds.ts
  var functions = getCommandlineFns({});
  var CmdlineCmds = new Proxy(functions, {
    get(target, property) {
      if (target[property]) {
        return (...args) => messageActiveTab("commandline_cmd", property, args);
      }
      return target[property];
    }
  });

  // src/lib/editor.ts
  var editor_exports = {};
  __export(editor_exports, {
    backward_char: () => backward_char,
    backward_kill_line: () => backward_kill_line,
    backward_kill_word: () => backward_kill_word,
    backward_word: () => backward_word,
    beginning_of_line: () => beginning_of_line,
    capitalize_word: () => capitalize_word,
    delete_backward_char: () => delete_backward_char,
    delete_char: () => delete_char,
    downcase_word: () => downcase_word,
    end_of_line: () => end_of_line,
    forward_char: () => forward_char,
    forward_word: () => forward_word,
    insert_text: () => insert_text,
    jumble: () => jumble,
    kill_line: () => kill_line,
    kill_whole_line: () => kill_whole_line,
    kill_word: () => kill_word,
    rot13: () => rot13,
    tab_insert: () => tab_insert,
    transpose_chars: () => transpose_chars,
    transpose_words: () => transpose_words,
    upcase_word: () => upcase_word
  });

  // src/lib/editor_utils.ts
  function applyToElem(e, fn) {
    let result;
    if (e instanceof HTMLInputElement && e.type !== "text") {
      const t = e.type;
      e.type = "text";
      result = fn(e);
      e.type = t;
    } else {
      result = fn(e);
    }
    return result;
  }
  function getSimpleValues(e) {
    return applyToElem(e, (e2) => [e2.value, e2.selectionStart, e2.selectionEnd]);
  }
  function getContentEditableValues(e) {
    const selection = e.ownerDocument.getSelection();
    let n = selection.anchorNode;
    while (n && n !== e)
      n = n.parentNode;
    if (!n)
      return [null, null, null];
    const r = selection.getRangeAt(0).cloneRange();
    const selectionLength = r.toString().length;
    r.setEnd(e, e.childNodes.length);
    const lengthFromCaretToEndOfText = r.toString().length;
    r.setStart(e, 0);
    const s = r.toString();
    const caretPos = s.length - lengthFromCaretToEndOfText;
    return [s, caretPos, caretPos + selectionLength];
  }
  function setSimpleValues(e, text, start, end) {
    return applyToElem(e, (e2) => {
      if (text !== null)
        e2.value = text;
      if (start !== null) {
        if (end === null)
          end = start;
        e2.selectionStart = start;
        e2.selectionEnd = end;
      }
    });
  }
  function setContentEditableValues(e, text, start, end) {
    const selection = e.ownerDocument.getSelection();
    if (selection.rangeCount < 1) {
      const r = new Range();
      r.setStart(e, 0);
      r.setEnd(e, e.childNodes.length);
      selection.addRange(r);
    }
    if (text !== null) {
      const range3 = selection.getRangeAt(0);
      const anchorNode = selection.anchorNode;
      const focusNode = selection.focusNode;
      range3.setStart(anchorNode, 0);
      range3.setEndAfter(focusNode, focusNode.length);
      e.ownerDocument.execCommand("insertText", false, text);
    }
    if (start !== null) {
      if (end === null)
        end = start;
      let range3 = selection.getRangeAt(0);
      range3.setStart(range3.startContainer, start);
      range3 = selection.getRangeAt(0);
      range3.setEnd(range3.startContainer, end);
    }
  }
  function wrap_input(fn) {
    return (e, arg) => {
      let getValues = getSimpleValues;
      let setValues = setSimpleValues;
      if (e.isContentEditable) {
        getValues = getContentEditableValues;
        setValues = setContentEditableValues;
      }
      const [origText, origStart, origEnd] = getValues(e);
      if (origText === null || origStart === null)
        return false;
      setValues(e, ...fn(origText, origStart, origEnd, arg));
      return true;
    };
  }
  function needs_text(fn, arg) {
    return (text, selectionStart, selectionEnd, arg2) => {
      if (text.length === 0 || selectionStart === null || selectionStart === void 0)
        return [null, null, null];
      return fn(text, selectionStart, typeof selectionEnd === "number" ? selectionEnd : selectionStart, arg2);
    };
  }
  function getLineAndColNumber(text, start) {
    const lines = text.split("\n");
    let totalChars = 0;
    for (let i = 0; i < lines.length; ++i) {
      if (totalChars + lines[i].length + 1 > start) {
        return [text, i + 1, start - totalChars];
      }
      totalChars += lines[i].length + 1;
    }
    return [text, lines.length, 1];
  }
  function getWordBoundaries(text, position, before) {
    if (position < 0 || position > text.length)
      throw new Error(`getWordBoundaries: position (${position}) should be within text ("${text}") boundaries (0, ${text.length})`);
    const pattern = new RegExp(get("wordpattern"), "g");
    let boundary1 = position < text.length ? position : text.length;
    const direction = before ? -1 : 1;
    if (before && boundary1 > 0)
      boundary1 -= 1;
    while (boundary1 >= 0 && boundary1 < text.length && !text[boundary1].match(pattern)) {
      boundary1 += direction;
    }
    if (boundary1 < 0)
      boundary1 = 0;
    else if (boundary1 >= text.length)
      boundary1 = text.length - 1;
    while (boundary1 >= 0 && boundary1 < text.length && !text[boundary1].match(pattern)) {
      boundary1 -= direction;
    }
    if (boundary1 < 0)
      boundary1 = 0;
    else if (boundary1 >= text.length)
      boundary1 = text.length - 1;
    if (!text[boundary1].match(pattern)) {
      throw new Error(`getWordBoundaries: no characters matching wordpattern (${pattern.source}) in text (${text})`);
    }
    while (boundary1 >= 0 && boundary1 < text.length && !!text[boundary1].match(pattern)) {
      boundary1 += direction;
    }
    boundary1 -= direction;
    let boundary2 = boundary1;
    while (boundary2 >= 0 && boundary2 < text.length && !!text[boundary2].match(pattern)) {
      boundary2 -= direction;
    }
    boundary2 += direction;
    if (boundary1 > boundary2)
      return [boundary2, boundary1 + 1];
    return [boundary1, boundary2 + 1];
  }
  function wordAfterPos(text, position) {
    if (position < 0)
      throw new Error(`wordAfterPos: position (${position}) is less that 0`);
    const pattern = new RegExp(get("wordpattern"), "g");
    while (position < text.length && !!text[position].match(pattern))
      position += 1;
    while (position < text.length && !text[position].match(pattern))
      position += 1;
    if (position >= text.length)
      return -1;
    return position;
  }
  var rot13_helper = (s, n = 13) => {
    let sa = s.split("");
    sa = sa.map((x) => charesar(x, n));
    return sa.join("");
  };
  var charesar = (c, n = 13) => {
    const cn = c.charCodeAt(0);
    if (cn >= 65 && cn <= 90)
      return String.fromCharCode((cn - 65 + n) % 26 + 65);
    if (cn >= 97 && cn <= 122)
      return String.fromCharCode((cn - 97 + n) % 26 + 97);
    return c;
  };
  var jumble_helper = (text) => {
    const wordSplitRegex = new RegExp("([^a-zA-Z]|[A-Z][a-z]+)");
    return text.split(wordSplitRegex).map(jumbleWord).join("");
  };
  function jumbleWord(word) {
    if (word.length < 4 || isAcronym()) {
      return word;
    }
    const innerText = word.slice(1, -1);
    return word.charAt(0) + shuffle(innerText) + word.charAt(word.length - 1);
    function isAcronym() {
      return word.length < 5 && word.toUpperCase() === word;
    }
  }
  var shuffle = (text) => {
    const arr = text.split("");
    for (let i = arr.length - 1; i >= 0; i--) {
      const j = Math.floor(Math.random() * i + 1);
      const t = arr[i];
      arr[i] = arr[j];
      arr[j] = t;
    }
    return arr.join("");
  };

  // src/lib/editor.ts
  var delete_char = wrap_input(needs_text((text, selectionStart, selectionEnd) => {
    if (selectionStart !== selectionEnd) {
      text = text.substring(0, selectionStart) + text.substring(selectionEnd);
    } else {
      text = text.substring(0, selectionStart) + text.substring(selectionStart + 1);
    }
    return [text, selectionStart, null];
  }));
  var delete_backward_char = wrap_input(needs_text((text, selectionStart, selectionEnd) => {
    if (selectionStart !== selectionEnd) {
      text = text.substring(0, selectionStart) + text.substring(selectionEnd);
    } else {
      text = text.substring(0, selectionStart - 1) + text.substring(selectionStart);
    }
    selectionStart -= 1;
    return [text, selectionStart, null];
  }));
  var tab_insert = wrap_input((text, selectionStart, selectionEnd) => {
    if (selectionStart !== selectionEnd) {
      text = text.substring(0, selectionStart) + "	" + text.substring(selectionEnd);
    } else {
      text = text.substring(0, selectionStart) + "	" + text.substring(selectionStart);
    }
    selectionStart += 1;
    return [text, selectionStart, null];
  });
  var transpose_chars = wrap_input((text, selectionStart) => {
    if (text.length < 2)
      return [null, null, null];
    if (selectionStart === 0)
      selectionStart = 1;
    if (selectionStart >= text.length)
      selectionStart = text.length - 1;
    text = text.substring(0, selectionStart - 1) + text.substring(selectionStart, selectionStart + 1) + text.substring(selectionStart - 1, selectionStart) + text.substring(selectionStart + 1);
    selectionStart += 1;
    return [text, selectionStart, null];
  });
  function applyWord(text, selectionStart, selectionEnd, fn) {
    if (text.length === 0)
      return [null, null, null];
    if (selectionStart >= text.length) {
      selectionStart = text.length - 1;
    }
    const boundaries = getWordBoundaries(text, selectionStart, false);
    const beginning = text.substring(0, boundaries[0]) + fn(text.substring(boundaries[0], boundaries[1]));
    text = beginning + text.substring(boundaries[1]);
    selectionStart = beginning.length + 1;
    return [text, selectionStart, null];
  }
  var transpose_words = wrap_input(needs_text((text, selectionStart) => {
    if (selectionStart >= text.length) {
      selectionStart = text.length - 1;
    }
    let firstBoundaries = getWordBoundaries(text, selectionStart, false);
    let secondBoundaries = firstBoundaries;
    const nextWord = wordAfterPos(text, firstBoundaries[1]);
    if (nextWord > -1) {
      secondBoundaries = getWordBoundaries(text, nextWord, false);
    } else {
      firstBoundaries = getWordBoundaries(text, firstBoundaries[0] - 1, true);
    }
    const firstWord = text.substring(firstBoundaries[0], firstBoundaries[1]);
    const secondWord = text.substring(secondBoundaries[0], secondBoundaries[1]);
    const beginning = text.substring(0, firstBoundaries[0]) + secondWord + text.substring(firstBoundaries[1], secondBoundaries[0]);
    selectionStart = beginning.length;
    return [
      beginning + firstWord + text.substring(secondBoundaries[1]),
      selectionStart,
      null
    ];
  }));
  var upcase_word = wrap_input(needs_text((text, selectionStart, selectionEnd) => applyWord(text, selectionStart, selectionEnd, (word) => word.toUpperCase())));
  var downcase_word = wrap_input(needs_text((text, selectionStart, selectionEnd) => applyWord(text, selectionStart, selectionEnd, (word) => word.toLowerCase())));
  var capitalize_word = wrap_input(needs_text((text, selectionStart, selectionEnd) => applyWord(text, selectionStart, selectionEnd, (word) => word[0].toUpperCase() + word.substring(1))));
  var kill_line = wrap_input(needs_text((text, selectionStart) => {
    let newLine = text.substring(selectionStart).search("\n");
    if (newLine !== -1) {
      if (newLine === 0)
        newLine = 1;
      text = text.substring(0, selectionStart) + text.substring(selectionStart + newLine);
    } else {
      text = text.substring(0, selectionStart);
    }
    return [text, selectionStart, null];
  }));
  var backward_kill_line = wrap_input(needs_text((text, selectionStart) => {
    if (selectionStart > 0 && text[selectionStart - 1] === "\n") {
      return [
        text.substring(0, selectionStart - 1) + text.substring(selectionStart),
        selectionStart,
        null
      ];
    }
    let newLine;
    for (newLine = selectionStart; newLine > 0 && text[newLine - 1] !== "\n"; --newLine)
      ;
    return [
      text.substring(0, newLine) + text.substring(selectionStart),
      newLine,
      null
    ];
  }));
  var kill_whole_line = wrap_input(needs_text((text, selectionStart) => {
    let firstNewLine;
    let secondNewLine;
    for (firstNewLine = selectionStart; firstNewLine > 0 && text[firstNewLine - 1] !== "\n"; --firstNewLine)
      ;
    for (secondNewLine = selectionStart; secondNewLine < text.length && text[secondNewLine - 1] !== "\n"; ++secondNewLine)
      ;
    return [
      text.substring(0, firstNewLine) + text.substring(secondNewLine),
      firstNewLine,
      null
    ];
  }));
  var kill_word = wrap_input(needs_text((text, selectionStart) => {
    const boundaries = getWordBoundaries(text, selectionStart, false);
    if (selectionStart < boundaries[1]) {
      boundaries[0] = selectionStart;
      return [
        text.substring(0, boundaries[0]) + text.substring(boundaries[1]),
        boundaries[0],
        null
      ];
    } else {
      return [null, selectionStart, null];
    }
  }));
  var backward_kill_word = wrap_input(needs_text((text, selectionStart) => {
    const boundaries = getWordBoundaries(text, selectionStart, true);
    if (selectionStart > boundaries[0]) {
      boundaries[1] = selectionStart;
      return [
        text.substring(0, boundaries[0]) + text.substring(boundaries[1]),
        boundaries[0],
        null
      ];
    } else {
      return [null, selectionStart, null];
    }
  }));
  var beginning_of_line = wrap_input(needs_text((text, selectionStart) => {
    while (text[selectionStart - 1] !== void 0 && text[selectionStart - 1] !== "\n")
      selectionStart -= 1;
    return [null, selectionStart, null];
  }));
  var end_of_line = wrap_input(needs_text((text, selectionStart) => {
    while (text[selectionStart] !== void 0 && text[selectionStart] !== "\n")
      selectionStart += 1;
    return [null, selectionStart, null];
  }));
  var forward_char = wrap_input((text, selectionStart) => [
    null,
    selectionStart + 1,
    null
  ]);
  var backward_char = wrap_input((text, selectionStart) => [null, selectionStart - 1, null]);
  var forward_word = wrap_input(needs_text((text, selectionStart) => {
    if (selectionStart === text.length)
      return [null, null, null];
    const boundaries = getWordBoundaries(text, selectionStart, false);
    return [null, boundaries[1], null];
  }));
  var backward_word = wrap_input((text, selectionStart) => {
    if (selectionStart === 0)
      return [null, null, null];
    const boundaries = getWordBoundaries(text, selectionStart, true);
    return [null, boundaries[0], null];
  });
  var insert_text = wrap_input((text, selectionStart, selectionEnd, arg) => [
    text.slice(0, selectionStart) + arg + text.slice(selectionEnd),
    selectionStart + arg.length,
    null
  ]);
  var rot13 = wrap_input((text, selectionStart, selectionEnd) => [
    rot13_helper(text.slice(0, selectionStart) + text.slice(selectionEnd)),
    selectionStart,
    null
  ]);
  var jumble = wrap_input((text, selectionStart, selectionEnd) => [
    jumble_helper(text.slice(0, selectionStart) + text.slice(selectionEnd)),
    selectionStart,
    null
  ]);

  // src/background/editor.ts
  var EditorCmds = new Proxy(editor_exports, {
    get(target, property) {
      if (target[property]) {
        return (...args) => messageActiveTab("editorfn_content", property, args);
      }
      return target[property];
    }
  });

  // src/content/commandline_content.ts
  var commandline_content_exports = {};
  __export(commandline_content_exports, {
    blur: () => blur,
    executeWithoutCommandLine: () => executeWithoutCommandLine,
    focus: () => focus2,
    hide: () => hide,
    hide_and_blur: () => hide_and_blur,
    show: () => show
  });

  // src/content/styling.ts
  var styling_exports = {};
  __export(styling_exports, {
    THEMES: () => THEMES,
    theme: () => theme
  });
  var logger10 = new Logger("styling");
  var THEMES = staticThemes;
  function capitalise(str) {
    if (str === "")
      return str;
    return str[0].toUpperCase() + str.slice(1);
  }
  function prefixTheme(name) {
    return "TridactylTheme" + capitalise(name);
  }
  var THEMED_ELEMENTS = [];
  var insertedCSS = false;
  var customCss = {
    allFrames: true,
    matchAboutBlank: true,
    code: ""
  };
  async function theme(element) {
    for (const theme2 of THEMES.map(prefixTheme)) {
      element.classList.remove(theme2);
    }
    if (insertedCSS) {
      await browserBg.tabs.removeCSS(await ownTabId(), customCss);
      insertedCSS = false;
    }
    const newTheme = await getAsync("theme");
    if (newTheme !== "default") {
      element.classList.add(prefixTheme(newTheme));
    }
    if (newTheme !== "default") {
      customCss.code = THEMES.includes(newTheme) ? "@import url('" + browser.runtime.getURL("static/themes/" + newTheme + "/" + newTheme + ".css") + "');" : await getAsync("customthemes", newTheme);
      if (customCss.code) {
        await browserBg.tabs.insertCSS(await ownTabId(), customCss);
        insertedCSS = true;
      } else {
        logger10.error("Theme " + newTheme + " couldn't be found.");
      }
    }
    if (THEMED_ELEMENTS.length < 2 && element.tagName.toUpperCase() === "HTML") {
      THEMED_ELEMENTS.push(element);
    }
  }
  function retheme() {
    THEMED_ELEMENTS.forEach((element) => {
      theme(element).catch((e) => {
        logger10.warning(`Failed to retheme element "${element}". Error: ${e}`);
      });
    });
  }
  addChangeListener("theme", retheme);
  var cb = async (mutationList) => {
    const theme2 = await getAsync("theme");
    mutationList.filter((m) => m.target.className.search(prefixTheme("")) === -1).forEach((m) => m.target.classList.add(prefixTheme(theme2)));
  };
  new MutationObserver(cb).observe(document.documentElement, {
    attributes: true,
    childList: false,
    characterData: false,
    subtree: false,
    attributeOldValue: false,
    attributeFilter: ["class"]
  });

  // src/content/commandline_content.ts
  var logger11 = new logging_default("messaging");
  var cmdline_logger = new logging_default("cmdline");
  var cmdline_iframe = window.document.createElementNS("http://www.w3.org/1999/xhtml", "iframe");
  cmdline_iframe.className = "cleanslate";
  cmdline_iframe.setAttribute("src", browser.runtime.getURL("static/commandline.html"));
  cmdline_iframe.setAttribute("id", "cmdline_iframe");
  cmdline_iframe.setAttribute("loading", "lazy");
  var enabled = false;
  async function init5() {
    const noiframe = await getAsync("noiframe");
    if (noiframe === "false" && !enabled) {
      hide();
      document.documentElement.appendChild(cmdline_iframe);
      enabled = true;
      await theme(window.document.querySelector(":root"));
    }
  }
  init5().catch(() => {
    document.addEventListener("DOMContentLoaded", () => setTimeout(() => {
      init5().catch((e) => logger11.error("Couldn't initialise cmdline_iframe!", e));
    }, 0));
  });
  function show(hidehover = false) {
    try {
      if (hidehover) {
        const a = window.document.createElement("A");
        a.href = "";
        document.body.appendChild(a);
        a.focus({ preventScroll: true });
        document.body.removeChild(a);
      }
      cmdline_iframe.classList.remove("hidden");
      const height = cmdline_iframe.contentWindow.document.body.offsetHeight + "px";
      cmdline_iframe.setAttribute("style", `height: ${height} !important;`);
    } catch (e) {
      console.error(e);
    }
  }
  function hide() {
    try {
      cmdline_iframe.classList.add("hidden");
      cmdline_iframe.setAttribute("style", "height: 0px !important;");
    } catch (e) {
      cmdline_logger.error(e);
    }
  }
  function focus2() {
    try {
      cmdline_iframe.focus();
    } catch (e) {
      console.error(e);
    }
  }
  function blur() {
    try {
      cmdline_iframe.blur();
    } catch (e) {
      cmdline_logger.error(e);
    }
  }
  function hide_and_blur() {
    hide();
    blur();
  }
  function executeWithoutCommandLine(fn) {
    let parent;
    if (cmdline_iframe) {
      parent = cmdline_iframe.parentNode;
      parent.removeChild(cmdline_iframe);
    }
    let result;
    try {
      result = fn();
    } catch (e) {
      cmdline_logger.error(e);
    }
    if (cmdline_iframe)
      parent.appendChild(cmdline_iframe);
    return result;
  }
  addListener("commandline_content", attributeCaller(commandline_content_exports));

  // src/content/scrolling.ts
  var scrolling_exports = {};
  __export(scrolling_exports, {
    recursiveScroll: () => recursiveScroll,
    scroll: () => scroll,
    setCurrentFocus: () => setCurrentFocus
  });
  var opts = { smooth: null, duration: null };
  async function getSmooth() {
    if (opts.smooth === null)
      opts.smooth = await getAsync("smoothscroll");
    return opts.smooth;
  }
  async function getDuration() {
    if (opts.duration === null)
      opts.duration = await getAsync("scrollduration");
    return opts.duration;
  }
  addChangeListener("smoothscroll", (prev, cur) => opts.smooth = cur);
  addChangeListener("scrollduration", (prev, cur) => opts.duration = cur);
  var ScrollingData = class {
    constructor(elem, scrollDirection = "scrollTop") {
      this.elem = elem;
      this.scrollDirection = scrollDirection;
      this.scrolling = false;
      this.duration = 0;
    }
    scroll(distance2, duration) {
      this.duration = duration;
      this.startTime = performance.now();
      this.startPos = this.elem[this.scrollDirection];
      if (this.scrolling) {
        this.endPos = this.endPos + distance2;
        return true;
      }
      this.endPos = this.startPos + distance2;
      if ("style" in this.elem)
        this.elem.style.scrollBehavior = "unset";
      this.scrolling = this.scrollStep();
      if (this.scrolling)
        this.scheduleStep();
      return this.scrolling;
    }
    getStep() {
      if (this.startTime === void 0) {
        this.startTime = performance.now();
      }
      const elapsed = performance.now() - this.startTime;
      if (elapsed >= this.duration || this.elem[this.scrollDirection] === this.endPos)
        return this.endPos;
      let pixelToScrollTo = this.startPos + (this.endPos - this.startPos) * elapsed / this.duration;
      if (this.startPos < this.endPos) {
        pixelToScrollTo = Math.ceil(pixelToScrollTo);
        if (pixelToScrollTo == this.elem[this.scrollDirection])
          pixelToScrollTo += 1;
      } else {
        pixelToScrollTo = Math.floor(pixelToScrollTo);
        if (pixelToScrollTo == this.elem[this.scrollDirection])
          pixelToScrollTo -= 1;
      }
      return pixelToScrollTo;
    }
    scrollStep() {
      const prevScrollPos = this.elem[this.scrollDirection];
      this.elem[this.scrollDirection] = this.getStep();
      return prevScrollPos !== this.elem[this.scrollDirection];
    }
    scheduleStep() {
      window.requestAnimationFrame(() => this.scrollStep() ? this.scheduleStep() : this.scrolling = false);
    }
  };
  var horizontallyScrolling = new Map();
  var verticallyScrolling = new Map();
  async function scroll(xDistance = 0, yDistance = 0, e, duration) {
    const smooth = await getSmooth();
    if (smooth === "false")
      duration = 0;
    else if (duration === void 0)
      duration = await getDuration();
    let didScroll = false;
    if (xDistance !== 0) {
      let scrollData = horizontallyScrolling.get(e);
      if (!scrollData) {
        scrollData = new ScrollingData(e, "scrollLeft");
        horizontallyScrolling.set(e, scrollData);
      }
      didScroll = didScroll || scrollData.scroll(xDistance, duration);
    }
    if (yDistance !== 0) {
      let scrollData = verticallyScrolling.get(e);
      if (!scrollData) {
        scrollData = new ScrollingData(e, "scrollTop");
        verticallyScrolling.set(e, scrollData);
      }
      didScroll = didScroll || scrollData.scroll(yDistance, duration);
    }
    return didScroll;
  }
  var lastRecursiveScrolled = null;
  var lastFocused = null;
  var currentFocused = document.activeElement;
  var lastX = 0;
  var lastY = 0;
  function setCurrentFocus(v) {
    currentFocused = v;
  }
  document.addEventListener("mousedown", (event) => {
    currentFocused = event.target;
  });
  document.addEventListener("focusin", (event) => {
    currentFocused = event.target;
  });
  async function recursiveScroll(xDistance, yDistance, node) {
    var _a2;
    let startingFromCached = false;
    if (!node) {
      const sameSignX = xDistance < 0 === lastX < 0;
      const sameSignY = yDistance < 0 === lastY < 0;
      const sameElement = lastFocused == currentFocused;
      if (lastRecursiveScrolled && sameSignX && sameSignY && sameElement) {
        startingFromCached = true;
        node = lastRecursiveScrolled;
      } else {
        if (!currentFocused || currentFocused.nodeName == "#document")
          currentFocused = document.activeElement;
        node = currentFocused;
        while (true) {
          if (await scroll(xDistance, yDistance, node))
            return true;
          node = node.parentElement;
          if (!node)
            break;
        }
        node = document.documentElement;
        lastFocused = currentFocused;
      }
    }
    let treeWalker = document.createTreeWalker(node, NodeFilter.SHOW_ELEMENT);
    do {
      if (await scroll(xDistance, yDistance, treeWalker.currentNode) || treeWalker.currentNode.contentDocument && !((_a2 = treeWalker.currentNode.src) == null ? void 0 : _a2.startsWith("moz-extension://")) && await recursiveScroll(xDistance, yDistance, treeWalker.currentNode.contentDocument.body)) {
        lastRecursiveScrolled = treeWalker.currentNode;
        lastX = xDistance;
        lastY = yDistance;
        return true;
      }
    } while (treeWalker.nextNode());
    if (startingFromCached) {
      treeWalker = document.createTreeWalker(node, NodeFilter.SHOW_ELEMENT);
      do {
        if (await scroll(xDistance, yDistance, treeWalker.currentNode)) {
          lastRecursiveScrolled = treeWalker.currentNode;
          lastX = xDistance;
          lastY = yDistance;
          return true;
        }
      } while (treeWalker.previousNode());
    }
    lastRecursiveScrolled = null;
    lastX = xDistance;
    lastY = yDistance;
    return false;
  }

  // src/content/finding.ts
  var finding_exports = {};
  __export(finding_exports, {
    jumpToMatch: () => jumpToMatch,
    jumpToNextMatch: () => jumpToNextMatch,
    removeHighlighting: () => removeHighlighting
  });
  var host;
  function getFindHost() {
    if (host) {
      return host;
    }
    const elem = document.createElement("span");
    elem.id = "TridactylFindHost";
    elem.className = "cleanslate";
    elem.style.position = "absolute";
    elem.style.top = "0px";
    elem.style.left = "0px";
    document.body.appendChild(elem);
    host = elem.attachShadow({ mode: "closed" });
    return host;
  }
  var FindHighlight = class extends HTMLSpanElement {
    constructor(rects, node) {
      super();
      this.rects = rects;
      this.node = node;
      this.top = Infinity;
      this.unfocus = () => {
        for (const node2 of this.children) {
          ;
          node2.style.background = `rgba(127,255,255,0.5)`;
        }
      };
      this.focus = () => {
        if (!isVisible(this.children[0])) {
          this.children[0].scrollIntoView({
            block: "center",
            inline: "center"
          });
        }
        let parentNode = this.node.parentNode;
        while (parentNode && !(parentNode instanceof HTMLAnchorElement)) {
          parentNode = parentNode.parentNode;
        }
        if (parentNode) {
          parentNode.focus();
        }
        for (const node2 of this.children) {
          ;
          node2.style.background = `rgba(255,127,255,0.5)`;
        }
      };
      this.style.position = "absolute";
      this.style.top = "0px";
      this.style.left = "0px";
      for (const rect of rects) {
        if (rect.top < this.top) {
          this.top = rect.top;
        }
        const highlight = document.createElement("span");
        highlight.className = "TridactylFindHighlight";
        highlight.style.position = "absolute";
        highlight.style.top = `${rect.top}px`;
        highlight.style.left = `${rect.left}px`;
        highlight.style.width = `${rect.right - rect.left}px`;
        highlight.style.height = `${rect.bottom - rect.top}px`;
        highlight.style.zIndex = "2147483645";
        highlight.style.pointerEvents = "none";
        this.appendChild(highlight);
      }
      ;
      this.unfocus();
    }
  };
  customElements.define("find-highlight", FindHighlight, { extends: "span" });
  var lastHighlights;
  var selected = 0;
  async function jumpToMatch(searchQuery, reverse2) {
    const findcase = get("findcase");
    const sensitive = findcase === "sensitive" || findcase === "smart" && /[A-Z]/.test(searchQuery);
    const findPromise = await browserBg.find.find(searchQuery, {
      tabId: await activeTabId(),
      caseSensitive: sensitive,
      entireWord: false,
      includeRangeData: true,
      includeRectData: true
    });
    state.lastSearchQuery = searchQuery;
    lastHighlights = [];
    removeHighlighting();
    const walker = document.createTreeWalker(document, NodeFilter.SHOW_TEXT, null, false);
    const nodes = [];
    let node;
    do {
      node = walker.nextNode();
      nodes.push(node);
    } while (node);
    const results = await findPromise;
    const host2 = getFindHost();
    let focused = false;
    for (let i = 0; i < results.count; ++i) {
      const data = results.rectData[i];
      if (data.rectsAndTexts.rectList.length < 1) {
        continue;
      }
      const range3 = results.rangeData[i];
      const high = new FindHighlight(data.rectsAndTexts.rectList, nodes[range3.startTextNodePos]);
      host2.appendChild(high);
      lastHighlights.push(high);
      if (!focused && isVisible(high)) {
        focused = true;
        high.focus();
        selected = lastHighlights.length - 1;
      }
    }
    if (lastHighlights.length < 1) {
      throw new Error("Pattern not found: " + searchQuery);
    }
    lastHighlights.sort(reverse2 ? (a, b) => b.top - a.top : (a, b) => a.top - b.top);
    if (!focused) {
      selected = 0;
      lastHighlights[selected].focus();
    }
  }
  function drawHighlights(highlights) {
    const host2 = getFindHost();
    highlights.forEach((elem) => host2.appendChild(elem));
  }
  function removeHighlighting() {
    const host2 = getFindHost();
    while (host2.firstChild)
      host2.removeChild(host2.firstChild);
  }
  async function jumpToNextMatch(n) {
    const lastSearchQuery = await getAsync2("lastSearchQuery");
    if (!lastHighlights) {
      return lastSearchQuery ? jumpToMatch(lastSearchQuery, n < 0) : void 0;
    }
    if (!host.firstChild) {
      drawHighlights(lastHighlights);
    }
    if (lastHighlights[selected] === void 0) {
      removeHighlighting();
      throw new Error("Pattern not found: " + lastSearchQuery);
    }
    ;
    lastHighlights[selected].unfocus();
    selected = (selected + n + lastHighlights.length) % lastHighlights.length;
    lastHighlights[selected].focus();
  }

  // src/content/toys.ts
  function jack_in() {
    const chinese = "\u7530\u7531\u7532\u7533\u7534\u7535\u7536\u7537\u7538\u7539\u753A\u753B\u753C\u753D\u753E\u753F\u7540\u7541\u7542\u7543\u7544\u7545\u7546\u7547\u7548\u7549\u754A\u754B\u754C\u754D\u754E\u754F\u7550\u7551".split("");
    const colour = "#0F0";
    rain(makeBlock(), chinese, colour);
  }
  function music() {
    const music2 = "\u{1D11E}\u{1D11F}\u{1D130}\u{1D160}\u{1D161}\u{1D162}\u{1D13D}".split("");
    const colour = "#ead115";
    rain(makeBlock(), music2, colour);
  }
  function no_mouse() {
    makeBlock();
  }
  function makeBlock() {
    const overlaydiv = document.createElement("div");
    overlaydiv.className = "_tridactyl_no_mouse_";
    overlaydiv.style.position = "fixed";
    overlaydiv.style.display = "block";
    overlaydiv.style.width = String(window.innerWidth);
    overlaydiv.style.height = String(document.documentElement.scrollHeight);
    overlaydiv.style.top = "0px";
    overlaydiv.style.bottom = "0px";
    overlaydiv.style.left = "0px";
    overlaydiv.style.right = "0px";
    overlaydiv.style.zIndex = "1000";
    overlaydiv.style.opacity = "0.5";
    document.body.appendChild(overlaydiv);
    return overlaydiv;
  }
  function drawable() {
    eraser = false;
    make_drawable(makeBlock());
  }
  var clickX = [];
  var clickY = [];
  var clickDrag = [];
  var ink;
  var eraser = false;
  function eraser_toggle() {
    eraser = !eraser;
  }
  function addClick(x, y, dragging) {
    clickX.push(x);
    clickY.push(y);
    clickDrag.push(dragging);
  }
  function redraw(context) {
    if (eraser) {
      context.globalCompositeOperation = "destination-out";
      context.lineWidth = 18;
    } else {
      context.globalCompositeOperation = "source-over";
      context.lineWidth = 3;
    }
    context.strokeStyle = "#000000";
    context.lineJoin = "miter";
    for (let i = 0; i < clickX.length; i++) {
      context.beginPath();
      if (clickDrag[i] && i) {
        context.moveTo(clickX[i - 1], clickY[i - 1]);
      } else {
        context.moveTo(clickX[i] - 1, clickY[i]);
      }
      context.lineTo(clickX[i], clickY[i]);
      context.closePath();
      context.stroke();
    }
  }
  function handleDown(e, context) {
    ink = true;
    addClick(e.pageX, e.pageY, false);
    redraw(context);
    e.preventDefault();
    e.stopPropagation();
  }
  function handleUp(e) {
    ink = false;
    clickX.length = 0;
    clickY.length = 0;
    clickDrag.length = 0;
    e.stopPropagation();
    e.preventDefault();
  }
  function handleMove(e, context) {
    if (ink) {
      addClick(e.pageX, e.pageY, true);
      redraw(context);
    }
    e.preventDefault();
    e.stopPropagation();
  }
  function make_drawable(overlaydiv) {
    overlaydiv.style.position = "absolute";
    overlaydiv.style.opacity = "0.8";
    const c = document.createElement("canvas");
    overlaydiv.appendChild(c);
    const context = c.getContext("2d");
    c.height = document.documentElement.scrollHeight;
    c.width = window.innerWidth * 0.98;
    c.style.touchAction = "none";
    c.addEventListener("pointerdown", (e) => handleDown(e, context));
    c.addEventListener("pointerup", handleUp);
    c.addEventListener("pointermove", (e) => handleMove(e, context));
  }
  function removeBlock() {
    Array.from(document.getElementsByClassName("_tridactyl_no_mouse_")).map((el) => {
      if (typeof el.intid === "number") {
        clearInterval(el.intid);
      }
      el.remove();
    });
  }
  var snow = () => rain(makeBlock(), ["\u2744"], "#FFF", 0.15);
  function rain(overlaydiv, characters, colour, darkening = 0.05) {
    const c = document.createElement("canvas");
    overlaydiv.appendChild(c);
    const ctx = c.getContext("2d");
    c.height = window.innerHeight;
    c.width = window.innerWidth;
    const font_size = 10;
    const columns = c.width / font_size;
    const drops = [];
    for (let x = 0; x < columns; x++)
      drops[x] = 1;
    function draw() {
      ctx.fillStyle = "rgba(0, 0, 0, " + darkening + ")";
      ctx.fillRect(0, 0, c.width, c.height);
      ctx.fillStyle = colour;
      ctx.font = font_size + "px arial";
      for (let i = 0; i < drops.length; i++) {
        const text = characters[Math.floor(Math.random() * characters.length)];
        ctx.fillText(text, i * font_size, drops[i] * font_size);
        if (drops[i] * font_size > c.height && Math.random() > 0.975)
          drops[i] = 0;
        drops[i]++;
      }
    }
    overlaydiv.intid = setInterval(draw, 33);
  }

  // src/.excmds_content.generated.ts
  var ALL_EXCMDS;
  var cmd_params = new Map();
  var logger12 = new Logger("excmd");
  var TRI_VERSION = getTriVersion();
  ALL_EXCMDS = {
    "": excmds_content_generated_exports,
    ex: CmdlineCmds,
    text: EditorCmds
  };
  cmd_params.set("getNativeVersion", new Map([]));
  async function getNativeVersion() {
    logger12.debug("shimming excmd getNativeVersion from content to background");
    return message("excmd_background", "getNativeVersion");
  }
  cmd_params.set("getRssLinks", new Map([]));
  async function getRssLinks() {
    const seen = new Set();
    return Array.from(document.querySelectorAll("a, link[rel='alternate']")).filter((e) => typeof e.href === "string").reduce((acc, e) => {
      let type2 = "";
      if (e.type) {
        if (e.type.indexOf("rss") < 0 && e.type.indexOf("atom") < 0)
          return acc;
        type2 = e.type;
      } else {
        if (/(\.rss)|(rss\.xml)/i.test(e.href))
          type2 = "application/rss+xml";
        else if (/(\.atom)|(atom\.xml)/i.test(e.href))
          type2 = "application/atom+xml";
        else
          return acc;
      }
      if (seen.has(e.href))
        return acc;
      seen.add(e.href);
      return acc.concat({ type: type2, url: e.href, title: e.title || e.innerText });
    }, []);
  }
  cmd_params.set("rssexec", new Map([["url", "string"], ["type", "string"], ["...title", "string[]"]]));
  async function rssexec(url, type2, ...title) {
    if (!url || url === "") {
      const links = await getRssLinks();
      switch (links.length) {
        case 0:
          throw new Error("No rss link found on this page.");
          break;
        case 1:
          url = links[0].url;
          title = [links[0].title];
          type2 = links[0].type;
          break;
        default:
          return fillcmdline("rssexec");
      }
    }
    let rsscmd = get("rsscmd");
    if (rsscmd.match("%[uty]")) {
      rsscmd = rsscmd.replace("%u", url).replace("%t", title.join(" ")).replace("%y", type2 || "");
    } else {
      rsscmd += " " + url;
    }
    return acceptExCmd(rsscmd);
  }
  cmd_params.set("fillinput", new Map([["selector", "string"], ["...content", "string[]"]]));
  function fillinput(selector, ...content) {
    let inputToFill = document.querySelector(selector);
    if (!inputToFill)
      inputToFill = getLastUsedInput();
    if ("value" in inputToFill) {
      ;
      inputToFill.value = content.join(" ");
    } else {
      inputToFill.textContent = content.join(" ");
    }
  }
  function getInput(e) {
    if ("value" in e) {
      return e.value;
    } else {
      return e.textContent;
    }
  }
  cmd_params.set("getinput", new Map([]));
  function getinput() {
    return getInput(getLastUsedInput());
  }
  cmd_params.set("getInputSelector", new Map([]));
  function getInputSelector() {
    return getSelector(getLastUsedInput());
  }
  cmd_params.set("addTridactylEditorClass", new Map([["selector", "string"]]));
  function addTridactylEditorClass(selector) {
    const elem = document.querySelector(selector);
    elem.className = elem.className + " TridactylEditing ";
    return elem;
  }
  cmd_params.set("removeTridactylEditorClass", new Map([["selector", "string"]]));
  function removeTridactylEditorClass(selector) {
    const elem = document.querySelector(selector);
    elem.className = elem.className.replace(" TridactylEditing ", "");
  }
  cmd_params.set("editor", new Map([]));
  async function editor2() {
    const elem = getLastUsedInput();
    const selector = getSelector(elem);
    addTridactylEditorClass(selector);
    if (!await nativegate()) {
      removeTridactylEditorClass(selector);
      return void 0;
    }
    try {
      let text = "";
      let line = 0;
      let col = 0;
      wrap_input((t, start) => {
        ;
        [text, line, col] = getLineAndColNumber(t, start);
        return [null, null, null];
      })(elem);
      const file = (await temp(text, document.location.hostname)).content;
      const exec = await editor(file, line, col);
      if (exec.code == 0) {
        fillinput(selector, exec.content);
        return [file, exec.content];
      } else {
        logger12.debug(`Editor terminated with non-zero exit code: ${exec.code}`);
      }
    } catch (e) {
      throw new Error(`:editor failed: ${e}`);
    } finally {
      return removeTridactylEditorClass(selector);
    }
  }
  cmd_params.set("guiset_quiet", new Map([["rule", "string"], ["option", "string"]]));
  async function guiset_quiet(rule, option) {
    logger12.debug("shimming excmd guiset_quiet from content to background");
    return message("excmd_background", "guiset_quiet", rule, option);
  }
  cmd_params.set("guiset", new Map([["rule", "string"], ["option", "string"]]));
  async function guiset(rule, option) {
    logger12.debug("shimming excmd guiset from content to background");
    return message("excmd_background", "guiset", rule, option);
  }
  cmd_params.set("cssparse", new Map([["...css", "string[]"]]));
  function cssparse(...css) {
    logger12.debug("shimming excmd cssparse from content to background");
    return message("excmd_background", "cssparse", ...css);
  }
  cmd_params.set("loadtheme", new Map([["themename", "string"]]));
  async function loadtheme(themename) {
    logger12.debug("shimming excmd loadtheme from content to background");
    return message("excmd_background", "loadtheme", themename);
  }
  cmd_params.set("unloadtheme", new Map([["themename", "string"]]));
  async function unloadtheme(themename) {
    logger12.debug("shimming excmd unloadtheme from content to background");
    return message("excmd_background", "unloadtheme", themename);
  }
  cmd_params.set("colourscheme", new Map([["...args", "string[]"]]));
  async function colourscheme(...args) {
    logger12.debug("shimming excmd colourscheme from content to background");
    return message("excmd_background", "colourscheme", ...args);
  }
  cmd_params.set("setpref", new Map([["key", "string"], ["...value", "string[]"]]));
  function setpref(key, ...value) {
    logger12.debug("shimming excmd setpref from content to background");
    return message("excmd_background", "setpref", key, ...value);
  }
  cmd_params.set("removepref", new Map([["key", "string"]]));
  function removepref(key) {
    logger12.debug("shimming excmd removepref from content to background");
    return message("excmd_background", "removepref", key);
  }
  cmd_params.set("fixamo_quiet", new Map([]));
  async function fixamo_quiet() {
    logger12.debug("shimming excmd fixamo_quiet from content to background");
    return message("excmd_background", "fixamo_quiet");
  }
  cmd_params.set("fixamo", new Map([]));
  async function fixamo() {
    logger12.debug("shimming excmd fixamo from content to background");
    return message("excmd_background", "fixamo");
  }
  cmd_params.set("nativeopen", new Map([["...args", "string[]"]]));
  async function nativeopen(...args) {
    logger12.debug("shimming excmd nativeopen from content to background");
    return message("excmd_background", "nativeopen", ...args);
  }
  cmd_params.set("exclaim", new Map([["...str", "string[]"]]));
  async function exclaim(...str) {
    logger12.debug("shimming excmd exclaim from content to background");
    return message("excmd_background", "exclaim", ...str);
  }
  cmd_params.set("exclaim_quiet", new Map([["...str", "string[]"]]));
  async function exclaim_quiet(...str) {
    logger12.debug("shimming excmd exclaim_quiet from content to background");
    return message("excmd_background", "exclaim_quiet", ...str);
  }
  cmd_params.set("native", new Map([]));
  async function native() {
    logger12.debug("shimming excmd native from content to background");
    return message("excmd_background", "native");
  }
  cmd_params.set("nativeinstall", new Map([]));
  async function nativeinstall() {
    logger12.debug("shimming excmd nativeinstall from content to background");
    return message("excmd_background", "nativeinstall");
  }
  cmd_params.set("mktridactylrc", new Map([["...args", "string[]"]]));
  async function mktridactylrc(...args) {
    logger12.debug("shimming excmd mktridactylrc from content to background");
    return message("excmd_background", "mktridactylrc", ...args);
  }
  cmd_params.set("source", new Map([["...args", "string[]"]]));
  async function source(...args) {
    logger12.debug("shimming excmd source from content to background");
    return message("excmd_background", "source", ...args);
  }
  cmd_params.set("source_quiet", new Map([["...args", "string[]"]]));
  async function source_quiet(...args) {
    logger12.debug("shimming excmd source_quiet from content to background");
    return message("excmd_background", "source_quiet", ...args);
  }
  cmd_params.set("updatenative", new Map([["interactive", "boolean"]]));
  async function updatenative(interactive = true) {
    logger12.debug("shimming excmd updatenative from content to background");
    return message("excmd_background", "updatenative", interactive);
  }
  cmd_params.set("restart", new Map([]));
  async function restart() {
    logger12.debug("shimming excmd restart from content to background");
    return message("excmd_background", "restart");
  }
  cmd_params.set("saveas", new Map([["...args", "string[]"]]));
  async function saveas(...args) {
    let overwrite = false;
    let cleanup = false;
    const argParse = (args2) => {
      if (args2[0] === "--overwrite") {
        overwrite = true;
        args2.shift();
        argParse(args2);
      }
      if (args2[0] === "--cleanup") {
        cleanup = true;
        args2.shift();
        argParse(args2);
      }
      return args2;
    };
    const file = argParse(args).join(" ") || void 0;
    const requiredNativeMessengerVersion = "0.3.2";
    if ((overwrite || cleanup) && !await nativegate(requiredNativeMessengerVersion, false)) {
      throw new Error(`":saveas --{overwrite, cleanup}" requires native ${requiredNativeMessengerVersion} or later`);
    }
    if (args.length > 0) {
      const filename = await message("download_background", "downloadUrlAs", window.location.href, file, overwrite, cleanup);
      return fillcmdline_tmp(1e4, `Download completed: ${filename} stored in ${file}`);
    } else {
      return message("download_background", "downloadUrl", window.location.href, true);
    }
  }
  var JUMPED;
  var JUMP_TIMEOUTID;
  function getJumpPageId() {
    return document.location.href;
  }
  async function saveJumps(jumps) {
    return browserBg.sessions.setTabValue(await activeTabId(), "jumps", jumps);
  }
  async function curJumps() {
    const tabid = await activeTabId();
    let jumps = await browserBg.sessions.getTabValue(tabid, "jumps");
    if (!jumps)
      jumps = {};
    const ensure = (obj, key, def) => {
      if (obj[key] === null || obj[key] === void 0)
        obj[key] = def;
    };
    const page = getJumpPageId();
    ensure(jumps, page, {});
    ensure(jumps[page], "list", [{ x: window.scrollX, y: window.scrollY }]);
    ensure(jumps[page], "cur", 0);
    saveJumps(jumps);
    return jumps;
  }
  cmd_params.set("jumpnext", new Map([["n", "number"]]));
  function jumpnext(n = 1) {
    return jumpprev(-n);
  }
  cmd_params.set("jumpprev", new Map([["n", "number"]]));
  function jumpprev(n = 1) {
    return curJumps().then((alljumps) => {
      const jumps = alljumps[getJumpPageId()];
      const current = jumps.cur - n;
      if (current < 0) {
        jumps.cur = 0;
        saveJumps(alljumps);
        return back(-current);
      } else if (current >= jumps.list.length) {
        jumps.cur = jumps.list.length - 1;
        saveJumps(alljumps);
        return forward(current - jumps.list.length + 1);
      }
      jumps.cur = current;
      const p = jumps.list[jumps.cur];
      saveJumps(alljumps);
      JUMPED = true;
      window.scrollTo(p.x, p.y);
    });
  }
  function addJump() {
    if (JUMPED) {
      JUMPED = false;
      return;
    }
    const { scrollX, scrollY } = window;
    clearTimeout(JUMP_TIMEOUTID);
    const localTimeoutID = window.setTimeout(async () => {
      const alljumps = await curJumps();
      if (localTimeoutID !== JUMP_TIMEOUTID)
        return;
      const jumps = alljumps[getJumpPageId()];
      const list = jumps.list;
      if (list[jumps.cur].x === scrollX && list[jumps.cur].y === scrollY)
        return;
      list.push({ x: scrollX, y: scrollY });
      jumps.cur = jumps.list.length - 1;
      saveJumps(alljumps);
    }, get("jumpdelay"));
    JUMP_TIMEOUTID = localTimeoutID;
  }
  document.addEventListener("scroll", addJump, { passive: true });
  document.addEventListener("load", () => curJumps().then(() => jumpprev(0)));
  cmd_params.set("unfocus", new Map([]));
  function unfocus() {
    ;
    (document.activeElement.shadowRoot ? deepestShadowRoot(document.activeElement.shadowRoot) : document).activeElement.blur();
    contentState.mode = "normal";
  }
  cmd_params.set("scrollpx", new Map([["a", "number"], ["b", "number"]]));
  async function scrollpx(a, b) {
    let done = Promise.resolve(void 0);
    if (!await scroll(a, b, document.documentElement)) {
      done = recursiveScroll(a, b);
    }
    return done.then(() => void 0);
  }
  cmd_params.set("scrollto", new Map([["a", "number | string"], ["b", 'number | "x" | "y" = "y"']]));
  function scrollto(a, b = "y") {
    if (typeof a === "string" && /c$/i.exec(a)) {
      a = Number(a.replace(/c$/, "")) * 100 / (2 * Math.PI);
    }
    a = Number(a);
    const elem = window.document.scrollingElement || window.document.documentElement;
    const percentage = a.clamp(0, 100);
    let done = Promise.resolve(void 0);
    if (b === "y") {
      const top = elem.getClientRects()[0].top;
      window.scrollTo(window.scrollX, percentage * elem.scrollHeight / 100);
      if (top === elem.getClientRects()[0].top && (percentage === 0 || percentage === 100)) {
        done = recursiveScroll(window.scrollX, 1073741824 * (percentage === 0 ? -1 : 1), document.documentElement);
      }
    } else if (b === "x") {
      const left = elem.getClientRects()[0].left;
      window.scrollTo(percentage * elem.scrollWidth / 100, window.scrollY);
      if (left === elem.getClientRects()[0].left && (percentage === 0 || percentage === 100)) {
        done = recursiveScroll(1073741824 * (percentage === 0 ? -1 : 1), window.scrollX, document.documentElement);
      }
    } else {
      window.scrollTo(a, Number(b));
    }
    return done.then(() => void 0);
  }
  var lineHeight = null;
  cmd_params.set("scrollline", new Map([["n", "number"], ["mult", "number"]]));
  function scrollline(n = 1, mult = 1) {
    n = mult * n;
    if (lineHeight === null) {
      const getLineHeight = (elem) => {
        const cssHeight = window.getComputedStyle(elem).getPropertyValue("line-height");
        return parseInt(cssHeight.substr(0, cssHeight.length - 2), 10);
      };
      lineHeight = getLineHeight(document.documentElement);
      if (!lineHeight)
        lineHeight = getLineHeight(document.body);
      if (!lineHeight)
        lineHeight = 22;
    }
    return recursiveScroll(0, lineHeight * n);
  }
  cmd_params.set("scrollpage", new Map([["n", "number"], ["count", "number"]]));
  function scrollpage(n = 1, count = 1) {
    return scrollpx(0, window.innerHeight * n * count);
  }
  cmd_params.set("find", new Map([["...args", "string[]"]]));
  function find3(...args) {
    const flagpos = args.indexOf("-?");
    const reverse2 = flagpos >= 0;
    if (reverse2)
      args.splice(flagpos, 1);
    const searchQuery = args.join(" ");
    return jumpToMatch(searchQuery, reverse2);
  }
  cmd_params.set("findnext", new Map([["n", "number"]]));
  function findnext(n = 1) {
    return jumpToNextMatch(n);
  }
  cmd_params.set("clearsearchhighlight", new Map([]));
  function clearsearchhighlight() {
    return removeHighlighting();
  }
  function history(n) {
    window.history.go(n);
  }
  cmd_params.set("forward", new Map([["n", "number"]]));
  function forward(n = 1) {
    history(n);
  }
  cmd_params.set("back", new Map([["n", "number"]]));
  function back(n = 1) {
    history(n * -1);
  }
  cmd_params.set("reload", new Map([["n", "number"], ["hard", "boolean"]]));
  async function reload(n = 1, hard = false) {
    logger12.debug("shimming excmd reload from content to background");
    return message("excmd_background", "reload", n, hard);
  }
  cmd_params.set("reloadall", new Map([["hard", "boolean"]]));
  async function reloadall(hard = false) {
    logger12.debug("shimming excmd reloadall from content to background");
    return message("excmd_background", "reloadall", hard);
  }
  cmd_params.set("reloadallbut", new Map([["hard", "boolean"]]));
  async function reloadallbut(hard = false) {
    logger12.debug("shimming excmd reloadallbut from content to background");
    return message("excmd_background", "reloadallbut", hard);
  }
  cmd_params.set("reloaddead", new Map([["hard", "boolean"]]));
  async function reloaddead(hard = false) {
    logger12.debug("shimming excmd reloaddead from content to background");
    return message("excmd_background", "reloaddead", hard);
  }
  cmd_params.set("reloadhard", new Map([["n", "number"]]));
  async function reloadhard(n = 1) {
    logger12.debug("shimming excmd reloadhard from content to background");
    return message("excmd_background", "reloadhard", n);
  }
  var ABOUT_WHITELIST = ["about:license", "about:logo", "about:rights", "about:blank"];
  cmd_params.set("open", new Map([["...urlarr", "string[]"]]));
  var _a;
  async function open(...urlarr) {
    const url = urlarr.join(" ");
    if (!ABOUT_WHITELIST.includes(url) && /^(about|file):.*/.exec(url)) {
      return nativeopen(url);
    } else if (/^javascript:/.exec(url)) {
      const bookmarklet = url.replace(/^javascript:/, "");
      document.body.append(html(_a || (_a = __template(["\n                <script>\n                    ", "\n                <\/script>\n            "])), bookmarklet));
    } else {
      const tab2 = await ownTab();
      return openInTab(tab2, {}, urlarr);
    }
  }
  cmd_params.set("bmarks", new Map([["opt", "string"], ["...urlarr", "string[]"]]));
  async function bmarks(opt, ...urlarr) {
    logger12.debug("shimming excmd bmarks from content to background");
    return message("excmd_background", "bmarks", opt, ...urlarr);
  }
  cmd_params.set("open_quiet", new Map([["...urlarr", "string[]"]]));
  async function open_quiet(...urlarr) {
    const url = urlarr.join(" ");
    if (!ABOUT_WHITELIST.includes(url) && /^(about|file):.*/.exec(url)) {
      return nativeopen(url);
    }
    return ownTab().then((tab2) => openInTab(tab2, { loadReplace: true }, urlarr));
  }
  cmd_params.set("url2args", new Map([]));
  async function url2args() {
    const url = document.location.href;
    const searchurls = await getAsync("searchurls");
    let result = url;
    for (const engine of Object.keys(searchurls)) {
      const [beginning, end] = [...searchurls[engine].split("%s"), ""];
      if (url.startsWith(beginning) && url.endsWith(end)) {
        let encodedArgs = url.substring(beginning.length);
        encodedArgs = encodedArgs.substring(0, encodedArgs.length - end.length);
        const amperpos = encodedArgs.search("&");
        if (amperpos > 0)
          encodedArgs = encodedArgs.substring(0, amperpos);
        if (beginning.search("duckduckgo") > 0)
          encodedArgs = encodedArgs.replace(/\+/g, " ");
        else if (beginning.search("wikipedia") > 0)
          encodedArgs = encodedArgs.replace(/_/g, " ");
        const args = engine + " " + decodeURIComponent(encodedArgs);
        if (args.length < result.length)
          result = args;
      }
    }
    return result;
  }
  var sourceElement;
  function removeSource() {
    if (sourceElement) {
      sourceElement.remove();
      sourceElement = void 0;
    }
  }
  cmd_params.set("viewsource", new Map([["url", "string"]]));
  function viewsource(url = "") {
    if (url === "")
      url = window.location.href;
    if (get("viewsource") === "default") {
      window.location.href = "view-source:" + url;
      return;
    }
    if (!sourceElement) {
      sourceElement = executeWithoutCommandLine(() => {
        const pre = document.createElement("pre");
        pre.id = "TridactylViewsourceElement";
        pre.className = "cleanslate " + get("theme");
        pre.innerText = document.documentElement.innerHTML;
        document.documentElement.appendChild(pre);
        window.addEventListener("popstate", removeSource);
        return pre;
      });
    } else {
      sourceElement.parentNode.removeChild(sourceElement);
      sourceElement = void 0;
      window.removeEventListener("popstate", removeSource);
    }
  }
  cmd_params.set("home", new Map([["all", '"false" | "true" = "false"']]));
  function home(all2 = "false") {
    logger12.debug("shimming excmd home from content to background");
    return message("excmd_background", "home", all2);
  }
  cmd_params.set("help", new Map([["...helpItems", "string[]"]]));
  async function help(...helpItems) {
    logger12.debug("shimming excmd help from content to background");
    return message("excmd_background", "help", ...helpItems);
  }
  cmd_params.set("apropos", new Map([["...helpItems", "string[]"]]));
  async function apropos(...helpItems) {
    logger12.debug("shimming excmd apropos from content to background");
    return message("excmd_background", "apropos", ...helpItems);
  }
  cmd_params.set("tutor", new Map([["newtab", "string"]]));
  async function tutor(newtab) {
    logger12.debug("shimming excmd tutor from content to background");
    return message("excmd_background", "tutor", newtab);
  }
  cmd_params.set("credits", new Map([]));
  async function credits() {
    logger12.debug("shimming excmd credits from content to background");
    return message("excmd_background", "credits");
  }
  cmd_params.set("no_mouse_mode", new Map([]));
  function no_mouse_mode() {
    no_mouse();
  }
  cmd_params.set("neo_mouse_mode", new Map([]));
  function neo_mouse_mode() {
    jack_in();
  }
  cmd_params.set("snow_mouse_mode", new Map([]));
  function snow_mouse_mode() {
    snow();
  }
  cmd_params.set("pied_piper_mouse_mode", new Map([]));
  function pied_piper_mouse_mode() {
    music();
  }
  cmd_params.set("drawingstart", new Map([]));
  function drawingstart() {
    drawable();
  }
  cmd_params.set("drawingerasertoggle", new Map([]));
  function drawingerasertoggle() {
    eraser_toggle();
  }
  cmd_params.set("mouse_mode", new Map([]));
  function mouse_mode() {
    removeBlock();
  }
  function findRelLink(pattern) {
    const links = Array.from(document.querySelectorAll("a[href]"));
    return links.reverse().find((link) => pattern.test(link.innerText));
  }
  function selectLast(selector) {
    const nodes = document.querySelectorAll(selector);
    return nodes.length ? nodes[nodes.length - 1] : null;
  }
  cmd_params.set("followpage", new Map([["rel", '"next" | "prev" = "next"']]));
  function followpage(rel = "next") {
    const link = selectLast(`link[rel~=${rel}][href]`);
    if (link) {
      window.location.href = link.href;
      return;
    }
    const anchor = selectLast(`a[rel~=${rel}][href]`) || findRelLink(new RegExp(get("followpagepatterns", rel), "i"));
    if (anchor) {
      mouseEvent(anchor, "click");
    } else {
      urlincrement(rel === "next" ? 1 : -1);
    }
  }
  cmd_params.set("urlincrement", new Map([["count", "number"], ["multiplier", "number"]]));
  function urlincrement(count = 1, multiplier = 1) {
    const newUrl = incrementUrl(window.location.href, count * multiplier);
    if (newUrl !== null) {
      try {
        window.location.href = newUrl;
      } catch (e) {
        logger12.info(`urlincrement: Impossible to navigate to ${newUrl}`);
      }
    }
  }
  cmd_params.set("urlroot", new Map([]));
  function urlroot() {
    const rootUrl = getUrlRoot(window.location);
    if (rootUrl !== null) {
      window.location.href = rootUrl.href;
    }
  }
  cmd_params.set("urlparent", new Map([["count", "number"]]));
  function urlparent(count = 1) {
    const trailingSlash = get("urlparenttrailingslash") === "true";
    const parentUrl = getUrlParent(window.location, trailingSlash, count);
    if (parentUrl !== null) {
      window.location.href = parentUrl.href;
    }
  }
  cmd_params.set("urlmodify", new Map([["mode", '"-t" | "-r" | "-s" | "-q" | "-Q" | "-g" | "-tu" | "-ru" | "-su" | "-qu" | "-Qu" | "-gu"'], ["...args", "string[]"]]));
  function urlmodify(mode2, ...args) {
    const newUrl = urlmodify_js(mode2, ...args);
    if (newUrl && newUrl !== window.location.href) {
      window.location.replace(newUrl);
    }
  }
  cmd_params.set("urlmodify_js", new Map([["mode", '"-t" | "-r" | "-s" | "-q" | "-Q" | "-g" | "-tu" | "-ru" | "-su" | "-qu" | "-Qu" | "-gu"'], ["...args", "string[]"]]));
  function urlmodify_js(mode2, ...args) {
    let oldUrl;
    let newmode;
    if (mode2.slice(-1) == "u") {
      oldUrl = new URL(args.pop());
      newmode = mode2.slice(0, -1);
    } else {
      oldUrl = new URL(window.location.href);
      newmode = mode2;
    }
    let newUrl;
    switch (newmode) {
      case "-t":
        if (args.length !== 2) {
          throw new Error("Text replacement needs 2 arguments:<old> <new>");
        }
        newUrl = oldUrl.href.replace(args[0], args[1]);
        break;
      case "-r":
        if (args.length < 2 || args.length > 3) {
          throw new Error("RegExp replacement takes 2 or 3 arguments: <regexp> <new> [flags]");
        }
        if (args[2] && args[2].search(/^[gi]+$/) === -1) {
          throw new Error("RegExp replacement flags can only include 'g', 'i', Got '" + args[2] + "'");
        }
        const regexp = new RegExp(args[0], args[2]);
        newUrl = oldUrl.href.replace(regexp, args[1]);
        break;
      case "-s":
        if (args.length !== 2) {
          throw new Error("Query setting needs 2 arguments:<query> <value>");
        }
        newUrl = setQueryValue(oldUrl, args[0], args[1]);
        break;
      case "-q":
        if (args.length !== 2) {
          throw new Error("Query replacement needs 2 arguments:<query> <new_val>");
        }
        newUrl = replaceQueryValue(oldUrl, args[0], args[1]);
        break;
      case "-Q":
        if (args.length !== 1) {
          throw new Error("Query deletion needs 1 argument:<query>");
        }
        newUrl = deleteQuery(oldUrl, args[0]);
        break;
      case "-g":
        if (args.length !== 2) {
          throw new Error("URL path grafting needs 2 arguments:<graft point> <new path tail>");
        }
        newUrl = graftUrlPath(oldUrl, args[1], Number(args[0]));
        break;
    }
    return newUrl;
  }
  cmd_params.set("geturlsforlinks", new Map([["reltype", "string"], ["rel", "string"]]));
  async function geturlsforlinks(reltype = "rel", rel) {
    const elems = document.querySelectorAll("link[" + reltype + "='" + rel + "']");
    if (elems)
      return Array.prototype.map.call(elems, (x) => x.href);
    return [];
  }
  cmd_params.set("zoom", new Map([["level", "number"], ["rel", "string"], ["tabId", "string"]]));
  async function zoom(level = 0, rel = "false", tabId = "auto") {
    logger12.debug("shimming excmd zoom from content to background");
    return message("excmd_background", "zoom", level, rel, tabId);
  }
  cmd_params.set("reader", new Map([]));
  async function reader() {
    logger12.debug("shimming excmd reader from content to background");
    return message("excmd_background", "reader");
  }
  loadaucmds("DocStart");
  var autocmd_logger = new Logger("autocmds");
  window.addEventListener("pagehide", () => loadaucmds("DocEnd"));
  window.addEventListener("DOMContentLoaded", () => loadaucmds("DocLoad"));
  getAsync("autocmds", "UriChange").then((ausites) => {
    if (!ausites)
      return;
    const aukeyarr = Object.keys(ausites).filter((e) => window.document.location.href.search(e) >= 0);
    if (aukeyarr.length > 0) {
      let maybeLoad = function() {
        const nowUri = window.document.location.href;
        if (nowUri != currUri) {
          currUri = nowUri;
          loadaucmds("UriChange");
        }
      };
      let currUri = window.document.location.href;
      setInterval(maybeLoad, 100);
    }
  });
  var fullscreenhandler = () => {
    loadaucmds("FullscreenChange");
    if (document.fullscreenElement || document.mozFullScreenElement) {
      loadaucmds("FullscreenEnter");
    } else {
      loadaucmds("FullscreenLeft");
    }
  };
  var fullscreenApiIsPrefixed = "mozFullScreenEnabled" in document;
  if (fullscreenApiIsPrefixed) {
    document.addEventListener("mozfullscreenchange", fullscreenhandler);
  } else if ("fullscreenEnabled" in document) {
    document.addEventListener("fullscreenchange", fullscreenhandler);
  }
  cmd_params.set("loadaucmds", new Map([["cmdType", '"DocStart" | "DocLoad" | "DocEnd" | "TabEnter" | "TabLeft" | "FullscreenEnter" | "FullscreenLeft" | "FullscreenChange" | "UriChange"']]));
  async function loadaucmds(cmdType) {
    const aucmds = await getAsync("autocmds", cmdType);
    const ausites = Object.keys(aucmds);
    const aukeyarr = ausites.filter((e) => window.document.location.href.search(e) >= 0);
    const owntab = await ownTab();
    const replacements = {
      TRI_FIRED_MOZ_TABID: owntab.id,
      TRI_FIRED_TRI_TABINDEX: owntab.index + 1,
      TRI_FIRED_MOZ_WINID: owntab.windowId,
      TRI_FIRED_TRI_WININDEX: await ownWinTriIndex(),
      TRI_FIRED_MOZ_OPENERTABID: owntab.openerTabId,
      TRI_FIRED_ACTIVE: owntab.active,
      TRI_FIRED_AUDIBLE: owntab.audible,
      TRI_FIRED_MUTED: owntab.mutedInfo.muted,
      TRI_FIRED_DISCARDED: owntab.discarded,
      TRI_FIRED_HEIGHT: owntab.height,
      TRI_FIRED_WIDTH: owntab.width,
      TRI_FIRED_HIDDEN: owntab.hidden,
      TRI_FIRED_INCOGNITO: owntab.incognito,
      TRI_FIRED_ISARTICLE: owntab.isArticle,
      TRI_FIRED_LASTACCESSED: owntab.lastAccessed,
      TRI_FIRED_PINNED: owntab.pinned,
      TRI_FIRED_TITLE: owntab.title,
      TRI_FIRED_URL: owntab.url
    };
    for (const aukey of aukeyarr) {
      for (const [k, v] of Object.entries(replacements)) {
        aucmds[aukey] = aucmds[aukey].replace(k, v);
      }
      try {
        autocmd_logger.debug(`${cmdType} matched ${aukey}: ${aucmds[aukey]}`);
        await acceptExCmd(aucmds[aukey]);
      } catch (e) {
        autocmd_logger.error(e.toString());
      }
    }
  }
  var INPUTTAGS_selectors = `
input:not([disabled]):not([readonly]):-moz-any(
 :not([type]),
 [type='text'],
 [type='search'],
 [type='password'],
 [type='datetime'],
 [type='datetime-local'],
 [type='date'],
 [type='month'],
 [type='time'],
 [type='week'],
 [type='number'],
 [type='range'],
 [type='email'],
 [type='url'],
 [type='tel'],
 [type='color']
),
textarea:not([disabled]):not([readonly]),
object,
[role='application'],
[contenteditable='true'][role='textbox']
`;
  var INPUTPASSWORD_selectors = `
input[type='password']
`;
  cmd_params.set("focusinput", new Map([["nth", "number | string"]]));
  function focusinput(nth2) {
    let inputToFocus = null;
    let fallbackToNumeric = true;
    if (nth2 === "-l") {
      if (getLastUsedInput()) {
        inputToFocus = getLastUsedInput();
      } else {
        inputToFocus = getElemsBySelector(INPUTTAGS_selectors, [isSubstantial])[0];
      }
    } else if (nth2 === "-n" || nth2 === "-N") {
      const inputs = getElemsBySelector(INPUTTAGS_selectors, [isSubstantial]);
      if (inputs.length) {
        let index = inputs.indexOf(getLastUsedInput());
        if (getLastUsedInput()) {
          if (nth2 === "-n") {
            index++;
          } else {
            index--;
          }
          index = index.mod(inputs.length);
        } else {
          index = 0;
        }
        inputToFocus = inputs[index];
      }
    } else if (nth2 === "-p") {
      fallbackToNumeric = false;
      const inputs = getElemsBySelector(INPUTPASSWORD_selectors, [isSubstantial]);
      if (inputs.length) {
        inputToFocus = inputs[0];
      }
    } else if (nth2 === "-b") {
      const inputs = getElemsBySelector(INPUTTAGS_selectors, [isSubstantial]);
      inputs.sort(compareElementArea);
      inputToFocus = inputs[inputs.length - 1];
    }
    if ((!inputToFocus || !document.contains(inputToFocus)) && fallbackToNumeric) {
      const index = isNaN(nth2) ? 0 : nth2;
      inputToFocus = getNthElement(INPUTTAGS_selectors, index, [isSubstantial]);
    }
    if (inputToFocus) {
      focus(inputToFocus);
      if (get("gimode") === "nextinput" && contentState.mode !== "input") {
        contentState.mode = "input";
      }
    }
  }
  cmd_params.set("changelistjump", new Map([]));
  async function changelistjump() {
    logger12.debug("shimming excmd changelistjump from content to background");
    return message("excmd_background", "changelistjump");
  }
  cmd_params.set("focusbyid", new Map([["id", "string"]]));
  function focusbyid(id2) {
    document.getElementById(id2).focus();
  }
  cmd_params.set("tabnext", new Map([["increment", "number"]]));
  async function tabnext(increment = 1) {
    logger12.debug("shimming excmd tabnext from content to background");
    return message("excmd_background", "tabnext", increment);
  }
  cmd_params.set("tabnext_gt", new Map([["index", "number"]]));
  async function tabnext_gt(index) {
    logger12.debug("shimming excmd tabnext_gt from content to background");
    return message("excmd_background", "tabnext_gt", index);
  }
  cmd_params.set("tabprev", new Map([["increment", "number"]]));
  async function tabprev(increment = 1) {
    logger12.debug("shimming excmd tabprev from content to background");
    return message("excmd_background", "tabprev", increment);
  }
  cmd_params.set("tabpush", new Map([["windowId", "number"]]));
  async function tabpush(windowId) {
    logger12.debug("shimming excmd tabpush from content to background");
    return message("excmd_background", "tabpush", windowId);
  }
  cmd_params.set("tabaudio", new Map([]));
  async function tabaudio() {
    logger12.debug("shimming excmd tabaudio from content to background");
    return message("excmd_background", "tabaudio");
  }
  cmd_params.set("winmerge", new Map([["...windowIds", "string[]"]]));
  async function winmerge(...windowIds) {
    logger12.debug("shimming excmd winmerge from content to background");
    return message("excmd_background", "winmerge", ...windowIds);
  }
  cmd_params.set("tabgrab", new Map([["id", "string"]]));
  async function tabgrab(id2) {
    logger12.debug("shimming excmd tabgrab from content to background");
    return message("excmd_background", "tabgrab", id2);
  }
  cmd_params.set("tabopen", new Map([["...addressarr", "string[]"]]));
  async function tabopen(...addressarr) {
    logger12.debug("shimming excmd tabopen from content to background");
    return message("excmd_background", "tabopen", ...addressarr);
  }
  cmd_params.set("tabqueue", new Map([["...addresses", "string[]"]]));
  function tabqueue(...addresses) {
    logger12.debug("shimming excmd tabqueue from content to background");
    return message("excmd_background", "tabqueue", ...addresses);
  }
  cmd_params.set("tabonly", new Map([]));
  async function tabonly() {
    logger12.debug("shimming excmd tabonly from content to background");
    return message("excmd_background", "tabonly");
  }
  cmd_params.set("tabduplicate", new Map([["index", "number"]]));
  async function tabduplicate(index) {
    logger12.debug("shimming excmd tabduplicate from content to background");
    return message("excmd_background", "tabduplicate", index);
  }
  cmd_params.set("tabdetach", new Map([["index", "number"]]));
  async function tabdetach(index) {
    logger12.debug("shimming excmd tabdetach from content to background");
    return message("excmd_background", "tabdetach", index);
  }
  cmd_params.set("fullscreen", new Map([]));
  async function fullscreen() {
    logger12.debug("shimming excmd fullscreen from content to background");
    return message("excmd_background", "fullscreen");
  }
  cmd_params.set("tabclose", new Map([["...indexes", "string[]"]]));
  async function tabclose(...indexes) {
    logger12.debug("shimming excmd tabclose from content to background");
    return message("excmd_background", "tabclose", ...indexes);
  }
  cmd_params.set("tabcloseallto", new Map([["side", "string"]]));
  async function tabcloseallto(side) {
    logger12.debug("shimming excmd tabcloseallto from content to background");
    return message("excmd_background", "tabcloseallto", side);
  }
  cmd_params.set("undo", new Map([["item", "string"]]));
  async function undo(item = "recent") {
    logger12.debug("shimming excmd undo from content to background");
    return message("excmd_background", "undo", item);
  }
  cmd_params.set("tabmove", new Map([["index", "string"]]));
  async function tabmove(index = "$") {
    logger12.debug("shimming excmd tabmove from content to background");
    return message("excmd_background", "tabmove", index);
  }
  cmd_params.set("tabsort", new Map([["...callbackchunks", "string[]"]]));
  async function tabsort(...callbackchunks) {
    logger12.debug("shimming excmd tabsort from content to background");
    return message("excmd_background", "tabsort", ...callbackchunks);
  }
  cmd_params.set("pin", new Map([]));
  async function pin() {
    logger12.debug("shimming excmd pin from content to background");
    return message("excmd_background", "pin");
  }
  cmd_params.set("mute", new Map([["...muteArgs", "string[]"]]));
  async function mute(...muteArgs) {
    logger12.debug("shimming excmd mute from content to background");
    return message("excmd_background", "mute", ...muteArgs);
  }
  cmd_params.set("winopen", new Map([["...args", "string[]"]]));
  async function winopen(...args) {
    logger12.debug("shimming excmd winopen from content to background");
    return message("excmd_background", "winopen", ...args);
  }
  cmd_params.set("winclose", new Map([["...ids", "string[]"]]));
  async function winclose(...ids) {
    logger12.debug("shimming excmd winclose from content to background");
    return message("excmd_background", "winclose", ...ids);
  }
  cmd_params.set("qall", new Map([]));
  async function qall() {
    logger12.debug("shimming excmd qall from content to background");
    return message("excmd_background", "qall");
  }
  cmd_params.set("containerclose", new Map([["name", "string"]]));
  async function containerclose(name) {
    logger12.debug("shimming excmd containerclose from content to background");
    return message("excmd_background", "containerclose", name);
  }
  cmd_params.set("containercreate", new Map([["name", "string"], ["color", "string"], ["icon", "string"]]));
  async function containercreate(name, color, icon) {
    logger12.debug("shimming excmd containercreate from content to background");
    return message("excmd_background", "containercreate", name, color, icon);
  }
  cmd_params.set("containerdelete", new Map([["name", "string"]]));
  async function containerdelete(name) {
    logger12.debug("shimming excmd containerdelete from content to background");
    return message("excmd_background", "containerdelete", name);
  }
  cmd_params.set("containerupdate", new Map([["name", "string"], ["uname", "string"], ["ucolor", "string"], ["uicon", "string"]]));
  async function containerupdate(name, uname, ucolor, uicon) {
    logger12.debug("shimming excmd containerupdate from content to background");
    return message("excmd_background", "containerupdate", name, uname, ucolor, uicon);
  }
  cmd_params.set("viewcontainers", new Map([]));
  async function viewcontainers() {
    const containers = await browserBg.contextualIdentities.query({});
    jsonview(JSON.stringify(containers));
  }
  cmd_params.set("recontain", new Map([["containerName", "string"]]));
  async function recontain(containerName) {
    logger12.debug("shimming excmd recontain from content to background");
    return message("excmd_background", "recontain", containerName);
  }
  cmd_params.set("version", new Map([]));
  function version() {
    logger12.debug("shimming excmd version from content to background");
    return message("excmd_background", "version");
  }
  cmd_params.set("mode", new Map([["mode", "ModeName"]]));
  function mode(mode2) {
    if (mode2 === "hint") {
      hint();
    } else {
      contentState.mode = mode2;
    }
  }
  cmd_params.set("repeat", new Map([["n", "number"], ["...exstr", "string[]"]]));
  async function repeat2(n = 1, ...exstr) {
    logger12.debug("shimming excmd repeat from content to background");
    return message("excmd_background", "repeat", n, ...exstr);
  }
  cmd_params.set("composite", new Map([["...cmds", "string[]"]]));
  async function composite(...cmds) {
    try {
      return cmds.join(" ").split(";").reduce(async (prev_pipeline, cmd) => {
        await prev_pipeline;
        const cmds2 = cmd.split("|");
        const [fn, args] = parser(cmds2[0], ALL_EXCMDS);
        const first_value = fn.call({}, ...args);
        return cmds2.slice(1).reduce(async (pipedValue, cmd2) => {
          const [fn2, args2] = parser(cmd2, ALL_EXCMDS);
          return fn2.call({}, ...args2, await pipedValue);
        }, first_value);
      }, null);
    } catch (e) {
      logger12.error(e);
    }
  }
  async function shellescape(...quoteme) {
    const str = quoteme.join(" ");
    const os = (await browserBg.runtime.getPlatformInfo()).os;
    if (os === "win") {
      return windows_cmd(str);
    } else {
      return sh(str);
    }
  }
  cmd_params.set("escapehatch", new Map([]));
  async function escapehatch() {
    logger12.debug("shimming excmd escapehatch from content to background");
    return message("excmd_background", "escapehatch");
  }
  cmd_params.set("sleep", new Map([["time_ms", "number"]]));
  function sleep3(time_ms) {
    return new Promise((resolve) => setTimeout(resolve, time_ms));
  }
  cmd_params.set("showcmdline", new Map([["focus", "boolean"]]));
  function showcmdline(focus3 = true) {
    const hidehover = true;
    show(hidehover);
    let done = Promise.resolve();
    if (focus3) {
      focus2();
      done = messageOwnTab("commandline_frame", "focus");
    }
    return done;
  }
  cmd_params.set("hidecmdline", new Map([]));
  function hidecmdline() {
    hide_and_blur();
  }
  cmd_params.set("fillcmdline", new Map([["...strarr", "string[]"]]));
  function fillcmdline(...strarr) {
    const str = strarr.join(" ");
    showcmdline();
    return messageOwnTab("commandline_frame", "fillcmdline", [str]);
  }
  cmd_params.set("fillcmdline_notrail", new Map([["...strarr", "string[]"]]));
  function fillcmdline_notrail(...strarr) {
    const str = strarr.join(" ");
    showcmdline();
    return messageOwnTab("commandline_frame", "fillcmdline", [str, false]);
  }
  cmd_params.set("fillcmdline_nofocus", new Map([["...strarr", "string[]"]]));
  function fillcmdline_nofocus(...strarr) {
    showcmdline(false);
    return messageOwnTab("commandline_frame", "fillcmdline", [strarr.join(" "), false, false]);
  }
  cmd_params.set("fillcmdline_tmp", new Map([["ms", "number"], ["...strarr", "string[]"]]));
  async function fillcmdline_tmp(ms, ...strarr) {
    const str = strarr.join(" ");
    showcmdline(false);
    messageOwnTab("commandline_frame", "fillcmdline", [strarr.join(" "), false, false]);
    return new Promise((resolve) => setTimeout(async () => {
      if (await messageOwnTab("commandline_frame", "getContent", []) === str) {
        hide_and_blur();
        resolve(messageOwnTab("commandline_frame", "clear", [true]));
      }
      resolve();
    }, ms));
  }
  cmd_params.set("yank", new Map([["...content", "string[]"]]));
  function yank(...content) {
    logger12.debug("shimming excmd yank from content to background");
    return message("excmd_background", "yank", ...content);
  }
  cmd_params.set("getclip", new Map([["from", '"clipboard" | "selection"']]));
  async function getclip(from) {
    logger12.debug("shimming excmd getclip from content to background");
    return message("excmd_background", "getclip", from);
  }
  cmd_params.set("clipboard", new Map([["excmd", '"open" | "yank" | "yankshort" | "yankcanon" | "yanktitle" | "yankmd" | "yankorg" | "xselpaste" | "tabopen" = "open"'], ["...toYank", "string[]"]]));
  async function clipboard2(excmd = "open", ...toYank) {
    logger12.debug("shimming excmd clipboard from content to background");
    return message("excmd_background", "clipboard", excmd, ...toYank);
  }
  cmd_params.set("yankimage", new Map([["url", "string"]]));
  async function yankimage(url) {
    logger12.debug("shimming excmd yankimage from content to background");
    return message("excmd_background", "yankimage", url);
  }
  cmd_params.set("tab", new Map([["...id", "string[]"]]));
  async function tab(...id2) {
    logger12.debug("shimming excmd tab from content to background");
    return message("excmd_background", "tab", ...id2);
  }
  cmd_params.set("taball", new Map([["...id", "string[]"]]));
  async function taball(...id2) {
    logger12.debug("shimming excmd taball from content to background");
    return message("excmd_background", "taball", ...id2);
  }
  cmd_params.set("tab_helper", new Map([["interactive", "boolean"], ["anyWindow", "boolean"], ["...key", "string[]"]]));
  async function tab_helper(interactive, anyWindow, ...key) {
    logger12.debug("shimming excmd tab_helper from content to background");
    return message("excmd_background", "tab_helper", interactive, anyWindow, ...key);
  }
  cmd_params.set("command", new Map([["name", "string"], ["...definition", "string[]"]]));
  function command(name, ...definition) {
    logger12.debug("shimming excmd command from content to background");
    return message("excmd_background", "command", name, ...definition);
  }
  cmd_params.set("comclear", new Map([["name", "string"]]));
  function comclear(name) {
    logger12.debug("shimming excmd comclear from content to background");
    return message("excmd_background", "comclear", name);
  }
  cmd_params.set("bind", new Map([["...args", "string[]"]]));
  async function bind(...args) {
    logger12.debug("shimming excmd bind from content to background");
    return message("excmd_background", "bind", ...args);
  }
  cmd_params.set("bindurl", new Map([["pattern", "string"], ["mode", "string"], ["keys", "string"], ["...excmd", "string[]"]]));
  function bindurl(pattern, mode2, keys2, ...excmd) {
    logger12.debug("shimming excmd bindurl from content to background");
    return message("excmd_background", "bindurl", pattern, mode2, keys2, ...excmd);
  }
  cmd_params.set("keymap", new Map([["source", "string"], ["target", "string"]]));
  function keymap(source2, target) {
    logger12.debug("shimming excmd keymap from content to background");
    return message("excmd_background", "keymap", source2, target);
  }
  cmd_params.set("searchsetkeyword", new Map([]));
  function searchsetkeyword() {
    logger12.debug("shimming excmd searchsetkeyword from content to background");
    return message("excmd_background", "searchsetkeyword");
  }
  function validateSetArgs(key, values2) {
    const target = key.split(".");
    let value;
    const file = everything.getFile("src/lib/config.ts");
    const default_config2 = file.getClass("default_config");
    const md = default_config2.getMember(target[0]);
    if (md !== void 0) {
      const strval = values2.join(" ");
      if (md.type.kind === "object" && target.length > 1) {
        value = md.type.convertMember(target.slice(1), strval);
      } else {
        value = md.type.convert(strval);
      }
    } else {
      logger12.warning("Could not fetch setting metadata. Falling back to type of current value.");
      const currentValue = get(...target);
      if (Array.isArray(currentValue)) {
      } else if (currentValue === void 0 || typeof currentValue === "string") {
        value = values2.join(" ");
      } else {
        throw new Error("Unsupported setting type!");
      }
    }
    target.push(value);
    return target;
  }
  cmd_params.set("seturl", new Map([["pattern", "string"], ["key", "string"], ["...values", "string[]"]]));
  function seturl(pattern, key, ...values2) {
    if (values2.length === 0 && key) {
      values2 = [key];
      key = pattern;
      pattern = window.location.href;
    }
    if (!pattern || !key || !values2.length) {
      throw new Error("seturl syntax: [pattern] key value");
    }
    return setURL(pattern, ...validateSetArgs(key, values2));
  }
  cmd_params.set("set", new Map([["key", "string"], ["...values", "string[]"]]));
  function set3(key, ...values2) {
    logger12.debug("shimming excmd set from content to background");
    return message("excmd_background", "set", key, ...values2);
  }
  cmd_params.set("firefoxsyncpull", new Map([]));
  function firefoxsyncpull() {
    logger12.debug("shimming excmd firefoxsyncpull from content to background");
    return message("excmd_background", "firefoxsyncpull");
  }
  cmd_params.set("firefoxsyncpush", new Map([]));
  function firefoxsyncpush() {
    logger12.debug("shimming excmd firefoxsyncpush from content to background");
    return message("excmd_background", "firefoxsyncpush");
  }
  cmd_params.set("autocmd", new Map([["event", "string"], ["url", "string"], ["...excmd", "string[]"]]));
  function autocmd(event, url, ...excmd) {
    logger12.debug("shimming excmd autocmd from content to background");
    return message("excmd_background", "autocmd", event, url, ...excmd);
  }
  cmd_params.set("autocontain", new Map([["...args", "string[]"]]));
  function autocontain(...args) {
    logger12.debug("shimming excmd autocontain from content to background");
    return message("excmd_background", "autocontain", ...args);
  }
  cmd_params.set("autocmddelete", new Map([["event", "string"], ["url", "string"]]));
  function autocmddelete(event, url) {
    logger12.debug("shimming excmd autocmddelete from content to background");
    return message("excmd_background", "autocmddelete", event, url);
  }
  cmd_params.set("blacklistadd", new Map([["url", "string"]]));
  function blacklistadd(url) {
    logger12.debug("shimming excmd blacklistadd from content to background");
    return message("excmd_background", "blacklistadd", url);
  }
  cmd_params.set("unbind", new Map([["...args", "string[]"]]));
  async function unbind(...args) {
    logger12.debug("shimming excmd unbind from content to background");
    return message("excmd_background", "unbind", ...args);
  }
  cmd_params.set("unbindurl", new Map([["pattern", "string"], ["mode", "string"], ["keys", "string"]]));
  async function unbindurl(pattern, mode2, keys2) {
    logger12.debug("shimming excmd unbindurl from content to background");
    return message("excmd_background", "unbindurl", pattern, mode2, keys2);
  }
  cmd_params.set("reset", new Map([["mode", "string"], ["key", "string"]]));
  async function reset3(mode2, key) {
    logger12.debug("shimming excmd reset from content to background");
    return message("excmd_background", "reset", mode2, key);
  }
  cmd_params.set("reseturl", new Map([["pattern", "string"], ["mode", "string"], ["key", "string"]]));
  async function reseturl(pattern, mode2, key) {
    logger12.debug("shimming excmd reseturl from content to background");
    return message("excmd_background", "reseturl", pattern, mode2, key);
  }
  cmd_params.set("sanitise", new Map([["...args", "string[]"]]));
  async function sanitise(...args) {
    logger12.debug("shimming excmd sanitise from content to background");
    return message("excmd_background", "sanitise", ...args);
  }
  cmd_params.set("quickmark", new Map([["key", "string"], ["...addressarr", "string[]"]]));
  async function quickmark(key, ...addressarr) {
    logger12.debug("shimming excmd quickmark from content to background");
    return message("excmd_background", "quickmark", key, ...addressarr);
  }
  cmd_params.set("get", new Map([["...keys", "string[]"]]));
  function get2(...keys2) {
    logger12.debug("shimming excmd get from content to background");
    return message("excmd_background", "get", ...keys2);
  }
  cmd_params.set("viewconfig", new Map([["...key", "string[]"]]));
  function viewconfig(...key) {
    logger12.debug("shimming excmd viewconfig from content to background");
    return message("excmd_background", "viewconfig", ...key);
  }
  cmd_params.set("jsonview", new Map([["...json", "string[]"]]));
  async function jsonview(...json) {
    logger12.debug("shimming excmd jsonview from content to background");
    return message("excmd_background", "jsonview", ...json);
  }
  cmd_params.set("unseturl", new Map([["pattern", "string"], ["key", "string"]]));
  function unseturl(pattern, key) {
    if (!key) {
      key = pattern;
      pattern = window.location.href;
    }
    return unsetURL(pattern, key.split("."));
  }
  cmd_params.set("unset", new Map([["...keys", "string[]"]]));
  function unset2(...keys2) {
    logger12.debug("shimming excmd unset from content to background");
    return message("excmd_background", "unset", ...keys2);
  }
  cmd_params.set("setnull", new Map([["...keys", "string[]"]]));
  function setnull(...keys2) {
    logger12.debug("shimming excmd setnull from content to background");
    return message("excmd_background", "setnull", ...keys2);
  }
  var KILL_STACK = [];
  cmd_params.set("hint", new Map([["...args", "string[]"]]));
  async function hint(...args) {
    const config = HintConfig.parse(args);
    config.printWarnings(logger12);
    const hintTabOpen = async (href, active = !config.rapid) => {
      const containerId = await activeTabContainerId();
      if (containerId) {
        return openInNewTab(href, {
          active,
          related: true,
          cookieStoreId: containerId
        });
      } else {
        return openInNewTab(href, {
          active,
          related: true
        });
      }
    };
    return new Promise((resolve, reject) => {
      const hintables = config.hintables();
      const action = config.callback ? eval(config.callback) : (elem) => {
        if (config.pipeAttribute !== null) {
          return elem[config.pipeAttribute];
        }
        if (config.excmd) {
          if (elem.href) {
            run_exstr(config.excmd + " " + elem.href);
            return elem;
          }
          return;
        }
        switch (config.openMode) {
          case OpenMode.Highlight:
            const r = document.createRange();
            r.setStart(elem, 0);
            r.setEnd(elem, 1);
            const s = document.getSelection();
            s.addRange(r);
            return elem;
          case OpenMode.Images:
          case OpenMode.ImagesTab:
            const src = elem.getAttribute("src");
            if (src) {
              if (config.openMode === OpenMode.ImagesTab) {
                hintTabOpen(new URL(src, window.location.href).href);
              } else {
                open(new URL(src, window.location.href).href);
              }
              return elem;
            }
            return;
          case OpenMode.Kill:
            elem.remove();
            return elem;
          case OpenMode.KillTridactyl:
            elem.classList.add("TridactylKilledElem");
            return elem;
          case OpenMode.SaveResource:
          case OpenMode.SaveImage:
          case OpenMode.SaveAsResource:
          case OpenMode.SaveAsImage:
            const saveAs = config.openMode === OpenMode.SaveAsResource || config.openMode === OpenMode.SaveAsImage;
            const attr = config.openMode === OpenMode.SaveImage || config.openMode === OpenMode.SaveAsImage ? "src" : "href";
            message("download_background", "downloadUrl", new URL(elem[attr], window.location.href).href, saveAs);
            return elem;
          case OpenMode.Scroll:
            elem.scrollIntoView(true);
            return elem;
          case OpenMode.ScrollFocus:
            let tabindexAdded = false;
            if (elem instanceof HTMLImageElement && !elem.getAttribute("tabindex")) {
              elem.setAttribute("tabindex", "-1");
              tabindexAdded = true;
            }
            elem.focus();
            setCurrentFocus(elem);
            if (tabindexAdded)
              elem.removeAttribute("tabindex");
            return elem;
          case OpenMode.TTSRead:
            readText(elem.textContent);
            return elem;
          case OpenMode.YankAlt:
            return elem.title ? elem.title : elem.alt;
          case OpenMode.YankAnchor:
            const anchorUrl = new URL(window.location.href);
            anchorUrl.hash = elem.id || elem.name;
            return anchorUrl.href;
          case OpenMode.YankLink:
            if (elem.href) {
              return elem.href;
            }
            return;
          case OpenMode.YankText:
            return elem.textContent;
        }
        if (elem.href) {
          elem.focus();
          switch (config.openMode) {
            case OpenMode.Default:
              simulateClick(elem);
              break;
            case OpenMode.Tab:
              hintTabOpen(elem.href, true).catch(() => simulateClick(elem));
              break;
            case OpenMode.BackgroundTab:
              hintTabOpen(elem.href, false).catch(() => simulateClick(elem));
              break;
            case OpenMode.Window:
              openInNewWindow({ url: new URL(elem.href, window.location.href).href });
              break;
            case OpenMode.WindowPrivate:
              openInNewWindow({ url: elem.href, incognito: true });
              break;
          }
        } else {
          if (config.openMode === OpenMode.WindowPrivate) {
            return;
          } else {
            elem.focus();
            simulateClick(elem);
          }
        }
        return elem;
      };
      if (config.immediate) {
        const results = [];
        for (const elements of hintables) {
          for (const hintable of elements.elements) {
            try {
              results.push(action(hintable));
            } catch (error) {
              logger12.error(error);
            }
          }
        }
        resolve(results);
      } else {
        hintPage(hintables, action, resolve, reject, config.rapid);
      }
    }).then((value) => {
      if (config.isYank) {
        if (Array.isArray(value)) {
          yank(value.join("\n"));
        } else {
          yank(value);
        }
      }
      return value;
    });
  }
  cmd_params.set("rot13", new Map([["n", "number"]]));
  function rot132(n) {
    if (n === void 0)
      n = 13;
    const body = document.createTreeWalker(document.body, NodeFilter.SHOW_TEXT, { acceptNode: () => NodeFilter.FILTER_ACCEPT });
    while (body.nextNode()) {
      const t = body.currentNode.textContent;
      body.currentNode.textContent = rot13_helper(t, n);
    }
  }
  cmd_params.set("jumble", new Map([]));
  function jumble2() {
    const body = document.createTreeWalker(document.body, NodeFilter.SHOW_TEXT, { acceptNode: () => NodeFilter.FILTER_ACCEPT });
    while (body.nextNode()) {
      const t = body.currentNode.textContent;
      body.currentNode.textContent = jumble_helper(t);
    }
  }
  cmd_params.set("run_exstr", new Map([["...commands", "string[]"]]));
  function run_exstr(...commands) {
    return message("controller_background", "acceptExCmd", commands.join(""));
  }
  cmd_params.set("gobble", new Map([["nChars", "number"], ["endCmd", "string"]]));
  async function gobble(nChars, endCmd) {
    return init3(nChars, endCmd);
  }
  cmd_params.set("nmode", new Map([["mode", "string"], ["n", "number"], ["...endexArr", "string[]"]]));
  async function nmode2(mode2, n, ...endexArr) {
    const endex = endexArr.join(" ") || "mode ignore";
    return init4(endex, mode2, n);
  }
  function tssReadFromCss(selector) {
    const elems = getElemsBySelector(selector, []);
    elems.forEach((e) => {
      readText(e.textContent);
    });
  }
  cmd_params.set("ttsread", new Map([["mode", '"-t" | "-c"'], ["...args", "string[]"]]));
  async function ttsread(mode2, ...args) {
    if (mode2 === "-t") {
      readText(args.join(" "));
    } else if (mode2 === "-c") {
      if (args.length > 0) {
        tssReadFromCss(args[0]);
      } else {
        throw new Error("Error: no CSS selector supplied");
      }
    } else {
      throw new Error("Unknown mode for ttsread command: " + mode2);
    }
  }
  cmd_params.set("ttsvoices", new Map([]));
  async function ttsvoices() {
    logger12.debug("shimming excmd ttsvoices from content to background");
    return message("excmd_background", "ttsvoices");
  }
  cmd_params.set("ttscontrol", new Map([["action", "string"]]));
  async function ttscontrol(action) {
    if (action !== "stop") {
      throw new Error("Unknown text-to-speech action: " + action);
    }
    return doAction(action);
  }
  cmd_params.set("perfdump", new Map([["...filters", "string[]"]]));
  async function perfdump(...filters) {
    logger12.debug("shimming excmd perfdump from content to background");
    return message("excmd_background", "perfdump", ...filters);
  }
  cmd_params.set("perfhistogram", new Map([["...filters", "string[]"]]));
  async function perfhistogram(...filters) {
    logger12.debug("shimming excmd perfhistogram from content to background");
    return message("excmd_background", "perfhistogram", ...filters);
  }
  cmd_params.set("bmark", new Map([["url", "string"], ["...titlearr", "string[]"]]));
  async function bmark(url, ...titlearr) {
    logger12.debug("shimming excmd bmark from content to background");
    return message("excmd_background", "bmark", url, ...titlearr);
  }
  cmd_params.set("echo", new Map([["...str", "string[]"]]));
  function echo(...str) {
    logger12.debug("shimming excmd echo from content to background");
    return message("excmd_background", "echo", ...str);
  }
  async function js_helper(str) {
    let JS_ARG = null;
    let JS_ARGS = [];
    let jsContent = null;
    let doSource = false;
    let fromRC = false;
    let separator = null;
    while (true) {
      const flag = str[0];
      if (flag == "-p") {
        JS_ARG = str.pop();
        str.shift();
        continue;
      }
      if (flag == "-s") {
        doSource = true;
        str.shift();
        continue;
      }
      if (flag == "-r") {
        doSource = true;
        fromRC = true;
        str.shift();
        continue;
      }
      const match2 = /-d(.)/.exec(flag);
      if (match2 !== null) {
        separator = match2[1];
        str.shift();
        continue;
      }
      break;
    }
    if (separator !== null) {
      JS_ARGS = str.join(" ").split(separator)[1].split(" ");
      jsContent = str.join(" ").split(separator)[0];
    } else {
      jsContent = str.join(" ");
    }
    if (doSource) {
      let sourcePath = jsContent;
      if (fromRC) {
        const sep = "/";
        const rcPath = (await getrcpath("unix")).split(sep).slice(0, -1);
        sourcePath = [...rcPath, sourcePath].join(sep);
      }
      const file = await read(sourcePath);
      if (file.code !== 0)
        throw new Error("Couldn't read js file " + sourcePath);
      jsContent = file.content;
    }
    return eval(jsContent);
  }
  cmd_params.set("js", new Map([["...str", "string[]"]]));
  async function js(...str) {
    return js_helper(str);
  }
  cmd_params.set("jsb", new Map([["...str", "string[]"]]));
  async function jsb(...str) {
    logger12.debug("shimming excmd jsb from content to background");
    return message("excmd_background", "jsb", ...str);
  }
  cmd_params.set("issue", new Map([]));
  async function issue() {
    const newIssueUrl = "https://github.com/tridactyl/tridactyl/issues/new";
    if (window.location.href !== newIssueUrl) {
      return tabopen(newIssueUrl);
    }
    const textarea = document.getElementById("issue_body");
    if (!(textarea instanceof HTMLTextAreaElement)) {
      logger12.warning("issue(): Couldn't find textarea element in github issue page.");
      return;
    }
    let template = await fetch(browser.runtime.getURL("issue_template.md")).then((resp) => resp.body.getReader()).then((reader2) => reader2.read()).then((r) => new TextDecoder("utf-8").decode(r.value));
    if (textarea.value !== template) {
      logger12.debug("issue(): Textarea value differs from template, exiting early.");
      return;
    }
    const platform2 = await browserBg.runtime.getPlatformInfo();
    template = template.replace("*   Operating system:\n", "");
    template = `Operating system: ${platform2.os}
` + template;
    const info = await browserBg.runtime.getBrowserInfo();
    template = template.replace("*   Firefox version (Top right menu > Help > About Firefox):\n\n", "");
    template = `Firefox version: ${info.vendor} ${info.name} ${info.version}
` + template;
    template = template.replace("*   Tridactyl version (`:version`):\n\n", "");
    template = `Tridactyl version: ${TRI_VERSION}
` + template;
    textarea.value = template;
  }
  cmd_params.set("updatecheck", new Map([["source", '"manual" | "auto_polite" | "auto_impolite" = "manual"']]));
  async function updatecheck(source2 = "manual") {
    logger12.debug("shimming excmd updatecheck from content to background");
    return message("excmd_background", "updatecheck", source2);
  }
  cmd_params.set("keyfeed", new Map([["mapstr", "string"]]));
  async function keyfeed(mapstr) {
    const keyseq4 = mapstrToKeyseq(mapstr);
    for (const k of keyseq4) {
      generator.next(k);
      await sleep3(10);
    }
  }
  cmd_params.set("extoptions", new Map([["...optionNameArgs", "string[]"]]));
  async function extoptions(...optionNameArgs) {
    logger12.debug("shimming excmd extoptions from content to background");
    return message("excmd_background", "extoptions", ...optionNameArgs);
  }
  cmd_params.set("elementunhide", new Map([]));
  async function elementunhide() {
    const elem = KILL_STACK.pop();
    elem.className = elem.className.replace("TridactylKilledElem", "");
  }

  // src/content/commandline_cmds.ts
  var functions2 = getCommandlineFns({});
  var CmdlineCmds2 = new Proxy(functions2, {
    get(target, property) {
      if (target[property]) {
        return (...args) => messageOwnTab("commandline_cmd", property, args);
      }
      return target[property];
    }
  });

  // src/content/editor.ts
  var EditorCmds2 = new Proxy(editor_exports, {
    get(target, property) {
      if (target[property]) {
        return (...args) => {
          if (document.activeElement.src === browser.runtime.getURL("static/commandline.html")) {
            return messageOwnTab("commandline_frame", "editor_function", [property].concat(args));
          }
          return editor_exports[property](getLastUsedInput(), ...args);
        };
      }
      return target[property];
    }
  });
  addListener("editorfn_content", attributeCaller(EditorCmds2));

  // src/perf.ts
  var perf_exports = {};
  __export(perf_exports, {
    Marker: () => Marker,
    StatsFilter: () => StatsFilter,
    StatsLogger: () => StatsLogger,
    listenForCounters: () => listenForCounters,
    measured: () => measured,
    measuredAsync: () => measuredAsync,
    renderStatsHistogram: () => renderStatsHistogram
  });
  var logger13 = new Logger("performance");
  function measured(cls, propertyKey, descriptor) {
    if (!performanceApiAvailable())
      return;
    const originalMethod = descriptor.value;
    descriptor.value = function(...args) {
      const marker = new Marker(cls.constructor.name, propertyKey).start();
      const result = originalMethod.apply(this, args);
      marker.end();
      return result;
    };
    return descriptor;
  }
  function measuredAsync(cls, propertyKey, descriptor) {
    if (!performanceApiAvailable())
      return;
    const originalMethod = descriptor.value;
    descriptor.value = async function(...args) {
      const marker = new Marker(cls.constructor.name, propertyKey).start();
      const result = await originalMethod.apply(this, args);
      marker.end();
      return result;
    };
    return descriptor;
  }
  var Marker = class {
    constructor(ownerName, functionName, active = performanceApiAvailable() && get("perfcounters") === "true", metricName = new MetricName(ownerName, functionName)) {
      this.active = active;
      this.metricName = metricName;
    }
    start() {
      if (!this.active)
        return this;
      logger13.debug("Marking startpoint of performance counter for %o", this.metricName);
      performance.mark(this.metricName.startName);
      return this;
    }
    end() {
      if (!this.active)
        return this;
      logger13.debug("Marking endpoint of performance counter for %o", this.metricName);
      performance.mark(this.metricName.endName);
      performance.measure(this.metricName.fullName, this.metricName.startName, this.metricName.endName);
      return this;
    }
  };
  function listenForCounters(statsLogger) {
    let callback;
    if (statsLogger === void 0) {
      callback = (list) => {
        sendStats(list.getEntries());
      };
    } else {
      callback = (list) => {
        statsLogger.pushList(list.getEntries());
      };
    }
    const perfObserver = new PerformanceObserver(callback);
    perfObserver.observe({ entryTypes: ["mark", "measure"] });
    return perfObserver;
  }
  var StatsLogger = class {
    constructor() {
      this.buffer = [];
      this.idx = 0;
      this.buffersize = 1e4;
      this.lastError = 0;
    }
    receiveStatsJson(entriesJson) {
      this.pushList(JSON.parse(entriesJson));
    }
    pushList(entries) {
      for (const entry of entries) {
        this.pushEntry(entry);
      }
    }
    getEntries(...filterConfigs) {
      const filters = filterConfigs.map((fc) => new StatsFilter(fc));
      const filterFun = (e) => filters.every((f) => f.matches(e));
      return this.buffer.filter(filterFun);
    }
    updateBuffersize() {
      const perfsamples = Number(get("perfsamples"));
      if (Number.isInteger(perfsamples)) {
        this.buffersize = perfsamples;
      } else {
        if (performance.now() - this.lastError > 5e3) {
          this.lastError = performance.now();
          logger13.error("perfsamples must be an integer, is %O", perfsamples);
        }
      }
    }
    pushEntry(entry) {
      logger13.debug("Pushing performance entry %o into performance counters", entry);
      if (!entry.name.startsWith(TRI_PERFORMANCE_NAME_PREFIX))
        return;
      this.buffer[this.idx] = entry;
      this.incrementIdx();
    }
    incrementIdx() {
      this.idx = (this.idx + 1) % this.buffersize;
    }
  };
  function renderStatsHistogram(samples, buckets = 15, width = 80) {
    const durs = samples.map((sample) => sample.duration);
    const min2 = durs.reduce((a, b) => Math.min(a, b));
    const max2 = durs.reduce((a, b) => Math.max(a, b));
    const bucketvals = linspace(min2, max2, buckets);
    const bucketed = bucketize(durs, bucketvals);
    const maxcount = Array.from(bucketed.values()).reduce((a, b) => Math.max(a, b), 0);
    const labelwidth = 20;
    const barwidth = width - labelwidth;
    const tobarwidth = (n) => barwidth * n / maxcount;
    const result = [];
    for (const [bucketval, bucketcount] of bucketed.entries()) {
      const bar = "#".repeat(tobarwidth(bucketcount));
      const label = bucketval.toString().padEnd(labelwidth);
      result.push(label + bar);
    }
    return result.join("\n");
  }
  var StatsFilter = class {
    constructor(config14) {
      this.config = config14;
    }
    matches(entry) {
      const metricNameInfo = extractMetricName(entry.name);
      if (this.config.kind === "functionName" && this.config.functionName !== metricNameInfo.functionName) {
        return false;
      }
      if (this.config.kind === "ownerName" && this.config.ownerName !== metricNameInfo.ownerName) {
        return false;
      }
      if (this.config.kind === "eventType" && this.config.eventType !== entry.entryType) {
        return false;
      }
      return true;
    }
  };
  var TRI_PERFORMANCE_NAME_PREFIX = "tri";
  function performanceApiAvailable() {
    return performance.mark !== void 0;
  }
  var extractRegExp = new RegExp(`^${TRI_PERFORMANCE_NAME_PREFIX}/([^/]+)/([^:]+):([^:]+)`);
  function extractMetricName(counterName) {
    const matchresult = extractRegExp.exec(counterName);
    if (!matchresult)
      return;
    const [ownerName, functionName, uniqueSuffix] = matchresult.slice(1);
    return {
      ownerName,
      functionName,
      uniqueSuffix
    };
  }
  var MetricName = class {
    constructor(ownerName, functionName) {
      const uniqueSuffix = Math.floor(Math.random() * Math.floor(1e6)).toString();
      this.fullName = `${TRI_PERFORMANCE_NAME_PREFIX}/${ownerName}/${functionName}:${uniqueSuffix}`;
      this.startName = `${this.fullName}:start`;
      this.endName = `${this.fullName}:end`;
    }
  };
  function sendStats(list) {
    message("performance_background", "receiveStatsJson", JSON.stringify(list));
  }

  // src/lib/updates.ts
  var updates_exports = {};
  __export(updates_exports, {
    getInstalledPatchVersion: () => getInstalledPatchVersion,
    getInstalledVersion: () => getInstalledVersion,
    getLatestVersion: () => getLatestVersion,
    naggedForVersion: () => naggedForVersion,
    secondsSinceLastCheck: () => secondsSinceLastCheck,
    shouldNagForVersion: () => shouldNagForVersion,
    updateLatestNaggedVersion: () => updateLatestNaggedVersion
  });
  var import_semver_compare2 = __toModule(require_semver_compare());
  var logger14 = new Logger("updates");
  var TRI_VERSION2 = getTriVersion();
  function secondsSinceLastCheck() {
    const lastCheck = get("update", "lastchecktime");
    return (Date.now() - lastCheck) / 1e3;
  }
  async function getLatestVersion() {
    try {
      const feed = new DOMParser().parseFromString(await (await fetch("https://github.com/tridactyl/tridactyl/tags.atom")).text(), "application/xml");
      const mostRecent = feed.querySelectorAll("entry")[0];
      set2("update", "lastchecktime", Date.now());
      const highestKnownVersion = {
        version: mostRecent.querySelector("title").textContent,
        releaseDate: new Date(mostRecent.querySelector("updated").textContent)
      };
      logger14.debug("Checked for new version of Tridactyl, found ", highestKnownVersion);
      return highestKnownVersion;
    } catch (e) {
      logger14.error("Error while checking for updates: ", e);
    }
  }
  function shouldNagForVersion(version2) {
    const timeSinceRelease = (Date.now() - version2.releaseDate.getTime()) / 1e3;
    const updateNagWaitSeconds = get("update", "nagwait") * 24 * 60 * 60;
    const newerThanInstalled = (0, import_semver_compare2.default)(version2.version, getInstalledPatchVersion()) > 0;
    return newerThanInstalled && timeSinceRelease > updateNagWaitSeconds;
  }
  function naggedForVersion(version2) {
    const lastNaggedVersion = get("update", "lastnaggedversion");
    if (lastNaggedVersion) {
      return (0, import_semver_compare2.default)(version2.version, lastNaggedVersion) <= 0;
    } else {
      return false;
    }
  }
  function updateLatestNaggedVersion(version2) {
    set2("update", "lastnaggedversion", version2.version);
  }
  function getInstalledPatchVersion() {
    return TRI_VERSION2.replace(/pre.*/, "");
  }
  function getInstalledVersion() {
    return TRI_VERSION2;
  }

  // src/lib/visual.ts
  var visual_exports = {};
  __export(visual_exports, {
    reverseSelection: () => reverseSelection
  });
  function reverseSelection(selection) {
    const direction = getSelectionDirection(selection);
    if (direction == null) {
      return;
    }
    const range3 = selection.getRangeAt(0);
    const [edgeNode, edgeOffset] = direction ? [range3.startContainer, range3.startOffset] : [range3.endContainer, range3.endOffset];
    range3.collapse(!direction);
    selection.removeAllRanges();
    selection.addRange(range3);
    selection.extend(edgeNode, edgeOffset);
  }
  function getSelectionDirection(selection) {
    if (selection.isCollapsed) {
      return void 0;
    }
    const { anchorNode, focusNode } = selection;
    if (anchorNode == null || focusNode == null) {
      return void 0;
    }
    const range3 = document.createRange();
    range3.setStart(anchorNode, selection.anchorOffset);
    range3.setEnd(focusNode, selection.focusOffset);
    return !range3.collapsed;
  }

  // src/content.ts
  if (window.tridactyl_content_lock !== void 0) {
    throw Error("Trying to load Tridactyl, but it's already loaded.");
  }
  window.tridactyl_content_lock = "locked";
  var logger15 = new Logger("content");
  logger15.debug("Tridactyl content script loaded, boss!");
  setExCmds({
    "": excmds_content_generated_exports,
    ex: CmdlineCmds2,
    text: EditorCmds2,
    hint: getHintCommands()
  });
  addListener("excmd_content", attributeCaller(excmds_content_generated_exports));
  addListener("controller_content", attributeCaller(controller_exports));
  addListener("alive", async () => true);
  var guardedAcceptKey = (keyevent) => {
    if (!keyevent.isTrusted)
      return;
    acceptKey(keyevent);
  };
  function listen(elem) {
    elem.removeEventListener("keydown", guardedAcceptKey, true);
    elem.removeEventListener("keypress", canceller.cancelKeyPress, true);
    elem.removeEventListener("keyup", canceller.cancelKeyUp, true);
    elem.addEventListener("keydown", guardedAcceptKey, true);
    elem.addEventListener("keypress", canceller.cancelKeyPress, true);
    elem.addEventListener("keyup", canceller.cancelKeyUp, true);
  }
  listen(window);
  document.addEventListener("readystatechange", (_) => getAllDocumentFrames().forEach((f) => listen(f)));
  getAsync("preventautofocusjackhammer").then((allowautofocus) => {
    if (allowautofocus === "false") {
      return;
    }
    const preventAutoFocus = () => {
      ;
      document.activeElement.blur();
      const elem = document.activeElement;
      elem.tabIndex = 0;
      const focusElem = () => elem.focus();
      elem.addEventListener("blur", focusElem);
      elem.addEventListener("focusout", focusElem);
      const interval = setInterval(() => {
        if (document.activeElement != elem)
          focusElem();
      }, 200);
      function stopResettingFocus(event) {
        if (!event.isTrusted)
          return;
        elem.removeEventListener("blur", focusElem);
        elem.removeEventListener("focusout", focusElem);
        clearInterval(interval);
        window.removeEventListener("keydown", stopResettingFocus);
        window.removeEventListener("mousedown", stopResettingFocus);
      }
      window.addEventListener("keydown", stopResettingFocus);
      window.addEventListener("mousedown", stopResettingFocus);
    };
    const tryPreventAutoFocus = () => {
      document.removeEventListener("readystatechange", tryPreventAutoFocus);
      try {
        preventAutoFocus();
      } catch (e) {
        document.addEventListener("readystatechange", tryPreventAutoFocus);
      }
    };
    tryPreventAutoFocus();
  });
  window.tri = Object.assign(Object.create(null), {
    browserBg,
    commandline_content: commandline_content_exports,
    convert: convert_exports,
    config: config_exports,
    controller: controller_exports,
    dom: dom_exports,
    editor: EditorCmds2,
    excmds: excmds_content_generated_exports,
    finding_content: finding_exports,
    hinting_content: hinting_exports,
    itertools: itertools_exports,
    logger: logger15,
    metadata: metadata_generated_exports,
    keyseq: keyseq_exports,
    messaging: messaging_exports,
    state,
    State: state_exports,
    scrolling: scrolling_exports,
    visual: visual_exports,
    webext: webext_exports,
    l: (prom) => prom.then(console.log).catch(console.error),
    native: native_exports,
    styling: styling_exports,
    contentLocation: window.location,
    perf: perf_exports,
    R: rambda_esm_exports,
    updates: updates_exports,
    urlutils: url_util_exports
  });
  logger15.info("Loaded commandline content?", commandline_content_exports);
  try {
    setupFocusHandler();
    hijackPageListenerFunctions();
  } catch (e) {
    logger15.warning("Could not hijack due to CSP:", e);
  }
  if (window.location.protocol === "moz-extension:" && window.location.pathname === "/static/newtab.html") {
    getAsync("newtab").then((newtab) => {
      if (newtab !== "about:blank") {
        if (newtab) {
          open_quiet(newtab);
        } else {
          const content = document.getElementById("trinewtab");
          content.style.display = "block";
          document.title = "Tridactyl Top Tips & New Tab Page";
        }
      }
    });
  }
  getAsync("modeindicator").then((mode2) => {
    if (mode2 !== "true")
      return;
    const containerIndicator = get("containerindicator");
    const style = document.createElement("style");
    style.type = "text/css";
    style.innerHTML = `@media print {
        .TridactylStatusIndicator {
            display: none !important;
        }
    }`;
    const statusIndicator = document.createElement("span");
    const privateMode = browser.extension.inIncognitoContext ? "TridactylPrivate" : "";
    statusIndicator.className = "cleanslate TridactylStatusIndicator " + privateMode + " TridactylModenormal ";
    if (containerIndicator === "true") {
      ownTabContainer().then((ownTab2) => browserBg.contextualIdentities.get(ownTab2.cookieStoreId)).then((container) => {
        statusIndicator.setAttribute("style", `border: ${container.colorCode} solid 1.5px !important`);
      }).catch((error) => {
        logger15.debug(error);
      });
    }
    statusIndicator.addEventListener("mouseenter", (ev) => {
      const target = ev.target;
      const rect = target.getBoundingClientRect();
      target.classList.add("TridactylInvisible");
      const onMouseOut = (ev2) => {
        if (ev2.clientX < rect.x || ev2.clientX > rect.x + rect.with || ev2.clientY < rect.y || ev2.clientY > rect.y + rect.height) {
          target.classList.remove("TridactylInvisible");
          window.removeEventListener("mousemove", onMouseOut);
        }
      };
      window.addEventListener("mousemove", onMouseOut);
    });
    try {
      statusIndicator.textContent = contentState.mode || "normal";
      document.body.appendChild(statusIndicator);
      document.head.appendChild(style);
    } catch (e) {
      window.addEventListener("DOMContentLoaded", () => {
        statusIndicator.textContent = contentState.mode || "normal";
        document.body.appendChild(statusIndicator);
        document.head.appendChild(style);
      });
    }
    addContentStateChangedListener((property, oldMode, oldValue, newValue) => {
      let mode3 = newValue;
      let suffix = "";
      let result = "";
      if (property !== "mode") {
        if (property === "suffix") {
          mode3 = oldMode;
          suffix = newValue;
        } else {
          return;
        }
      }
      const privateMode2 = browser.extension.inIncognitoContext ? "TridactylPrivate" : "";
      statusIndicator.className = "cleanslate TridactylStatusIndicator " + privateMode2;
      if (isTextEditable(document.activeElement) && !["input", "ignore"].includes(mode3)) {
        result = "insert";
      } else if (mode3 === "insert" && !isTextEditable(document.activeElement)) {
        result = "normal";
      } else {
        result = mode3;
      }
      const modeindicatorshowkeys = get("modeindicatorshowkeys");
      if (modeindicatorshowkeys === "true" && suffix !== "") {
        result = mode3 + " " + suffix;
      }
      logger15.debug("statusindicator: ", result, ";", "config", modeindicatorshowkeys);
      statusIndicator.textContent = result;
      statusIndicator.className += " TridactylMode" + statusIndicator.textContent;
      if (get("modeindicator") !== "true" || get("modeindicatormodes", mode3) === "false") {
        statusIndicator.remove();
      }
    });
  });
  function protectSlash(e) {
    if (!e.isTrusted)
      return;
    get("blacklistkeys").map((protkey) => {
      if (protkey.indexOf(e.key) !== -1 && contentState.mode === "normal") {
        e.cancelBubble = true;
        e.stopImmediatePropagation();
      }
    });
  }
  getAsync("leavegithubalone").then((v) => {
    if (v === "true")
      return;
    try {
      document.body.addEventListener("keydown", protectSlash);
    } catch (e) {
      window.addEventListener("DOMContentLoaded", () => {
        document.body.addEventListener("keydown", protectSlash);
      });
    }
  });
  var phoneHome = () => browser.runtime.sendMessage("dom_loaded_background");
  document.readyState === "complete" && phoneHome();
  window.addEventListener("load", () => {
    phoneHome();
  });
  document.addEventListener("selectionchange", () => {
    const selection = document.getSelection();
    if (contentState.mode == "visual" && get("visualexitauto") == "true" && selection.anchorOffset == selection.focusOffset) {
      contentState.mode = "normal";
      return;
    }
    if (contentState.mode !== "normal" || get("visualenterauto") == "false")
      return;
    if (selection.anchorOffset !== selection.focusOffset) {
      contentState.mode = "visual";
    }
  });
  window.tri = Object.assign(window.tri, {
    perfObserver: listenForCounters()
  });
})();
//# sourceMappingURL=content.js.map
